SystemOrganization addCategory: #'GBT-DSL'!
SystemOrganization addCategory: 'GBT-DSL-Actions'!
SystemOrganization addCategory: 'GBT-DSL-BizApp'!
SystemOrganization addCategory: 'GBT-DSL-BizAppServer'!
SystemOrganization addCategory: 'GBT-DSL-Contexts'!
SystemOrganization addCategory: 'GBT-DSL-Declarative'!
SystemOrganization addCategory: 'GBT-DSL-Messaging'!
SystemOrganization addCategory: 'GBT-DSL-Tests'!
SystemOrganization addCategory: 'GBT-DSL-Tests-AppService'!
SystemOrganization addCategory: 'GBT-DSL-Tests-GUI'!
SystemOrganization addCategory: 'GBT-DSL-Things'!
SystemOrganization addCategory: 'GBT-DSL-UI-VO'!
SystemOrganization addCategory: 'GBT-DSL-UI-context'!
SystemOrganization addCategory: 'GBT-DSL-Utilities'!
SystemOrganization addCategory: 'GBT-DSL-core'!

Trait named: #TGbtAccessSerialized
	uses: {}
	category: 'GBT-DSL-BizAppServer'!

!TGbtAccessSerialized commentStamp: 'hk 3/31/2017 13:24' prior: 0!
either STON or JSON 

I read thing attributes out of the serialized string using patterns

My implementaion relates to the structure of names and ids in things!

!TGbtAccessSerialized classSide methodsFor: 'longName parts' stamp: 'hk 3/30/2017 12:52'!
classInitialAndIdOf: aLongName
	^(self matchesOf: aLongName)
		subexpression: 3	
	

	! !

!TGbtAccessSerialized classSide methodsFor: 'private' stamp: 'hk 3/30/2017 12:52'!
matchesOf: aLongName
	"values are longNames of the Form (\w+)\:([T|U]\d+)(v\d+) 
	answer the matches of the parts"
	^ '(\w+)\:([T|U]\w*\d+)(v\d+)' asRegex matchesPrefix: aLongName; yourself! !

!TGbtAccessSerialized classSide methodsFor: 'longName parts' stamp: 'hk 3/30/2017 12:52'!
svoNameOf: aLongName
	^(self matchesOf: aLongName)
		subexpression: 2	
	

	! !

!TGbtAccessSerialized classSide methodsFor: 'longName parts' stamp: 'hk 3/30/2017 12:52'!
versionOf: aLongName
	^(self matchesOf: aLongName)
		subexpression: 4	
	

	! !

!TGbtAccessSerialized methodsFor: 'accessing serialized node' stamp: 'hk 3/30/2017 12:37'!
classInitialAndIdOf: aSerializedNode 
	"aSerializedNode classInitialAndId "
	| searchString |
	searchString := '#id\s\:\s\''(\w+)\''\,'.
	^ 'T',	((searchString asRegex search: aSerializedNode; yourself) subexpression: 2) ! !

!TGbtAccessSerialized methodsFor: 'accessing serialized node' stamp: 'hk 2/7/2017 14:24'!
longNameOf: aSerializedNode
	"aSerializedNode longName"
	^(self svoNameOf: aSerializedNode), ':', (self classInitialAndIdOf: aSerializedNode), (self versionStringOf: aSerializedNode)! !

!TGbtAccessSerialized methodsFor: 'accessing serialized node' stamp: 'hk 2/7/2017 14:25'!
svoNameOf: aSerializedNode
	"aSerializedNode svoName"
	^('#svoName\s\:\s[''|#](\w+)' asRegex search: aSerializedNode; yourself) subexpression: 2 ! !

!TGbtAccessSerialized methodsFor: 'accessing serialized node' stamp: 'hk 2/7/2017 14:25'!
versionStringOf: aSerializedNode 
	"aSerializedNode versionString"
	^ 'v',	(('#version\s\:\s([0-9]+)' asRegex search: aSerializedNode; yourself) subexpression: 2)! !

Trait named: #TGbtProgramStore
	uses: {}
	category: 'GBT-DSL-BizAppServer'!

!TGbtProgramStore commentStamp: 'hk 3/16/2017 13:02' prior: 0!
I hold the delegation protocoll for the  instance variable programStore!

!TGbtProgramStore methodsFor: 'program store' stamp: 'hk 3/16/2017 12:37'!
add: anSVO full: aFullVO
	self programStore add: anSVO full: aFullVO! !

!TGbtProgramStore methodsFor: 'program store' stamp: 'hk 3/22/2017 12:15'!
addAC: anAC 
	^self programStore addAC: anAC ! !

!TGbtProgramStore methodsFor: 'program store' stamp: 'hk 3/16/2017 12:37'!
addDecl: anSVO 
	^self programStore addDecl: anSVO ! !

!TGbtProgramStore methodsFor: 'thing cache' stamp: 'hk 3/20/2017 17:40'!
addThing: anSVO 
	self tecNoPolicy adaptTo: anSVO id.
	^(self programStore thingsAt: anSVO svoName) addLast: anSVO 
! !

!TGbtProgramStore methodsFor: 'template editor' stamp: 'hk 3/23/2017 15:40'!
allACsWithTemplates
	"answer all ACs with templates for the template editor"
	^self allContexts select: [:c| c templates isNotEmpty].
! !

!TGbtProgramStore methodsFor: 'program store' stamp: 'hk 3/16/2017 12:37'!
allContexts
	^self programStore allContexts! !

!TGbtProgramStore methodsFor: 'program store' stamp: 'hk 3/21/2017 14:24'!
allFsvosWithTemplates
	^self programStore allFsvosWithTemplates! !

!TGbtProgramStore methodsFor: 'template editor' stamp: 'hk 3/23/2017 15:41'!
allSlotAssocsWithTemplates
	^self allACsWithTemplates! !

!TGbtProgramStore methodsFor: 'thing cache' stamp: 'hk 3/21/2017 12:54'!
allThings
	^self programStore allThings! !

!TGbtProgramStore methodsFor: 'program store' stamp: 'hk 3/16/2017 12:36'!
contextNamed: anACname  
	^self contextNamed: anACname ifAbsent: []! !

!TGbtProgramStore methodsFor: 'program store' stamp: 'hk 3/16/2017 12:37'!
contextNamed: anACname  ifAbsent: absentBlock
	^self programStore contextNamed: anACname  ifAbsent: absentBlock! !

!TGbtProgramStore methodsFor: 'program store' stamp: 'hk 3/21/2017 14:03'!
contextNoPolicyOf: anACname  
	^self programStore contextNoPolicyOf: anACname  ! !

!TGbtProgramStore methodsFor: 'program store' stamp: 'hk 3/20/2017 20:05'!
contextNoPolicyOf: anACname getter: aSelector
	"set the getter"
	(self programStore contextNoPolicyOf: anACname) getter: aSelector ! !

!TGbtProgramStore methodsFor: 'program store' stamp: 'hk 3/20/2017 20:05'!
contextNoPolicyOf: anACname prefix: aString
	"set the prefix"
	(self programStore contextNoPolicyOf: anACname) prefix: aString! !

!TGbtProgramStore methodsFor: 'program store' stamp: 'hk 3/16/2017 12:38'!
declarativeNamed: aName ifAbsent: absentBlock
	^self programStore declarativeNamed: aName ifAbsent: absentBlock! !

!TGbtProgramStore methodsFor: 'program store' stamp: 'hk 3/16/2017 12:38'!
fsvoEntry: aSvoName ifAbsent: aBlock
	^self programStore fsvoEntry: aSvoName ifAbsent: aBlock! !

!TGbtProgramStore methodsFor: 'program store' stamp: 'hk 3/21/2017 19:37'!
hasContext: anACName
	(self contextNamed: anACName) ifNil: [^false].
	^true! !

!TGbtProgramStore methodsFor: 'testing' stamp: 'hk 3/22/2017 12:31'!
isCompiled
	^self programStore mainCtxtName isNotNil! !

!TGbtProgramStore methodsFor: 'api' stamp: 'hk 3/21/2017 14:01'!
loadList: svoName 
	| list |
	list := self programStore reader loadList: svoName .
	list do: [:th| th registerWith: self].
	^list! !

!TGbtProgramStore methodsFor: 'program store' stamp: 'hk 3/22/2017 12:57'!
mainContext  
	^self contextNamed: self programStore mainCtxtName ifAbsent: []! !

!TGbtProgramStore methodsFor: 'program store' stamp: 'hk 3/16/2017 12:37'!
nextIdOfContextNoPolicy: anACname  
	^(self contextNoPolicyOf: anACname) nextID! !

!TGbtProgramStore methodsFor: 'analysis' stamp: 'hk 3/20/2017 12:51'!
selectedNodesInHierarchy
	^self programStore selectedNodesInHierarchy! !

!TGbtProgramStore methodsFor: 'template editor' stamp: 'hk 3/23/2017 15:39'!
svoName
	"used by the template editor"  
	^'Context Templates'! !

!TGbtProgramStore methodsFor: 'accessing' stamp: 'hk 3/20/2017 17:40'!
tecNoPolicy
	^self programStore tecNoPolicy! !

!TGbtProgramStore methodsFor: 'thing cache' stamp: 'hk 3/20/2017 12:35'!
thingDefinedAs: aName 
	"answer the svo with aName = svoName:id-version or svoName(with lowest id-version)"

	^self thingDefinedAs: aName ifAbsent: []! !

!TGbtProgramStore methodsFor: 'thing cache' stamp: 'hk 3/20/2017 12:47'!
thingDefinedAs: aName ifAbsent: absentBlock
	^self programStore thingDefinedAs: aName ifAbsent: absentBlock ! !

!TGbtProgramStore methodsFor: 'thing cache' stamp: 'hk 3/20/2017 12:43'!
withBizId: aBizId
	^self programStore withBizId: aBizId ! !

Trait named: #TGbtSerializer
	uses: {}
	category: 'GBT-DSL-BizAppServer'!

!TGbtSerializer commentStamp: 'hk 2/7/2017 14:49' prior: 0!
either STON or JSON

I know about GbtThing>>versionedNodes & stripped!

!TGbtSerializer classSide methodsFor: 'deserializing' stamp: 'hk 2/6/2017 13:45'!
fromString: aSerializedNode
	^STON fromString: aSerializedNode ! !

!TGbtSerializer methodsFor: 'serializing' stamp: 'hk 2/7/2017 14:46'!
serializedNodes
	^self versionedNodes collect: [:n| n stripped toString]
! !

!TGbtSerializer methodsFor: 'serializing' stamp: 'hk 2/6/2017 13:58'!
toString
	^STON toStringPretty: self! !

Trait named: #TGbtThingMeta
	uses: {}
	category: 'GBT-DSL-Things'!

!TGbtThingMeta commentStamp: 'hk 2/8/2017 15:29' prior: 0!
I hold all meta functions of Things: 
- interpreting the slotName or a tag as getter message
- direct slot access 
- interpreting smart paths

==========================
Refaktoring-Vorschlag:
- die Semantik der Tags ist i.w. in den Methoden für Tiefen- und Breitensuche implementiert: broadPathTo...  und deepPathTo...., aufgerufen von pathTo:  /  nodeAndSlotAssocOf:  /  doesNotUnderstand

Alternativ könnte  der slot-Aufruf selbst hasKeyOrTag:  benutzen  !

!TGbtThingMeta methodsFor: 'meta' stamp: 'hk 2/16/2017 15:08'!
addNodesTo: nodesToVisit withPath: aPath
	"breadth-first search: add subnodes to nodesToVisit "

	self slots do: [ :a |  |p|
		p := aPath copy add: a key; yourself.
		nodesToVisit add: {p . a} ].
! !

!TGbtThingMeta methodsFor: 'meta' stamp: 'hk 2/15/2017 10:37'!
broadPathTo: aSymbol onPath: aPath with: nodesToVisit
	"answer the path of the node or leaf with the unique tag or slotName aSymbol.
	aPath is anOrderedCollection of slotNames"

	self addNodesTo: nodesToVisit withPath: aPath.

	[nodesToVisit isNotEmpty] whileTrue: [ | a p |
		a := nodesToVisit first at: 2.
		p := nodesToVisit first at: 1.
		(a hasKeyOrTag: aSymbol) ifTrue: 
			[^{ #success . p} ] .
		a value ifNotNil: [:v | 
			v isNode ifTrue: 
				[v addNodesTo: nodesToVisit withPath: p]].
		nodesToVisit removeFirst ].
	^{ #failure . aPath}! !

!TGbtThingMeta methodsFor: 'meta' stamp: 'hk 2/16/2017 15:09'!
deepPathTo: aSymbol onPath: aPath 
	"answer the path of the node or leaf with the unique tag or slotName aSymbol.
	aPath is anOrderedCollection of slotNames"

	| res |  
	self slots do: [ :a | 
		(a hasKeyOrTag: aSymbol) ifTrue: 
			[^{ #success . aPath add: a key; yourself} ] .
		a value ifNotNil: [:v | |p|
			v isNode ifTrue: 
				[(p := aPath copy) add: a key.
				res := v deepPathTo: aSymbol onPath: p .
				(res at: 1) = #success ifTrue: [^res] ] ] ].
	^{ #failure . aPath}! !

!TGbtThingMeta methodsFor: 'meta' stamp: 'hk 2/20/2017 12:16'!
doesNotUnderstand: aMessage
	"answer the slot named by aMessage or change a value slot resp. node slot.
	the changed thing is not saved, the history of a node slot is not recorded"

	| sel node slotName nsa failBlock |  
	failBlock := [super doesNotUnderstand: aMessage].
	sel := aMessage selector asSymbol.		"may be a slotName or a tag"
	nsa := self nodeAndSlotAssocOf: sel.
	node := nsa first.
	slotName  := nsa second key.
	sel isKeyword ifTrue: [  	"= setter:"
		(node slotAt: slotName) ifNil: [^failBlock] .
		node slotAt: slotName value: aMessage argument].
	^(node slotValueAt: slotName) ifNil: [^failBlock]			! !

!TGbtThingMeta methodsFor: 'meta-smart path' stamp: 'hk 2/7/2017 17:05'!
getOnPath: aSmartPath
	"aSmartPath is an Array of some slotnames of this path"
	| res |
	res := self.
	aSmartPath do: [ :getter | res := res perform: getter ].
	^ res! !

!TGbtThingMeta methodsFor: 'meta-slot resolution' stamp: 'hk 2/8/2017 15:18'!
nodeAndSlotAssocOf: aSelector
	"answer the node and slotAssoc of aSlotName|tag, grow the smart thing if necessary"

	| path slotName |
	slotName := (aSelector trimRight: [ :c | c = $: ]) asSymbol.
	path := (self pathTo: slotName) ifNil: [self smartGrowTo: slotName].
	^self nodeAndSlotAssocOnPath: path! !

!TGbtThingMeta methodsFor: 'meta-slot resolution' stamp: 'hk 2/7/2017 15:02'!
nodeAndSlotAssocOnPath: aPath
	"answer the subNode slot aSlotName. aPath is valid and isNotEmpty"

	| res eld |
	res := self. 
	aPath do: [ :edge | 
		eld := res value. 
		res := (eld slotAssocAt: edge asSymbol)].
	^{ eld . res }! !

!TGbtThingMeta methodsFor: 'meta-slot aggregation' stamp: 'hk 2/16/2017 17:36'!
numbersTaggedWith: aTag
	"answer a collection of all numerical slot values with aTag"
	
	| coll |  
	coll := (self allSlotsWith: aTag) select: 
		[ :e | [e value val asNumber isNumber] ifError: [false] ] .
	^coll collect: [ :e | e value val asNumber ]! !

!TGbtThingMeta methodsFor: 'meta-slot resolution' stamp: 'hk 2/15/2017 10:38'!
pathTo: aTagOrSlotName
	"answer the path of the node or leaf with aTagSymbol or nil
	aPath is anOrderedCollection of slotNames"

	| res |
	self searchStrategy
		ifNotNil: [res := self deepPathTo: aTagOrSlotName onPath: OrderedCollection new]
		ifNil: [res := self broadPathTo: aTagOrSlotName onPath: OrderedCollection new with: OrderedCollection new].
	^(res at: 1) = #success
		ifTrue: [res at: 2] 	"the path"
		ifFalse: [nil]! !

!TGbtThingMeta methodsFor: 'meta-smart path' stamp: 'hk 2/8/2017 16:43'!
resolveTag: aSmartPath
	"answer the slot found | nil"

	| val tag|  
	tag := aSmartPath .
	val := (self respondsTo: tag asSymbol)
		ifTrue: [self perform: tag asSymbol]
		ifFalse: [self  slotOnSmartPath: tag] .
	^val 
! !

!TGbtThingMeta methodsFor: 'meta-slot resolution' stamp: 'hk 2/8/2017 15:22'!
slotNamed: aSlotNameOrTag
	"answer the slot named by aMessage - nil if not found"

	| path |
	^self slotAt: aSlotNameOrTag ifAbsent: 
		[(path := self pathTo: aSlotNameOrTag) ifNil: [^ nil].
		self slotOnPath: path ].
! !

!TGbtThingMeta methodsFor: 'meta-smart path' stamp: 'hk 2/8/2017 16:40'!
slotOn: aSmartPath
	"answer the slot found | nil"

	| val tag |
	tag := aSmartPath.
	val := (self respondsTo: tag asSymbol)
		ifTrue: [ self perform: tag asSymbol ]
		ifFalse: [ self slotOnSmartPath: tag ].
	^ val! !

!TGbtThingMeta methodsFor: 'meta-slot resolution' stamp: 'hk 2/7/2017 15:03'!
slotOnPath: aPath
	"answer the subNode slot aSlotName. aPath isNotNil "
	^(self nodeAndSlotAssocOnPath: aPath) second value! !

!TGbtThingMeta methodsFor: 'meta-smart path' stamp: 'hk 2/15/2017 11:26'!
slotOnSmartPath: aSmartPath
	"answer the VO denoted by aColonSeparatedString | nil if absent"
	
	| selectors res path |
	selectors := aSmartPath substrings: ':'.
	res := self.
	path := #''. 	
	selectors do: [:s| 
		path ifNotNil: [path := [res pathTo: s asSymbol] ifError: 
								[^self error: 'no path from ', path printString, ' to ', s ]].
		path ifNotNil: [res := res perform: s asSymbol] ].
	^path ifNotNil: [res]! !

!TGbtThingMeta methodsFor: 'meta-smart path' stamp: 'hk 2/8/2017 16:44'!
testAndResolveTag: aSmartPath
	^aSmartPath first = $R
		ifTrue: [self globalRoot resolveTag: aSmartPath allButFirst]
		ifFalse: [self resolveTag: aSmartPath]! !

!ComposableModel methodsFor: '*GBT-DSL' stamp: 'hk 11/9/2016 14:06'!
notify: aString
	owner notify: aString! !

ComposableModel subclass: #GbtWidget
	instanceVariableNames: 'widgetValue slotVO changeFlag slotLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-VO'!

!GbtWidget commentStamp: 'hk 6/14/2016 14:21' prior: 0!
abstract superclass of all default widgets referenced by things and leafs

    Instance Variables
	changeFlag:		<ValueHolder>			used to indicate value changes for calc slots
	slotLabel:		<String>					label for the slot name
	slotVO:			<LeafVO | ThingVO>		leaf ot thing to be displayed
	widgetValue:		<ComposableModel>		the real widget  

We need the changeFlag to handle horizontal dependencies between the widgets of a thing,
see GbtThingEditor>>initializePresenter  and GbtThingDiEditor>>initializeRightPresenter!

GbtWidget subclass: #GbtCalcWidget
	instanceVariableNames: 'inputButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-VO'!

!GbtCalcWidget commentStamp: 'hk 1/21/2016 14:32' prior: 0!
I display a CalcVO.
thats why I understand someValueHasChanged, see GcIphoneEditor>>initializePresenter

    Instance Variables
	inputButton:		<ButtonModel>		allows to edit my "formula"
!

!GbtCalcWidget class methodsFor: 'specs' stamp: 'hk 1/20/2016 14:56'!
defaultSpec
	<spec>
	
	^ (SpecLayout composed newRow: [ :r| r
		add: #slotLabel width: self labelWidth;
		add: #widgetValue;
		add: #inputButton width: 20 ])! !

!GbtCalcWidget methodsFor: 'ui actions' stamp: 'hk 2/23/2017 12:45'!
chooseNewCalcInput
	| res |
	res := (UIManager default request: 'new slot content' initialAnswer: self readRaw).
	res ifNil: [^self]	.
	self write: res.
	self read.! !

!GbtCalcWidget methodsFor: 'ui actions' stamp: 'hk 11/1/2016 20:07'!
chooseNewInput
	^slotVO isSumLeaf 
		ifTrue: [self chooseNewTagInput]		"SumVO or ProdVO or ValueRefVO"
		ifFalse: [self chooseNewCalcInput] 	"CalcVO or ConstraintVO"
! !

!GbtCalcWidget methodsFor: 'ui actions' stamp: 'hk 2/23/2017 12:45'!
chooseNewTagInput
	| res |
	res := (UIManager default request: 'new tag' initialAnswer: self readRaw).
	res ifNil: [ ^self ]	. 
	self write: res.
	self read.! !

!GbtCalcWidget methodsFor: 'initialization' stamp: 'hk 6/14/2016 13:42'!
initializeWidgets
	self instantiateModels: #(
		inputButton 	ButtonModel
		widgetValue	TextInputFieldModel ) .
	self widgetValue 
		enabled: false;
		ghostText: slotVO ghostText .
	self inputButton 
		icon: (GbtIcons at: #goto);
		action: [ self chooseNewInput ];
		state: false.
	super initializeWidgets.
	self someValueHasChanged 
! !

!GbtCalcWidget methodsFor: 'accessing' stamp: 'hk 1/15/2016 20:47'!
inputButton 	
	^inputButton! !

!GbtCalcWidget methodsFor: 'protocol' stamp: 'hk 2/23/2017 12:45'!
someValueHasChanged  
	self read
! !

GbtWidget subclass: #GbtChoiceWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-VO'!

!GbtChoiceWidget commentStamp: 'hk 1/21/2016 14:31' prior: 0!
I display a EnumVO

    Instance Variables
	selection:		<Object>!

!GbtChoiceWidget methodsFor: 'initialization' stamp: 'hk 2/23/2017 14:30'!
initializePresenter
	self widgetValue whenSelectedItemChanged: 
		[:item | self write: item] ! !

!GbtChoiceWidget methodsFor: 'initialization' stamp: 'hk 2/23/2017 12:59'!
initializeWidgets
	self instantiateModels: #(widgetValue	DropListModel ) .	
	self widgetValue 
		items: slotVO list;
		displayBlock: [ :item | item printString ] .
	self read.
	super initializeWidgets
! !

!GbtChoiceWidget methodsFor: 'basic read-write' stamp: 'hk 2/23/2017 13:39'!
read
	self widgetValue selectedItem = slotVO val ifTrue: [^nil].
	self widgetValue setSelectedItem: slotVO val! !

GbtWidget subclass: #GbtDateWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-VO'!

!GbtDateWidget commentStamp: 'hk 1/21/2016 14:31' prior: 0!
I display a DateVO!

!GbtDateWidget class methodsFor: 'specs' stamp: 'hk 1/20/2016 14:37'!
defaultSpec
	<spec>
	
	^ SpecLayout composed
		add: #widgetValue;
		yourself! !

!GbtDateWidget methodsFor: 'initialization' stamp: 'hk 2/23/2017 14:31'!
initializePresenter
	self widgetValue whenDateChanged: 
		[ self write: self widgetValue date]! !

!GbtDateWidget methodsFor: 'initialization' stamp: 'hk 2/23/2017 12:47'!
initializeWidgets
	self instantiateModels: #(widgetValue GbtDateModel ) .	
	self read.
	super initializeWidgets
! !

!GbtDateWidget methodsFor: 'as yet unclassified' stamp: 'hk 2/23/2017 15:03'!
read
	self widgetValue date asString = slotVO val ifTrue: [^nil].
	self widgetValue date: slotVO val! !

GbtWidget subclass: #GbtLinkWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-VO'!

!GbtLinkWidget commentStamp: 'hk 4/30/2016 18:25' prior: 0!
I display a ThingLink
!

!GbtLinkWidget methodsFor: 'initialization' stamp: 'hk 4/30/2016 19:15'!
initializeWidgets
	self instantiateModels: #(widgetValue	LabelModel ).
	self widgetValue label: 'Link to: ', slotVO sparsePath.
	super initializeWidgets
! !

GbtWidget subclass: #GbtListWidget
	instanceVariableNames: 'editBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-VO'!

!GbtListWidget commentStamp: 'hk 1/7/2017 19:28' prior: 0!
I display a UlistVO in a thing editor

    Instance Variables
	editBlock:		<Block>
!

!GbtListWidget class methodsFor: 'specs' stamp: 'hk 1/20/2016 14:42'!
defaultSpec
	<spec>
	
	^ SpecLayout composed
		add: #widgetValue;
		yourself! !

!GbtListWidget methodsFor: 'ui actions' stamp: 'hk 10/6/2016 19:05'!
add
	"add a list element"  
	self askForEntry ifNil: [^self].
	widgetValue items: slotVO list.
	self buildWithSpec.
	self changeFlag valueChanged.
! !

!GbtListWidget methodsFor: 'ui actions' stamp: 'hk 1/9/2017 20:39'!
askForEntry 
	"the widget is not initialized yet - 
	add the first list element from the list templates.
	if the container context has a choose context, let the user choose"
	
	| tmplt sel purp elem simpleReturn ctxt dialogWindow ctxtDecl decl res |  
	tmplt := (self chooseTemplate) ifNil: [ ^nil].  
	elem := tmplt copy.
	tmplt purposes ifNotEmpty:  "if the template has purposes, choose or add one"
		[purp := (self choosePurposeFrom: tmplt purposes).
		elem purposes: (purp ifNil: [#()] ifNotNil: [{purp}] )].
	purp := elem purposes.
	simpleReturn := [ ^slotVO newEntry: elem].
	ctxt := slotVO container contextVO.
	ctxt ifNil: simpleReturn .
	ctxtDecl := ctxt choiceContextAt: slotLabel label ifAbsent: [simpleReturn value].
	decl := ctxtDecl first.
	ctxt := ctxtDecl second.
	dialogWindow := (GbtListUI on: ctxt) openDialogWithSpec .
	dialogWindow 
		okAction: [(sel := dialogWindow model selection) 
			ifNil: []
			ifNotNil: [elem := sel save]];
		cancelAction: [elem := nil];
		title: ctxt displayName  ;
		centeredRelativeTo: self currentWorld ;
		modalRelativeTo: self currentWorld.
	elem ifNil: [^nil].
	res := elem copyWith: decl.
	res purposes: purp.
	^slotVO newEntry: res.! !

!GbtListWidget methodsFor: 'ui actions' stamp: 'hk 1/16/2016 19:56'!
choosePurposeFrom: aList
	"^nil or the chosen purpose"
	
	^UIManager default 
				chooseOrRequestFrom: aList 
				title: 'choose a purpose'.! !

!GbtListWidget methodsFor: 'ui actions' stamp: 'hk 3/27/2017 20:56'!
chooseTemplate
	"^nil or the chosen template"
	
	^GbtWidget chooseTemplateFrom: slotVO templateThings .
! !

!GbtListWidget methodsFor: 'ui actions' stamp: 'hk 2/23/2017 12:32'!
deleteSelection
	"delete the selected list element"  
	self widgetValue selectedItem remove.
	widgetValue items: slotVO list.
	self buildWithSpec.
	self changeFlag valueChanged.! !

!GbtListWidget methodsFor: 'accessing' stamp: 'hk 1/21/2016 12:05'!
editBlock: aBlock  
	editBlock :=  aBlock! !

!GbtListWidget methodsFor: 'ui actions' stamp: 'hk 11/1/2016 20:10'!
editSelection
	"edit a list element"  
	editBlock  value: self widgetValue selectedItem ! !

!GbtListWidget methodsFor: 'initialization' stamp: 'hk 1/16/2016 19:46'!
initializePresenter
	widgetValue whenListChanged: [self buildWithSpec]! !

!GbtListWidget methodsFor: 'initialization' stamp: 'hk 6/30/2016 13:22'!
initializeWidgets
	widgetValue := self newList  .
	widgetValue items: slotVO list.
	widgetValue displayBlock: [:item | item listIndex, ':   ', item summaryEnriched].
	widgetValue menu: [ :m | self listMenu: m ] .
	super initializeWidgets
! !

!GbtListWidget methodsFor: 'ui actions' stamp: 'hk 1/20/2016 13:51'!
inspect
	"inspect a list element"  
	self widgetValue selectedItem inspect! !

!GbtListWidget methodsFor: 'ui actions' stamp: 'hk 11/1/2016 20:17'!
listMenu: m
	(m add: #edit target: self selector:  #editSelection) 
		enablementSelector: [ self widgetValue selectedItem isNotNil ] .
	(m add: #inspect target: self selector:  #inspect) 
		enablementSelector: [ self widgetValue selectedItem isNotNil ] .
	(m add: #add target: self selector:  #add) .
	(m add: #delete target: self selector:  #deleteSelection) 
		enablementSelector: [ self widgetValue selectedItem isNotNil ] .
	^m! !

!GbtListWidget methodsFor: 'basic read-write' stamp: 'hk 2/23/2017 13:14'!
read
	"do nothing"! !

!GbtListWidget methodsFor: 'accessing' stamp: 'hk 10/3/2016 13:18'!
widgetHeight
	^(((widgetValue listSize max: 3) /2) min: 3) * self singleHeight! !

GbtWidget subclass: #GbtNumberWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-VO'!

!GbtNumberWidget commentStamp: 'hk 3/2/2017 13:15' prior: 0!
I display a RangeVO (for numbers)

my accept function allows to use auto accept .
when my widget is updated, a change is signalled that might be used to trigger calc slots!

!GbtNumberWidget methodsFor: 'initialization' stamp: 'hk 3/2/2017 13:17'!
acceptFunction: arg
	"no autoaccept please, accept by cr"  
	self write: (self entryStringOf: arg); read.
! !

!GbtNumberWidget methodsFor: 'initialization' stamp: 'hk 2/26/2017 11:48'!
entryStringOf: aStringOrNumber
	| no min max |  
	"empty"
	(aStringOrNumber ifNil: [^'']) = '' ifTrue: [^aStringOrNumber].
	"leading digits"
	[no := aStringOrNumber asNumber] ifError: [^'NaN']. 
	"trailing digits"
	aStringOrNumber asString last isDigit ifFalse: [^'NaN'].	
	min := slotVO min.
	max := slotVO max.	
	min ifNotNil: [no < min asNumber ifTrue: [ ^'min: ', min ]].
	max ifNotNil: [no > max asNumber ifTrue: [ ^'max: ', max ]].
	^no asString
! !

!GbtNumberWidget methodsFor: 'initialization' stamp: 'hk 2/26/2017 12:38'!
initializeWidgets
	self instantiateModels: #(widgetValue	TextInputFieldModel ) .
	self widgetValue 
		autoAccept: false;
		ghostText: slotVO ghostText ;
		acceptBlock: [ :v| self acceptFunction: v];
		text: slotVO val.
	super initializeWidgets
! !

GbtWidget subclass: #GbtTextWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-VO'!

!GbtTextWidget commentStamp: 'hk 1/21/2016 14:36' prior: 0!
I display a TextVO!

!GbtTextWidget class methodsFor: 'specs' stamp: 'hk 2/21/2017 10:47'!
defaultSpec
	<spec>
	^SpecLayout composed newRow: [ :r| r
			add: #slotLabel width: self labelWidth;
			add: #widgetValue] 
					height: (2 * self toolbarHeight)! !

!GbtTextWidget methodsFor: 'initialization' stamp: 'hk 2/23/2017 14:31'!
initializePresenter
	self widgetValue whenTextChanged: 
		[:item | self write: item] 
! !

!GbtTextWidget methodsFor: 'initialization' stamp: 'hk 2/23/2017 12:54'!
initializeWidgets
	self instantiateModels: #(widgetValue	TextInputFieldModel ) .
	self read .
	super initializeWidgets
! !

!GbtTextWidget methodsFor: 'accessing' stamp: 'hk 1/16/2016 13:40'!
widgetHeight
	^2 * self singleHeight! !

GbtWidget subclass: #GbtValueWidget
	instanceVariableNames: 'askButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-VO'!

!GbtValueWidget commentStamp: 'hk 7/31/2016 15:27' prior: 0!
I display a ValueVO.

when my widget is updated, a change is signalled that might be used to trigger calc slots

!

!GbtValueWidget class methodsFor: 'specs' stamp: 'hk 7/31/2016 14:39'!
defaultSpec
	<spec>
	
	^ (SpecLayout composed newRow: [ :r| r
		add: #slotLabel width: self labelWidth;
		add: #widgetValue;
		add: #askButton width: 20 ])! !

!GbtValueWidget methodsFor: 'initialization' stamp: 'hk 7/31/2016 14:44'!
askButton 
	^askButton! !

!GbtValueWidget methodsFor: 'ui actions' stamp: 'hk 7/31/2016 15:18'!
askForValue
	self widgetValue text: (self valuesDialog ifNil: [^self])! !

!GbtValueWidget methodsFor: 'initialization' stamp: 'hk 2/23/2017 15:32'!
initializePresenter
	self widgetValue whenTextChanged: 
		[self write: self widgetValue getText]
! !

!GbtValueWidget methodsFor: 'initialization' stamp: 'hk 2/26/2017 12:53'!
initializeWidgets
	self instantiateModels: #(
		widgetValue	TextInputFieldModel 
		askButton ButtonModel).
	self widgetValue 
		autoAccept: false;
		ghostText: self slotLabel label asString .
	self askButton 
		icon: (GbtIcons at: #ask) ;
		action: [self askForValue];
		help: 'show values used'   ;
		state: true .
	self read.
	super initializeWidgets
! !

!GbtValueWidget methodsFor: 'ui actions' stamp: 'hk 2/15/2017 11:31'!
valuesDialog
	| values res |
	slotVO container ifNil: 
		[self inform: 'no container' . ^nil].  
	values := slotVO container valuesOf: self slotLabel label.
	values ifEmpty: [^nil].
	values size =1 ifTrue: [^values at: 1].
	res := UIManager default chooseFrom: values values: values.
	^res! !

GbtWidget subclass: #GbtVoWidget
	instanceVariableNames: 'editBlock editButton widgetHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-VO'!

!GbtVoWidget commentStamp: 'hk 1/21/2016 14:40' prior: 0!
I display a ThingVO.

In case the thing (slotVO) has  subnodes, a label with the summary is assignet to widgetValue.
Otherwise, a VoBoxWidget is assignet to widgetValue.

Instance Variables
	editBlock:		<Block>
	editButton:		<ButtonModel | LabelModel>
	widgetHeight:	<Number>
!

!GbtVoWidget class methodsFor: 'specs' stamp: 'hk 1/20/2016 17:28'!
defaultSpec
	<spec>
	
	^ (SpecLayout composed newRow: [ :r| r
			add: #slotLabel width: self labelWidth;
			add: #widgetValue;
			add: #editButton width: 20] )! !

!GbtVoWidget methodsFor: 'accessing' stamp: 'hk 1/21/2016 19:57'!
editBlock: aBlock     
	editBlock :=  aBlock! !

!GbtVoWidget methodsFor: 'accessing' stamp: 'hk 1/16/2016 15:36'!
editButton
	^editButton! !

!GbtVoWidget methodsFor: 'initialization' stamp: 'hk 10/6/2016 15:19'!
initializeWidgets
	
	editBlock := [:vo|(GbtThingEditor on: vo) openWithSpec].
	editButton := self newButton .	
	widgetValue := self newLabel 
		label: slotVO summaryEnriched  .	
	widgetHeight := self singleHeight .
	self editButton
		icon: (GbtIcons at: #edit) ;
		action: [ editBlock value: slotVO. 
					self editButton state: true];	"put some emphasis"
		state: false.
	super initializeWidgets
! !

!GbtVoWidget methodsFor: 'basic read-write' stamp: 'hk 2/23/2017 13:15'!
read
	"do nothing"! !

!GbtVoWidget methodsFor: 'ui actions' stamp: 'hk 11/1/2016 20:24'!
resetEditButton
	slotVO hasSubnodes ifFalse: [^self].
	self editButton state: false.
	self buildWithSpec! !

!GbtVoWidget methodsFor: 'accessing' stamp: 'hk 1/16/2016 18:19'!
widgetHeight
	^widgetHeight! !

!GbtWidget class methodsFor: 'helpers' stamp: 'hk 1/29/2016 16:46'!
chooseTemplateFrom: templates
	| ind tmpltLines |  
	ind := (templates size =1) 
				ifTrue: [1]
				ifFalse: [tmpltLines := templates collect: [ :e | e summaryEnriched ]. 
							UIManager default chooseFrom: tmpltLines lines: #() message: 'choose a template'].
	ind = 0 ifTrue: [ ^nil].
	^templates at: ind	
! !

!GbtWidget class methodsFor: 'specs' stamp: 'hk 1/20/2016 14:56'!
defaultSpec
	<spec>
	
	^ SpecLayout composed newRow: [ :r |  r
			add: #slotLabel width: self labelWidth;
			add: #widgetValue];
		yourself! !

!GbtWidget class methodsFor: 'specs' stamp: 'hk 1/25/2016 13:05'!
labelWidth
	^100! !

!GbtWidget class methodsFor: 'instance creation' stamp: 'hk 10/11/2016 16:37'!
on: aVO
	^self basicNew slotVO: aVO; label: aVO svoName! !

!GbtWidget class methodsFor: 'instance creation' stamp: 'hk 1/25/2016 12:18'!
on: aVO label: aString
	^self basicNew slotVO: aVO; label: aString; initialize! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 1/19/2016 16:12'!
changeFlag
	^changeFlag! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 10/6/2016 19:04'!
changeFlag: aBoolean
	changeFlag value: aBoolean! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 1/21/2016 12:03'!
editBlock: aBlock! !

!GbtWidget methodsFor: 'initialization' stamp: 'hk 6/10/2016 21:00'!
initializeWidgets
	self focusOrder add: self widgetValue.
	changeFlag := false asValueHolder.
	self needRebuild: false! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 1/21/2016 13:40'!
label: aString
	slotLabel	 := self newLabel label: aString! !

!GbtWidget methodsFor: 'basic read-write' stamp: 'hk 2/23/2017 13:38'!
read
	self widgetValue text = slotVO val ifTrue: [^nil].
	self widgetValue text: slotVO val
	! !

!GbtWidget methodsFor: 'basic read-write' stamp: 'hk 2/22/2017 12:12'!
readRaw
	^slotVO inputValue
	! !

!GbtWidget methodsFor: 'ui actions' stamp: 'hk 1/16/2016 15:28'!
resetEditButton! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 1/16/2016 13:33'!
singleHeight
	^self class toolbarHeight! !

!GbtWidget methodsFor: 'initialization' stamp: 'hk 1/20/2016 14:27'!
slotLabel
	^slotLabel! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 10/6/2016 18:27'!
slotVO
	^slotVO ! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 1/15/2016 18:55'!
slotVO: aLeaf
	slotVO := aLeaf! !

!GbtWidget methodsFor: 'protocol' stamp: 'hk 2/23/2017 12:25'!
someValueHasChanged  
	"default"
! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 1/16/2016 13:34'!
widgetHeight
	^self singleHeight! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 1/15/2016 18:55'!
widgetValue
	^widgetValue
! !

!GbtWidget methodsFor: 'basic read-write' stamp: 'hk 3/2/2017 13:31'!
write: aValue
	"all writes to slotVO must use #write - see evolve"  
	(slotVO inputValue = aValue) ifTrue: [^self].
	self slotVO: (slotVO container updateLeaf: owner slotName with: aValue).
	self changeFlag: true! !

!OrderedDictionary methodsFor: '*GBT-DSL' stamp: 'hk 2/14/2017 17:15'!
assocsSelect: aBlock
	"do not copy the associations into a new Array, take the GbtAssociations directly"
	| res |
	res := self species new.
	self associationsDo: [:a| (aBlock value: a) ifTrue: [res add: a] ].
	^res! !

TestCase subclass: #GbtTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTests commentStamp: 'hk 4/3/2015 17:04' prior: 0!
The SpoTests class

for manual experience evaluate ...!

GbtTests subclass: #GbtClearPermanentTraces
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-AppService'!

!GbtClearPermanentTraces methodsFor: 'tests' stamp: 'hk 3/14/2017 10:37'!
testClearBizNet
	GbtBizNetMockUp messageDir ensureDeleteAllChildren.
	GbtBizNetMockUp stopPolling ! !

!GbtClearPermanentTraces methodsFor: 'tests' stamp: 'hk 3/14/2017 13:08'!
testClearStore
	GbtBizAppServer clearStore! !

GbtTests subclass: #GbtGUITests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-GUI'!

GbtGUITests subclass: #GbtGUITestDefBehaviors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-GUI'!

!GbtGUITestDefBehaviors methodsFor: 'tests' stamp: 'hk 3/16/2017 13:22'!
testBehaviors
	self exampleContextBehaviors ui buildWithSpec
! !

GbtGUITests subclass: #GbtGUITestDefConstraints
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-GUI'!

!GbtGUITestDefConstraints methodsFor: 'tests' stamp: 'hk 3/16/2017 13:22'!
testBehaviors
	self exampleContextConstraints ui buildWithSpec
! !

!GbtGUITests methodsFor: 'examples' stamp: 'hk 3/22/2017 13:14'!
exampleContextBehaviors

	^GbtPlainAC struct: 'GCEmailContext' define: {
		{#displayAs: . 'Email'  } .
		{#uiSpec:icon: . #GbtItemUI . #email} .
		{#vo: . GbtVOGUITests new dialogThing } .

		{#onReceiveDo: . #(beh1 beh2) }.
		{#menu:items: . #GbtBizNetMockUp . #(beh3 beh4) }.
		{#menu: . #beh1}.

		{#behavior:actions: . #beh1 . #(HALT viod)}.
		{#behavior:actions: . #beh2 . #(HALT viod)}.
		{#behavior:actions: . #beh3 . #(HALT viod)}.	
		{#behavior:actions: . #beh4 . #(HALT viod)}.
	}! !

!GbtGUITests methodsFor: 'examples' stamp: 'hk 3/22/2017 13:14'!
exampleContextConstraints

	^GbtPlainAC struct: 'GCEmailContext' define: {
		{#displayAs: . 'Email'  } .
		{#uiSpec:icon: . #GbtItemUI . #email} .
		{#vo: . GbtVOGUITests new dialogThing } .

		{#constraints: . #(constr1 constr2) } .
		{#constraint:left:right: . #constr1 . #(HALT viod) . #(HALT viod)}.
		{#constraint:left:right: . #constr2 . #(HALT viod) . #(HALT viod)}.
	}
	
! !

GbtTests subclass: #GbtTestActions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestActions methodsFor: 'helpers' stamp: 'hk 3/22/2017 13:14'!
activeContext 
	
	^GbtPlainAC struct: 'ActiveContext' define: { 
		{#vo: . self thing }.
		{ #aspect:on: . self aspectContext . #aspect } .
		{#behavior:actions: . #val2Slot . #(ASSIGNVAL #(zehn neu1)) }.
		{#behavior:actions: . #set2Slot . #(BEHAVIORS #("VO" void neu2)) }.

 	}  ! !

!GbtTestActions methodsFor: 'helpers' stamp: 'hk 3/22/2017 13:14'!
aspectContext 

	^GbtPlainAC struct: 'AspectContext' define: { 
		{#behavior:actions: . #aspectVO . #(ASSUREVO void) }.
		{#behavior:actions: . #aspectVoBeh . #(BEHAVIORS #(aspectVO)) }.
	}
	
! !

!GbtTestActions methodsFor: 'helpers' stamp: 'hk 3/14/2017 13:01'!
aspectVO
	"self new aspectVO edit"
	
	^GbtThing struct: 'AspectVO' define: { 
		{ #val . #val: . '4711' }}.! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/5/2016 19:05'!
testAssignVO
	| aspectContext |
	aspectContext := self activeContext subcontexts first .
	self should: [ aspectContext vo isNil ].
	aspectContext doBehaviors: #(aspectVO).
	self should: [ aspectContext vo isNotNil ]! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/5/2016 19:05'!
testBehaviorCall
	| aspectContext |
	aspectContext := self activeContext subcontexts first .
	aspectContext doBehaviors: #(aspectVoBeh).
	self should: [ aspectContext vo isNotNil ]! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/3/2016 11:29'!
testCompose
	"tbd"! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/3/2016 11:29'!
testEmbed
	"tbd"! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/3/2016 11:28'!
testGetAspect
	"tbd"! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/3/2016 11:28'!
testGetSlot
	"tbd"! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/3/2016 12:19'!
testMatch
	"tbd"! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/3/2016 11:28'!
testSetToList
	"tbd"! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/3/2016 11:29'!
testSetToSlot
	"tbd"! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/5/2016 20:27'!
testSetValToSlot
	self activeContext 
	 	doBehaviors: #(val2Slot).
	self should: [self activeContext vo neu1 = 'zehn' ]! !

!GbtTestActions methodsFor: 'helpers' stamp: 'hk 3/14/2017 13:01'!
thing
	
	^GbtThing struct: 'testActiveVO' define: { 
		{ #aspect . #thing: . self aspectVO }.
		{ #neu1 . #val: . '' }.
		{ #neu2 . #thing: . self aspectVO }.
	}.! !

GbtTests subclass: #GbtTestAppService
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-AppService'!

!GbtTestAppService methodsFor: 'tests' stamp: 'hk 3/20/2017 18:07'!
testStoreAndReconstruct
	| th th2 |
	th := GbtThing struct: 'superThing' define: { 
		{ #theThing . #thing: . self theThing }}.
	th store. 

	th2 := (th bizApp loadList: #superThing) first.
	self should: [ th2 theThing isThing ].	
	self should: [ th2 sub isThing ].	
	self should: [ th2 sub1 = #Blondie ].	
	self should: [ th2 sub2 = #Devote ].	
! !

!GbtTestAppService methodsFor: 'tests' stamp: 'hk 3/20/2017 20:09'!
testStoreAndRetrieveSimple
	| th th2 list |
	th := self theThing store. 

	list := th bizApp  loadList: th svoName.
	self should: [ list size = 1 ].
	th2 := list first.
	self should: [ th slots size = th2 slots size ].	
	self should: [ th fullThing = th2 fullThing ].	
! !

!GbtTestAppService methodsFor: 'tests' stamp: 'hk 3/30/2017 13:08'!
testStoreTecNoPolicy
	|  sub id |
	sub := self theSub store. 

	sub bizApp tecNoPolicy initialize.
	self should: [sub bizApp tecNoPolicy next = 1 ].
	
	id := (sub bizApp loadList: sub svoName) first id .
	self should: [sub bizApp tecNoPolicy next -1 = id asNumber].
! !

!GbtTestAppService methodsFor: 'tests' stamp: 'hk 3/20/2017 18:10'!
testThingStore
	| th |
	th := GbtThing struct: 'superThing' define: { 
		{ #theThing . #thing: . self theThing }}.
	"program store"
	self should: [(th bizApp fsvoEntry: #FsuperThing ifAbsent: []) isNotNil].
	self should: [(th bizApp fsvoEntry: #FtestThing ifAbsent: []) isNotNil].
	self should: [(th bizApp fsvoEntry: #FtestSub ifAbsent: []) isNotNil].
	"program store"
	self should: [(th bizApp thingDefinedAs: #superThing ifAbsent: []) isNotNil].
	self should: [(th bizApp thingDefinedAs: #testThing ifAbsent: []) isNotNil].
	self should: [(th bizApp thingDefinedAs: #testSub ifAbsent: []) isNotNil].
	"thing cache"
	self should: [(th bizApp thingDefinedAs: #superThing ifAbsent: []) isNotNil].
	self should: [(th bizApp thingDefinedAs: #testThing ifAbsent: []) isNotNil].
	self should: [(th bizApp thingDefinedAs: #testSub ifAbsent: []) isNotNil].! !

!GbtTestAppService methodsFor: 'helpers' stamp: 'hk 3/14/2017 13:01'!
theSub 
	^GbtThing struct: 'testSub' define: { 
		{ #sub1 . #val:tag: . 'Blondie' . #foo31 }.
		{ #sub2 . #val:tag: . 'Devote' . #foo32} }! !

!GbtTestAppService methodsFor: 'helpers' stamp: 'hk 3/14/2017 13:01'!
theThing 
	^GbtThing struct: 'testThing' define: { 
		{ #nname . #val:tag: . 'Master' . #foo1 }.
		{ #vname . #val:tag: . 'Max' . #foo2}.
		{ #sub . #thing:tag: . self theSub . #foo3}.
	}	full: { 
		{ #misc . #val: . 'miscelaneous'} }! !

GbtTests subclass: #GbtTestAuthoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 2/22/2017 12:28'!
testDefineDate
	| bla |
	bla := (GbtThing new)
		define: #jan1st date: '1.1.2015';
		define: #today date: Date today;
		yourself.
	self should: [ bla today = (Date today asString) ]! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testDefineEnum
	| bla |
	bla := (GbtThing struct: #bla)
		define: #as enum: #(#aaa #bbb #cbb #'111' ) ;
		yourself.
	self should: [ (bla slotSVOAt: #as) val = 'aaa' ].
	
! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testDefineEnumNumerical
	| bla |
	bla := (GbtThing struct: #bla)
		define: #as enum: #('1' '4' '7' abc) ;
		yourself.
	self should: [ (bla slotSVOAt: #as) val = '1' ].
	
! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testDefineNo
	| bla |
	bla := (GbtThing struct: #bla)
		define: #foo2 no: 0 tag: #abc;
		define: #foo4 no: 4 from: -5 to: 5 tag: #abc;
		define: #foo6 no: 'abc' from: -5 to: 5 tag: nil;
		yourself.
	self should: [ bla foo2 = '0' ].
	self should: [ (bla slotSVOAt: #foo4) min = '-5' ].
	self should: [ (bla slotSVOAt: #foo4) max = '5' ].
	self should: [ bla foo6 = #abc ].
! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testDefineThing
	| bla bla2 |
	bla := (GbtThing struct: #bla).
	bla2 := (GbtThing struct: #bla2)
		define: #slot thing: bla;
		yourself.
	self should: [ bla2 slot isNode ].
	self should: [GbtThing new define: #slot thing: #bla] raise: Error! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testDefineUlist1
	| bla foo1 foo2  view |
	foo1 := GbtThing struct: #foo1.
	foo2 := GbtThing struct: #foo2.
	
	bla := (GbtThing struct: #bla)
		define: #ulist
			list: {foo1 . foo2}
			of: { }
			display: nil
			for: #()
			tag: #bla1
			private: nil;
		yourself .
	(view := GbtDeclarative struct: #Decl) sources: bla; define: #theList tag: #bla1 .
	
	self should: [ (bla ulist slotSVOAt: #'1') = foo1 ].
	self should: [ (bla ulist slotSVOAt: #'2') = foo2 ].
	self should: [((view slotSVOAt: #theList) slotSVOAt: #'1') = foo1 ].! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 5/11/2016 14:13'!
testDefineUlist1e
	self should: [GbtThing new define: #ulist list: {#foo1. #foo2} of: #() display: nil for: nil tag: nil private: nil]
		   raise: Error! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testDefineUlist3
	| bla foo1 |
	foo1 := GbtThing struct: #foo1.
	(bla := GbtThing new) define: #ulist listOf: foo1.  
	bla ulist newEntry.
	
	self should: [ (bla ulist slotSVOAt: #'1') fullThing longName = foo1 fullThing longName].
! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 5/11/2016 14:13'!
testDefineUlist3e
	self should: [GbtThing new define: #ulist listOf: #foo1 ]
		   raise: Error! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testDefineVal
	| bla |
	bla := (GbtThing struct: #bla)
		define: #foo val: Date today asString;
		yourself.
	self should: [bla foo isString ]! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testEnumSelect
	| thing|
	thing := GbtThing struct: 'Thing' define: { 
		{#enum . #enum: . #(a b c '1.1' '2.2' '3.3') } .
		{#enum . #enumSelect: . #b} .
	} full: {}.

	self should: [(thing slotSVOAt: #enum) val = 'b' ].
	self should: [thing enum = 'b' ].
	
	thing define: #enum enumSelect: '3.3' .
	self should: [ thing enum  = '3.3' ]


! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testThingAspectEnrich
	| thing |
	thing := GbtThing struct: 'Thing' define: { 
		{#summary . 'In #city gibt es den #str'} .
		{#street . #val:tag: . 'Hofweg' . #str } .
		{#addressLocation . #val: . #bla} .
		{#city . #val: . 'Hamburg'} 
	} full: {  } .
	
	self should: [thing summaryEnriched = 'In Hamburg gibt es den Hofweg '  ]! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 2/22/2017 12:31'!
testWrongDate
	| bla |
	bla := (GbtThing new)
		define: #jan1st date: '1.1.2015';
		define: #today date: Date today;
		yourself.
	bla today: #Unsinn.
	self should: [ (bla slotSVOAt: #today) val = (Date fromString: '1000-01-01') asString ].! !

GbtTests subclass: #GbtTestCalc
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestCalc methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testCalc1
	|thing|
	thing := GbtThing struct: #thing define: {
			{#slot1 . #val: . '3' }.
			{#slot2 . #no: . 7 }.
			{#slot3 . #calc: . 'eval #slot1 + #slot2 + 10' }.
			{#slot4 . #calc: . '#slot1 * #slot2 - 1' }}.

	self should: [thing slot3 = '20'].
	self should: [thing slot4 = '20'].


! !

!GbtTestCalc methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testCalc2
	|thing|
	thing := GbtThing struct: #thing define: {
			{#slot1 . #val: . '3' }.
			{#slot2 . #no: . 7 }.
			{#slot3 . #calc: . '{ #slot1 . #slot2 . -5} sum' }.
			{#slot4 . #calc: . '{ #slot1 . 5 . #slot2 } average' }}.

	self should: [thing slot3 = '5'].
	self should: [thing slot4 = '5'].


! !

!GbtTestCalc methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testCalc3
	| bla |  
	bla := (GbtThing struct: #bla)
		define: #calculate calc: '( #abc + #foo2 ) * #foo3' ;
		define: #foo2 no: 13 ;
		define: #foo3 no: 5 ;
		define: #abc val: '74' ;
		yourself.
	self should: [ bla calculate  = '435' ].
! !

!GbtTestCalc methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testCalcE
	| t1 |
	t1 := (GbtThing struct: #bla)
		define: #calculate calc: '( #abc + #foo4 ) * #foo3';
		define: #foo2 no: 13;
		define: #foo3 no: 5;
		define: #abc val: '74';
		yourself.
	self should: [ t1 calculate = 'cannot eval: ( 74 + ''-'' ) * 5 '].
	^ self! !

!GbtTestCalc methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testCalcSlotError
	|thing|
	thing := GbtThing struct: #thing define: {
			{#slot1 . #val: . '3' }.
			{#slot2 . #no: . 7 }.
			{#slot3 . #calc: . 'eval #slot1 + #slota + 10' }}.

	self should: [thing slot3 = 'cannot eval: 3 + ''-'' + 10 '].


! !

!GbtTestCalc methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testCalcSlotProd
	|thing|
	thing := GbtThing struct: #thing define: {
			{#slot0 . #val:tag: . 'abc' . #tag}.
			{#slot1 . #val:tag: . '2' . #tag}.
			{#slot2 . #no:tag: . 3 . #tag}.
			{#slot3 . #calc: . 'prod #tag' }.
			{#tag . #no: . 4 }.
			}.

	self should: [thing slot3 = '24']! !

!GbtTestCalc methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testCalcSlotSum
	|thing|
	thing := GbtThing struct: #thing define: {
			{#slot0 . #val:tag: . 'abc' . #tag}.
			{#slot1 . #val:tag: . '3' . #tag}.
			{#slot2 . #no:tag: . 7 . #tag}.
			{#slot3 . #calc: . 'sum #tag' }.
			{#tag . #no: . 7 }.
			}.

	self should: [thing slot3 = '17']! !

!GbtTestCalc methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testOnNodeTree
	| bla bla1 |
	bla1 := GbtThing struct: #bla1 define: {
		{#foo2 . #no:tag: . 13 . #abc}.
		{#foo3 . #no:tag: . 5 . #abc} }.
	bla := GbtThing struct: #bla define: {
		{ #sum . #calc: . 'sum #abc' } .
		{#bla1 . #thing: . bla1} }.
	self should: [ bla sum = (13+5) asString ]! !

!GbtTestCalc methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testSumOnNodeTree
	| bla bla1 |
	bla1 := GbtThing struct: #bla1 define: {
		 {#foo2 . #no:tag: . 13 . #abc}.
		 {#foo3 . #no:tag: . 5 . #abc }}.
	bla := GbtThing struct: #bla define: {
		 {#sum . #calc: . 'sum #abc' }.
		 {#bla1 . #thing: . bla1 }}.
	self should: [ bla sum = (13+5) asString ]! !

!GbtTestCalc methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testSumOnNodeTreeWithUlist
	| bla templ |
	templ := (GbtThing struct: #templ)
		define: #foo no: 13 ; 
		yourself.
	bla := (GbtThing struct: #bla)
		define: #sum calc: 'sum #foo' ;
		define: #list1 listOf: templ ;
		yourself.
	self should: [ bla sum = '0' ].
	bla list1 newEntry .  
	self should: [ bla sum = '13' ].
	bla list1 newEntry .
	self should: [ bla sum  = (2*13) asString ]! !

!GbtTestCalc methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testSumWithRecursion
	| bla |
	bla := (GbtThing struct: #bla)
		define: #sum calc: 'sum #abc' tag: #def;
		define: #sum2 calc: 'sum #def' ;
		define: #foo2 no: 13 tag: #abc;
		define: #foo3 no: 5 tag: #abc;
		define: #def val: '74' ;
		yourself.
	self should: [ bla sum = (13+5) asString ].
	self should: [ bla sum2 = (13+5+74) asString ].
! !

GbtTests subclass: #GbtTestCalcLookup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestCalcLookup methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testLookupDown

	| bla1 bla2 bla3|
	bla3 := GbtThing struct: #bla3 define: {  
		{ #slot31 . #val: . #b }.
	}.
	bla2 := GbtThing struct: #bla2 define: {  
		{ #slot21 . #thing: . bla3 }. 
		{ #slot22 . #val: . #slot31 }	.
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #slot11 . #thing: . bla2 }.
		{ #slot12 . #val: . #slot11 }.
		{ #slot13 . #calc: . 'lookup #slot12 #slot22 ' }.
		{ #slot14 . #calc: . 'lookup #slot12  ' }.
		{ #slot15 . #calc: . 'lookup #slot22  ' }.
	}.
	self should: [bla1 slot14 = 'bla2:T11v0' ].
	self should: [bla1 slot15 = 'b' ].
	self should: [bla1 slot13 = 'b' ].
! !

!GbtTestCalcLookup methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testLookupError

	| bla1 bla2 bla3|
	bla3 := GbtThing struct: #bla3 define: {  
		{ #slot31 . #val: . #b }.
		{ #slot33 . #calc: . 'lookup #slot12 #slot22 ' }.
	}.
	bla2 := GbtThing struct: #bla2 define: {  
		{ #slot21 . #thing: . bla3 }. 
		{ #slot22 . #val: . #slot31 }	.
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #slot11 . #thing: . bla2 }.
		{ #slot12 . #val: . #slot11 }.
	}.
	self should: [bla1 slot33 = 'b' ].
! !

!GbtTestCalcLookup methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testLookupErrorNoPath
	"path does not exist"
	| bla1 bla2 bla3|
	bla3 := GbtThing struct: #bla3 define: {  
		{ #slot31 . #val: . #b }.
		{ #slot33 . #calc: . 'lookup #slot12 #slot12 ' }.
	}.
	bla2 := GbtThing struct: #bla2 define: {  
		{ #slot21 . #thing: . bla3 }. 
		{ #slot22 . #val: . #slot31 }	.
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #slot11 . #thing: . bla2 }.
		{ #slot12 . #val: . #slot11 }.
	}.
	self should: [bla1 slot33 = #nil ].
! !

!GbtTestCalcLookup methodsFor: 'tests' stamp: 'hk 3/25/2017 15:34'!
testLookupErrorThingButValue
	"no value found but thing "
	| bla1 bla2 bla3|
	bla3 := GbtThing struct: #bla3 define: {  
		{ #slot31 . #val: . #b }.
		{ #slot33 . #calc: . 'lookup #slot12 #slot11 ' }.
	}.
	bla2 := GbtThing struct: #bla2 define: {  
		{ #slot21 . #thing: . bla3 }. 
		{ #slot22 . #val: . #slot31 }	.
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #slot11 . #thing: . bla2 }.
		{ #slot12 . #val: . #slot11 }.
	}.
	self should: [bla1 slot33 = 'bla2:T13v0' ].
! !

!GbtTestCalcLookup methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testLookupUp

	| bla1 bla2 bla3|
	bla3 := GbtThing struct: #bla3 define: {  
		{ #slot31 . #val: . #b }.
		{ #slot33 . #calc: . 'lookup #slot12 #slot22 ' }.
	}.
	bla2 := GbtThing struct: #bla2 define: {  
		{ #slot21 . #thing: . bla3 }. 
		{ #slot22 . #val: . #slot31 }	.
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #slot11 . #thing: . bla2 }.
		{ #slot12 . #val: . #slot11 }.
	}.
	self should: [bla1 slot33 = 'b' ].
! !

!GbtTestCalcLookup methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testLookupUp2Local

	| bla1 bla2 bla3|
	bla3 := GbtThing struct: #bla3 define: {  
		{ #slot31 . #val: . #b }.
		{ #slot32 . #val: .  #slot31 }.
		{ #slot33 . #calc: . 'lookup #slot32 ' }.
		{ #slot36 . #calc: . 'lookup #slot13 ' }.
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #slot11 . #listOf: . bla3 }.
		{ #slot13 . #val: . #slot11 }.
	}.
	bla2 := bla1 slot11 newEntry.
	self should: [bla1 slot33 = 'b' ].
	self should: [bla2 slot33 = 'b' ].
	self should: [bla1 slot36 = #nil ].
	self should: [bla2 slot36 = #nil ].

! !

!GbtTestCalcLookup methodsFor: 'tests' stamp: 'hk 3/25/2017 15:34'!
testLookupUp2Root

	| bla1 bla2 bla3|
	bla3 := GbtThing struct: #bla3 define: {  
		{ #slot31 . #val: . #b }.
		{ #slot32 . #val: .  #slot31 }.
		{ #slot33 . #calc: . 'lookup #R #slot13 ' }.
		{ #slot34 . #calc: . 'lookup #R #slot12 ' }.
		{ #slot36 . #calc: . 'lookup #R #slot13 #slot32 ' }.
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #slot11 . #listOf: . bla3 }.
		{ #slot12 . #val: .  #slot31 }.
		{ #slot13 . #val: . #slot11 }.
		{ #slot31 . #val: . #a }.
	}.
	bla2 := bla1 slot11 newEntry.
	self should: [bla1 slot33 = 'Ulist:U12v0' ].
	self should: [bla1 slot34 = 'a' ].
	self should: [bla1 slot36 = #b ].
	self should: [bla2 slot36 = #b ].

! !

GbtTests subclass: #GbtTestCalcRef
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestCalcRef methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testRefDown

	| bla1 bla2 bla3|
	bla3 := GbtThing struct: #bla3 define: {  
		{ #xyz . #val: . #b }.
	}.
	bla2 := GbtThing struct: #bla2 define: {  
		{ #def . #thing: . bla3 }. 
		{ #ghi . #val: . #a }	.
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #ref1 . #calc: . 'ref #xyz' }.
		{ #ref2 . #calc: . 'ref #def:xyz' }.
		{ #ref3 . #calc: . 'ref #abc:xyz' }.
		{ #ref4 . #calc: . 'ref #abc:def:xyz' }.
		{ #abc . #thing: . bla2 }.
	}.
	self should: [bla1 ref1 = 'b' ].
	self should: [bla1 ref2 = 'b' ].
	self should: [bla1 ref3 = 'b' ].
	self should: [bla1 ref4 = 'b' ].
! !

!GbtTestCalcRef methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testRefError

	| bla1 bla2 bla3|
	bla3 := GbtThing struct: #bla3 define: {  
		{ #xyz . #val: . #b }.
	}.
	bla2 := GbtThing struct: #bla2 define: {  
		{ #def . #thing: . bla3 }. 
		{ #ghi . #val: . #a }	.
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #ref1 . #calc: . 'ref #ghi:xyz' }.
		{ #abc . #thing: . bla2 }.
	}.
	self should: [bla1 ref1 = 'b' ] raise: Error.
! !

!GbtTestCalcRef methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testRefUp1

	| bla1 bla2 bla3|
	bla3 := GbtThing struct: #bla3 define: {  
		{ #xyz . #val: . #b }.
		{ #ref1 . #calc: . 'ref #xyz' }.
		{ #ref2 . #calc: . 'ref #def:xyz' }.
		{ #ref3 . #calc: . 'ref #abc:def:xyz' }.
		{ #ref4 . #calc: . 'ref #abc:xyz '}.      "smartPath may be incomplete"
	}.
	bla2 := GbtThing struct: #bla2 define: {  
		{ #def . #thing: . bla3 }. 
		{ #ghi . #val: . #a }	.
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #abc . #thing: . bla2 }.
	}.
	self should: [bla1 ref1 = 'b' ].
	self should: [bla1 ref2 = 'b' ].
	self should: [bla1 ref3 = 'b' ].
	self should: [bla1 ref4 = 'b' ]! !

!GbtTestCalcRef methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testRefUp2
	"shall work from bottom too"
	| bla1 bla2 bla3|
	bla3 := GbtThing struct: #bla3 define: {  
		{ #xyz . #val: . #b }.
		{ #ref1 . #calc: . 'ref #xyz' }.
		{ #ref2 . #calc: . 'ref #def:xyz '}.
		{ #ref3 . #calc: . 'ref #abc:def:xyz '}.
		{ #ref4 . #calc: . 'ref #abc:xyz '}.      "smartPath may be incomplete"
	}.
	bla2 := GbtThing struct: #bla2 define: {  
		{ #def . #thing: . bla3 }. 
		{ #ghi . #val: . #a }	.
	}.	
	bla1 := GbtThing struct: #bla1 define: {  
		{ #abc . #thing: . bla2 }.
	}.   
	bla3 := bla1 def.  "see testThingContainers"
	self should: [bla3 ref1 = 'b' ].
	self should: [bla3 ref2 = 'b' ].
	self should: [bla3 ref3 = 'b' ].
	self should: [bla3 ref4 = 'b' ]! !

!GbtTestCalcRef methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testRefUp2Root
	"up reference across a list via #R for Root"
	| bla1 bla2 bla3|
	bla3 := GbtThing struct: #bla3 define: {  
		{ #xyz . #val: . #b }.
		{ #ref1 . #calc: . 'ref #R:xyz' }.
		{ #ref4 . #calc: . 'ref #R:abc:xyz' }.      
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #xyz . #val: . #a }.
		{ #abc . #listOf: . bla3 }.
	}.   
	bla2 := bla1 abc newEntry.  
	self should: [bla2 xyz = 'b' ].
	self should: [bla2 ref1 = 'a' ].
	self should: [bla2 ref4 = 'b' ].
	self should: [bla1 ref1 = 'a' ].
	self should: [bla1 ref4 = 'b' ]! !

!GbtTestCalcRef methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testRefUpLocal
	"local up reference does not cross a list"
	| bla1 bla2 bla3|
	bla3 := GbtThing struct: #bla3 define: {  
		{ #xyz . #val: . #b }.
		{ #ref1 . #calc: . 'ref #xyz ' }.
		{ #ref2 . #calc: . 'ref #xyz2 '}.
		{ #ref4 . #calc: . 'ref #abc:xyz ' }.      
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #xyz2 . #val: . #a }.
		{ #abc . #listOf: . bla3 }.
	}.   
	bla2 := bla1 abc newEntry.  
	self should: [bla1 ref1 = 'b' ].
	self should: [bla2 ref2 = #nil ].
	self should: [bla1 ref4 = #nil ]! !

GbtTests subclass: #GbtTestConstraints
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestConstraints methodsFor: 'helpers' stamp: 'hk 3/14/2017 13:01'!
aMasterThingWithConstraints 	
	^GbtThing struct: 'M' define: { 
		{ #slotX . #thing: . self aThingWithTrueConstraints }.
		{ #slotY . #thing: . self aThingWithFalseConstraints } .
		{ #slotZ . #val: . 'Crasemann' } .
		{ #constraintA . #constraint: . ' #slott1 = #slotf1' } .
		{ #constraintB . #constraint: . ' #slotZ = #slotf2' } .
		{ #constraintC . #constraint: . ' #slott2 = #slof2' } .
	}! !

!GbtTestConstraints methodsFor: 'helpers' stamp: 'hk 3/14/2017 13:01'!
aThingWithConstraintErrors 	
	^GbtThing struct: 'E' define: { 
		{ #slot1 . #val: . 'Krase'  }.
		{ #slot2 . #val: . 'Krase' } .
		{ #slot7 . #constraint: . ' #slot1 = #slot2' } .
		{ #slot8 . #constraint: . ' #slot2 - katze + #slot1' } .
	}! !

!GbtTestConstraints methodsFor: 'helpers' stamp: 'hk 3/14/2017 13:01'!
aThingWithFalseConstraints
	^GbtThing struct: 'F' define: { 
		{ #slotf1 . #val: . 'Krasemann'  }.
		{ #slotf2 . #val: . 'Crasemann' } .
		{ #slotf7 . #constraint: . ' #slotf1 = ''Krase'' ' } .
		{ #slotf8 . #constraint: . ' #slotf1 = #slotf2' } .
	}! !

!GbtTestConstraints methodsFor: 'helpers' stamp: 'hk 3/14/2017 13:01'!
aThingWithNumberConstraints 
	^GbtThing struct: 'N' define: { 
		{ #slotno7 . #no: . 7  }.
		{ #slotno13 . #no: . 13 } .
		{ #slotf7 . #constraint: . ' #slotno7 = #slotno13' } .
		{ #slott8 . #constraint: . ' #slotno7 > ''6'' ' } .
	}! !

!GbtTestConstraints methodsFor: 'helpers' stamp: 'hk 3/14/2017 13:01'!
aThingWithTrueConstraints 
	"GbtTestConstraints new aThingWithConstraint"
	
	^GbtThing struct: 'T' define: { 
		{ #slott1 . #val: . 'Krasemann'  }.
		{ #slott2 . #val: . 'Krasemann' } .
		{ #slott7 . #constraint: . ' #slott1 = #slott2' } .
		{ #slott8 . #constraint: . ' ''Krasemann'' = #slott1' } .
	}! !

!GbtTestConstraints methodsFor: 'tests' stamp: 'hk 2/10/2017 21:39'!
testConstraintErrors
	| bla |  
	bla := self aThingWithConstraintErrors .
	self should: [bla slot7 = #true ]. 
	self should: [ bla checkConstraints isNil].
	self should: [ bla slot8  = 'cannot eval: ''Krase'' - katze + ''Krase'' '].! !

!GbtTestConstraints methodsFor: 'tests' stamp: 'hk 8/17/2016 21:42'!
testConstraintsInHierarchy
	| bla |  
	bla := self aMasterThingWithConstraints .
	self should: [bla constraintA = #true].
	self should: [bla constraintB = #true].
	self should: [bla constraintC = #false]! !

!GbtTestConstraints methodsFor: 'tests' stamp: 'hk 2/17/2017 15:50'!
testFalseConstraints
	| bla |  
	bla := self aThingWithFalseConstraints .
	self should: [ bla slotf7 = 'false'].
	self should: [ bla slotf1 = 'Krasemann'].
	self should: [ bla slotf2 = 'Crasemann'].
	self should: [ (bla slotSVOAt: #slotf8) val = #false].
	bla checkConstraints .
	self should: [ bla isConsistent not].
	self should: [ bla constraintViolationString  = 'violated:
 #slotf1 = ''Krase'' 
 #slotf1 = #slotf2']! !

!GbtTestConstraints methodsFor: 'tests' stamp: 'hk 8/17/2016 21:34'!
testNumberConstraints
	| bla |  
	bla := self aThingWithNumberConstraints .
	self should: [bla slotf7 = #false].
	self should: [bla slott8 = #true].
	bla checkConstraints .
	self should: [bla isConsistent not]! !

!GbtTestConstraints methodsFor: 'tests' stamp: 'hk 2/17/2017 15:50'!
testTrueConstraints
	| bla |  
	bla := self aThingWithTrueConstraints .
	self should: [bla slott7 = #true].
	self should: [(bla slotSVOAt: #slott8) val = #true].
	self should: [bla checkConstraints]! !

GbtTests subclass: #GbtTestCopying
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 3/30/2017 12:58'!
testCopyBasics
	| bla blabla | 
	"erzeuge smart + full thing !!"
	bla := GbtThing struct: #bla define: {{#zip . #val: . #private}}.  
	"kopiere smart thing"
	blabla := bla copy.
	self shouldnt: [ bla == blabla ].
	self should: [ bla id asNumber + 1 = blabla id asNumber].	
	blabla zip: #new.
	self should: [ blabla zip = #new ].
	self should: [ bla zip = #private ].
! !

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 3/25/2017 15:26'!
testCopyCalcSlots
	"test the evolve copy semantics on a calc slot"
	| bla bla1 bla2 |  
	bla := (GbtThing struct: #bla)
		define: #calculate calc: '( #abc + #foo2 ) * #foo3' ;
		define: #foo2 no: 13 ;
		define: #foo3 no: 5 ;
		define: #abc val: '74' ;
		yourself.
	bla1 := bla copy.
	bla2 := bla1 copy.
	bla1 foo2: 6.
	bla1 foo3: 3.
	bla2 foo2: 1.
	bla2 foo3: 1.
	self should: [ bla calculate  = '435' ].
	self should: [ bla1 calculate  = '240' ].
	self should: [ bla2 calculate  = '75' ].

! !

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testCopyFreezeHierarchy
	| bla blabla blaSub|
	blaSub := GbtThing struct: #blaSub define: {
		{#slot1 . #val:tag: . '7' . #sum}.
		{#slot2 . #val:tag: . '8' . #sum}.
		{#slot4 . #calc: . '#slot1 + #slot2'}.
		{#slot5 . #calc: .'sum #sum'}.
		{#slot6 . #calc: . 'prod #sum'}.
		{#slot7 . #calc: . 'ref  #slot1'}.
		{#slot8 . #calc: . 'lookup #slot2'}.
	}.
	bla := GbtThing struct: #bla define: {
		{#slot3 . #thing: . blaSub} 
	}.
	blabla := bla copyFreeze.
	self should: [ blabla slot4 = '15' ].
	self should: [ blabla slot5 = '15' ].
	self should: [ blabla slot6 = '56' ].
	self should: [ blabla slot7 = '7' ].
	self shouldnt: [ (blabla slot3 slotSVOAt: #slot4) isCalc].
	self shouldnt: [ (blabla slot3 slotSVOAt: #slot5) isCalc].
	self shouldnt: [ (blabla slot3 slotSVOAt: #slot6) isCalc].
	self shouldnt: [ (blabla slot3 slotSVOAt: #slot7) isCalc].
	self shouldnt: [ (blabla slot3 slotSVOAt: #slot8) isCalc].
! !

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testCopyFreezeSlots
	| bla blabla |
	bla := GbtThing struct: #bla define: {
		{#slot1 . #val:tag: . '7' . #sum}.
		{#slot2 . #val:tag: . '8' . #sum}.
		{#slot3 . #val: . #slot1}.
		{#slot4 . #calc: . '#slot1 + #slot2'}.
		{#slot5 . #calc: .'sum #sum'}.
		{#slot6 . #calc: . 'prod #sum'}.
		{#slot7 . #calc: . 'ref  #slot1'}.
		{#slot8 . #calc: . 'lookup #slot3'}.
		}.
	blabla := bla copyFreeze.
	self should: [ blabla slot1 = '7' ].
	self should: [ blabla slot2 = '8' ].
	self should: [ blabla slot3 = 'slot1' ].
	self should: [ blabla slot4 = '15' ].
	self should: [ blabla slot5 = '15' ].
	self should: [ blabla slot6 = '56' ].
	self should: [ blabla slot7 = '7' ].
	self should: [ blabla slot8 = '7' ].
	self shouldnt: [ (blabla slotSVOAt: #slot1) isCalc].
	self shouldnt: [ (blabla slotSVOAt: #slot2) isCalc].
	self shouldnt: [ (blabla slotSVOAt: #slot3) isCalc].
	self should: [ (bla slotSVOAt: #slot4) isCalc].
	self should: [ (bla slotSVOAt: #slot5) isCalc].
	self should: [ (bla slotSVOAt: #slot6) isCalc].
	self should: [ (bla slotSVOAt: #slot7) isCalc].
	self should: [ (bla slotSVOAt: #slot8) isCalc].
	self shouldnt: [ (blabla slotSVOAt: #slot4) isCalc].
	self shouldnt: [ (blabla slotSVOAt: #slot5) isCalc].
	self shouldnt: [ (blabla slotSVOAt: #slot6) isCalc].
	self shouldnt: [ (blabla slotSVOAt: #slot7) isCalc].
	self shouldnt: [ (blabla slotSVOAt: #slot8) isCalc].
! !

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testCopySlotAssocs
	| foo bar foo2|
	bar := GbtThing struct: 'bar' define: {{#val . #val: . 'bar'}} .
	foo := GbtThing struct: #foo define: {
		{#val . #val: . 'foo'}.
		{#thing . #thing: . bar}.
	 }.
	foo2 := foo copy.
	self should: [ (foo2 slots first) isKindOf: GbtSlotAssociation ].
	self should: [ (foo2 slots second) isKindOf: GbtSlotAssociation ].
	self should: [ ((foo2 slotSVOAt: #thing) slots first) isKindOf: GbtSlotAssociation ].
! !

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testCopySlotTag
	| foo bla |
	foo := GbtThing struct: #foo define: {{#zag . #val:tag: . #priv . #blabla}} .
	bla := foo copy.
	self should: [ bla slots anyOne hasTag: #blabla ]! !

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testCopySlots
	"test the evolve copy semantics on a sample of slots"
	| foo foo2 |
	foo := (GbtThing struct: #foo)
		define: #zag val: 'private';
		define: #enum enum: #(#a #b);
		yourself.
	foo2 := foo copy.	"so far no slots have changed"
	self should: [ (foo2 slotAt: #zag) isKindOf: GbtSlotAssociation ].
	self should: [ (foo2 slotSVOAt: #zag) == (foo slotSVOAt: #zag) ].
	self should: [ foo2 zag == foo zag ].
	self should: [ foo2 enum == foo enum ].
	
	foo2 zag: #changed.
	foo2 enum: #b.
	self shouldnt: [ (foo2 slotSVOAt: #zag) == (foo slotSVOAt: #zag) ].
	self should: [ foo zag = #private ].
	self should: [ foo2 zag = #changed ].
	self shouldnt: [ (foo2 slotSVOAt: #enum) == (foo slotSVOAt: #enum) ].
	self should: [ foo enum = #a ].
	self should: [ foo2 enum = #b ]! !

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testCopySlotsInHierarchy
	"test the evolve copy semantics"
	| foo foo2 email |
	email := GbtThing struct: 'GCemail' define: {{#val1 . #val: . 'bla'}} .
	foo := (GbtThing struct: #foo)
		define: #email thing: email;
		yourself.
		
	foo2 := foo copy.	"so far no slots have changed but nodes"
	self should: [ (foo2 slotAt: #email) isKindOf: GbtSlotAssociation ].
	self should: [ (foo2 email slotAt: #val1) isKindOf: GbtSlotAssociation ].
	self shouldnt: [ foo2 email == foo email ].
	self should: [ foo2 val1 == foo val1 ].
		
	foo2 val1: #blau.
	self should: [ foo2 val1 = #blau ].
	self should: [ foo val1 = #bla ]! !

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testCopyText
	| foo foo2 th |
	th := GbtThing struct: 'GCth' define: {{#note . #text: . ''}}.
	(foo := th copy) note: 'bla'.
	(foo2 := foo copy) note: 'blabla'.
	self should: [ th note = '' ].
	self should: [ foo note = 'bla' ].
	self should: [ foo2 note = 'blabla']! !

GbtTests subclass: #GbtTestCreation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestCreation methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testDefineDeclarative
	| bla bla1  |
	bla := GbtDeclarative struct: 'GCView' define: { 
		{'street' . #tag: . #strasse} .
		{#city}} .
	bla1 := GbtDeclarative struct: 'GCView'.		"same"
		
	self should: [ bla = bla1  ].
! !

!GbtTestCreation methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testNoDoubleUseOfThings
	| bla  thing |
	bla := GbtThing struct: 'GCAddressLocation' define: { 
		{#street . #val: . 'Astrasse'}
	} full: {  } .
	thing := GbtThing struct: 'GCAddress' define: {  
		{#addressLocation . #thing: . bla} }.
"	self should: [(GbtThing typed: 'GCAddress') define: #addr thing: bla ]
		  raise: Error description: 'cant be double used in GCAddress' "! !

!GbtTestCreation methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testSlotAssocs
	| foo bar|
	bar := GbtThing struct: #bar define: { 
		{ #s1 . #val: . #bar }}.
	foo := GbtThing struct: #foo define: { 
		{ #s1 . #val: . #bar1 }.
		{ #s2 . #val: . 'bar2' }.
		{ #s3 . #thing: . bar }.
		{ #s4 . #thing: . bar copy }.
	}.	
		
	self should: [ foo leafs size = 2 ]. 	
	"alas - not a GbtSlotAssiciation"
	self should: [ (foo slotSVOAt: #s1) isValue ].
	self should: [ foo subnodes size = 2 ].
	self should: [ foo allLeafSVOs size = 4 ].
! !

!GbtTestCreation methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testSlotContainers
	| foo |
	foo := GbtThing struct: #foo define: { 
		{ #s1 . #val: . #bar }.
		{ #s2 . #calc: . 'sum  #xyz' }.
		{ #s3 . #calc: . '6 * 7' }.
		{ #s4 . #enum: . #(aa bb cc) }.
		{ #s5 . #calc: . 'ref  #abc:xyz' }.     
	}.	
		
	self should: [ (foo slotSVOAt: #s1) container = foo ].
	self should: [ (foo slotSVOAt: #s2) container = foo ].
	self should: [ (foo slotSVOAt: #s3) container = foo ].
	self should: [ (foo slotSVOAt: #s4) container = foo ].
	self should: [ (foo slotSVOAt: #s5) container = foo ].
! !

!GbtTestCreation methodsFor: 'tests' stamp: 'hk 3/25/2017 15:34'!
testThingContainers
	"	{Full, original, copies ... }
	bla3 			T2 		T1 		T3 		T7 		T12
		container					|	 	|		|
	bla2 					T5 		T4 		T6 		T11 	
		container							|		|				
	bla1							T9 		T8 		T10
	"
	| bla1 bla2 bla3 bla2c bla3c |
	bla3 := GbtThing struct: #bla3 define: {  "T3"
		{ #xyz . #val: . #b }.
		{ #ref1 . #calc: . 'ref #xyz' }.
		{ #ref2 . #calc: . 'ref #def:xyz' }.
		{ #ref3 . #calc: . 'ref #abc:def:xyz '}.
		{ #ref4 . #calc: . 'ref #abc:xyz' }.      "smartPath may be incomplete"
	}.	
	bla2 := GbtThing struct: #bla2 define: {  "T6"
		{ #def . #thing: . bla3 }. 
		{ #ghi . #val: . #a }	.
	}.	
	bla1 := GbtThing struct: #bla1 define: {  "T10"
		{ #abc . #thing: . bla2 }.
	}. 
	bla2c := bla1 abc. 	"T11"
	bla3c := bla2c def. 	"T12"
		
	self should: [ bla3c container = bla2c ].
	self should: [ bla2c container = bla1 ].
	
	self should: [ bla2 container autoName = #T16v0].
	self should: [ bla3 container autoName = #T8v0].! !

!GbtTestCreation methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testThingNewOfTypeDefine
	| bla bla1 thing |
	bla := GbtThing struct: 'GCAddressLocation' define: { 
		{#street . #val: . 'Astrasse'}
	} full: {  }.
	bla1 := GbtThing struct: 'GCAddressLocation'.	"copy master exists"
	thing := GbtThing struct: 'GCAddress' define: {  
		{#addressLocation . #thing: . bla} .
		{#anotherAddressLocation . #thing: . bla1} . 
		{#cityName . #val: . '<city name>'} 
	} full: {  } .  
	thing anotherAddressLocation street: 'Bstrasse' .	
		
	self shouldnt: [ bla == bla1 ].
	self should: [ bla fullThing = bla1 fullThing ].	
	self should: [thing addressLocation street = 'Astrasse' ].
	self should: [thing anotherAddressLocation street = 'Bstrasse' ] . 
! !

!GbtTestCreation methodsFor: 'tests' stamp: 'hk 3/22/2017 13:14'!
testVONamedAccessThings
	| original |
	original := GbtThing struct: #original .
	GbtPlainAC struct: 'PlainContext' define: {{#vo: . original}}.
	self should: [ original longName = 'original:T3v0'] .
	self should: [ original version = 0 ] .
	original store .
	original store .
	original store .
	original store .
	self should: [ original longName  = 'original:T3v4' ] .
	self should: [ original version = 4 ] ! !

GbtTests subclass: #GbtTestDeclaratives
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestDeclaratives methodsFor: 'authoring access' stamp: 'hk 3/14/2017 13:01'!
address 

	^GbtThing struct: 'Address' define: {  
		{ #street . #val:tag: . 'street' . #foo1}.
		{ #zip . #val: . '9999'}.
		{ #city . #val:tag: . 'city' . #foo2 }}! !

!GbtTestDeclaratives methodsFor: 'authoring access' stamp: 'hk 3/14/2017 13:01'!
contact 

	^GbtThing struct: 'Contact' define: { 
		{ #nname . #val:tag: . 'Krasemann' . #foo8 }.
		{ #adr . #thing:tag: . self address . #foo7}.
		{ #vname . #val: . 'Hartmut'}}! !

!GbtTestDeclaratives methodsFor: 'authoring access' stamp: 'hk 3/14/2017 13:01'!
customerDecl
		
	^GbtDeclarative struct: 'Customer' define: {  
		{ #vorname . #tag: . #vname}.
		{ #nachname . #tag: . #nname}.
		{ #strasse . #tag: . #street}.
		{ #adresse . #tag: . #foo7}}.
! !

!GbtTestDeclaratives methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testCombinatorHierarchy
	| contact subView addrView thing |
	contact := GbtThing struct: 'Contact' define:  {
		{ #stadt . #val: . 'myCity'}.
		{ #strasse . #val: . 'myStrasse'}.
		{ #firma . #val: . 'myFirma'}} .
	subView := GbtDeclarative struct: 'SubDecl' define: { 
		{#street . #tag: . #strasse} .
		{#city . #tag: . #stadt}}.
	addrView := GbtDeclarative struct: 'Decl' define: { 
		{#company . #tag: . #firma }.
		{#sub . #decl: . subView} }.

	thing := addrView copyWithSource: contact.

	self should: [ thing company = 'myFirma' ].
	self should: [ thing sub isNode ].
	self should: [ thing city = 'myCity' ].
	self should: [ thing street = 'myStrasse' ]! !

!GbtTestDeclaratives methodsFor: 'tests' stamp: 'hk 10/11/2016 16:37'!
testCreate
	"create a new structure"
	
	| th |
	th := (self customerDecl sources: { self address . self contact }) copySources.

	self should: [ th svoName = #Customer ].
	self should: [ th fullThing svoName = 'FCustomer' ].
	
	self should: [ th vorname = #Hartmut ].
	self should: [ th nachname = #Krasemann ].
	self should: [ th strasse = #street ].
	self shouldnt: [ th adresse id = self address id ].
	self should: [ th adresse = self address ].
! !

!GbtTestDeclaratives methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testCreate2nd
	"copy into existing structure and add new one"
	
	| th1 th2 |
	th1 := GbtThing struct: 'Customer' define: {  
		{ #vorname . #val: . #Karl}.
		{ #zweitname . #val: . #Wilhelm}.
		{ #nachname . #val: . #Heinz}.
		{ #strasse . #val: . #foo}}.
	self customerDecl.	"creates Declarative #Customer"
	th2 := ((GbtDeclarative definedAs: #Customer) 
					sources: { self contact }) 
							copySources.
	self should: [ th1 nachname = #Heinz ].
	self should: [ th1 vorname = #Karl ].

	self should: [ th2 nachname = #Krasemann ].
	self should: [ th2 vorname = #Hartmut ].
	self should: [ th2 zweitname = #Wilhelm ].
	self should: [ (th2 slotSVOAt: #strasse) val = #street ].	
	self should: [ th2 slots size = 5 ].
	self should: [ th2 adresse street = #street ]. 		"neu"
	self should: [ th2 adresse slots size = 3 ].
! !

!GbtTestDeclaratives methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testCreateHierarchy
	"copy a structure into existing things with new structure"
	
	| father subView view thing son |
	father := GbtThing struct: 'Father' define:  {
		{ #company . #val: . 'firma' }.
		{ #chef . #val: . 'person'}} .
	son := GbtThing struct: 'Son' define:  {
		{ #plz . #val: . '1234'}} .
	subView := GbtDeclarative struct: 'Son' define: { 
		{#street } .
		{#city }}.
	view := GbtDeclarative struct: 'Father' define: { 
		{#chef . #tag: . #nname }.
		{#adresse . #decl: . subView} }.
		
	thing := view copyWithSource: self contact.

	self should: [ thing slots size = 3 ].
	self should: [ thing svoName  = #Father ].
	self should: [ thing company = #firma ].
	self should: [ thing chef = #Krasemann ].
	self should: [ thing adresse slots size = 3 ].
	self should: [ thing street = #street ].
	self should: [ thing city = #city ].
	self should: [ thing plz = '1234' ].
! !

!GbtTestDeclaratives methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testCreatePublic
	| contact subView addrView thing |
	contact := GbtThing struct: 'Contact' define:  {
		{ #stadt . #val:private: . 'myCity' . true}.
		{ #strasse . #val: . 'myStrasse'}.
		{ #firma . #val:private: . 'myFirma' . true}} .
	subView := GbtDeclarative struct: 'SubDecl' define: { 
		{#street . #tag: . #strasse} .
		{#city . #tag: . #stadt}}.
	addrView := GbtDeclarative struct: 'Decl' define: { 
		{#company . #tag: . #firma }.
		{#sub . #decl: . subView} }.
		
	thing := addrView copyWithSource: contact.

	self should: [ thing svoName  = #Decl ].
	self should: [ thing fullThing svoName = #FDecl].

	self should: [ thing street  = 'myStrasse' ].
	self should: [ (thing sub slotSVOAt: #city ) = nil ].
	self should: [ (thing slotSVOAt: #company ) = nil ].
! !

!GbtTestDeclaratives methodsFor: 'tests' stamp: 'hk 3/22/2017 13:15'!
testFilterBigList
	| filter ctxt constraint1 constraint2 |
	ctxt := GbtBigListAC 	struct: 'Rolodex' define:
			{{#templates:. (self contact)}}.
	ctxt newEntry: (self contact vname: #a; nname: #A; yourself).
	ctxt newEntry: (self contact vname: #b; nname: #A; yourself).
	ctxt newEntry: (self contact vname: #a; nname: #B; yourself).
	ctxt newEntry: (self contact vname: #b; nname: #B; yourself).
	
	filter := GbtDeclarative struct: 'Filter' define: {{#nname}}.
	constraint1 := GbtThing struct: 'Constraint1' define:
		{{#constr1. #constraint:. '#vname = ''a'' '}.
		{#constr2. #constraint:. '#nname = ''A'' '}}.
	constraint2 := GbtThing struct: 'Constraint2' define:
		{{#constr1. #constraint:. '#nname = ''B'' '}}.
		
	self should: [ (GbtService list: ctxt list filteredBy: constraint1 transformedWith: filter) size = 1 ].
	self should: [ (GbtService list: ctxt list filteredBy: constraint2 transformedWith: filter) size = 2 ].
	self should: [ (GbtService list: ctxt list filteredBy: constraint2 transformedWith: filter) first slots size = 1 ]! !

!GbtTestDeclaratives methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testFilterError
	
	|  filter |
	filter := GbtThing struct: 'Filter' define: {  
		{ #constr3 . #constraint: . '#city = 3/0 '}.
	}.
	self should: [ (self contact testWith: filter) = nil].

! !

!GbtTestDeclaratives methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testFilterMismatch
	
	|  filter |
	filter := GbtThing struct: 'Filter' define: {  
		{ #constr1 . #constraint: . '#vname = #nname '}.
	}.
	self should: [ (self contact testWith: filter) = false].

! !

!GbtTestDeclaratives methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testFilterRepeated
	
	| contact filter |
	filter := GbtThing struct: 'Filter' define: {  
		{ #constr1 . #constraint: . '#vname = ''Hartmut'' '}.
		{ #constr2 . #constraint: . '#nname = ''Krasemann'' '}.
		{ #constr3 . #constraint: . '#city = #vname '}.
	}.
	contact := self contact.
	self should: [ (contact testWith: filter) = false].
	contact city: #Hartmut.
	self should: [ (contact testWith: filter) = true].

! !

!GbtTestDeclaratives methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testFilterSimple
	
	| filter |
	filter := GbtThing struct: 'Filter' define: {  
		{ #constr1 . #constraint: . '#vname = ''Hartmut'' '}.
		{ #constr2 . #constraint: . '#nname = ''Krasemann'' '}.
	}.
	self should: [ (self contact testWith: filter) = true]
! !

!GbtTestDeclaratives methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testFullThingCreation
	| contact subView addrView thing |
	contact := GbtThing struct: 'Contact' define:  {
		{ #stadt . #val:tag: . 'myCity' . #tag1 }.
		{ #strasse . #val: . 'myStrasse'}.
		{ #firma . #val: . 'myFirma'}} .
	subView := GbtDeclarative struct: 'SubDecl' define: { 
		{#street . #tag: . #strasse} .
		{#city . #tag: . #stadt}}.
	addrView := GbtDeclarative struct: 'Decl' define: { 
		{#company . #tag: . #firma }.
		{#sub . #decl: . subView} }.
		
	thing := addrView copyWithSource: contact.

	self should: [ thing svoName  = #Decl ].
	self should: [ thing fullThing svoName  = #FDecl ].

	self should: [ thing slots size = 2 ].
	self should: [ thing sub slots size = 2 ].

	self should: [ thing fullThing slots size = 0 ]! !

!GbtTestDeclaratives methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testListTransformation
	"feld1 	feld2 					  			  num1 	  num2
		4 			6 			--SubDecl->			4 			6
	 	2 			3 									2 			3"
					
	| listElem subDecl decl thing listCont sumThing |
	listElem := GbtThing struct: 'ListElem' define:  {
		{ #feld1 . #no: . 0 }.
		{ #feld2 . #no: . 0  }.
	} .
	listCont := GbtThing struct: 'ListCont' define:  {
		{ #list . #listOf: . listElem}.
	} .
	listCont list newEntry: (listElem copy feld1: 4; feld2: 6; yourself).
	listCont list newEntry: (listElem copy feld1: 2; feld2: 3; yourself).

	sumThing := GbtThing struct: 'SumThing' define:  {
		{ #calc1 . #calc: . 'sum  #num1'}.
		{ #calc2 . #calc: . 'sum  #num2'}.
	} .
	subDecl := GbtDeclarative struct: #SubDecl define: {
		{ #num1 . #tag: . #feld1}.
		{ #num2 . #tag: . #feld2}}.
	decl := GbtDeclarative struct: #anonymous define: {
		{ #summe1 . #tag: . #calc1}.
		{ #summe2 . #tag: . #calc2}.
		{ #liste . #list: . {#list . subDecl}}}.
 
	thing := (decl sources: sumThing) copyWithSource: listCont.  
 
	self should: [ thing summe1  = '6' ].
	self should: [ thing summe2  = '9']! !

GbtTests subclass: #GbtTestDeclarativesAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestDeclarativesAccess methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testDefaultMultiTargetAccess
	| contact address newView |
	address := (GbtThing struct: 'GCAddress')
		define: #street val: 'street';
		define: #zip val: '9999';
		define: #city val: 'city'.
	contact := (GbtThing struct: 'GCContact')
		define: #nname val: 'Krase';
		define: #adr thing: address;
		define: #vname val: 'Hartmut'.
	newView := GbtDeclarative struct: #Decl define: {
		{ #stadt . #tag: . #city}. 
		{ #nachname . #tag: . #nname}}.
	newView
		sources: {contact . address}.
	self should: [ newView nachname = 'Krase' ].	"do the references work?"
	self should: [ newView stadt = 'city' ].	"do the references work?"
	newView stadt: 'Hamburg'.	"original slots changed"
	newView nachname: 'Bonn'.	"to prove the copy"
	self should: [ newView stadt = 'Hamburg' ].	"copied slots are not changed"
	self should: [ newView nachname = 'Bonn' ]! !

!GbtTestDeclarativesAccess methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testDefaultTagsSimple
	| tmp1 tmp2 tmp3 |
	tmp1 := GbtThing
		struct: 'GCAddress'
		define:
			{{#street . #val: . 'street'}.
			{#zip . #val: . '9999'}.
			{#city . #val: . 'city'}}.
	tmp3 := GbtDeclarative
		struct: 'AdrComb'
		define:
			{{#Postleitzahl . #tag: . #zip}.
			{#Straße . #tag: . #street}.
			{#Stadt . #tag: . #city}}.
	tmp2 := tmp3 copyWithSource: tmp1.
	self
		should: [ (tmp2 slotSVOAt: #Postleitzahl) val = '9999' ];
		should: [ (tmp2 slotSVOAt: #Stadt) val = 'city' ];
		should: [ (tmp2 slotSVOAt: #Straße) val = 'street' ]! !

!GbtTestDeclarativesAccess methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testDefaultTagsVOstructure
	| tmp1 tmp2 tmp3 tmp4 |
	tmp2 := GbtThing
		struct: 'GCAddress'
		define:
			{{#street . #val: . 'street'}.
			{#zip . #val: . '9999'}.
			{#city . #val: . 'city'}}.
	tmp1 := GbtThing
		struct: 'GCContact'
		define:
			{{#nname . #val: . 'Krase'}.
			{#adr.
			#thing:.
			tmp2}.
			{#vname . #val: . 'Hartmut'}}.
	tmp4 := GbtDeclarative
		struct: 'AdrComb'
		define:
			{{#vorname . #tag: . #vname}.
			{#nachname . #tag: . #nname}.
			{#Straße . #tag: . #street}.
			{#Stadt . #tag: . #city}}.
	tmp3 := tmp4 copyWithSource: tmp1.
	self
		should: [ (tmp3 slotSVOAt: #vorname) val = 'Hartmut' ];
		should: [ (tmp3 slotSVOAt: #nachname) val = 'Krase' ];
		should: [ (tmp3 slotSVOAt: #Stadt) val = 'city' ];
		should: [ (tmp3 slotSVOAt: #Straße) val = 'street' ]! !

!GbtTestDeclarativesAccess methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testMultiTargetAccess
	| contact address newView |
	address := (GbtThing struct: 'GCAddress')
		define: #street val: 'street' tag: #foo1;
		define: #zip val: '9999' tag: #foo2;
		define: #city val: 'city' tag: #foo3.
	contact := (GbtThing struct: 'GCContact')
		define: #nname val: 'Krase' tag: #foo9;
		define: #adr thing: address tag: #foo7;
		define: #vname val: 'Hartmut' tag: #foo8.
	newView := GbtDeclarative struct: #Decl define: {
		{ #stadt . #tag: . #foo3}. 
		{ #nachname . #tag: . #foo9}}.
	newView sources: {contact . address}.
	self should: [ newView nachname = 'Krase' ].	"do the references work?"
	self should: [ newView stadt = 'city' ].	"do the references work?"
	newView stadt: 'Hamburg'.	"original slots changed"
	newView nachname: 'Bonn'.	"to prove the copy"
	self should: [ newView stadt = 'Hamburg' ].	"copied slots are not changed"
	self should: [ newView nachname = 'Bonn' ]! !

!GbtTestDeclarativesAccess methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testTagsBasic
	| bla  |
	bla := GbtDeclarative struct: 'GCView' define: { 
		{'street' . #tag: . #strasse} .
		{#city}} .
	self should: [ (bla slotAt: #city) = #city ].
	self should: [ (bla slotAt: #street) = #strasse ]! !

!GbtTestDeclarativesAccess methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testTagsSimple
	| tmp1 tmp2 tmp3 |
	tmp1 := GbtThing
		struct: 'GCAddress'
		define:
			{{#street . #val:tag: . 'street' . #foo1}.
			{#zip . #val:tag: . '9999' . #foo2}.
			{#city . #val:tag: . 'city' . #foo3}}.
	tmp3 := GbtDeclarative
		struct: 'AdrComb'
		define:
			{{#Postleitzahl . #tag: . #foo2}.
			{#Straße . #tag: . #foo1}.
			{#Stadt . #tag: . #foo3}}.
	tmp2 := tmp3 copyWithSource: tmp1.
	self
		should: [ (tmp2 slotSVOAt: #Postleitzahl) val = '9999' ];
		should: [ (tmp2 slotSVOAt: #Stadt) val = 'city' ];
		should: [ (tmp2 slotSVOAt: #Straße) val = 'street' ]! !

!GbtTestDeclarativesAccess methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testTagsVOnodes
	| contact address myAddr adrComb |
	address := GbtThing struct: 'GCAddress' define: {
		{ #street . #val: . 'street'}.
		{ #zip . #val: . '9999'}.
		{ #city . #val: . 'city'}}.
	contact := GbtThing struct: 'GCContact' define: {
		{ #nname . #val:tag: . 'Krase' . #foo9} .
		{ #adr . #thing:tag: . address . #foo7 }.
		{ #vname . #val:tag: . 'Hartmut' . #foo8 }}.
	adrComb := GbtDeclarative struct: 'AdrComb' define: {
		{ #vorname . #tag: . #foo8 }.
		{ #name . #tag: . #foo9 }.
		{ #adresse . #tag: . #foo7 }}.
	myAddr := adrComb copyWithSource: contact.
	self should: [ (myAddr slotSVOAt: #vorname) val = 'Hartmut' ].
	self should: [ (myAddr slotSVOAt: #name) val = 'Krase' ].
	self should: [ ((myAddr slotSVOAt: #adresse) slotSVOAt: #city) val = 'city' ].
	self should: [ ((myAddr slotSVOAt: #adresse) slotSVOAt: #street) val = 'street' ] ! !

!GbtTestDeclarativesAccess methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testTagsVOstructure
	| tmp1 tmp2 tmp3 tmp4 |
	tmp2 := GbtThing
		struct: 'GCAddress'
		define:
			{{#street . #val:tag: . 'street' . #foo1}.
			{#zip . #val: . '9999'}.
			{#city . #val:tag: . 'city' . #foo3}}.
	tmp1 := GbtThing
		struct: 'GCContact'
		define:
			{{#nname . #val:tag: . 'Krase' . #foo9}.
			{#adr.
			#thing:.
			tmp2}.
			{#vname . #val:tag: . 'Hartmut' . #foo8}}.
	tmp4 := GbtDeclarative
		struct: 'AdrComb'
		define:
			{{#vorname . #tag: . #foo8}.
			{#nachname . #tag: . #foo9}.
			{#Straße . #tag: . #foo1}.
			{#Stadt . #tag: . #foo3}}.
	tmp3 := tmp4 copyWithSource: tmp1.
	self
		should: [ (tmp3 slotSVOAt: #vorname) val = 'Hartmut' ];
		should: [ (tmp3 slotSVOAt: #nachname) val = 'Krase' ];
		should: [ (tmp3 slotSVOAt: #Stadt) val = 'city' ];
		should: [ (tmp3 slotSVOAt: #Straße) val = 'street' ]! !

!GbtTestDeclarativesAccess methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testTagsVOstructureError
	| tmp1 tmp2 tmp3 tmp4 |
	tmp2 := GbtThing
		struct: 'GCAddress'
		define:
			{{#street . #val:tag: . 'street' . #foo1}.
			{#zip . #val: . '9999'}.
			{#city . #val:tag: . 'city' . #foo3}}.
	tmp1 := GbtThing
		struct: 'GCContact'
		define:
			{{#nname . #val:tag: . 'Krase' . #foo9}.
			{#adr.
			#thing:.
			tmp2}.
			{#vname . #val:tag: . 'Hartmut' . #foo8}}.
	tmp4 := GbtDeclarative
		struct: 'AdrComb'
		define:
			{{#vorname . #tag: . #foo8}.
			{#nachname . #tag: . #foo9}.
			{#Straße . #tag: . #foo1}.
			{#Stadt . #tag: . #foo3}}.
	tmp3 := tmp4 copyWithSource: tmp2.
	self
		should: [ (tmp3 slotSVOAt: #vorname) = nil ];
		should: [ (tmp3 slotSVOAt: #nachname) = nil ];
		should: [ (tmp3 slotSVOAt: #Stadt) val = 'city' ];
		should: [ (tmp3 slotSVOAt: #Straße) val = 'street' ]! !

!GbtTestDeclarativesAccess methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testTagsVOstructureNodes
	| contact address myAddr adrComb |
	address := GbtThing struct: 'GCAddress' define: {
		{ #street . #val: . 'street'}.
		{ #zip . #val: . '9999'}.
		{ #city . #val: . 'city'}}.
	contact := GbtThing struct: 'GCContact' define: {
		{ #nname . #val:tag: . 'Krase' . #foo9} .
		{ #adr . #thing:tag: . address . #foo7 }.
		{ #vname . #val:tag: . 'Hartmut' . #foo8 }}.
	adrComb := GbtDeclarative struct: 'AdrComb' define: {
		{ #vorname . #tag: . #foo8 }.
		{ #name . #tag: . #foo9 }.
		{ #adresse . #tag: . #foo7 }}.
	myAddr := adrComb copyWithSource: contact.

	self should: [ (myAddr slotSVOAt: #vorname) val = 'Hartmut' ].
	self should: [ (myAddr slotSVOAt: #name) val = 'Krase' ].
	self should: [ ((myAddr slotSVOAt: #adresse) slotSVOAt: #city) val = 'city' ].
	self should: [ ((myAddr slotSVOAt: #adresse) slotSVOAt: #street) val = 'street' ]! !

!GbtTestDeclarativesAccess methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testTagsWithPathAccessGet
	| contact address myAddr adrComb |
	address := GbtThing struct: 'GCAddress' define: {
		{ #street . #val: . 'street'}.
		{ #zip . #val: . '9999'}.
		{ #city . #val: . 'city'}}.
	contact := GbtThing struct: 'GCContact' define: {
		{ #nname . #val:tag: . 'Krase' . #foo9} .
		{ #adr . #thing:tag: . address . #foo7 }.
		{ #vname . #val:tag: . 'Hartmut' . #foo8 }}.
	adrComb := GbtDeclarative struct: 'AdrComb' define: {
		{ #vorname . #tag: . #foo8 }.
		{ #nname . #tag: . #foo9 }.
		{ #adresse . #tag: . #foo7 }}.
	myAddr := adrComb copyWithSource: contact.

	self should: [ myAddr vorname = 'Hartmut' ].
	self should: [ myAddr nname = 'Krase' ].
	self should: [ myAddr adresse city = 'city' ].
	self should: [ myAddr adresse street = 'street' ]! !

!GbtTestDeclarativesAccess methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testTagsWithPathAccessSet
	| contact address myAddr adrComb |
	address := GbtThing struct: 'GCAddress' define: {
		{ #street . #val: . 'street'}.
		{ #zip . #val: . '9999'}.
		{ #city . #val: . 'city'}}.
	contact := GbtThing struct: 'GCContact' define: {
		{ #nname . #val:tag: . 'Krase' . #foo9} .
		{ #adr . #thing:tag: . address . #foo7 }.
		{ #vname . #val:tag: . 'Hartmut' . #foo8 }}.
	adrComb := GbtDeclarative struct: 'AdrComb' define: {
		{ #vorname . #tag: . #foo8 }.
		{ #nachname . #tag: . #foo9 }.
		{ #adresse . #tag: . #foo7 }}.
	myAddr := adrComb copyWithSource: contact.
	myAddr vorname: 'Karl'.
	myAddr nachname: 'Weller'.
	myAddr city: 'Hamburg'.
	myAddr street: 'ABCstrasse'.
	self should: [ myAddr vorname = 'Karl' ].
	self should: [ myAddr nachname = 'Weller' ].
	self should: [ myAddr adresse city = 'Hamburg' ].
	self should: [ myAddr adresse street = 'ABCstrasse' ]! !

GbtTests subclass: #GbtTestDeclarativesEmbed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestDeclarativesEmbed methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testEmbedDeepNode
	| target source newData combinator thing oldData newSub oldSub |
	newSub := GbtThing struct: 'NewSub' define: {
		{ #no . #val: . '42'} }.
	oldSub := GbtThing struct: 'OldSub' define: {
		{ #no . #val: . ''} }.	
	newData := GbtThing struct: 'NewData' define: {
		{ #street . #val: . 'street'}.
		{ #city . #val: . 'city'} .
		{ #sub . #thing: . newSub} .
		}.
	oldData := GbtThing struct: 'OldData' define: {
		{ #street . #val: . ''}.
		{ #city . #val: . ''}.
		{ #sub . #thing: . oldSub} .
		}.
	source := GbtThing struct: 'Source' define: {
		{ #globalSlot . #thing:  . newData} }.
	target := GbtThing struct: 'Target' define: {
		{ #localSlot . #thing: . oldData } }.
	combinator := GbtDeclarative struct: #Decl define: {{#globalSlot . #tag: . #localSlot}}.
	
	thing := target copy embed: source with: combinator.

	self should: [ target city = '' ].
	self should: [ target street = '' ].
	self should: [ target no = '' ].
	
	self should: [ thing city = 'city' ].
	self should: [ thing street = 'street' ].
	self should: [ thing no = '42' ].
! !

!GbtTestDeclarativesEmbed methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testEmbedDeepNodeExpand
	| target source newData combinator thing oldData newSub oldSub |
	newSub := GbtThing struct: 'NewSub' define: {
		{ #no . #val: . '42'} }.
	oldSub := GbtThing struct: 'OldSub' define: {
		{ #no . #val: . ''} }.	
	newData := GbtThing struct: 'NewData' define: {
		{ #street . #val: . 'street'}.
		{ #city . #val: . 'city'} .
		{ #sub . #thing: . newSub} }.
	oldData := GbtThing struct: 'OldData' define: {} full: { 
			{ #city . #val: . ''}.
			{ #street . #val: . ''}.
			{ #sub . #thing: . oldSub}}.
	source := GbtThing struct: 'Source' define: {
		{ #globalSlot . #thing:  . newData} }.
	target := GbtThing struct: 'Target' define: {
		{ #localSlot . #thing: . oldData } }.
	combinator := GbtDeclarative struct: #Decl define: {{#globalSlot . #tag: . #localSlot}}.
	
	thing := target copy embed: source with: combinator.

	self should: [ target city = '' ].
	self should: [ target street = '' ].
	self should: [ target no = '' ].
	
	self should: [ thing city = 'city' ].
	self should: [ thing street = 'street' ].
	self should: [ thing no = '42' ].
! !

!GbtTestDeclarativesEmbed methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testEmbedIncompleteSlots
	| target source combinator thing |
	source := GbtThing struct: 'Source' define: {
		{ #city . #val: . 'city'} }.
	target := GbtThing struct: 'Target' define: {
		{ #stadt . #val: . ''}.
		{ #strasse . #val: . ''} } .
	combinator := GbtDeclarative struct: #Decl define: {
		{ #street . #tag: .#strasse}.
		{ #city . #tag: . #stadt}}.
		
	thing := target embed: source with: combinator.
	
	self should: [ thing stadt = 'city' ] .
	self should: [ thing strasse = '' ].
! !

!GbtTestDeclarativesEmbed methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testEmbedNodeWithDelete
	| target source newData combinator thing oldData |
	newData := GbtThing struct: 'NewData' define: {
		{ #city . #val: . 'city'} }.
	oldData := GbtThing struct: 'OldData' define: {
		{ #street . #val: . ''}.
		{ #city . #val: . ''} }.
	source := GbtThing struct: 'Source' define: {
		{ #globalSlot . #thing:  . newData} }.
	target := GbtThing struct: 'Target' define: {
		{ #localSlot . #thing: . oldData } }.
	combinator := GbtDeclarative struct: #Decl define: {{#globalSlot . #tag: . #localSlot}}.
	
	thing := target copy embed: source with: combinator.

	self should: [ target city = '' ].
	self should: [ target street = '' ].
	
	self should: [ thing city = 'city' ].
	self should: [ (thing slotSVOAt: #street) = nil] .

! !

!GbtTestDeclarativesEmbed methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testEmbedNodeWithPrivate
	| target source newData combinator thing oldData subData subsubData |
	newData := GbtThing struct: 'NewData' define: {
		{ #city . #val: . 'city'} }.
	subsubData := GbtThing struct: 'SubSubData' define: {
		{ #blabla . #val: . 'blabla' }}.
	subData := GbtThing struct: 'SubData' define: {
		{ #bla . #val:private: . 'bla' . true}.
		{ #bla2 . #val: . 'bla2' }.
		{#subsub . #thing:private: . subsubData . true }}.
	oldData := GbtThing struct: 'OldData' define: {
		{ #street . #val:private: . 'local' . true}.
		{ #city . #val: . '' }.
		{ #sub . #thing: . subData } }.
	source := GbtThing struct: 'Source' define: {
		{ #globalSlot . #thing:  . newData} }.
	target := GbtThing struct: 'Target' define: {
		{ #localSlot . #thing: . oldData } }.
	combinator := GbtDeclarative struct: #Decl define: {{#globalSlot . #tag: . #localSlot}}.
	
	thing := target copy embed: source with: combinator.

	self should: [ target city = '' ].
	self should: [ target street = 'local' ].
	
	self should: [ thing city = 'city' ].
	self should: [ thing street = 'local' ] .
	self should: [ thing bla = 'bla' ] .
	self should: [ (thing sub slotSVOAt: #bla2) = nil] .
	self should: [ thing blabla = 'blabla' ] ! !

!GbtTestDeclarativesEmbed methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testEmbedSimpleNode
	| target source newData combinator thing oldData |
	newData := GbtThing struct: 'NewData' define: {
		{ #street . #val: . 'street'}.
		{ #city . #val: . 'city'} }.
	oldData := GbtThing struct: 'OldData' define: {
		{ #street . #val: . ''}.
		{ #city . #val: . ''} }.
	source := GbtThing struct: 'Source' define: {
		{ #globalSlot . #thing:  . newData} }.
	target := GbtThing struct: 'Target' define: {
		{ #localSlot . #thing: . oldData } }.
	combinator := GbtDeclarative struct: #Decl define: {{#globalSlot . #tag: . #localSlot}}.
	
	thing := target copy embed: source with: combinator.

	self should: [ target city = '' ].
	self should: [ target street = '' ].
	
	self should: [ thing city = 'city' ].
	self should: [ thing street = 'street' ].
! !

!GbtTestDeclarativesEmbed methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testEmbedSimpleSlots
	| target source combinator thing |
	source := GbtThing struct: 'Source' define: {
		{ #street . #val: . 'street'}.
		{ #city . #val: . 'city'} }.
	target := GbtThing struct: 'Target' define: {
		{ #stadt . #val: . ''}.
		{ #strasse . #val: . ''} } .
	combinator := GbtDeclarative struct: #Decl define: {
		{ #street . #tag: .#strasse}.
		{ #city . #tag: . #stadt}}.
		
	thing := target embed: source with: combinator.
	
	self should: [ thing stadt = 'city' ].
	self should: [ thing strasse = 'street' ].
! !

!GbtTestDeclarativesEmbed methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testEmbedSmartNode
	| target source newData combinator thing oldData |
	newData := GbtThing struct: 'NewData' define: {
		{ #street . #val: . 'street'}.
		{ #city . #val: . 'city'} }.
	oldData := GbtThing struct: 'OldData' define: {
		{ #street . #val: . ''}.
		{ #city . #val: . ''} }.
	source := GbtThing struct: 'Source' define: { } 
	full: { { #globalSlot . #thing:  . newData} }.
	target := GbtThing struct: 'Target' define: {
		{ #localSlot . #thing: . oldData } }.
	combinator := GbtDeclarative struct: #Decl define: {{#globalSlot . #tag: . #localSlot}}.
	
	thing := target copy embed: source with: combinator.

	self should: [ target city = '' ].
	self should: [ target street = '' ].
	
	self should: [ thing city = 'city' ].
	self should: [ thing street = 'street' ].
! !

!GbtTestDeclarativesEmbed methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testEmbedWithCombinatorHierarchy
	| target source2 source1 subComb comb thing dummy |
	dummy := GbtThing struct: 'dummy'.
	source1 := GbtThing struct: 'Source1' define: {
		{ #street . #val: . 'street'} .
		{ #city . #val: . 'city'}}.
	source2 := GbtThing struct: 'Source2' define: {
		{ #company . #val: . 'myCompany'} .
		{ #addr . #thing: . source1}}.
	target := GbtThing struct: 'Target' define:  {
		{ #stadt . #val: . ''}.
		{ #strasse . #val: . ''}.
		{ #firma . #val: . ''}} .
	subComb := GbtDeclarative struct: #SubDecl define: {
		{ #street . #tag: .#strasse}.
		{ #city . #tag: . #stadt}}.
	comb := GbtDeclarative struct: 'Decl' define: { 
		{#company . #tag: . #firma }.
		{#addr . #decl: . subComb} }.
		
	thing := target embed: source2 with: comb.

	self should: [ thing stadt = 'city' ].
	self should: [ thing firma = 'myCompany' ].
	self should: [ thing strasse = 'street' ]! !

!GbtTestDeclarativesEmbed methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testEmbedWithTargetHierarchy
	| target subtarget source  comb thing  |
	source := GbtThing struct: 'Source' define: {
		{ #company . #val: . 'myCompany'} .
		{ #street . #val: . 'street'} .
		{ #city . #val: . 'city'}}.
	subtarget := GbtThing struct: 'Subtarget' define:  {
		{ #strasse . #val: . ''}.
		{ #firma . #val: . ''}} .
	target := GbtThing struct: 'Target' define:  {
		{ #stadt . #val: . ''}.
		{ #sub . #thing: . subtarget}} .
	comb := GbtDeclarative struct: #Decl define: {
		{ #company . #tag: .#firma}.
		{ #street . #tag: .#strasse}.
		{ #city . #tag: . #stadt}}.
		
	thing := target embed: source with: comb.

	self should: [ thing stadt = 'city' ].
	self should: [ thing firma = 'myCompany' ].
	self should: [ thing strasse = 'street' ]! !

GbtTests subclass: #GbtTestEvolve
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testAddAndRemove
	|  thing th1 th3 |
	th1 := GbtThing struct: 'GCTh1' define: {} .	
	th3 := GbtThing struct: 'GCTh3' define: {} .	
	thing := GbtThing struct: 'GCThing' define: { } full: {		
		{#slot1 . #thing: . th1 }.
		{#slot2 . #val: . #original}.
		{#slot3 . #thing: . th3}} .	
			
	thing slot1.	
	thing slot2.	
	thing removeSlotAt: #slot1.
	thing slot3.
	thing removeSlotAt: #slot2.
	
	self should: [thing slots size = 1].
	self should: [thing slot3 svoName = 'GCTh3' ].

	self should: [thing previous slots size = 2].
	self should: [thing previous slot2 = #original ].
	self should: [thing previous slot3 svoName = 'GCTh3' ].

	self should: [thing previous previous slots size = 1].
	self should: [thing previous previous slot2 = #original ].

	self should: [thing previous previous previous slots size = 2].
	self should: [thing previous previous previous slot1 svoName = 'GCTh1' ].
	self should: [thing previous previous previous slot2 = #original ].

	self should: [thing previous previous previous previous slots size = 1].
	self should: [thing previous previous previous previous previous slots size = 0].
! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testAddNodesAndValues
	|  thing th1 th3 |
	th1 := GbtThing struct: 'GCTh1' define: {} .	
	th3 := GbtThing struct: 'GCTh3' define: {} .	
	thing := GbtThing struct: 'GCThing' define: { } full: {		
		{#slot1 . #thing: . th1 }.
		{#slot2 . #val: . #original}.
		{#slot3 . #thing: . th3}} .	
			
	thing slot1.	
	thing slot2.	
	thing slot3.
	thing removeSlot: thing slot1.
	
	self should: [thing slots size = 2].
	self should: [thing slot2 = #original ].
	self should: [thing slot3 svoName = 'GCTh3' ].

	self should: [thing previous slots size = 3].
	self should: [thing previous slot1 svoName = 'GCTh1' ].
	self should: [thing previous slot2 = #original ].
	self should: [thing previous slot3 svoName = 'GCTh3' ].

	self should: [thing previous previous slots size = 2].
	self should: [thing previous previous previous slots size = 1].
	self should: [thing previous previous previous previous slots size = 0].
! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testNextVersion
	|  thing th1 |
	th1 := GbtThing struct: 'GCTh1' define: {
		{#slotv1 . #val:. #original }} .	
	thing := GbtThing struct: 'GCThing' define: {  
		{#slott . #thing: . th1 }} .	
	thing slotv1: #changed.
	self should: [thing slott previous svoName = (thing slott svoName)].
	self should: [(thing slott slotAt: #slotv1) value  val = #changed ].
	thing store.
	self should: [thing slott previous isNil].
	self should: [(thing slott slotAt: #slotv1) value previous isNil ].
! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testPreviousMultiNodes
	|  thing th1 th2 th3 |
	th1 := GbtThing struct: 'GCTh1' define: {} .	
	th2 := GbtThing struct: 'GCTh2' define: {} .	
	th3 := GbtThing struct: 'GCTh3' define: {} .	
	thing := GbtThing struct: 'GCThing' define: {  
		{#slot1 . #thing: . th1 }.
		{#slot2 . #thing: . th1 copy}} .	
	thing slot1: th2.	
	thing slot2: th3.
	self should: [thing slot1 svoName = 'GCTh2' ].
	self should: [thing slot2 svoName = 'GCTh3' ].
	self should: [thing previous slot1 svoName = 'GCTh2' ].
	self should: [thing previous slot2 svoName = 'GCTh1' ].
	self should: [thing previous previous slot1 svoName = 'GCTh1' ].
	self should: [thing previous previous slot2 svoName = 'GCTh1' ].
! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testPreviousMultiValues
	|  thing |
	thing := GbtThing struct: 'GCThing' define: {  
		{#slot1 . #val:. #original }.
		{#slot2 . #val:. #original }} .	
	thing slot1: #change1. 
	thing slot2: #change2.
	self should: [thing slot1 = #change1 ].
	self should: [thing slot2 = #change2 ].
	self should: [thing previous slot1 = #change1 ].
	self should: [thing previous  slot2 = #original ].
	self should: [thing previous previous slot1 = #original ].
	self should: [thing previous previous slot2 = #original ].

! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testPreviousMultiValues2
	|  thing |
	thing := GbtThing struct: 'GCThing' define: {  
		{#slot1 . #no:. 0 }.
		{#slot2 . #val:. #original }} .	
	thing slot1: 1. 
	thing slot2: #change2.
	thing slot2: #change3.
	thing slot1: 4. 
	self should: [thing slot1 = '4' ].
	self should: [thing slot2 = #change3 ].
	self should: [thing previous slot1 = '1' ].
	self should: [thing previous  slot2 = #change3 ].
	self should: [thing previous previous slot1 = '1' ].
	self should: [thing previous previous slot2 = #change2 ].
	self should: [thing previous previous previous previous slot1 = '0' ].
	self should: [thing previous previous previous previous slot2 = #original ].

! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testPreviousNodes
	|  thing th1 th2 th3 |
	th1 := GbtThing struct: 'GCTh1' define: {} .	
	th2 := GbtThing struct: 'GCTh2' define: {} .	
	th3 := GbtThing struct: 'GCTh3' define: {} .	
	thing := GbtThing struct: 'GCThing' define: {  
		{#slotv . #val:. #original }.
		{#slott . #thing: . th1 }} .	
	self should: [thing slott svoName = 'GCTh1' ].
	thing slott: th2.
	thing slott: th3.
	self should: [thing slott svoName = 'GCTh3' ].
	self should: [thing previous slott svoName = 'GCTh2' ].
	self should: [thing previous previous slott svoName = 'GCTh1' ].
! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testPreviousValues
	|  thing |
	thing := GbtThing struct: 'GCThing' define: {  
		{#slotv . #val:. #original }} .	
	self should: [thing slotv = #original ].
	thing slotv: #change1.
	thing slotv: #change2.
	self should: [thing slotv = #change2 ].
	self should: [thing previous slotv = #change1 ].
	self should: [thing previous previous slotv = #original ].

! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testPreviousValuesAndNodes
	|  thing th1 th2 th3 |
	th1 := GbtThing struct: 'GCTh1' define: {} .	
	th2 := GbtThing struct: 'GCTh2' define: {} .	
	th3 := GbtThing struct: 'GCTh3' define: {} .	
	thing := GbtThing struct: 'GCThing' define: {  
		{#slot1 . #val:. #original }.
		{#slot2 . #thing: . th1 }.
		{#slot3 . #val:. #original } .	
		{#slot4 . #thing: . th1 copy}} .	
	thing slot1: #change1. 
	thing slot2: th2.	
	thing slot3: #change2.
	thing slot4: th3.

	self should: [thing slot1 = #change1 ].
	self should: [thing slot2 svoName = 'GCTh2' ].
	self should: [thing slot3 = #change2 ].
	self should: [thing slot4 svoName = 'GCTh3' ].

	self should: [thing previous slot1  = #change1 ].
	self should: [thing previous slot2 svoName = 'GCTh2' ].
	self should: [thing previous slot3  = #change2 ].
	self should: [thing previous slot4 svoName = 'GCTh1' ].

	self should: [thing previous previous slot1  = #change1 ].
	self should: [thing previous previous slot2 svoName = 'GCTh2' ].
	self should: [thing previous previous slot3  = #original ].
	self should: [thing previous previous slot4 svoName = 'GCTh1' ].

	self should: [thing previous previous previous  slot1  = #change1 ].
	self should: [thing previous previous previous  slot2 svoName = 'GCTh1' ].
	self should: [thing previous previous previous  slot3  = #original ].
	self should: [thing previous previous previous  slot4 svoName = 'GCTh1' ].

	self should: [thing previous previous previous previous slot1  = #original ].
	self should: [thing previous previous previous previous slot2 svoName = 'GCTh1' ].
	self should: [thing previous previous previous previous slot3  = #original ].
	self should: [thing previous previous previous previous slot4 svoName = 'GCTh1' ].
! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testRemove
	|  thing |
	thing := GbtThing struct: 'GCThing' define: {  
		{#slotv . #val:. #original }} .	
	thing removeSlotAt: #slotv.
	self should: [(thing slotAt: #slotv) isNil].
	self should: [thing previous slotv = #original ].
	self should: [(thing previous slotSVOAt: #slotv) container == thing previous ].

! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testRemoveNodesAndValues
	|  thing th1 th2 th3 |
	th1 := GbtThing struct: 'GCTh1' define: {} .	
	th2 := GbtThing struct: 'GCTh2' define: {} .	
	th3 := GbtThing struct: 'GCTh3' define: {} .	
	thing := GbtThing struct: 'GCThing' define: {  
		{#slot0 . #val: . #original}.
		{#slot1 . #thing: . th1 }.
		{#slot2 . #thing: . th1 copy}} .	
	thing slot1: th2.	
	thing slot2: th3.
	thing removeSlot: th3.
	thing slot0: #change.
	thing removeSlot: th2.
	
	self should: [thing slots size = 1].
	self should: [thing slot0 = #change ].

	self should: [thing previous slots size = 2].
	self should: [thing previous slot0 = #change ].
	self should: [thing previous slot1 svoName = 'GCTh2' ].

	self should: [thing previous previous slots size = 2].
	self should: [thing previous previous slot0 = #original ].
	self should: [thing previous previous slot1 svoName = 'GCTh2' ].

	self should: [thing previous previous previous slots size = 3].
	self should: [thing previous previous previous slot0 = #original ].
	self should: [thing previous previous previous slot1 svoName = 'GCTh2' ].
	self should: [thing previous previous previous slot2 svoName = 'GCTh3' ].

	self should: [thing previous previous previous previous previous slots size = 3].
	self should: [thing previous previous previous previous previous slot0 = #original ].
	self should: [thing previous previous previous previous previous slot1 svoName = 'GCTh1' ].
	self should: [thing previous previous previous previous previous slot2 svoName = 'GCTh1' ].
! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testUnchangedSlots
	|  thing th1 th2 |
	th1 := GbtThing struct: 'GCTh1' define: {} .	
	th2 := GbtThing struct: 'GCTh2' define: {} .	
	thing := GbtThing struct: 'GCThing' define: {  
		{#slotv1 . #val:. #original }.
		{#slotv2 . #val:. #original }.
		{#slott . #thing: . th1 }} .	
	self should: [thing slott svoName = 'GCTh1' ].
	thing slott: th2.
	thing slotv1: #changed.
	self should: [thing slotv2  = 'original' ].
! !

GbtTests subclass: #GbtTestHooks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestHooks methodsFor: 'as yet unclassified' stamp: 'hk 3/22/2017 13:15'!
listContext 
	
	^GbtBigListAC struct: 'ListContext' define: { 
		{#templates: . self thing }.
		{#subcontext: . self plainContext }.
		{#uiSpec:icon: . #GbtListAndItemUI . #edit }.
		{#onRemoveDo: . #(remove) } .
		{#behavior:actions: . #remove . #(ASSIGNVAL #(BAR s2) ) }}  ! !

!GbtTestHooks methodsFor: 'as yet unclassified' stamp: 'hk 3/22/2017 13:15'!
plainContext 
	
	^GbtPlainAC struct: 'PlainContext' define: { 
		{#vo: . self thing }.
		{#uiSpec:icon: . #GbtItemUI . #edit }.
		{#onEditDo: . #(save) } .
		{#onSaveDo: . #(save) } .
		{#behavior:actions: . #save . #(ASSIGNVAL #(BAR s2) ) } }  ! !

!GbtTestHooks methodsFor: 'as yet unclassified' stamp: 'hk 9/23/2016 12:07'!
testCreate
	"todo after refaktoring insideTransport and the hook"
! !

!GbtTestHooks methodsFor: 'as yet unclassified' stamp: 'hk 1/9/2017 16:12'!
testEdit
	| context thing appUI |
	context := self listContext.
	appUI := context ui.
	thing := context newEntry.
	self should: [ thing s2 = 'foo' ].
	appUI setSelection: thing.
	self should: [ thing s2 = 'BAR' ]
! !

!GbtTestHooks methodsFor: 'as yet unclassified' stamp: 'hk 11/30/2016 12:03'!
testRemove
	| context one two |
	context := self listContext.
	one := context newEntry.
	two := context newEntry.
	self should: [ two s2 = 'foo' ].
	context deleteListElement: two .
	self should: [ two s2 = 'BAR' ]
! !

!GbtTestHooks methodsFor: 'as yet unclassified' stamp: 'hk 2/20/2017 13:06'!
testSave
	| context |
	context := self plainContext.
	self should: [ context vo s2 = 'foo' ].  
	context vo beDirty; save.
	self should: [ context vo s2 = 'BAR' ]
! !

!GbtTestHooks methodsFor: 'as yet unclassified' stamp: 'hk 3/14/2017 13:01'!
thing
	"self new activeVO edit"
	
	^GbtThing struct: 'test2ActiveVO' define: { 
		{ #s1 . #val: . 'bar' }.
		{ #s2 . #val: . 'foo' } }! !

GbtTests subclass: #GbtTestLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestLink methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testLinkAccess
	| tmp1 tmp2 tmp3 |
	tmp2 := GbtThing
		struct: 'Level21'
		define: {{#str . #val: . 'Bstrasse'}}.
	tmp3 := GbtThing
		struct: 'Level22'
		define: {{#link . #linkTo: . #bla21}}.
	tmp1 := GbtThing
		struct: 'root'
		define:
			{{#bla21.
			#thing:.
			tmp2}.
			{#bla22.
			#thing:.
			tmp3}}.
	self
		should: [ tmp1 str = 'Bstrasse' ];
		should: [ tmp1 link str = 'Bstrasse' ].
	tmp1 str: #Cstraße.
	self
		should: [ tmp1 str = 'Cstraße' ];
		should: [ tmp1 link str = 'Cstraße' ]! !

!GbtTestLink methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testLinkAccessCopy
	|root level21 level22 level31 level32 root2 |
	level31 := GbtThing struct: 'Level31' define: {{#str . #val: . 'Bstrasse'}} .    
	level32 := GbtThing struct: 'Level32' define: {{#str . #val: . 'Cstrasse'}} .    

	level21 := GbtThing struct: 'Level21' define: {{#node . #thing: . level31}} .
	level22 := GbtThing struct: 'Level22' define: {{#link . #linkTo: . #bla21}}.

	root := GbtThing struct: 'root' define: { 
		{#bla21 . #thing: . level21 }.		"bla21 - level21 - node - level31 - str"
		{#bla22 . #thing: . level22 }.		"bla22 - level22 - link - node"
	} .

	self should: [root node str = 'Bstrasse' ].
	self should: [root link str = 'Bstrasse' ].

	root2 := root copy.
	root2 node: level32 .		
	self should: [root2 node str = 'Cstrasse' ] .
	self should: [root2 link str = 'Cstrasse' ] .
! !

!GbtTestLink methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testLinkAccessFull
	| tmp1 tmp2 tmp3 tmp5 tmp7 |
	tmp2 := GbtThing
		struct: 'Level21'
		define: {}
		full: {{#str . #val: . 'Bstrasse'}}.
	tmp3 := GbtThing
		struct: 'Level22'
		define: {}
		full: {{#link . #linkTo: . #bla21}}.
	tmp1 := GbtThing
		struct: 'root'
		define:
			{{#bla21.
			#thing:.
			tmp2}.
			{#bla22.
			#thing:.
			tmp3}}.
	tmp5 := self.
	tmp5
		should: [ tmp1 str = 'Bstrasse' ];
		should: [ tmp1 link str = 'Bstrasse' ].
	tmp1 str: #Cstraße.
	tmp7 := self.
	tmp7
		should: [ tmp1 str = 'Cstraße' ];
		should: [ tmp1 link str = 'Cstraße' ]! !

!GbtTestLink methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testLinkAccessList
	|root  level22 bElement cElement|
	bElement := GbtThing struct: 'Level31' define: {{#str . #val: . 'Bstrasse'}} .    
	cElement := GbtThing struct: 'Level32' define: {{#str . #val: . 'Cstrasse'}} .    

	level22 := GbtThing struct: 'Level22' define: {{#link . #linkTo: . 'bla21:2' }}.

	root := GbtThing struct: 'root' define: { 
		{#bla21 . #listOf: . bElement }.		"bla21 - level21 - node - level31 - str"
		{#bla22 . #thing: . level22 }.			"bla22 - level22 - link - node"
	} .
	root bla21 newEntry: bElement.
	root bla21 newEntry: cElement.
	
	self should: [(root bla21 perform: #'1') str = 'Bstrasse' ].
	self should: [(root bla21 perform: #'2') str = 'Cstrasse' ].
	self should: [root link str = 'Cstrasse' ].

	root bla22 link setLink: 'bla21:1'.
	self should: [root link str = 'Bstrasse' ].
! !

!GbtTestLink methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testLinkAccessNode
	|root level21 level22 level31 level32|
	level31 := GbtThing struct: 'Level31' define: {{#str . #val: . 'Bstrasse'}} .    
	level32 := GbtThing struct: 'Level32' define: {{#str . #val: . 'Cstrasse'}} .    

	level21 := GbtThing struct: 'Level21' define: {{#nada . #thing: . level31}} .
	level22 := GbtThing struct: 'Level22' define: {{#link . #linkTo: . #nada}}.

	root := GbtThing struct: 'root' define: { 
		{#bla21 . #thing: . level21 }.		"bla21 - level21 - node - level31 - str"
		{#bla22 . #thing: . level22 }.		"bla22 - level22 - link - node"
	} .

	self should: [root nada str = 'Bstrasse' ].
	self should: [root link str = 'Bstrasse' ].

	root nada: level32 .		
	self should: [root nada str = 'Cstrasse' ] .
	self should: [root link str = 'Cstrasse' ] .
! !

!GbtTestLink methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testLinkSummary
	|root level21 level22 |
	level21 := GbtThing struct: 'Level21' define: {
		{#str . #val: . 'Bstrasse'}.
		{ #summary . '#str' }
		} .
	level22 := GbtThing struct: 'Level22' define: {
		{#link . #linkTo: . #bla21}.
		{ #summary . '#link' }.
		}.

	root := GbtThing struct: 'root' define: { 
		{#bla21 . #thing: . level21 }.		"bla21 - str"
		{#bla22 . #thing: . level22 }.		"bla22 - link - level21"
		{ #summary . '#bla21 #bla22'}.
	} .

	self should: [root  summaryEnriched = 'Bstrasse  Bstrasse   '].
! !

GbtTests subclass: #GbtTestNodeTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestNodeTree methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testHierarchySlotAccessTagged
	| bla  thing |
	bla := GbtThing struct: 'GCAddressLocation' define: { 
		{#street . #val:tag: . 'Astrasse' . #tagAstrasse }
	} full: {  } .
	thing := GbtThing struct: 'GCAddress' define: {  
		{#addressLocation . #thing: . bla} .
		{#cityName . #val: . '<city name>'} 
	} full: {  } .
	self should: [thing  tagAstrasse = 'Astrasse' ].

	thing tagAstrasse: 'Bstrasse' .		
	self should: [thing  tagAstrasse = 'Bstrasse' ] ! !

!GbtTestNodeTree methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testHierarchyThingAccess
	| tmp1 tmp2 tmp3 |
	tmp3 := GbtThing
		struct: 'GCALocation2'
		define: {{#str . #val: . 'Bstrasse'}}.
	tmp1 := GbtThing
		struct: 'GCALocation'
		define: {{#street . #val: . 'Astrasse'}}
		full:
			{{#test.
			#thing:.
			tmp3}}.
	tmp2 := GbtThing
		struct: 'GCAddress'
		define:
			{{#addressLocation.
			#thing:.
			tmp1}.
			{#cityName . #val: . '<city name>'}}.
	self should: [ tmp2 street = 'Astrasse' ].
	tmp2 test str: #Cstraße.
	self should: [ tmp2 str = 'Cstraße' ].
	tmp2 str: #Dstraße.
	self should: [ tmp2 test str = 'Dstraße' ]! !

!GbtTestNodeTree methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testHierarchyValueAccess
	| bla  thing |
	bla := GbtThing struct: 'GCAddressLocation' define: { 
		{#street . #val: . 'Astrasse'}
	} full: {  } .
	thing := GbtThing struct: 'GCAddress' define: {  
		{#addressLocation . #thing: . bla} .
		{#cityName . #val: . '<city name>'} 
	} full: {  } .
	self should: [thing  street = 'Astrasse' ].

	thing street: 'Bstrasse' .		
	self should: [thing  street = 'Bstrasse' ] .
	self should: [thing city ] raise: Error.
! !

GbtTests subclass: #GbtTestPathExpressions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestPathExpressions methodsFor: 'as yet unclassified' stamp: 'hk 3/14/2017 13:01'!
testSameNode

	| bla |
	bla := GbtThing struct: #bla define: {  
		{ #summary . ' #abc #def '}.
		{ #abc . #val: . #a }.
		{ #def . #val: . #b }. 
	}.
	self should: [ bla summaryEnriched = 'a b ' ].
! !

!GbtTestPathExpressions methodsFor: 'as yet unclassified' stamp: 'hk 3/14/2017 13:01'!
testSameNodeTagged
	"find slots by tag"
	| bla |
	bla := GbtThing struct: #bla define: {  
		{ #summary . ' #abc #def'}.
		{ #slot1 . #val:tag: . #a . #abc}.
		{ #slot2 . #val:tag: . #b . #def}. 
	}.
	self should: [ bla summaryEnriched = 'a b ' ].
! !

!GbtTestPathExpressions methodsFor: 'as yet unclassified' stamp: 'hk 3/14/2017 13:01'!
testSubNode

	| bla1 bla2 bla3|
	bla2 := GbtThing struct: #bla2 define: {  
		{ #summary . '#ghi'}.
		{ #ghi . #val: . #a }	.
	}.
	bla3 := GbtThing struct: #bla3 define: {  
		{ #summary . '#xyz'}.
		{ #xyz . #val: . #b }.
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #summary . ' #abc & #def '}.
		{ #abc . #thing: . bla2 }.
		{ #def . #thing: . bla3 }. 
	}.
	self should: [bla1 summaryEnriched = 'a  & b  '].
! !

!GbtTestPathExpressions methodsFor: 'as yet unclassified' stamp: 'hk 3/14/2017 13:01'!
testSubNodeChain

	| bla1 bla2 bla3|
	bla3 := GbtThing struct: #bla3 define: {  
		{ #xyz . #val: . #b }.
	}.
	bla2 := GbtThing struct: #bla2 define: {  
		{ #def . #thing: . bla3 }. 
		{ #ghi . #val: . #a }	.
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #summary . ' #ghi & #xyz '}.
		{ #abc . #thing: . bla2 }.
	}.
	self should: [bla1 summaryEnriched = 'a & b ' ].
! !

!GbtTestPathExpressions methodsFor: 'as yet unclassified' stamp: 'hk 3/14/2017 13:01'!
testSubNodeList

	| bla1 bla2 bla3|
	bla3 := GbtThing struct: #bla3 define: {  
		{ #xyz . #val: . #b }.
	}.
	bla2 := GbtThing struct: #bla2 define: {  
		{ #def . #thing: . bla3 }. 
		{ #ghi . #val: . #a }	.
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #summary . ' #ghi & #xyz '}.
		{ #abc . #listOf: . bla2 }.
	}.
	bla1 abc newEntry: bla2 copy.
	
	self should: [bla1 summaryEnriched = 'a & b ' ].
! !

!GbtTestPathExpressions methodsFor: 'as yet unclassified' stamp: 'hk 3/14/2017 13:01'!
testSubNodePath

	| bla1 bla2 bla3|
	bla3 := GbtThing struct: #bla3 define: {  
		{ #xyz . #val: . #b }.
	}.
	bla2 := GbtThing struct: #bla2 define: {  
		{ #def . #thing: . bla3 }. 
		{ #ghi . #val: . #a }	.
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #summary . ' #abc:def:xyz #abc:ghi'}.
		{ #abc . #thing: . bla2 }.
	}.
	self should: [bla1 summaryEnriched = 'b a ' ].
! !

!GbtTestPathExpressions methodsFor: 'as yet unclassified' stamp: 'hk 3/14/2017 13:01'!
testSubNodeWithCycle

	| bla1 bla2 bla3|
	bla2 := GbtThing struct: #bla2 define: {  
		{ #summary . ' #abc '}.
		{ #abc . #val: . #a }	.
	}.
	bla3 := GbtThing struct: #bla3 define: {  
		{ #summary . ' #abc '}.
		{ #abc . #val: . #b }.
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #summary . ' #abc & #def '}.
		{ #abc . #thing: . bla2 }.
		{ #def . #thing: . bla3 }. 
	}.
	self should: [bla1 summaryEnriched = 'a  & b  '].
! !

!GbtTestPathExpressions methodsFor: 'as yet unclassified' stamp: 'hk 3/14/2017 13:01'!
testUpOneNode

	| bla1  bla3 header |
	header := GbtThing struct: #header define: {  
		{ #ref . #calc: . 'ref #def:ghi'}.
	}.
	bla3 := GbtThing struct: #bla3 define: {  
		{ #ghi . #val: . #a }	.
		{ #xyz . #val: . #b }.
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #abc . #thing: . header }.
		{ #def . #thing: . bla3 }. 
	}.
	self should: [header ref  = 'a'].
! !

!GbtTestPathExpressions methodsFor: 'as yet unclassified' stamp: 'hk 3/25/2017 15:39'!
testUpOneNodeWithThingRef

	| bla1  bla3 header |
	header := GbtThing struct: #header define: {  
		{ #ref . #calc: . 'ref #def' }.
	}.
	bla3 := GbtThing struct: #bla3 define: {  
		{ #summary . ' #ghi & #xyz '}.
		{ #ghi . #val: . #a }	.
		{ #xyz . #val: . #b }.
	}.
	bla1 := GbtThing struct: #bla1 define: {  
		{ #abc . #thing: . header }.
		{ #def . #thing: . bla3 }. 
	}.  
	self should: [header ref = bla3 longName ]! !

GbtTests subclass: #GbtTestProgramVOCopying
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestProgramVOCopying methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testMultiTargetCombinatorCopy
	| contact address newView copyView |
	address := (GbtThing struct: 'GCAddress')
		define: #street val: 'street' tag: #foo1;
		define: #zip val: '9999' tag: #foo2;
		define: #city val: 'city' tag: #foo3.
	contact := (GbtThing struct: 'GCContact')
		define: #nname val: 'Krase' tag: #foo9;
		define: #adr thing: address tag: #foo7;
		define: #vname val: 'Hartmut' tag: #foo8.
	newView := GbtDeclarative struct: #Decl define: {
		{#strasse . #tag: . #foo1}.
		{#myName . #tag: . #foo8}.
		{#stadt . #tag: . #foo3}.
		{#nachname . #tag: . #foo9 }}.
	newView sources: {contact . address}.
	copyView := newView copySources.
	self should: [ copyView isKindOf: GbtThing ].
	self should: [ copyView nachname = 'Krase' ].	"do the references work?"
	address define: #city val: 'Hamburg'.	"original slots changed"
	contact define: #nname val: 'Hamburg'.	"to prove the copy"
	self should: [ copyView stadt = 'city' ].	"copied slots are not changed"
	self should: [ copyView nachname = 'Krase' ]! !

!GbtTestProgramVOCopying methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testSimpleViewCopy
	| tmp1 tmp2 tmp3 tmp5 tmp7 |
	tmp5 := GbtThing struct: 'GCAddress'.
	tmp5
		define: #street val: 'street' tag: #foo1;
		define: #zip val: '9999' tag: #foo2.
	tmp1 := tmp5 define: #city val: 'city' tag: #foo3.
	tmp7 := GbtDeclarative struct: 'MyAddr'.
	tmp7
		sources: tmp1;
		define: #Stadt tag: #foo3.
	tmp2 := tmp7 define: #Straße tag: #foo1.
	tmp3 := tmp2 copySources.
	self
		should: [ tmp3 isKindOf: GbtThing ];
		should: [ (tmp3 slotSVOAt: #Stadt) isLeaf ];
		should: [ tmp3 svoName = 'MyAddr' ];
		should: [ (tmp3 slotSVOAt: #Straße) val = 'street' ].
	tmp1 define: #city val: 'Hamburg'.
	self should: [ (tmp3 slotSVOAt: #Stadt) val = 'city' ]! !

GbtTests subclass: #GbtTestRightAndRoles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 3/14/2017 10:36'!
installFilter1Role
	| role |
	role := GbtRole forExecute 
			addFilter: '#country = ''Germany''' for: #GCContactsContext;
			yourself.
	GbtBizAppServer default addUser: #Test withRole: role! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 3/14/2017 10:36'!
installFilter2Role
	| role |
	role := GbtRole forExecute 
			addFilter: '#country = ''Germany''' for: #GCContactsContext;
			addFilter: '#street = ''Germany''' for: #GCContactsContext;
			yourself.
	GbtBizAppServer default addUser: #Test withRole: role! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 3/22/2017 12:39'!
listContext 
	^GbtBigListAC struct: 'ListContext' define: { 
		{#templates: . self thing }.
		{#subcontext: . self plainContext }.
		{#uiSpec:icon: . #GbtListAndItemUI . #edit }.
	}  ! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 3/22/2017 12:39'!
plainContext
	
	^GbtPlainAC struct: 'PlainContext' define: { 
		{#vo: . self thing }.
		{#uiSpec:icon: . #GbtItemUI . #edit }.
	}  ! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 3/22/2017 12:58'!
testExecuteRole
	| app appUI |
	GbtBizAppServer default addUser: #Test withRole: GbtRole forExecute.
	self listContext. 
	app := (GbtBizAppServer default registerAppFor: #Test) mainContext.
	appUI := app ui.
	appUI newElement.
	self should: [ app list size = 1 ].
	! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 3/22/2017 12:59'!
testExecuteRole2
	| app appUI |
	GbtBizAppServer default addUser: #Test withRole: GbtRole forWrite.
	self listContext. 
	app := (GbtBizAppServer default registerAppFor: #Test) mainContext.
	appUI := app ui.
	self should: [ appUI	newElement] raise: Exception.
			! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 3/22/2017 12:59'!
testFilterRole
	| app  role|
	role := GbtRole forWrite 
			addFilter: '#v1 = ''Germany''' for: #ListContext;
			addFilter: '#v2 = ''Austria''' for: #ListContext;
			yourself.
	GbtBizAppServer default addUser: #Test withRole: role.
	self listContext. 
	app := (GbtBizAppServer default registerAppFor: #Test) mainContext.
	self thing v1: #Germany; v2: #Austria; store.
	self thing v2: #Austria; store.
	app loadAll.
	
	self should: [ app list size = 1 ]! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 3/22/2017 12:59'!
testNothingRole
	"so far nothing is equivalent to read"
	| app appUI |
	GbtBizAppServer default addUser: #Test withRole: GbtRole forRead.
	self listContext. 
	app := (GbtBizAppServer default registerAppFor: #Test) mainContext.
	appUI := app ui.
	app newEntrySelect.

	self should: [ app subcontext ui mode value = #text ].
	self should: [( app subcontext ui widgets at: #item) isKindOf: GbtUiTextWidget ]
	! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 3/22/2017 12:59'!
testReadRole
	| app appUI |
	GbtBizAppServer default addUser: #Test withRole: GbtRole forRead.
	self listContext. 
	app := (GbtBizAppServer default registerAppFor: #Test) mainContext.
	appUI := app ui.
	app newEntrySelect.
	
	self should: [ app subcontext ui mode value = #text ].
	self should: [( app subcontext ui widgets at: #item) isKindOf: GbtUiTextWidget ]
	! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 3/22/2017 12:59'!
testWriteRole
	| app appUI |
	GbtBizAppServer default addUser: #Test withRole: GbtRole forWrite.
	self listContext. 
	app := (GbtBizAppServer default registerAppFor: #Test) mainContext.
	appUI := app ui.		
	app newEntrySelect.	
	self should: [ app subcontext ui mode value ~= #text ].
	self should: [ #(GbtThingDiEditor GbtThingEditor) includes: ( app subcontext ui widgets at: #item ) className]
	! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 3/14/2017 13:01'!
thing
	^GbtThing struct: 'listElementVO' define: { 
		{ #v1 . #val: . 'var1' }.
		{ #v2 . #val: . 'var2' }.
		{ #v3 . #val: . 'var3' }.
		{ #v4 . #val: . 'var4' }.
	}! !

GbtTests subclass: #GbtTestRootMap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-AppService'!

!GbtTestRootMap methodsFor: 'as yet unclassified' stamp: 'hk 1/28/2017 18:38'!
dirOf: aSvoName
	^(FileSystem workingDirectory / 'things' / aSvoName) 
					ensureCreateDirectory ! !

!GbtTestRootMap methodsFor: 'as yet unclassified' stamp: 'hk 3/14/2017 12:38'!
testDBStructure1
	| rootMap key keyColl thColl |
	rootMap :=  self testRead1.
	key := rootMap lines keys first.
	self should: [key = 'T10'].
	keyColl := rootMap at: key. 
	thColl := OrderedCollection new: 3.
	keyColl do: [:k| thColl add: (GbtReader new loadNode: k)] .
	self should: [ (thColl first slotSVOAt: #s2) val = #s12 ].
	self should: [ (thColl second slotSVOAt: #s2) val = #s22 ].
	self should: [( thColl third slotSVOAt: #s2 ) val = #s32 ]! !

!GbtTestRootMap methodsFor: 'as yet unclassified' stamp: 'hk 1/30/2017 14:06'!
testRead1
	| rootMap key|
	rootMap := GbtRootMap fromString: self testWrite1.
	self should: [rootMap lines size = 1].
	key := rootMap lines keys first.
	self should: [key = 'T10'].
	self should: [(rootMap at: key) includes: 'th2:T11v1'].
	self should: [(rootMap at: key) includes: 'th3:T12v1'].
	^rootMap! !

!GbtTestRootMap methodsFor: 'as yet unclassified' stamp: 'hk 2/3/2017 14:59'!
testReadEmpty
	| re |
	re := GbtRootMap fromString: ''.
	self should: [re lines isEmpty]! !

!GbtTestRootMap methodsFor: 'as yet unclassified' stamp: 'hk 3/14/2017 13:01'!
testWrite1
	| th3 th2 th1 dir fileContent |
	th3 := GbtThing struct: 'th3' define: { 
		{ #s1 . #val: . 's31' }.
		{ #s2 . #val: . #s32 }}.
	th2 := GbtThing struct: 'th2' define: { 
		{ #s1 . #thing: . th3 }.
		{ #s2 . #val: . #s22 }}.
	th1 := GbtThing struct: 'th1' define: { 
		{ #s1 . #thing: . th2 }.
		{ #s2 . #val: . #s12 }}.
	th1 store.
	dir := self dirOf: #th1.
	fileContent := (dir / 'rootMap') readStream contents.
	self should: [fileContent = 'th1:T10v1 th2:T11v1 th3:T12v1 
'].
	^fileContent! !

!GbtTestRootMap methodsFor: 'as yet unclassified' stamp: 'hk 3/21/2017 14:19'!
testWrite3
	| th dir fileContent |
	(th := GbtThing struct: 'th' define: { 
		{ #s1 . #val: . 's11' }.
		{ #s2 . #val: . #s12 }}) store.
	(th copy) store.
	(th copy) store.
	dir := self dirOf: #th.
	fileContent := (dir / 'rootMap') readStream contents.
	self should: [fileContent = 
'th:T3v1 
th:T6v1 
th:T9v1 
'].
	^fileContent! !

GbtTests subclass: #GbtTestScripting
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestScripting methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testAddChoice
	| bla |
	bla := (GbtThing struct: #bla)
		define: #street enum: #(#private #biz);
		yourself.
	self should: [ (bla slotSVOAt: #street) val = #private ].
	self should: [ (bla slotSVOAt: #street) list first = #private ]! !

!GbtTestScripting methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testAddMultipleValues
	| address |
	address := (GbtThing struct: 'GCAddress')
		define: #street val: 'street';
		define: #zip val: '9999';
		define: #city val: 'city';
		yourself.
	self should: [ address slots first key = #street ].
	self should: [ address slots last key = #city ].
	self should: [ (address slotSVOAt: #zip) val = '9999' ]! !

!GbtTestScripting methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testAddVO
	| bla blabla |
	bla := GbtThing struct: #bla define: {
			{#street . #enum: . #(#private #biz)}
		} full: {}.  
	blabla := GbtThing struct: #blabla define: {
			{#bla . #thing: . bla}
		} full: {}.
	self should: [ ((blabla slotSVOAt: #bla) slotSVOAt: #street) val = #private ].
! !

!GbtTestScripting methodsFor: 'tests' stamp: 'hk 10/26/2016 10:49'!
testDefaultNaming
	| vo1  |
	vo1 := GbtUlist new.
	self should: [ vo1 longName = 'Ulist:U1v0'] .
! !

!GbtTestScripting methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testPathScripting
	| bla blabla end |
	end := GbtThing struct: #end define: {
		{ #street . #val: . #private }.
		{ #zip . #val: . #mobile} }.
	bla := GbtThing struct: #bla define: {
		{#end . #thing: . end }}.
	blabla := GbtThing struct: #blabla define: {
		{#bla . #thing: . bla} }.
	self should: [ bla end street = #private ].
	self should: [ blabla bla end zip = #mobile ].
	bla end street: #irgend.
	blabla bla end zip: 'was'.
	self should: [ bla end street = #irgend ].
	self should: [ blabla bla end zip = #was ]! !

!GbtTestScripting methodsFor: 'tests' stamp: 'hk 3/20/2017 20:09'!
testRetreiveByQualifiedName
	"longNmae = thingName:autoName "
	| vo1  vo3|
	GbtThing struct: #default define: #() full: #().		"create default SVO"
	GbtThing struct: #default define: #() full: #().		"copy of same"	
	vo1 := GbtThing definedAs: #default . "retrieve from program store"
	vo3 := vo1 bizApp thingDefinedAs: #default:T3v0. "retrieve from thing cache"
	self should: [ vo1 longName = 'default:T1v0'] . 
	self should: [ vo3 longName = 'default:T3v0'] . 
! !

GbtTests subclass: #GbtTestSmartFullThings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestSmartFullThings methodsFor: 'helpers' stamp: 'hk 3/14/2017 13:01'!
address 

	^GbtThing struct: 'A' 
		define: {  
		{ #city . #val:tag: . 'city' . #foo2 } }
		full: { 		
		{ #street . #val:tag: . 'street' . #foo1} }! !

!GbtTestSmartFullThings methodsFor: 'helpers' stamp: 'hk 3/14/2017 13:01'!
contact 
	"SVOTestSmartFullThings new contact"
	
	^GbtThing struct: 'C' define: { 
		{ #nname . #val:tag: . 'Krasemann' . #foo8 }.
		{ #adr1 . #thing:tag: . self address . #foo7} }
		full: { 
		{ #adr2 . #thing:tag: . self address . #foo7}.
		{ #vname . #val: . 'Hartmut'} }! !

!GbtTestSmartFullThings methodsFor: 'tests' stamp: 'hk 2/17/2017 16:09'!
testDefineSimpleHierarchySmartFull
	
	| smart full |
	smart := self contact.
	full := smart fullThing. 
	self should: [ full adr2 city = 'city' ].
	self should: [ full adr1 street = 'street' ].
	self should: [ full adr1 fullThing == full adr2 fullThing].
	self should: [ (full allSlotSVOsWith: #foo7) size = 2 ].
	self should: [ full adr1 isSmart not].
	self should: [ full adr2 isSmart not].
	
	self should: [ (smart slotSVOAt: #vname) isNil ].
	self should: [ (smart allSlotSVOsWith: #foo7) size = 1 ].  
	
	smart adr2.  	"this will force the adr2 slot into smart"
	self should: [ (smart allSlotSVOsWith: #foo7) size = 2].
	self should: [ smart adr1 isSmart ].
	self should: [ smart adr2 isSmart ].! !

!GbtTestSmartFullThings methodsFor: 'tests' stamp: 'hk 2/17/2017 15:50'!
testDefineSimpleSmartFull
	
	| smart full |
	smart := self address.
	full := smart fullThing.
	self should: [ full svoName = ('F', smart svoName) ].
	self should: [ full city = 'city' ].
	self should: [ full street = 'street' ].
	self should: [ (smart slotSVOAt: #city) val = 'city' ].
	self should: [ (smart slotSVOAt: #street) isNil ].

! !

!GbtTestSmartFullThings methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testDefineSmartNativeSlots
	
	| smart  |
	smart := GbtThing struct: 'A' 
		define: {  
		{ #ensureBizId } .
		{ #summary . 'a new summary' } .
		{ #purpose . #purp } .
		{ #purposes . #(abc def purp) } .
		{ #idNumberPolicy . #noPol } .
		}
		full: { 		
		{ #city . #val:tag: . 'city' . #foo2 } .
		{ #street . #val:tag: . 'street' . #foo1} }.
		
	self should: [ (smart slotSVOAt: #city) isNil ].
	self should: [ (smart slotSVOAt: #street) isNil ].
	self should: [ smart street = 'street' ].


! !

!GbtTestSmartFullThings methodsFor: 'tests' stamp: 'hk 3/14/2017 13:01'!
testDefineSmartUlist
	
	| smart  |
	smart := GbtThing struct: 'X' 
		define: { }
		full: { { #cust . #listOf: . { self contact } } }.
	smart cust newEntry.	
	self should: [ smart nname = 'Krasemann'].
	self should: [ smart cust list first isSmart].
	self should: [( smart cust list first slotSVOAt: #vname) isNil ].


! !

GbtTests subclass: #GbtTestSton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-AppService'!

!GbtTestSton methodsFor: 'running' stamp: 'hk 8/3/2015 11:47'!
stonIsHere
	Smalltalk at: #STON ifAbsent: [ self error: 'no STON in image' ]
! !

!GbtTestSton methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testStonAttributes
	| a0 a1 a2 |
	self stonIsHere .
	a0 := GbtThing struct: 'GCSList'.
	a0 copy.
	a1 := (GbtThing struct: 'GCActivity')
		define: #type enum: #(#elementary #basic #composite);
		define: #tariff val: 'standard tariff';
		define: #quantity
			no: 0
			from: 0
			to: 1000
			tag: nil;
		define: #deadline date: '1.1.00';
		yourself.
	a2 := (STON fromString: (STON toStringPretty: a1))  .
	self should: [ a2 type = a1 type ].
	self should: [ a2 tariff = a1 tariff ].
	self should: [ a2 quantity = a1 quantity ].
	self should: [ a2 deadline = a1 deadline ]! !

!GbtTestSton methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testStonSlotAssociations
	| a0 a1 a2 |
	self stonIsHere .
	a0 := GbtThing struct: 'Type1'.
	a1 := (GbtThing struct: 'Type2')
		define: #node thing: a0.
		
	a2 := (STON fromString: (STON toStringPretty: a1)) .
	
	self should: [ a2 slots size = 1 ].
	self should: [ a2 slots anyOne isKindOf: GbtSlotAssociation ].! !

!GbtTestSton methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testStonUlist
	| a0 a1 a2 |
	self stonIsHere .
	a0 := GbtThing struct: 'GCSList'.
	a1 := (GbtThing struct: 'GCActivity')
		define: #list listOf: a0 .
	a1 list newEntry.
		
	a2 := (STON fromString: (STON toStringPretty: a1))  .
	
	self should: [ a2 list listSize = 1 ]! !

GbtTests subclass: #GbtTestTransactions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-AppService'!

!GbtTestTransactions methodsFor: 'helpers' stamp: 'hk 3/22/2017 13:05'!
installUsers
	#(Tom Lisa) do: [:u| 
		GbtBizAppServer default addUser: u withRole: GbtRole forExecute]! !

!GbtTestTransactions methodsFor: 'helpers' stamp: 'hk 3/22/2017 13:01'!
itemContext
	^GbtPlainAC struct: 'ItemContext' define: {
		{#displayAs: . 'Item'  } .
		{#uiSpec:icon: . #GbtItemUI . #nil}.
		{#txThings: . #(transferSource transferSink) }
		}
! !

!GbtTestTransactions methodsFor: 'helpers' stamp: 'hk 3/22/2017 13:01'!
listContext 
	^GbtBigListAC struct: 'ListContext' define: {
		{#displayAs: . 'List'} .
		{#noPolicyPrefix: . 'X'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #nil} .
		{#templates: . self thing1} .
		{#subcontext: . self itemContext}
		}

! !

!GbtTestTransactions methodsFor: 'tests' stamp: 'hk 3/22/2017 13:03'!
testNotifyChanges
	| th ctxt1 ctxt2 |
	self installUsers.
	self listContext.
	ctxt1 := (GbtBizAppServer default registerAppFor: #Tom) mainContext.
	ctxt2 := (GbtBizAppServer default registerAppFor: #Lisa) mainContext.

	th := ctxt1 newEntry.
	ctxt1 subcontext  newEntry: th.	"th's now in a plain context"
	th beDirty; save. 
	self should: [ctxt2 list isNotEmpty ].
	self should: [ctxt2 list first version = 1].

	th store.
	
	self shouldnt: [ctxt2 list first == (ctxt1 list first)].
	self should: [ctxt2 list first = (ctxt1 list first)].
	self should: [ctxt1 list first version = 2]! !

!GbtTestTransactions methodsFor: 'tests' stamp: 'hk 3/22/2017 13:03'!
testNotifyNew
	| th ctxt1 ctxt2 |
	self installUsers.
	self listContext.
	ctxt1 := (GbtBizAppServer default registerAppFor: #Tom) mainContext.
	ctxt2 := (GbtBizAppServer default registerAppFor: #Lisa) mainContext.
	th := ctxt1 newEntry. 
	self should: [ctxt2 list isEmpty ].
	ctxt1 subcontext vo: th.
	th store.

	self should: [ctxt2 list isNotEmpty].
	self should: [ctxt2 list first = th].
	self shouldnt: [ctxt2 list first == th].
! !

!GbtTestTransactions methodsFor: 'tests' stamp: 'hk 3/22/2017 13:04'!
testTxWithRoles
	|th ctxt1 ctxt2 th2 th3 |
	self installUsers.
	self listContext.
	ctxt1 := (GbtBizAppServer default registerAppFor: #Tom) mainContext.
	th := ctxt1 newEntry.
	ctxt2 := ctxt1 subcontext.
	ctxt2 newEntry: th beDirty.	
	ctxt2 assign: (th2 := self thing2) beDirty toTxThing: #transferSource. 
	ctxt2 assign: (th3 := self thing3) beDirty toTxThing: #transferSink.
	ctxt2 store.
	self should: [(th bizApp  loadList: th svoName) size = 1].
	self should: [(th bizApp  loadList: th2 svoName) size = 1].
	self should: [(th bizApp  loadList: th3 svoName) size = 1].
! !

!GbtTestTransactions methodsFor: 'helpers' stamp: 'hk 3/14/2017 13:01'!
thing1 
	^GbtThing struct: 'Thing1' define: {}! !

!GbtTestTransactions methodsFor: 'helpers' stamp: 'hk 3/14/2017 13:01'!
thing2 
	^GbtThing struct: 'Thing2' define: {}! !

!GbtTestTransactions methodsFor: 'helpers' stamp: 'hk 3/14/2017 13:01'!
thing3 
	^GbtThing struct: 'Thing3' define: {}! !

GbtTests subclass: #GbtTestUlist
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestUlist methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testCreation
	| list node1 node2 |
	(node1 := GbtThing struct: 'GCUnode1') define: #n1 val: #bla1 .
	(node2 := GbtThing struct: 'GCUnode2') define: #n2 val: #bla2 .
	(list := GbtUlist new)
		newEntry: node1;
		newEntry: node2.
		
	self should: [ list listSize  = 2 ].
	self should: [ ((list slotSVOAt: #'1') slotSVOAt: #n1) val = #bla1 ].
	self should: [ (list slotSVOAt: #'2') n2 = #bla2 ].
! !

!GbtTestUlist methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testTemplate1
	| list node1  |
	(node1 := GbtThing struct: 'GCUnode1') define: #n1 val: #bla1 .
	(list := GbtUlist new) 
		addTemplate: node1;
		newEntry .	
	self should: [ list listSize  = 1 ].
	self should: [ ((list slotSVOAt: #'1') slotSVOAt: #n1) val = #bla1 ].
! !

!GbtTestUlist methodsFor: 'tests' stamp: 'hk 3/27/2017 20:57'!
testTemplate2
	| list node1 node2 |
	(node1 := GbtThing struct: 'GCUnode1') define: #n1 val: #bla1 .
	(node2 := GbtThing struct: 'GCUnode2') define: #n2 val: #bla2 .
	list := (GbtUlist new)
		addTemplate: node1;
		addTemplate: node2 .	
	list newEntry: list templateThing copy.
	list newEntry: list templateThings last copy.
	self should: [ list listSize = 2 ].
	self should: [ list templates size = 2 ].
	self should: [ (list slotSVOAt: #'2') n2 = #bla2 ].
! !

!GbtTestUlist methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testView
	| list node1 node2 view |
	(node1 := GbtThing struct: 'GCUnode1') define: #n1 val: #bla1.
	(node2 := GbtThing struct: 'GCUnode2') define: #n2 val: #bla2.
	list := (GbtUlist new).  
	list	newEntry: node1.
	list	newEntry: node2.
	(view := GbtDeclarative struct: #Decl define: {
		{ #eins . #tag: . #n1}.
		{ #zwei . #tag: . #n2} })
		sources: list.
	self should: [ view copySources isKindOf: GbtThing ].
	self should: [ view eins = #bla1 ].
	self should: [ view zwei = #bla2 ] ! !

!GbtTestUlist methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testViewDisplay
	"Test loopt bei slot-Zugriff in displayStringFor:"
	| list node1  |
	(node1 := GbtThing struct: 'GCUnode1') 
		define: #n1 val: #bla1;
	 	define: #n2 val: #bla2.
	(list := GbtUlist new)
		displayColumns: #(n1 n2);
		newEntry: node1.
		
	self should: [ ((node1 displayArrayFrom: list displayColumns) first: 3) = {' nil* '  .	'bla1' . 'bla2'} ].
! !

!GbtTestUlist methodsFor: 'tests' stamp: 'hk 3/14/2017 13:02'!
testViewDisplayE
	"Test loopt bei slot-Zugriff in displayStringFor:"
	| list node1 space2 |
	space2 := '  '.
	(node1 := GbtThing struct: 'GCUnode1') 
		define: #n1 val: #bla1;
	 	define: #n2 val: #bla2.
	(list := GbtUlist new)
		displayColumns: #(bla1 bla2);
		newEntry: node1.
		
	self should: [ ((node1 displayArrayFrom: list displayColumns) first: 3) = (Array with: #' nil* ' with: '''-''' with: '''-''')  ].
! !

!GbtTests methodsFor: 'running' stamp: 'hk 12/12/2016 19:48'!
setUp
	self tearDown! !

!GbtTests methodsFor: 'running' stamp: 'hk 3/14/2017 13:08'!
tearDown 
	GbtBizAppServer clearStore. 
	GbtSVO initialize. 
	GbtBizNetMockUp stopPolling! !

GbtTests subclass: #GbtVOGUITests
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-GUI'!

GbtVOGUITests subclass: #GbtGUITestSuiteCalcSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-GUI'!

!GbtGUITestSuiteCalcSlot methodsFor: 'tests' stamp: 'hk 3/16/2017 13:14'!
testCalcSlot
	|   value calc |
	editor add: #slot2.
	editor add: #slot3.
	value := ((editor widgets at: #lbl_slot2) subWidget ) widgetValue .
	value accept: '3'.
	calc := ((editor widgets at: #lbl_slot3) subWidget ) widgetValue.
	self should: [ calc text =  '63' ].
	self should: [ editor smartVO slot3 =  '63' ]


! !

!GbtGUITestSuiteCalcSlot methodsFor: 'tests' stamp: 'hk 3/16/2017 13:14'!
testCalcSlotHierarchy
	| calcInputField |
	editor add: #slot1.
	editor add: #slot3. 		"leads to an error -> no number summed up"
	editor add: #sum4.
	calcInputField := ((editor widgets at: #lbl_sum4) subWidget) widgetValue.
	self should: [ calcInputField text =  '3' ].
	self should: [ editor smartVO sum4 =  '3' ].
	editor add: #slot8.		"has a street no = 3 with #calc tag"
	self should: [ editor smartVO sum4 =  '6' ]

! !

!GbtGUITestSuiteCalcSlot methodsFor: 'tests' stamp: 'hk 3/16/2017 13:14'!
testProdSlot
	|  value prod |
	editor add: #slot1.
	editor add: #slot2.
	editor add: #slot3.
	editor add: #prod5.
	value := ((editor widgets at: #lbl_slot2) subWidget) widgetValue.
	value accept: '2'.
	prod := ((editor widgets at: #lbl_prod5) subWidget) widgetValue.
	self should: [ prod text =  '252' ].
	self should: [ editor smartVO prod5 =  '252' ]


! !

!GbtGUITestSuiteCalcSlot methodsFor: 'tests' stamp: 'hk 3/16/2017 13:14'!
testSumSlot
	|   value  sum |
	editor add: #slot1.
	editor add: #slot2.
	editor add: #slot3.
	editor add: #sum4.
	value := ((editor widgets at: #lbl_slot2) subWidget) widgetValue.
	value accept: '2'.
	sum := ((editor widgets at: #lbl_sum4) subWidget) widgetValue.
	self should: [ sum text =  '47' ].
	self should: [ editor smartVO sum4 =  '47' ]


! !

GbtVOGUITests subclass: #GbtGUITestSuiteListSlots
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-GUI'!

GbtVOGUITests subclass: #GbtGUITestSuiteSimpleSlots
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-GUI'!

!GbtGUITestSuiteSimpleSlots methodsFor: 'tests' stamp: 'hk 3/16/2017 13:14'!
testEnumSlotInput
	| tifModel |
	editor add: #slot1.
	tifModel := ((editor widgets at: #lbl_slot1) subWidget) widgetValue.
	tifModel setSelectedItem: '7'.
	self should: [ (editor slotVO slotSVOAt: #slot1) val  = '7' ].
! !

!GbtGUITestSuiteSimpleSlots methodsFor: 'tests' stamp: 'hk 3/16/2017 13:14'!
testRangeSlotInput
	| tifModel |
	editor add: #slot7.  "#no:from:to: . '42'. '-19'. '81'."
	tifModel := ((editor widgets at: #lbl_slot7) subWidget) widgetValue.
	tifModel accept: '12'.
	self should: [ tifModel text = '12' ].
	tifModel accept: '-'.
	self should: [ tifModel text = 'NaN'].
	tifModel accept: '-20'.
	self should: [ tifModel text = 'min: -19'].
	tifModel accept: '81.0001'.
	self should: [ tifModel text = 'max: 81'].
	tifModel accept: 'abc'.
	self should: [ tifModel text = 'NaN'].
	tifModel accept: 'a12'.
	self should: [ tifModel text = 'NaN'].
	tifModel accept: '4a'.
	self should: [ tifModel text = 'NaN'].
! !

!GbtGUITestSuiteSimpleSlots methodsFor: 'tests' stamp: 'hk 3/16/2017 13:14'!
testValueSlotInput
	| tifModel |
	editor add: #slot2.
	tifModel := ((editor widgets at: #lbl_slot2) subWidget) widgetValue.
	tifModel accept: 'abcxyz'.
	self should: [ tifModel text = 'abcxyz' ].
! !

GbtVOGUITests subclass: #GbtGUITestSuiteVOSlots
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-GUI'!

!GbtVOGUITests class methodsFor: 'examples' stamp: 'hk 11/5/2015 12:46'!
exampleDialog
	(self new tearDown; exampleDialog) openWithSpec! !

!GbtVOGUITests class methodsFor: 'examples' stamp: 'hk 11/26/2015 23:03'!
exampleDialogD
	(self new tearDown; exampleDialogD) openWithSpec! !

!GbtVOGUITests class methodsFor: 'examples' stamp: 'hk 7/5/2016 20:27'!
exampleDialogFull
	(self new tearDown; exampleDialogFull) openWithSpec! !

!GbtVOGUITests class methodsFor: 'examples' stamp: 'hk 8/17/2016 22:10'!
exampleDialogFullFreeze
	(self new tearDown; exampleDialogFullFreeze) openWithSpec! !

!GbtVOGUITests methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
addr1 
	^GbtThing struct: #addr1 define:  {
		{ #summary . ' #city  #street ' }.
		{ #widgetClass . #GbtAddressBoxWidget }.
		{ #purposes . #(business private)}.
		{ #city . #val: . #Hamburg }.
		{ #street . #val: . 'an der Alster' } }! !

!GbtVOGUITests methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
addr2 
	"self new addr2 edit"
	^GbtThing struct: #addr2 define:  {
		{ #summary . ' #city am #street ' }.
"		{ #widgetClass . #GcAddressBoxWidget }.
"		{ #purposes . #(private spouse)}.
		{ #city . #val: . #Berlin }.
		{ #street . #val: . #Kuhdamm }.
		{ #no . #val:tag: . '3' . #calc} .
		{ #adr . #thing: . self addr1 }.	
	 }! !

!GbtVOGUITests methodsFor: 'things' stamp: 'hk 2/23/2017 17:48'!
dialogFullThing
	"self new dialogFullThing editD"
	^ self dialogThing 
		slot1 ;
		slot2 ;
		slot2a ;
		slot3 ;
		sum4 ;
		prod5 ;
		slot6 ;
		slot7 ;
		no ;
		addresses ;
		slot8 ;
		slot9 ;
		slot10 ;
		slotB ;
		slotC ;
		slotD ;
		yourself! !

!GbtVOGUITests methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
dialogThing
	^ GbtThing struct: #demo define: {
			{#summary . 'slot#1 and slot#6 touched in summary - #slot1 - #slot6'}}
		full: {
			{#slot1. #enum:for:tag:. #('3' '4' '7').
			#(#purp1 #purp2 #purp3). #calc}. {#slot2 . #val:tag: . #city . #calc}.
			{#slot2a . #val: . 'slot9'}.
			{#slot3 . #calc:tag: . '7 * 3 * #slot2 ' . #calc}.
			{#sum4 . #calc: . 'sum #calc'}.
			{#prod5 . #calc: . 'prod #calc'}.
			{#slot6. #date:. Date today}.
			{#slot7. #no:from:to:for:tag:. '42'. '-19'. '81'. #(#purp1 #purp2). nil}.
			{#no . #no: . '0'}.
			{#addresses. #listOf:. {self addr1. self addr2}}.
			{#slot8. #thing:for:. self addr2. #(#geschaeft #privat #anlieferung #dienstboten)}.
			{#slot9. #thing:. self addr1}.
			{#slot10. #text:for:. 'Beispieltext'. #(#abc #def)}.
			{#slotB . #calc: . 'ref #city'}.
			{#slotC . #calc: . 'lookup:  #slot2a #slot2 '}.
			{#slotD . #constraint: . '#slot7 = ''42'' '}}! !

!GbtVOGUITests methodsFor: 'running' stamp: 'hk 2/23/2017 17:48'!
exampleDialog
	^GbtThingEditor on: self dialogThing

! !

!GbtVOGUITests methodsFor: 'running' stamp: 'hk 2/23/2017 17:48'!
exampleDialogD
	^GbtThingDiEditor on: (self dialogThing copy)  

! !

!GbtVOGUITests methodsFor: 'running' stamp: 'hk 2/23/2017 17:56'!
exampleDialogFull
	"GbtVOGUITests new dialogFullThing"  
	^GbtThingEditor on: (self dialogFullThing)  

! !

!GbtVOGUITests methodsFor: 'running' stamp: 'hk 10/6/2016 19:01'!
exampleDialogFullFreeze
	"self new dialogFullThing copyFreeze editD"
	^GbtThingEditor on: (self dialogFullThing copyFreeze)  

! !

!GbtVOGUITests methodsFor: 'running' stamp: 'hk 3/16/2017 13:14'!
setUp
	super setUp.
	(editor := self exampleDialog) buildWithSpec! !

!RTGroup methodsFor: '*GBT-DSL' stamp: 'hk 10/20/2015 16:12'!
elementFromModel: anObject
	"Return an element that corresponds to the object provided as parameter. If none is found, then return nil.
	= corrected to == 20-10-2015 hk"
	^ self detect: [ :el | el model == anObject ] ifNone: [ nil ]! !

DynamicComposableModel subclass: #GbtAddressBoxWidget
	instanceVariableNames: 'slotVO fields slotName wh'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-VO'!

!GbtAddressBoxWidget commentStamp: 'hk 1/19/2016 12:42' prior: 0!
Box widget for an address

    Instance Variables
	fields:		<OrderedIdentityDictionary>
	slotVO:		<ThingVO>
	slotName:	<Symbol>
	wh: 			<Number>		widget height

=========================================================
|th|
SVO initializeAll.
th := ThingVO newOfType: 'GCAddress' define: { 
		{ #widgetClass . #GcAddressBoxWidget}.
		{ #street . #val: . ''}.		
		{ #streetNo . #val: . ''}.
		{ #cityCode . #val: . ''}.		
		{ #cityName . #val: . ''}.	}.
(self on: th key: nil  for: nil) openWithSpec!

!GbtAddressBoxWidget methodsFor: 'initialization' stamp: 'hk 1/19/2016 12:00'!
addColDivider: aColumn height: aNumber
	"corresponding method: hDivider"
	aColumn newRow: [:r| r add: #hDivider] height: aNumber! !

!GbtAddressBoxWidget methodsFor: 'api' stamp: 'hk 1/20/2016 15:08'!
initialExtent
	
	^600 @ self widgetHeight! !

!GbtAddressBoxWidget methodsFor: 'initialization' stamp: 'hk 11/1/2016 17:36'!
initializeLayout
	
	wh := (fields collect: [:f| (self widgets at: f) widgetHeight]) reduce: [:wh1 :wh2| wh1 max: wh2].
	self layout: 
		(SpecLayout composed newColumn: [:c| 
			c newRow: [:r| r add: #hDivider1] height: 8.
			c newRow: [:r| fields do: [:wl| r add: wl]] height: wh.
			c newRow: [:r| r add: #hDivider2] height: 8 ]
		).
	wh := wh + 16.		
	self needFullRebuild: false ! !

!GbtAddressBoxWidget methodsFor: 'initialization' stamp: 'hk 2/16/2017 14:46'!
initializeWidgets
	self instantiateModels: #(
		hDivider1 ButtonModel
		hDivider2 ButtonModel
		).
	self hDivider1 state: true.
	self hDivider2 state: true.
	fields := OrderedIdentityDictionary new.
	slotVO slots do: 
		[ :s |  |wl sw k v|
		k := s key. v := s value.
		wl:= ('lbl_',k) asSymbol.
		fields add: k -> wl .
		(sw := v uiClass basicNew)
				slotVO: v; 
				label: k;
				initialize.		
	self assign: sw to: wl].		
	self initializeLayout
	

! !

!GbtAddressBoxWidget methodsFor: 'accessing' stamp: 'hk 1/18/2016 11:44'!
label: aSymbol
	slotName := aSymbol! !

!GbtAddressBoxWidget methodsFor: 'compatibility' stamp: 'hk 1/19/2016 12:28'!
resetEditButton! !

!GbtAddressBoxWidget methodsFor: 'compatibility' stamp: 'hk 1/13/2016 16:16'!
rightEditBlock: aBlock! !

!GbtAddressBoxWidget methodsFor: 'compatibility' stamp: 'hk 1/18/2016 13:18'!
signalChangeToOwner
	""! !

!GbtAddressBoxWidget methodsFor: 'accessing' stamp: 'hk 1/13/2016 16:15'!
singleHeight
	^self class toolbarHeight! !

!GbtAddressBoxWidget methodsFor: 'accessing' stamp: 'hk 1/18/2016 11:18'!
slotName: aSymbol
	slotName := aSymbol! !

!GbtAddressBoxWidget methodsFor: 'accessing' stamp: 'hk 1/13/2016 15:34'!
slotVO: anObject
	slotVO := anObject! !

!GbtAddressBoxWidget methodsFor: 'accessing' stamp: 'hk 1/19/2016 11:51'!
widgetHeight
	^wh! !

DynamicComposableModel subclass: #GbtCustomSDBoxWidget
	instanceVariableNames: 'slotVO wh'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtCustomSDBoxWidget commentStamp: 'hk 2/24/2016 16:25' prior: 0!
I display the service Data ahead all aspects

    Instance Variables
	slotVO:		<Object>
	wh:		<Object>

=======================================

SVO initializeAll.
(self on: IntegrationTestThings serviceData_BtoHB_2Items ) openWithSpec!

!GbtCustomSDBoxWidget class methodsFor: 'instance creation' stamp: 'hk 6/12/2016 14:55'!
on: aVO 
	^self on: aVO key: #key for: #() tags: nil! !

!GbtCustomSDBoxWidget class methodsFor: 'instance creation' stamp: 'hk 6/12/2016 15:20'!
on: aVO key: aSymbol for: anArray tags: void
	^self basicNew 
		slotVO: aVO; 
		initialize! !

!GbtCustomSDBoxWidget class methodsFor: 'instance creation' stamp: 'hk 1/25/2016 14:57'!
on: aVO label: aString
	^self on: aVO! !

!GbtCustomSDBoxWidget class methodsFor: 'instance creation' stamp: 'hk 2/23/2016 15:58'!
on: aVO stopSlots: anObject
	^self on: aVO ! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/25/2016 14:15'!
dividerHeight
	^8! !

!GbtCustomSDBoxWidget methodsFor: 'initialization' stamp: 'hk 1/28/2016 13:44'!
initializeLayout
	self layout: (SpecLayout composed newColumn: [ :col| col 
		newRow: [ :r | r 
			add: #serviceData width: self labelWidth1;
			add: #serviceDataStatus width: self labelWidth0;
			add: #serviceDataStatusCont width: self labelWidth1;
			add: #serviceDataSummary
			] height: self singleHeight;
		newRow: [ :r | r add: #divider1 ] height: self dividerHeight;
		newRow: [ :r | r
			add: #transport width: self labelWidth1;
			add: #transportSummary;
			add: #editButton width: 24 
			] height: self singleHeight;
		newRow: [ :r | r
			add: #shipment width: self labelWidth1;
			add: #shipmentSummary 
			] height: self singleHeight;
		newRow: [ :r | r add: #divider2 ] height: self dividerHeight;
		newRow: [ :r | r
			add: #emptyLabel width: self insetWidth;
			add: #routeDate width: self labelWidth2;
			add: #routeDateSummary 
			] height: self singleHeight;
		newRow: [ :r | r add: #divider3 ] height: self dividerHeight;
		newRow: [ :r | r 
			newColumn: [ :c | c ] width: self insetWidth;
			newColumn: [ :c | c
				newRow: [ :r1 | r1 
					newColumn: [ :c1 | c1 add: #origin ] width: self labelWidth1;
					newColumn: [ :c1 | c1 
						add: #pickupLocation;
						add: #pickupDateTime
						] ] ];
			newColumn: [ :c | c add: #divider4] width: self dividerHeight;
			newColumn: [ :c | c 
				newRow: [ :r1 | r1 
					newColumn: [ :c1 | c1 add: #destination ] width: self labelWidth1;
					newColumn: [ :c1 | c1
						add: #destLocation;
						add: #destDateTime						
						] ] ]
			] height: 2 * self singleHeight;
		newRow: [ :r | r add: #emptyLabel ]
	]).
	wh := 6 * self singleHeight + (4 * self dividerHeight)! !

!GbtCustomSDBoxWidget methodsFor: 'initialization' stamp: 'hk 4/30/2016 18:29'!
initializeWidgets
	|tr|
	slotVO serviceDataItems list ifEmpty: [ slotVO serviceDataItems newEntry ].
	tr := slotVO serviceDataItems list first.		"needs to be extendet !!!!!! "
	self instantiateModels: #(
		editButton	ButtonModel 
		divider1 		ButtonModel
		divider2 		ButtonModel
		divider3 		ButtonModel
		divider4 		ButtonModel
		divider5 		ButtonModel
		emptyLabel	LabelModel
		serviceData	LabelModel
		serviceDataSummary			LabelModel
		serviceDataStatus			LabelModel
		serviceDataStatusCont		LabelModel
		transport		LabelModel
		transportSummary			LabelModel
		shipment		LabelModel
		shipmentSummary				LabelModel
		routeDate		LabelModel
		routeDateSummary			LabelModel
		origin			LabelModel
		pickupLocation				LabelModel
		pickupDateTime				LabelModel
		destination	LabelModel
		destLocation					LabelModel
		destDateTime					LabelModel
		).
	self editButton 
		icon: (GbtIcons at: #edit) ;
		action: [(GbtThingDiEditor on: tr) openWithSpec ];
		state: true.
	self divider1 state: true.
	self divider2 state: true.
	self divider3 state: true.
	self divider4 state: true.
	self divider5 state: true.
		self serviceData label: #ServiceData.
		self serviceDataSummary label: slotVO summaryEnriched.
		self serviceDataStatus label: #ASPECT:.
		self serviceDataStatusCont label: slotVO aspectStatus.
		self transport label: #Transport.
		self transportSummary label: tr summaryEnriched.
		self shipment label: #Shipment.
		self shipmentSummary label: tr serviceDataItemTransportHeader summaryEnriched.
		self routeDate label: 'Shipment Route & Date'.
		self routeDateSummary label: tr shipmentRouteAndDate summaryEnriched.
		self origin label: #Origin.
		self pickupLocation label: tr pickupLocation summaryEnriched.
		self pickupDateTime label: tr pickupDateAndTime summaryEnriched.
		self destination label: #Destination.
		self destLocation label: tr deliveryLocation summaryEnriched.
		self destDateTime label: tr deliveryDateAndTime summaryEnriched.
	
	self initializeLayout
	

! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/26/2016 11:47'!
insetWidth
	^20! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/26/2016 11:59'!
labelWidth0
	^60! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/26/2016 11:59'!
labelWidth1
	^120! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/26/2016 11:43'!
labelWidth2
	^160! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/6/2017 17:33'!
saved
	"compatibility with GbtThingEditor & GbtItemUI"
	^nil! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/25/2016 14:01'!
singleHeight
	^self class toolbarHeight! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/25/2016 13:23'!
slotVO: aVO
	slotVO := aVO! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/26/2016 11:56'!
white
	^(BorderedMorph new color: Color white) asSpecAdapter! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/25/2016 14:48'!
widgetHeight
	^wh! !

DynamicComposableModel subclass: #GbtEmptyWidget
	instanceVariableNames: 'slotName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-VO'!

!GbtEmptyWidget commentStamp: 'hk 1/21/2016 14:47' prior: 0!
I displayx an empty smart slot

    Instance Variables
	slotName:		<String>
!

!GbtEmptyWidget class methodsFor: 'instance creation' stamp: 'hk 1/15/2016 17:00'!
key: aSlotName
	^self basicNew 
		slotName: aSlotName;
		initialize! !

!GbtEmptyWidget methodsFor: 'initialization' stamp: 'hk 1/16/2016 13:51'!
contentLayout: aRow
	aRow add: #emptyLabel! !

!GbtEmptyWidget methodsFor: 'initialization' stamp: 'hk 1/16/2016 13:47'!
initializeCommonWidgets
	self instantiateModels: #( 
	emptyLabel	LabelModel
	button			ButtonModel
	label			LabelModel) ! !

!GbtEmptyWidget methodsFor: 'initialization' stamp: 'hk 1/20/2016 14:53'!
initializeLayout
	self layout: (SpecLayout composed newRow: [ :row |  row
		newColumn: [ :c | c
			newRow: [ :r | 
				r add: #button width: 24.
				r add: #label.
				self purposeLayout: r]] width: 160;
		newColumn: [ :c |  ] width: 24;
		newColumn: [ :c | c
			newRow: [ :r | self contentLayout: r] height: self widgetHeight ] ] 
		).
	self needRebuild: false ! !

!GbtEmptyWidget methodsFor: 'initialization' stamp: 'hk 4/30/2016 18:29'!
initializeWidgets
	self initializeCommonWidgets.
		
	self label label: slotName .
	self button 
		icon: (GbtIcons at: #add);
		action: [ self owner add: slotName ].
	self initializeLayout
! !

!GbtEmptyWidget methodsFor: 'initialization' stamp: 'hk 1/16/2016 13:53'!
purposeLayout: aRow! !

!GbtEmptyWidget methodsFor: 'accessing' stamp: 'hk 1/15/2016 16:50'!
singleHeight
	^self class toolbarHeight! !

!GbtEmptyWidget methodsFor: 'accessing' stamp: 'hk 2/22/2017 12:09'!
slotName
	^slotName ! !

!GbtEmptyWidget methodsFor: 'accessing' stamp: 'hk 1/15/2016 16:51'!
slotName: anObject
	slotName := anObject! !

!GbtEmptyWidget methodsFor: 'accessing' stamp: 'hk 1/20/2016 13:15'!
widgetHeight
	^self singleHeight ! !

GbtEmptyWidget subclass: #GbtSlotWidget
	instanceVariableNames: 'slotVO purposes tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-VO'!

!GbtSlotWidget commentStamp: 'hk 1/21/2016 14:48' prior: 0!
I displayx a filled smart slot

    Instance Variables
	purposes:	<OrderedCollection>		first entry = selection
	slotVO:		<ThingVO | LeafVO>
	
	slotName 	from superclass!

!GbtSlotWidget class methodsFor: 'instance creation' stamp: 'hk 6/12/2016 14:51'!
on: aVO key: aSymbol for: anArray tags: aCollOrNil
	^self basicNew 
		slotVO: aVO; 
		slotName: aSymbol; 
		purposes: anArray;
		tags: aCollOrNil ;
		initialize
! !

!GbtSlotWidget methodsFor: 'adding' stamp: 'hk 2/17/2017 16:02'!
addPurpose: aString
	purposes remove: aString ifAbsent: []. 
	purposes addFirst: aString .
	(owner slotVO slotAt: slotName) purposes: purposes! !

!GbtSlotWidget methodsFor: 'ui actions' stamp: 'hk 1/16/2016 13:11'!
chooseNewPurpose
	| purp |
	purp := (self choosePurposeFrom: self purposes) ifNil: [^self].
	self addPurpose: purp.
	self label label: self labelContent.
	self needFullRebuild: false.
	(widgets at: #label) needRebuild: true.
	self buildWithSpec! !

!GbtSlotWidget methodsFor: 'ui actions' stamp: 'hk 1/15/2016 16:55'!
choosePurposeFrom: aList
	"^nil or the chosen purpose"
	
	^UIManager default 
				chooseOrRequestFrom: aList 
				title: 'choose a purpose'.! !

!GbtSlotWidget methodsFor: 'initialization' stamp: 'hk 10/6/2016 15:41'!
contentLayout: aRow
	aRow add: #subWidget ! !

!GbtSlotWidget methodsFor: 'testing' stamp: 'hk 11/1/2016 17:39'!
hasPurposes
	^self purposes isNotEmpty 
! !

!GbtSlotWidget methodsFor: 'initialization' stamp: 'hk 10/6/2016 15:40'!
initializeWidgets
	"use the default uiClass"
	| sw |
	self initializeCommonWidgets.
	self instantiateModels: #(purpChooseButton 	ButtonModel) .
	(sw := slotVO defaultUiClass basicNew)
				slotVO: slotVO; 
				owner: self;
				label: slotName;
				initialize.		
	self assign: sw to: #subWidget.							
	self label label: self labelContent.
	self button 
		icon: (GbtIcons at: #delete);
		action: [ self owner remove: slotName ].
	self purpChooseButton 
		icon: (GbtIcons at: #goto);
		action: [ self chooseNewPurpose ];
		state: false.
	self focusOrder add: self subWidget.
	self initializeLayout
! !

!GbtSlotWidget methodsFor: 'initialization' stamp: 'hk 6/12/2016 15:07'!
labelContent
	^self hasPurposes 
		ifFalse: [slotName, self tagString] 
		ifTrue: [self selectedPurpose, self tagString].! !

!GbtSlotWidget methodsFor: 'initialization' stamp: 'hk 1/16/2016 13:55'!
purposeLayout: aRow
	self hasPurposes ifTrue: [ aRow add: #purpChooseButton width: 20]! !

!GbtSlotWidget methodsFor: 'accessing' stamp: 'hk 1/15/2016 16:58'!
purposes
	^purposes ifNil: [purposes := OrderedCollection new]! !

!GbtSlotWidget methodsFor: 'accessing' stamp: 'hk 1/15/2016 16:57'!
purposes: anArrayOfString
	purposes := anArrayOfString asOrderedCollection! !

!GbtSlotWidget methodsFor: 'accessing' stamp: 'hk 1/15/2016 17:06'!
selectedPurpose
	^purposes at: 1 ifAbsent: [^nil] ! !

!GbtSlotWidget methodsFor: 'accessing' stamp: 'hk 1/15/2016 16:57'!
slotVO: anObject
	slotVO := anObject! !

!GbtSlotWidget methodsFor: 'accessing' stamp: 'hk 11/1/2016 17:44'!
tagString
	| res |
	res := WriteStream on: ''.
	tags ifNotNil: 
		[res nextPut: $(. 
		tags do: [:t| res nextPutAll: t; nextPut: $ ].
		res nextPut: $)].
	^res contents! !

!GbtSlotWidget methodsFor: 'accessing' stamp: 'hk 6/12/2016 14:50'!
tags: aCollOrNil
	tags := aCollOrNil! !

!GbtSlotWidget methodsFor: 'accessing' stamp: 'hk 10/6/2016 15:38'!
widgetHeight
	 ^self subWidget widgetHeight! !

DynamicComposableModel subclass: #GbtTableListUI
	instanceVariableNames: 'list emptyLabel header displayColumns titleColumns template'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtTableListUI commentStamp: 'hk 1/13/2017 12:28' prior: 0!
A TableListUI is a list widget with row titles 
(may be replaced by a more sophisticated widget).

Hence the list items must respond to: 			This dependence can be weakened
-  displayArray and 								by introducing two inst vars:
-  displayLabelArray 							- one for the displayBlock of the list 
and it must carry an automatic id !!!!!!				- one for the header text (asReactiveVar))

Instance Variables
	emptyLabel:		<LabelModel> 				needed for fill in the blanks
	list:				<MultiColumnListModel>	
	header: 			<LabelModel>
	displayColumns: 	<Array of Symbol | nil>		for list display & filtering
	titleColumns: 	<Array of Symbol | nil>		for list header
	template: 		<GbtThing> 					for list elements

======= Tests ======

| ct |
(ct := GCContact  contact) copy .
(TableListUI new items: ct copies asOrderedCollection ) openWithSpec!

!GbtTableListUI class methodsFor: 'instance-creation' stamp: 'hk 1/13/2017 16:40'!
on: aTemplateThing columns: displayColumns
	^self basicNew template: aTemplateThing ; displayColumns: displayColumns ! !

!GbtTableListUI methodsFor: 'drop down filters' stamp: 'hk 1/13/2017 16:48'!
dcWidth
		^self class  buttonWidth *2
! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 7/1/2016 12:26'!
displayColumns
	^displayColumns ! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 1/13/2017 16:04'!
displayColumns: argArray
	"the argArray contains Symbols or Pairs of display and title symbol"
	displayColumns := argArray collect: [:e| e isArray ifTrue: [e first] ifFalse: [e]].
	titleColumns := argArray collect: [:e| e isArray ifTrue: [e second] ifFalse: [e]]
! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 2/14/2015 18:08'!
emptyLabel
	^ emptyLabel! !

!GbtTableListUI methodsFor: 'drop down filters' stamp: 'hk 1/13/2017 16:25'!
filterList: aSlotName for: aValue
	owner filteredList: aSlotName for: aValue
! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 2/15/2015 17:00'!
header
	^ header ! !

!GbtTableListUI methodsFor: 'initialization' stamp: 'hk 1/13/2017 16:46'!
headerRow: aColumn
	aColumn newRow: [:r| 
		r add: #header width: self dcWidth.
		displayColumns do: [:dc| r add: dc asSymbol width: self dcWidth ].
		r add: #emptyLabel
	] height: self class toolbarHeight ! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 8/26/2016 13:19'!
height
	^(((self list listSize max:2) / 2) min: 5)* self class toolbarHeight! !

!GbtTableListUI methodsFor: 'initialization' stamp: 'hk 1/13/2017 19:08'!
initializeColumnFilters
	1 to: titleColumns size do: [:i|  |w dc tc|
		dc := displayColumns at: i.
		tc := titleColumns at: i.
		self instantiateModels: { dc . #DropListModel }.
		w := widgets at: dc asSymbol.
		w addItemLabeled: tc do: [self resetList; resetDropDownListFor: dc ]].		"first item"
	self resetDropDownLists ! !

!GbtTableListUI methodsFor: 'initialization' stamp: 'hk 1/13/2017 16:33'!
initializeLayout
	self layout: (SpecLayout composed
		newColumn: [ :c | 
			self headerRow: c .  
			c  add: #list  ] )! !

!GbtTableListUI methodsFor: 'initialization' stamp: 'hk 1/13/2017 17:51'!
initializeWidgets
	emptyLabel := self newLabel  .
	list := self newMultiColumnList  .	
	header := self newLabel label: #bizId.	
	self initializeColumnFilters .	
	list displayBlock: [:item| self wrapItem: (item displayArrayFrom: self displayColumns)] .
	list menu: [ :m | self listMenu: m ] .
	self focusOrder add: list .
	self needFullRebuild: false . 
	self initializeLayout! !

!GbtTableListUI methodsFor: 'api' stamp: 'hk 2/14/2015 17:15'!
items: aCollection
	list items: aCollection! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 2/14/2015 18:08'!
list
	^ list! !

!GbtTableListUI methodsFor: 'api' stamp: 'hk 2/21/2015 14:38'!
listItems
	^list listItems! !

!GbtTableListUI methodsFor: 'initialization' stamp: 'hk 1/6/2017 18:09'!
listMenu: m
	| item |
	item := m add: #inspect target: self selectedItem selector: #inspect .
	item enablementSelector: [ self selectedItem isNotNil ] .
	^m! !

!GbtTableListUI methodsFor: 'api' stamp: 'hk 12/5/2016 13:40'!
listSize
	^list listSize! !

!GbtTableListUI methodsFor: 'api' stamp: 'hk 2/14/2015 18:02'!
menu:  aBlock
	" [ :menu :shifted | nil ] "
	list menu: aBlock  ! !

!GbtTableListUI methodsFor: 'drop down filters' stamp: 'hk 1/13/2017 19:03'!
resetDropDownListFor: aSlot
	| dropList first wgt |
	wgt := widgets at: aSlot asSymbol.
	dropList := wgt getList. 
	first := dropList first.
	dropList removeAll; add: first.
		(self valuesOf: aSlot) do: [:v|		"other items"
				wgt addItemLabeled: v 
					 do: [self filterList: aSlot for: v]]
	
	
	! !

!GbtTableListUI methodsFor: 'api' stamp: 'hk 1/13/2017 19:07'!
resetDropDownLists
	displayColumns do: [:dc| self resetDropDownListFor: dc ]! !

!GbtTableListUI methodsFor: 'drop down filters' stamp: 'hk 1/13/2017 16:14'!
resetList
	owner resetList.
	"erzeuge die dropdown listen neu"! !

!GbtTableListUI methodsFor: 'api' stamp: 'hk 3/27/2015 16:46'!
resetSelection
	list resetSelection! !

!GbtTableListUI methodsFor: 'api' stamp: 'hk 6/10/2015 10:18'!
selectedItem
	^list selectedItem! !

!GbtTableListUI methodsFor: 'api' stamp: 'hk 2/21/2015 14:42'!
setSelectedItem: anItem
	list setSelectedItem: anItem! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 3/23/2015 12:09'!
size
	^self list listSize ! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 1/13/2017 12:28'!
template
	^ template! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 1/13/2017 12:28'!
template: aThing
	template := aThing! !

!GbtTableListUI methodsFor: 'api' stamp: 'hk 11/1/2016 16:49'!
title
	^#TableList! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 7/1/2016 13:04'!
titleColumns
	^titleColumns ! !

!GbtTableListUI methodsFor: 'drop down filters' stamp: 'hk 1/13/2017 16:41'!
valuesOf: aSlot
	^owner context valuesOf: aSlot! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 8/10/2015 17:36'!
view
	^displayColumns ! !

!GbtTableListUI methodsFor: 'api-events' stamp: 'hk 12/3/2016 20:11'!
whenListChanged: aBlock
	list whenListChanged: aBlock! !

!GbtTableListUI methodsFor: 'api-events' stamp: 'hk 2/14/2015 17:18'!
whenSelectedItemChanged: aBlock
	list whenSelectedItemChanged: aBlock! !

!GbtTableListUI methodsFor: 'api-events' stamp: 'hk 1/9/2017 16:23'!
whenSelectionChanged: aBlock
	list whenSelectionChanged: aBlock! !

!GbtTableListUI methodsFor: 'private' stamp: 'hk 1/13/2017 16:58'!
wrapItem: anArray
	"set all strings of anArray to equal size"
	
	^anArray collect: [ :s | s padRightTo: 45 ] 
	
	
	! !

DynamicComposableModel subclass: #GbtTemplatesEditor
	instanceVariableNames: 'thingList thing slotList headline templateList slot headIcon emptyLabel hasTemplateEditor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtTemplatesEditor commentStamp: 'hk 8/21/2016 15:12' prior: 0!
I am a system special editor to manage the pre- and user defined templates
I allow to delete and modify them. Creation is in a concrete business context on the fly.

    Instance Variables
	headIcon:		<Object>
	headline:		<Object>
	slot:				<Object>	selected slot
	slotList:			<Object>	slots of the thing that carry templates
	templateList:	<Object>	all templates found
	thing:			<Object>	selected thing
	thingList:		<Object>	of the things that carry templates


    Implementation Points!

!GbtTemplatesEditor methodsFor: 'testing' stamp: 'hk 8/21/2016 19:03'!
clearTemplateEditor 
	hasTemplateEditor := false.
	self reBuild! !

!GbtTemplatesEditor methodsFor: 'menu' stamp: 'hk 8/21/2016 20:04'!
deleteSelectedTemplate 
	self slot templates remove: templateList selectedItem.
	templateList items: self templateListItems ; resetSelection! !

!GbtTemplatesEditor methodsFor: 'menu' stamp: 'hk 12/16/2016 18:50'!
editSelectedTemplate 
	| vo |
	vo := templateList selectedItem ifNil: 
		[hasTemplateEditor := false.
		^self reBuild].
	self assign: (GbtThingEditor on: vo) to: #subUi.
	hasTemplateEditor := true.
	self reBuild.! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 8/21/2016 18:25'!
emptyLabel
	^emptyLabel ! !

!GbtTemplatesEditor methodsFor: 'testing' stamp: 'hk 8/21/2016 18:27'!
hasTemplateEditor 
	^hasTemplateEditor = true! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 8/3/2016 13:19'!
headIcon 
	^headIcon ! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 8/3/2016 11:08'!
headline 
	^headline! !

!GbtTemplatesEditor methodsFor: 'initialization' stamp: 'hk 8/21/2016 18:45'!
initializeLayout
	self layout: (SpecLayout composed newColumn: [ :c |  c
			newRow: [:r| r
					add: #headIcon width: 24;
					add: #headline ] height: self class toolbarHeight;
			newRow: [:r| r
					add: #thingList;
					add: #slotList ;
					add: #templateList].
			self hasTemplateEditor 
				ifTrue: [ c add: #subUi ] 
				ifFalse: [ c add: #emptyLabel ] ];
		yourself)! !

!GbtTemplatesEditor methodsFor: 'initialization' stamp: 'hk 8/21/2016 19:42'!
initializePresenter
	thing whenChangedDo: [slotList	items: self slotListItems; resetSelection ].
	thingList whenSelectedItemChanged: [:item| thing value: item ].

	slot whenChangedDo: [templateList resetSelection; items: self templateListItems] .
	slotList whenSelectedItemChanged: [:item| slot value: item] .
	
	templateList whenSelectedItemChanged: [:item| self editSelectedTemplate ] .! !

!GbtTemplatesEditor methodsFor: 'initialization' stamp: 'hk 3/15/2017 10:14'!
initializeWidgets
	"GbtTemplatesEditor new openWithSpec"
	(headIcon := self newButton)
		icon: (GbtIcons at: #settings).
	(headline := self newLabel)
		label: 'Edit or Remove Templates'.
	thing := nil asValueHolder .
	thingList	 := self newList
		items: self tmplHolders;
		autoDeselect: true;
		displayBlock: [:item | item svoName].
	slot := nil asValueHolder .
	slotList	:= self newList 
		items: self slotListItems;
		autoDeselect: true;
		displayBlock: [:item | item key].
	templateList := self newList
		items: self templateListItems ;
		autoDeselect: true;
		displayBlock: [:item| item isString ifTrue: [item] ifFalse: [item summary] ];
		menu: [:m | self templateListMenu: m ] . 
	emptyLabel := self newLabel.
	self initializeLayout! !

!GbtTemplatesEditor methodsFor: 'initialization' stamp: 'hk 8/21/2016 18:35'!
reBuild
	self initializeLayout.
	self needFullRebuild: false .
	self buildWithSpec! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 8/3/2016 12:22'!
slot
	^slot value! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 8/3/2016 11:05'!
slotList 
	^slotList! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 11/22/2016 16:31'!
slotListItems
	^self thing ifNil: [#()] ifNotNil: [self thing allSlotAssocsWithTemplates]
	! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 8/3/2016 11:27'!
templateList
	^templateList ! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 8/3/2016 12:23'!
templateListItems
	^self slot ifNil: [#()] ifNotNil: [self slot templates]
	! !

!GbtTemplatesEditor methodsFor: 'menu' stamp: 'hk 8/21/2016 19:19'!
templateListMenu: m 
	| item item2 |
	item := m add: #remove target: self selector: #deleteSelectedTemplate .
	item2 := m add: #edit target: self selector: #editSelectedTemplate .
	item enablementSelector: [ self templateList selectedItem isNotNil ] .
	item2 enablementSelector: [ self templateList selectedItem isNotNil ] .
	^m! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 8/3/2016 11:16'!
thing 
	^thing value! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 8/3/2016 11:06'!
thingList
	 ^thingList ! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 3/17/2017 12:13'!
tmplHolders
	| app |
	app := owner context bizApp.
	^app asOrderedCollection 
		addAll: app allFsvosWithTemplates; 
		yourself! !

DynamicComposableModel subclass: #GbtThingDiEditor
	instanceVariableNames: 'vo stopSlots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-VO'!

!GbtThingDiEditor commentStamp: 'hk 6/20/2016 13:44' prior: 0!
I am an IphoneEditor with 2 panes,
the right pane for node editing

    Instance Variables
	stopSlots:		<Array of Symbolo> 		the slots not to show
	vo:				<GbtThing>				to be edited!

!GbtThingDiEditor class methodsFor: 'instance creation' stamp: 'hk 11/23/2015 16:35'!
on: aVO 
	^self basicNew 
		vo: aVO; 
		initialize
! !

!GbtThingDiEditor class methodsFor: 'instance creation' stamp: 'hk 2/23/2016 15:53'!
on: aVO stopSlots: arrayOfSlotNames
	^self basicNew 
		vo: aVO; 
		stopSlots: arrayOfSlotNames;
		initialize
! !

!GbtThingDiEditor methodsFor: 'adding' stamp: 'hk 1/19/2016 12:19'!
addRowDivider: aRow width: aNumber
	"corresponding method: vDivider"
	aRow newColumn: [:c| c add: #vDivider] width: aNumber! !

!GbtThingDiEditor methodsFor: 'ui actions' stamp: 'hk 6/14/2016 13:51'!
editRight: aVO 
	self editor1 resetEditButton.
	self assign: (GbtThingEditor on: aVO) to: #editor2.
	self initializeLayout .
	self initializeRightPresenter .
	self needFullRebuild: false.
	self buildWithSpec
! !

!GbtThingDiEditor methodsFor: 'api' stamp: 'hk 11/23/2015 16:41'!
initialExtent
		^ (widgets at: #editor1) initialExtent * (2@1) + (24@0)! !

!GbtThingDiEditor methodsFor: 'initialization' stamp: 'hk 1/22/2016 11:57'!
initializeLayout
	self layout: (SpecLayout composed newRow: [ :r | 
		r newColumn:  [ :c | c add: #editor1].
		self addRowDivider: r width: 8.
		r addSplitter.
		r newColumn:  [ :c | c add: #editor2]]).
	self needFullRebuild: false 
		 
! !

!GbtThingDiEditor methodsFor: 'initialization' stamp: 'hk 10/6/2016 19:38'!
initializeRightPresenter
	self editor2 slotwidgets do: 
		[:w | w subWidget changeFlag whenChangedDo: 
			[self editor2 someValueChanged value: true]	 ].
	self editor2 someValueChanged whenChangedDo: 
		[self editor1 someValueChanged value: true ].
	self editor2 saved whenChangedDo: "reflektiert den Thing-Ast"
		[self editor1 someValueChanged value: true.
		self editor1 saved value: true]! !

!GbtThingDiEditor methodsFor: 'initialization' stamp: 'hk 4/30/2016 16:48'!
initializeWidgets
	self instantiateModels: #(vDivider ButtonModel).
	self assign: (GbtThingEditor on: vo stopSlots: self stopSlots) to: #editor1.
	self assign: (LabelModel new) to: #editor2.
	self editor1 editBlock: [:v|(self class on: v) openWithSpec].
	self editor1 slotEditBlock: [:v|self editRight: v].
	self vDivider state: true.
	self initializeLayout

	! !

!GbtThingDiEditor methodsFor: 'accessing' stamp: 'hk 8/20/2016 18:46'!
saved
	^self editor1 saved! !

!GbtThingDiEditor methodsFor: 'accessing' stamp: 'hk 2/23/2016 15:54'!
stopSlots
	^stopSlots ifNil: [ #() ]! !

!GbtThingDiEditor methodsFor: 'accessing' stamp: 'hk 2/23/2016 15:52'!
stopSlots: anArrayOfSlotNames
	stopSlots := anArrayOfSlotNames! !

!GbtThingDiEditor methodsFor: 'accessing' stamp: 'hk 1/21/2016 18:32'!
vDividerMorph
    | morph |
    
    morph := BorderedMorph new 
					color: Color white;
					borderColor: Color black;
					bounds: (0@0 extent: 4@ (self initialExtent y) ).
	
    ^ morph asSpecAdapter! !

!GbtThingDiEditor methodsFor: 'accessing' stamp: 'hk 11/23/2015 16:45'!
vo: aVO
	vo := aVO! !

DynamicComposableModel subclass: #GbtThingEditor
	instanceVariableNames: 'smartVO fullVO widgetHeight editBlock someValueChanged slotEditBlock stopSlots saved consistent redoStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-VO'!

!GbtThingEditor commentStamp: 'hk 2/22/2017 16:02' prior: 0!
the iPhone editor for smart things allows to add and remove (smart) slots that are defined in the full thing

Instance Variables
	smartVO:			<ThingVO>
	fullVO:				<ThingVO>	the master of smartVO (cache)
	widgetHeight:		<Number>	used in  layout 
	editBlock:			<Block>
	saved:				<ValueHolder>
	someValueChanged:	<ValueHolder>
	consistent: 			<ValueHolder>
	slotEditBlock:		<Block>
	stopSlots:			<Object>
	redoStack: 			<OrdferedCollection> 			of undone SVOs

GUI updates:
1. all slots have a changeFlag.
2. any change of the changeFlag sets someValueChanged = true.
3. in turn all slots are notified 'someValueHasChanged'.
3. all Calc widgets recalculate (and eventually change their value).
4 this loops until nothing changes any more

GUI functions must update the widget when necessary, cf. GbtCalcWidget>>chooseNewCalcInput.

Domain functions use GbtActiveContext>>refreshUI
=============================

|th|
GbtSVO initializeAll.
th := GbtThing newStruct: 'some' define: { 
		{ #street . #val: . ''}.		
		{ #streetNo . #val: . ''}.
		{ #cityCode . #val: . ''}.		
		{ #cityName . #enum: .  #(one two) }.
		{ #cityCode . #date: . Date today}.		
	}.
(self on: th ) openWithSpec 
!

GbtThingEditor subclass: #GbtNonDefaultEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-VO'!

!GbtNonDefaultEditor commentStamp: 'hk 2/23/2016 16:12' prior: 0!
I am a variant of the iPhoneEditro that respects special uis of things


|th adr|
SVO initializeAll.
adr := ThingVO newOfType: 'adr' define: { 
		{ #widgetClass . #GcAddressBoxWidget }.
		{ #street . #val: . ''}.		
		{ #streetNo . #val: . ''}.
		{ #cityCode . #val: . ''}.
		{ #cityName . #val: .  #Bonn }.
		}.	
th := ThingVO newOfType: 'some' define: { 
		{ #address . #thing: . adr}.		
		{ #cityEnum . #enum: .  #(one two) }.
		{ #date. #date: . Date today}.		
	}.
(self "superclass" on: th ) openWithSpec !

!GbtNonDefaultEditor methodsFor: 'accessing' stamp: 'hk 6/20/2016 17:40'!
slotClass
	^nil! !

!GbtThingEditor class methodsFor: 'instance creation' stamp: 'hk 1/23/2016 18:56'!
on: aVO 
	^self basicNew 
		slotVO: aVO; 
		initialize
! !

!GbtThingEditor class methodsFor: 'instance creation' stamp: 'hk 1/23/2016 19:11'!
on: aVO label: aString
	^self on: aVO! !

!GbtThingEditor class methodsFor: 'instance creation' stamp: 'hk 2/23/2016 15:55'!
on: aVO stopSlots: arrayOfSlotNames
	^self basicNew 
		slotVO: aVO; 
		stopSlots: arrayOfSlotNames;
		initialize
! !

!GbtThingEditor class methodsFor: 'specs' stamp: 'hk 1/15/2016 16:43'!
title
	^ 'Smart Thing Editor'! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 2/22/2017 16:48'!
add: aSlotName
	"add a fullThing slot to smartThing"
	| purpColl widg  newSlot tags | 
	purpColl := (fullVO slotAt: aSlotName) purposes . 
	self expand: aSlotName.
	newSlot := smartVO slotSVOAt: aSlotName . 
	tags := smartVO tagsAt: aSlotName. 
	widg := GbtSlotWidget on: newSlot key: aSlotName for: purpColl tags: tags.
	self assign: widg to: (self wLabelFor: aSlotName) .
	self reBuildFor: aSlotName.
	self checkUndoRedo .

! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 2/17/2017 16:03'!
addSlotWidgetFor: sn

	| obj purp widg tags| 
	purp := (smartVO slotAt: sn ifAbsent: [fullVO slotAt: sn]) purposes . 
	obj := smartVO slotSVOAt: sn.
	tags := smartVO tagsAt: sn.
	widg := obj 
		ifNil:  [GbtEmptyWidget key: sn]
		ifNotNil: [(self slotClass ifNil: [obj uiClass]) on: obj key: sn for: purp tags: tags]. 
	self assign: widg to: (self wLabelFor: sn) .
	self focusOrder add: widg! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 7/25/2016 12:56'!
checkConsistency
	smartVO checkConstraints.
	consistent value: smartVO isConsistent.! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 2/22/2017 17:12'!
checkUndoRedo
	redoStack ifEmpty: [self redoButton disable] ifNotEmpty: [self redoButton enable].
	smartVO previous ifNil: [self undoButton disable] ifNotNil: [self undoButton enable]! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 12/14/2016 12:30'!
choiceDictValueOf: aSlotName
	"answer the choice context if there or nil"

	^(smartVO contextVO ifNil: [^nil]) choiceContextAt: aSlotName ifAbsent: [].
! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 1/23/2017 12:48'!
chooseFromContext: aSlotName okAction: okBlock cancelAction: cancelBlock
	| ctxt dialogWindow |
	ctxt := (self choiceDictValueOf: aSlotName)  second. 
	dialogWindow := (GbtListUI on: ctxt) openDialogWithSpec .
	dialogWindow 
		okAction: [okBlock value: dialogWindow model selection];
		cancelAction: cancelBlock;
		title: ctxt displayName  ;
		centeredRelativeTo: self currentWorld ;
		modalRelativeTo: self currentWorld! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 7/6/2016 16:31'!
consistencyHelp
	consistent  value ifNil: [^'unchecked'].
	consistent value ifTrue: [^'consistent'] .
	^smartVO constraintViolationString! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 7/5/2016 20:16'!
consistencyIcon
	^(consistent value ifNil: [^GbtIcons at: #constrYellow ])
		ifTrue: [ GbtIcons at: #constrGreen] 
		ifFalse: [ GbtIcons at: #constrRed ]! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 1/21/2016 18:53'!
editBlock: aBlock
	editBlock := aBlock! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 2/17/2017 16:17'!
expand: aSlotName
	"expand smartVO, use choiceContext or thing templates"

	| choiceArr thingSlot choice leafSlot |
	smartVO expandSVO: aSlotName.  
	choiceArr := self choiceDictValueOf: aSlotName .
	choice := choiceArr isNotNil.
	thingSlot := (smartVO slotSVOAt: aSlotName) isThing.
	leafSlot := (smartVO slotSVOAt: aSlotName) isLeaf.
	choice ifFalse: [thingSlot 
		ifFalse: [^self] 
		ifTrue: [^self expandTemplate: aSlotName]].
	choiceArr first isSymbol 
		ifTrue: [leafSlot ifTrue: [^self expandSlot: aSlotName  use: choiceArr first]] 
		ifFalse: [thingSlot ifTrue: [^self expandThing: aSlotName  use: choiceArr first]].
	self notify: 'choice authoring error: slot mismatch'
	
! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 2/17/2017 15:50'!
expandSlot: aSlotName use: aSlot 

	self chooseFromContext: aSlotName 
		okAction: [: th | th ifNotNil: [(smartVO slotSVOAt: aSlotName) inputValue: (th perform: aSlot)]] 
		cancelAction: [] 
! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 3/2/2017 16:06'!
expandSlot: aSlotName use: aSlot role: aRoleSymbol

	self chooseFromContext: aSlotName 
		okAction: [: th | th ifNotNil: [(smartVO slotSVOAt: aSlotName) inputValue: (th slotSVOAt: aSlot) val. smartVO contextVO assign: th toTxThing: aRoleSymbol]] 
		cancelAction: [] 
! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 2/23/2017 18:52'!
expandTemplate: aSlotName
	| templates new |
	templates := (fullVO slotAt: aSlotName) templates asOrderedCollection.
	new := templates ifNotEmpty: [GbtWidget chooseTemplateFrom: templates]. 
	new ifNotNil: [smartVO updateNode: aSlotName with: new copy]
! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 2/23/2017 18:52'!
expandThing: aSlotName use: aDecl

	self chooseFromContext: aSlotName 
		okAction: [: th | th ifNotNil: [smartVO updateNode: aSlotName with: (th save copyWith: aDecl)]] 
		cancelAction: [] 
! !

!GbtThingEditor methodsFor: 'api' stamp: 'hk 11/1/2016 20:01'!
initialExtent
	^600 @  (widgetHeight + self singleHeight + 6)
! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 2/20/2017 19:33'!
initializeLayout
	widgetHeight := 2 * self singleHeight.
	self layout: (SpecLayout composed newColumn: [ :c | 
		c newRow: [ :r | r 
				newColumn: [ :cc | cc 
					newRow: [ :rr | rr add: #summary ] ] ;
				newColumn: [ :cc | ] width: 24;
				newColumn: [ :cc | cc 
					newRow: [ :rr | rr 
						add: #voName;
						add: #undoButton width: 28;
						add: #redoButton width: 28;
						add: #inspectUi width: 48;
						add: #inspectVo width: 48;
						add: #constrButton width: 28 ;
						add: #saveTemplateButton width: 24 ;
						add: #saveButton width: 24 ] ]
			] height: self singleHeight .
		self slotNames do: [ :sn | |w wl|
			wl := self wLabelFor: sn.
			w := widgets at: wl.
			c newRow: [ :r | r add: wl] height: w widgetHeight.
			widgetHeight := widgetHeight + (w widgetHeight) ].
		c newRow: [ :r | r add: #emptyLabel] ]).
	self needFullRebuild: false .
! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 2/24/2017 12:26'!
initializePresenter
	
	self initializePresenterAfterRebuild .
	self someValueChanged whenChangedDo: 
		[self summary label: smartVO summaryEnriched.
		self voName label: smartVO voLabel. 
		consistent value: nil.
		self initializeRedo.
	Transcript cr;tab; tab; show: #someValueChanged3.
		self checkUndoRedo].
	consistent whenChangedDo: 
		[self constrButton icon: self consistencyIcon; help: self consistencyHelp]! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 2/24/2017 12:25'!
initializePresenterAfterRebuild
	
	self slotwidgets do: [:w |self initializeSomeValueChangedFor: w] .
	self someValueChanged whenChangedDo: 
		[		self slotwidgets do: [:w|w subWidget someValueHasChanged]].
! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 2/23/2017 15:08'!
initializeRedo
	redoStack := OrderedCollection new! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 3/2/2017 13:06'!
initializeSomeValueChangedFor: aWidget
	
	aWidget subWidget changeFlag whenChangedDo: [self someValueChanged: true]! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 2/26/2017 13:54'!
initializeWidgets
	|  |
	self instantiateModels: #( 
	emptyLabel			LabelModel
	voName					LabelModel
	summary				LabelModel
	constrButton			ButtonModel
	saveTemplateButton	ButtonModel
	saveButton			ButtonModel
	undoButton			ButtonModel
	redoButton			ButtonModel
	inspectUi				ButtonModel
	inspectVo				ButtonModel) .
	
	self initializeRedo.	
	consistent := nil asValueHolder. 	
	someValueChanged := false asValueHolder. 	
	saved := true asValueHolder. 	
	self voName label: smartVO voLabel.
	self summary label: smartVO summaryEnriched.
	self constrButton 
		icon: (GbtIcons at: #constrYellow) ;
		action: [self checkConsistency];
		help: 'unchecked'   ;
		state: true .
	self saveTemplateButton 
		icon: (GbtIcons at: #saveTemplate) ;
		action: [self saveTemplate];
		help: 'save as template';
		state: true.
	self saveButton 
		icon: (GbtIcons at: #save) ;
		action: [self save];
		help: 'save';
		state: true.
	self undoButton 
		icon: (GbtIcons at: #undo) ;
		action: [self undo];
		help: 'undo';
		state: true;
		disable.
	self redoButton 
		icon: (GbtIcons at: #redo) ;
		action: [self redo];
		help: 'redo';
		state: true;
		disable.
	self inspectUi 
		icon: (GbtIcons default inspectIcon) ;
		label: ' UI';
		action: [self inspect ];
		state: true.
	self inspectVo
		icon: (GbtIcons default inspectIcon) ;
		label: ' VO';
		action: [self smartVO inspect];
		state: true.
	self focusOrder 
		add: self constrButton; 
		add: self saveTemplateButton; 
		add: self saveButton. 
	self slotNames do: [ :sn | self addSlotWidgetFor: sn].
	self editBlock: self subWindowEditBlock .
	self slotEditBlock: editBlock.
	self initializeLayout
! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 2/22/2017 17:06'!
pushForRedo: aSVO    
	redoStack addLast: aSVO.
! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 2/23/2017 15:20'!
reBuildAll
	| oldSlotNames newSlotNames |
	self needFullRebuild: false.
	self voName label: smartVO voLabel.
	oldSlotNames := (self slotwidgets collect: [ :sw | sw slotName ]) values.
	newSlotNames := smartVO slotNames.
	oldSlotNames \ newSlotNames
		do: [ :sn | 
			| wl widg |
			wl := self wLabelFor: sn.
			widg := GbtEmptyWidget key: sn.
			self assign: widg to: wl ].
	newSlotNames
		do: [ :sn | 
			| newSlot tags widg pcoll |
			newSlot := smartVO slotSVOAt: sn.
			tags := smartVO tagsAt: sn.
			pcoll := (fullVO slotAt: sn) purposes.
			widg := GbtSlotWidget
				on: newSlot
				key: sn
				for: pcoll
				tags: tags.
			self assign: widg to: (self wLabelFor: sn) ].
	self initializeLayout.
	self initializePresenterAfterRebuild .
	self buildWithSpec.
	self checkUndoRedo! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 11/1/2016 20:04'!
reBuildFor: aSLotName

	| wdgt |
	self needFullRebuild: false .
	self voName label: smartVO voLabel.
	wdgt := self widgetAt: aSLotName.
	[wdgt subWidget editBlock: slotEditBlock] ifError: [].
	self focusOrder add: (self widgetAt: aSLotName).
	self initializeLayout.	
	self initializeSomeValueChangedFor: wdgt.	
	self buildWithSpec.
! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 2/23/2017 15:44'!
readAllSlots
	self slotwidgets do: [:w | w subWidget read]! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 2/26/2017 13:51'!
redo
	redoStack ifEmpty: ["button disabled" ^self].
	smartVO := redoStack removeLast. 
	smartVO buildContainerHierarchy .
	self reBuildAll.
	self readAllSlots .
	self checkUndoRedo ! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 2/23/2017 17:45'!
remove: aSlotName
	"remove a slot from smartThing"
	| wl widg |
	wl := self wLabelFor: aSlotName .
	widg := GbtEmptyWidget key: aSlotName .
	self assign: widg to: wl .  
	smartVO removeSlotAt: aSlotName.
	self needFullRebuild: false .
	self voName label: smartVO voLabel.
	self initializeLayout.			"in case a thing needed more space"
	self buildWithSpec.
	self checkUndoRedo .
	self someValueChanged: true 	"recalculate"
! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 10/6/2016 15:40'!
resetEditButton
	self widgetsDo: [:w| [w subWidget resetEditButton] ifError: []]! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 12/4/2016 14:07'!
save
	smartVO save.
	saved value: true.
	self voName label: smartVO voLabel.
! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 12/16/2016 18:42'!
saveTemplate
	smartVO saveAsTemplate
! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 6/20/2016 13:48'!
saved
	^saved! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 1/15/2016 18:43'!
singleHeight
	^self class toolbarHeight! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 6/20/2016 17:36'!
slotClass

	^GbtSlotWidget! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 10/6/2016 15:39'!
slotEditBlock: aBlock
	slotEditBlock := aBlock.
	self widgetsDo: [:w|  [w subWidget editBlock: aBlock] ifError: [] ].! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 7/27/2016 11:12'!
slotNames
	| sn |
	sn := fullVO slotNames asOrderedCollection .
	sn removeAll: self stopSlots .
	^sn! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 1/23/2016 18:57'!
slotVO
	^smartVO ! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 1/23/2016 18:56'!
slotVO: anObject
	smartVO := anObject.
	fullVO := anObject fullThing! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 10/6/2016 15:31'!
slotwidgets
	^self widgets select: [:w |w isKindOf: GbtSlotWidget ]! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 8/14/2016 12:24'!
smartVO
	^smartVO ! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 6/14/2016 13:54'!
someValueChanged
	^someValueChanged ! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 2/23/2017 17:45'!
someValueChanged: aBoolean
	someValueChanged value: aBoolean! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 2/23/2016 15:56'!
stopSlots
	^stopSlots ifNil: [ #() ]! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 2/23/2016 15:46'!
stopSlots: anArrayOfSlotNames
	stopSlots := anArrayOfSlotNames! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 6/23/2016 15:02'!
subWindowEditBlock
	^[:vo| |subW| 
	(subW := self class on: vo) openWithSpec.
	"initializePresenter same as initializeRightPresenter"
	subW someValueChanged whenChangedDo: [self someValueChanged value: true].
	subW saved whenChangedDo: [ self someValueChanged value: true ] ]
! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 2/26/2017 13:51'!
undo
	smartVO previous ifNil: ["button disabled" ^self].
	self pushForRedo: smartVO.
	smartVO := smartVO previous . 
	smartVO buildContainerHierarchy .
	self reBuildAll.
	self readAllSlots .
	self checkUndoRedo ! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 1/15/2016 17:39'!
wLabelFor: aSlotName
	^('lbl_', aSlotName) asSymbol! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 2/22/2017 13:18'!
widgetAt: aSlotName
	^self widgets at: (self wLabelFor: aSlotName) ifAbsent: []! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 11/1/2016 20:06'!
widgetHeight
	^widgetHeight 
! !

DynamicComposableModel subclass: #GbtUI
	instanceVariableNames: 'context mode modeToggler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtUI commentStamp: 'hk 11/21/2016 18:29' prior: 0!
I am an abstract GloConn UI on a context.

Instance Variables
	context:			<ActiveContextVO>		preset context
	mode:			<NewValueHolder>		rebuild on #edit / #txt / #sdBox change 
	modeToggler: 	<Dictionary> 				for mode switching
!

GbtUI subclass: #GbtAspectUI
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtAspectUI commentStamp: 'hk 11/21/2016 18:06' prior: 0!
I am a Gui for a fixed aspect of an item = my target.
depending on my context (allows add, allowsRemove, allowsChoice) I allow to add and remove the target. I need a target when instantiated !!

I have 3 modes:
	- #edit - with GbtThingEditor
	- #text - with a srollable text display
	-#sdBox - with the GbtCustomSDBoxWidget

Instance Variables
	target:		<NewValueHolder>		rebuild on target change 

====================================================

|  ctxt  superctxt  vo |
vo := ThingVO newOfType: 'Thing' define: { 
	{ #aspect . #thing: .   (ThingVO newOfType: 'Aspect' ) } }.
ctxt := AcPlainVO ofType: 'Context'  define: { 
	{ #uiSpec:at: . #GcAspectUI . #aspect } .
	{ #templates: . { vo } } } .
superctxt := AcPlainVO ofType: 'SuperContext' define: { 
	{ #uiSpec:at: .  GcItemWithTabsUI . #super } .
	{ #aspect:on: . ctxt . #aspect } .
	{ #vo: . vo } }.

(GcAspectUI  on:  superctxt)  openWithSpec!

!GbtAspectUI class methodsFor: 'instance creation' stamp: 'hk 11/21/2016 18:10'!
on: aContext mode: aSymbol
	^ self basicNew
		context: aContext;
		initialize;
		mode: aSymbol
! !

!GbtAspectUI methodsFor: 'initialization' stamp: 'hk 2/25/2016 15:34'!
addRemoveButton: r
	context allowsRemove ifFalse: [ ^self ]	.
	r  add: #removeButton width: 24! !

!GbtAspectUI methodsFor: 'ui actions' stamp: 'hk 2/17/2017 16:24'!
addTargetFrom: aTemplate

	| newNode |
	newNode := (aTemplate ifNil: [^self]) copy context: context; ensureBizId.
	context container vo slotExpandAt: context targetSlotname put: newNode.
	self setAspectTarget.
	context createHook: newNode
! !

!GbtAspectUI methodsFor: 'initialization' stamp: 'hk 10/3/2016 12:05'!
assignSubWidget
	"assign modeEditor, go to next mode, if modeEditor does not work
	!!!!!!  we have a loop here if no editor works !!!!!!"
	| subW | 
	[subW := self modeEditor on: self target stopSlots: self stopSlots]
		ifError: [^self toggleMode; assignSubWidget ]. 
	self assign: subW to: #subWidget .
	self subWidget owner: self .
	self focusOrder add: subW! !

!GbtAspectUI methodsFor: 'ui actions' stamp: 'hk 2/25/2016 15:49'!
choose
	context allowsChoice 
		ifTrue: [ self chooseFromContext ] ifFalse: [ self chooseTemplate ]! !

!GbtAspectUI methodsFor: 'ui actions' stamp: 'hk 1/9/2017 20:49'!
chooseFromContext
	| dialogWindow |  
	dialogWindow := (GbtListUI on: context choiceContext) openDialogWithSpec .
	dialogWindow 
		okAction: [ self addTargetFrom: dialogWindow model selection] ;
		cancelAction: [ ] ;
		title: context choiceContext displayName  ;
		centeredRelativeTo: self 
! !

!GbtAspectUI methodsFor: 'ui actions' stamp: 'hk 4/30/2016 16:49'!
chooseTemplate
	
	| tmpl |
	tmpl := (GbtWidget chooseTemplateFrom: self templates) .
	tmpl ifNil: [^nil].
	^self addTargetFrom:  tmpl
		
! !

!GbtAspectUI methodsFor: 'testing' stamp: 'hk 3/1/2016 12:06'!
hasTarget  
	^true
! !

!GbtAspectUI methodsFor: 'initialization' stamp: 'hk 3/1/2016 12:05'!
initializeLayout
	self target 
		ifNotNil: [ self initializeTargetLayout ] 
		ifNil: [ self initializeNoTargetLayout ] 
! !

!GbtAspectUI methodsFor: 'initialization' stamp: 'hk 8/21/2015 17:56'!
initializeNoTargetLayout

	self identityLabel label:  'none'  .
 
	self layout: (SpecLayout composed newColumn: [ :c | 
		c newRow: [ :r | 
				r  add: #chooseButton width: 24 .
				r add: #identityLabel .
				r  add: #pInspect width: self class buttonWidth ] height: self class toolbarHeight. 
		c add: #emptyLabel height: 1] ) .
	self needFullRebuild: false .
! !

!GbtAspectUI methodsFor: 'initialization' stamp: 'hk 4/27/2015 18:25'!
initializePresenter

	target whenChangedDo: 
		[ self initializeLayout .
		self buildWithSpec ]
! !

!GbtAspectUI methodsFor: 'initialization' stamp: 'hk 2/11/2016 19:28'!
initializeTargetLayout
 	self assignSubWidget .	 
	self identityLabel label: self target bizId.
	
	self layout: (SpecLayout composed newColumn: [ :c | 
		c newRow: [ :r | 
			self addRemoveButton: r.
			r add: #toggleButton width: 28.
			r add: #identityLabel. 
			r  add: #pInspect width: self class buttonWidth] height: self class toolbarHeight .
		c newRow: [ :r | r add: #subWidget] .
		c newRow: [ :r | r add: #emptyLabel ] height: 1 ] ).
	self needFullRebuild: false 
! !

!GbtAspectUI methodsFor: 'initialization' stamp: 'hk 11/21/2016 18:18'!
initializeWidgets
	super initializeWidgets .
	self instantiateModels: #( 
		identityLabel 	LabelModel
		toggleButton 	ButtonModel 	
		removeButton 	ButtonModel 	
		chooseButton 	ButtonModel 	) .				
	self toggleButton 
		icon: (GbtIcons at: #toggle) ;
		action: [ self toggle ];
		state: true.
	self removeButton 
		icon: (GbtIcons at: #delete) ;
		action: [ self removeTarget ];
		state: true.
	self chooseButton 
		icon:  (GbtIcons at: #add);
		action: [ self choose ];
		state: true.
	target := nil asValueHolder .
	self initializeMode.
	self setAspectTarget.
	self initializeLayout! !

!GbtAspectUI methodsFor: 'ui actions' stamp: 'hk 11/26/2015 22:38'!
refresh
 	"user asks to refresh the Tab content"  
	target valueChanged! !

!GbtAspectUI methodsFor: 'ui actions' stamp: 'hk 2/17/2017 15:58'!
removeTarget 
	context container vo removeSlotAt: context targetSlotname .   
	self setAspectTarget ! !

!GbtAspectUI methodsFor: 'ui actions' stamp: 'hk 9/22/2016 19:35'!
setAspectTarget
	"set the old or new (aBoolean=true) target to the defined DomainVO aspect "
	| t |   
	t := context setVOFromContainer.
	self target: t .

	! !

!GbtAspectUI methodsFor: 'accessing' stamp: 'hk 3/1/2016 13:16'!
stopSlots
	context ifNil: [^#()]. 
	context blackboardSlot = #nil ifTrue: [^#()].  
	^{context blackboardSlot}
	! !

!GbtAspectUI methodsFor: 'accessing' stamp: 'hk 5/7/2015 15:39'!
target
	^ target value! !

!GbtAspectUI methodsFor: 'accessing' stamp: 'hk 2/3/2016 13:55'!
target: aVo
	target value: aVo! !

!GbtAspectUI methodsFor: 'accessing' stamp: 'hk 5/10/2015 19:49'!
templates
	^ context templates ! !

!GbtAspectUI methodsFor: 'initialization' stamp: 'hk 1/28/2016 11:34'!
widgetHeight
	"hack: dont know the widgetHeight al long as the aspect is empty"
 	^240! !

GbtAspectUI subclass: #GbtSelfAspectUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtSelfAspectUI commentStamp: 'hk 2/25/2016 16:44' prior: 0!
I am an AspectUI  meant for the aspect self. I
-  ignore the target target !

!GbtSelfAspectUI methodsFor: 'accessing' stamp: 'hk 10/31/2016 16:27'!
aspectOwner
	"I am in a tab in a tabmanager in an Item"
	^self owner owner owner! !

!GbtSelfAspectUI methodsFor: 'initialization' stamp: 'hk 11/21/2016 20:04'!
assignSubWidget
	super assignSubWidget .
	(self subWidget saved ifNil: [^self]) whenChangedDo: [self aspectOwner saved value: true] ! !

!GbtSelfAspectUI methodsFor: 'ui actions' stamp: 'hk 9/23/2016 12:15'!
setAspectTarget
	self target: context vo.

	! !

!GbtSelfAspectUI methodsFor: 'accessing' stamp: 'hk 3/1/2016 12:59'!
stopSlots
	^(context ifNil: [^#()]) aspectSlots ! !

GbtUI subclass: #GbtItemUI
	instanceVariableNames: 'saved'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtItemUI commentStamp: 'hk 11/21/2016 18:05' prior: 0!
I am a general UI for editing one element of a list of things.
I have 2 modes:
	- #edit - with GbtThingEditor
	- #text - with a srollable text display

If my context has a blackboard subcontext, I also render the blackboard part.

    Instance Variables
	saved: 		<ValueHolder>

============================
(GbtItemUI on: (( GbtPlainAC newStruct: #bla) vo: (( GbtThing newStruct: #pro) copy; yourself); yourself)) openWithSpec!

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 1/9/2017 21:13'!
addBlackboardTo: aColumn
	aColumn newRow: [:r| r
		add: #emptyLabel width: 10;		"inset"
		newColumn: [:c| c add: #blackboard];
		add: #emptyLabel width: 10] 
			height: (widgets at: #blackboard) widgetHeight
	
	! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 1/23/2016 20:27'!
addContentTo: aRow
	aRow add: #item! !

!GbtItemUI methodsFor: 'accessing' stamp: 'hk 4/30/2016 18:31'!
blackboardContext
	^(context subcontextFor: context blackboardAspect) ifNil: [^GbtSVO error: 'no subcontext ', context blackboardAspect] ! !

!GbtItemUI methodsFor: 'ui actions' stamp: 'hk 1/7/2017 19:22'!
deleteMyself
	owner mayDelete 
		ifTrue: [owner deleteSelection] 
		ifFalse: [^self notify: 'no right to execute']! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 2/26/2016 13:33'!
initializeAuthoredMenu
	| menuItems |
	menuItems := context menuItemsWrappedWith: [:s| self notify: s].
	self paneMenu addGroup: [:g | menuItems do: [:i| g addMenuItem: i]]
! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 2/17/2017 16:19'!
initializeBlackboard
	| sc ui |
	sc := self blackboardContext .
	sc isListAc ifTrue: [^self].
	sc vo: (context vo slotSVOExpandAt: sc targetSlotname).
	ui := sc newUI: #sdBox.
	self assign: ui to: #blackboard ! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 7/1/2016 19:21'!
initializeDynamicPresenter
	(self item saved ifNil: [^self]) whenChangedDo: [ self saved value: true ]
! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 11/21/2016 19:39'!
initializeDynamicWidgets
	| subW |
	subW := self editor.
	self assign: subW to: #item .
	self focusOrder add: subW.
	self initializeDynamicPresenter.
	self initializeMenu! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 2/26/2016 13:48'!
initializeLayout
	self initializeDynamicWidgets .
	self layout: (SpecLayout composed newColumn: [ :c | 
		context hasBlackboard ifTrue: [self addBlackboardTo: c].		
		c add: #paneMenu height: self singleHeight .
		c newRow: [ :r | 
			r add: #emptyLabel width: 10.		"inset"
			self addContentTo: r .
			r add: #emptyLabel width: 10] ] ).
	[self needFullRebuild: false] ifError: [  ]

! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 2/26/2016 13:33'!
initializeMenu
	self instantiateModels: #(paneMenu MenuModel).
	self paneMenu addGroup: [ :g |  self menuFor: g].
	self initializeAuthoredMenu .! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 11/21/2016 18:26'!
initializeStaticWidgets
	self initializeMode.
! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 11/21/2016 18:26'!
initializeWidgets
	saved := false asValueHolder .
	self instantiateModels: #(emptyLabel LabelModel).
	context hasBlackboard ifTrue: [self initializeBlackboard].
	self initializeStaticWidgets .
	context hasAutoloadPolicy ifTrue: [context loadVO]. 
	self initializeLayout! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 1/6/2017 18:38'!
menuFor: aMenuGroup
		aMenuGroup addItem: [ :i |  i
			icon: (GbtIcons at: #delete) ;
			description: 'delete' ;
			action: [ self deleteMyself] ] .
		aMenuGroup addItem: [ :i |  i
				description: 'toggle display' ;
				icon: (GbtIcons at: #toggle) ;
				action: [ self toggle ] ] ! !

!GbtItemUI methodsFor: 'ui actions' stamp: 'hk 7/8/2016 17:57'!
runStatistics
	self context runStatistics
! !

!GbtItemUI methodsFor: 'accessing' stamp: 'hk 6/20/2016 13:50'!
saved
	^saved! !

GbtItemUI subclass: #GbtItemWithTabsUI
	instanceVariableNames: 'tabManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtItemWithTabsUI commentStamp: 'hk 8/26/2015 11:00' prior: 0!
I am a UI for editing a process with aspects of a list of processes

Instance Variables
	tabManager: 	<TabManager>		does not work with DynamicSpec

====== Tests ======

(GcItemWithTabsUI on: (( AcPlainVO ofType: #bla) vo: (( ThingVO newOfType: #pro) copy; yourself); yourself)) openWithSpec!

!GbtItemWithTabsUI methodsFor: 'initialization' stamp: 'hk 1/23/2016 20:27'!
addContentTo: aRow
	aRow add: #tabManager! !

!GbtItemWithTabsUI methodsFor: 'initialization' stamp: 'hk 8/20/2016 18:04'!
initializeDynamicWidgets
	self initializeMenu! !

!GbtItemWithTabsUI methodsFor: 'initialization' stamp: 'hk 2/1/2016 16:20'!
initializeStaticWidgets
	self initializeTabs ! !

!GbtItemWithTabsUI methodsFor: 'initialization' stamp: 'hk 2/17/2017 15:50'!
initializeTabs  

	| rIcon |
	tabManager := self newTabManager .  	
	rIcon := GbtIcons  at: #refresh .
	self initializeVoTabIn: tabManager.		"special treatment for the vo-tab"
	context tabcontexts do: [ :sc |  |key icon newTab ui contextVO tabVO|
		contextVO := context vo.
		sc isListAc ifFalse: 
			[sc vo: (tabVO := contextVO slotSVOAt: sc targetSlotname)].
		key := sc displayName asSymbol.
		icon := GbtIcons  at: sc uiKey .
		ui := self newModelFor: sc .
		(newTab := self newTab) 
				label: key ;
				icon: icon ; 
				model: ui ;
				closeable: false ;
				whenTabSelected: [self updateBlackboardWith: sc]; 
				actions: {(TabAction action: [ui refresh] icon: rIcon label: #refresh)} .
		tabManager addTab: newTab .
		"set owner explicitely - can't set owner in TabManager"
		ui owner: self]
! !

!GbtItemWithTabsUI methodsFor: 'initialization' stamp: 'hk 8/20/2016 18:11'!
initializeVoTabIn: aTabManager  
	"initializue the first tab with my own vo"
	| rIcon key newTab ui|
	rIcon := GbtIcons  at: #refresh .
	key := context displayName asSymbol.
	ui := GbtSelfAspectUI basicNew context: self context.  
	"set owner explicitely - can't set owner in TabManager"
	ui owner: self; initialize.
	(newTab := self newTab) 
				label: key ;
				icon: (GbtIcons  at: context uiKey) ; 
				model: ui ;
				closeable: false ;
				whenTabSelected: [self updateBlackboardWith: context]; 
				actions: {(TabAction action: [ui refresh] icon: rIcon label: #refresh)} .
	aTabManager addTab: newTab .
	ui target: context vo. 
! !

!GbtItemWithTabsUI methodsFor: 'initialization' stamp: 'hk 1/6/2017 18:37'!
menuFor: aMenuGroup
		aMenuGroup addItem: [ :i |  i
			icon: (GbtIcons at: #delete) ;
			description: 'delete' ;
			action: [ self deleteMyself] ]! !

!GbtItemWithTabsUI methodsFor: 'initialization' stamp: 'hk 11/1/2016 17:15'!
newModelFor: aViewContext 
	"create the UImodel for the view, fall back, if there is no UIclass"
	
	Smalltalk at: aViewContext uiSpec ifAbsent: [^LabelModel new label: aViewContext displayName]. 
	^aViewContext newUI ! !

!GbtItemWithTabsUI methodsFor: 'accessing' stamp: 'hk 5/8/2015 13:38'!
tabManager
	^tabManager! !

!GbtItemWithTabsUI methodsFor: 'initialization' stamp: 'hk 3/1/2016 14:03'!
updateBlackboardWith: aContext
	| header |  
	context updateBlackboardWith: aContext. 
	header := widgets at: #blackboard ifAbsent: [^self].
	header refresh! !

GbtUI subclass: #GbtListUI
	instanceVariableNames: 'hasSubUI otherUserEdits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtListUI commentStamp: 'hk 1/9/2017 14:28' prior: 0!
I am a universal ListUI

Instance Variables
	hasSubUI:  		<Boolean>		#subUI is the dynamic widget for the list element


======== Tests ========

(GcListUI on: (( AcListVO ofType: #bla) asvo: (( ThingVO newOfType: #pro) copy; yourself ) ; yourself )) openWithSpec
!

GbtListUI subclass: #GbtListAndItemUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtListAndItemUI commentStamp: 'hk 11/9/2016 15:06' prior: 0!
I am a  ListUI that integrates the editor for the selected item.
I edit on selection.
!

!GbtListAndItemUI methodsFor: 'private' stamp: 'hk 1/9/2017 18:06'!
checkSelection  
	(self filteredList includes: self selection) ifFalse: 
		[self resetSelection.
		self removeEditor]
! !

!GbtListAndItemUI methodsFor: 'initialization' stamp: 'hk 6/20/2016 14:45'!
initialExtent
	"default extent when stand alone"
	^800 @ 600! !

!GbtListAndItemUI methodsFor: 'initialization' stamp: 'hk 1/9/2017 15:32'!
initialize
	self subcontext ifNil: [^self notify: 'no editor context defined'].
	super initialize! !

!GbtListAndItemUI methodsFor: 'initialization' stamp: 'hk 1/9/2017 21:15'!
initializeLayout
	self pIcon icon: self contextIcon  .	"changes dynamically"
	self layout: (SpecLayout composed newColumn: [ :c | 
		self iconRowFor: c .  
		self menuRow: c. 
		c newRow: [:r| r newColumn: [:cc| 
			self hasSubUI 
				ifTrue: 
					[cc add: #list bottom: 0.80 .
					cc addSplitter.
					cc add: #subUI top: 0.20] 
				ifFalse: 
					[cc add: #list bottom: 0.2 .
					cc addSplitter.
					cc add: #emptyLabel top: 0.8] ] ] ] ).
	self needFullRebuild: false .
! !

!GbtListAndItemUI methodsFor: 'initialization' stamp: 'hk 1/6/2017 18:16'!
initializeMenu
	self menuRow addGroup: 
		[ :g | g addItem: [ :i | i 
				icon: (GbtIcons at: #add) ;
				description: 'add copy';
				action: [ self newElement ] ] ].
	super initializeMenu.
! !

!GbtListAndItemUI methodsFor: 'initialization' stamp: 'hk 3/24/2017 19:21'!
initializePresenter
	self list whenSelectedItemChanged: 
		[:new :old| self switchEditorFrom: old to: new] .
	otherUserEdits whenChangedDo: [self checkSelection] .
	super initializePresenter ! !

!GbtListAndItemUI methodsFor: 'private' stamp: 'hk 1/9/2017 15:16'!
prepareEditor
	self assign: self subcontext newUI to: #subUI.
	self subUI saved whenChangedDo: [self resetList].		"presenter"
	hasSubUI := true.
	self reBuild! !

!GbtListAndItemUI methodsFor: 'private' stamp: 'hk 1/9/2017 18:09'!
removeEditor   
	self hasSubUI ifFalse: [^self].
	self clearSubUI.
	self reBuild! !

!GbtListAndItemUI methodsFor: 'private' stamp: 'hk 3/24/2017 19:09'!
switchEditorFrom: oldSel to: newSel
	oldSel ifNotNil: [oldSel context: self context]. 
	newSel ifNil: [^self removeEditor] .
	self subcontext vo: newSel.
	self subcontext editHook: newSel.
	newSel setDataNotPending; removeOtherUserEdits. 
	self prepareEditor .
	context checkDirty . "eventually removes data pending flag"
 ! !

!GbtListUI methodsFor: 'ui actions' stamp: 'hk 3/23/2017 16:19'!
addListElement
	| newElement | 
	newElement := (self selection ifNil: [self chooseTemplateFrom: context templates])
		copy removeBizId.  
	context newEntrySelect: newElement .	 
	self subcontext vo: self selection.
	self createHook: self selection.
	self prepareEditor .
	self refresh

! !

!GbtListUI methodsFor: 'ui actions' stamp: 'hk 2/14/2017 14:58'!
addUlistElementFromAspect: aSelectedThing
	self setSelection: (context newEntryWithChoice: aSelectedThing) .
	self subcontext vo: self selection.
	self createHook: self selection.
	self prepareEditor .
	self refresh

! !

!GbtListUI methodsFor: 'ui actions' stamp: 'hk 2/15/2017 15:47'!
chooseTemplateFrom: aCollOfThings
	| res |
	aCollOfThings size = 1 ifTrue: [^aCollOfThings first ]. 
	res := (UIManager default chooseFrom: (aCollOfThings collect: #summary) values: aCollOfThings) .
	^(res	ifNil: [aCollOfThings first]) 
	! !

!GbtListUI methodsFor: 'private' stamp: 'hk 4/13/2015 12:41'!
clearSubUI
	hasSubUI := false! !

!GbtListUI methodsFor: 'accessing context' stamp: 'hk 4/30/2016 18:29'!
contextIcon
	^context hasDataPending 
		ifTrue:  [GbtIcons at: (context uiKey, 'Dirty') asSymbol]
		ifFalse: 	[GbtIcons at: context uiKey]
		
	
! !

!GbtListUI methodsFor: 'private' stamp: 'hk 9/23/2016 11:19'!
createHook: aThing
	self subcontext ifNil: [^self].
	self subcontext createHook: aThing! !

!GbtListUI methodsFor: 'api' stamp: 'hk 1/7/2017 19:22'!
deleteSelection
	context deleteListElement: self selection .	
	self resetList; resetSelection .
	context checkDirty .
	[self pLabel label: (owner context displayName)] ifError: ["below mainUI"] .
	self clearSubUI; reBuild! !

!GbtListUI methodsFor: 'ui actions' stamp: 'hk 1/9/2017 14:44'!
editSelection  
	self selection  ifNil: [^self] .
	self selection edit. 
	self resetList ! !

!GbtListUI methodsFor: 'accessing' stamp: 'hk 1/12/2017 18:22'!
filteredList  
	^context filteredListfrom: self textFilter text
! !

!GbtListUI methodsFor: 'accessing' stamp: 'hk 1/13/2017 12:16'!
filteredList: aSlot for: aSelection
 	self list items: (self filteredList select: [ :e| (e perform: aSlot) = aSelection ])! !

!GbtListUI methodsFor: 'testing' stamp: 'hk 11/1/2016 17:18'!
hasSubUI   
	^hasSubUI = true! !

!GbtListUI methodsFor: 'initialization' stamp: 'hk 1/9/2017 15:10'!
initialize
	context setUlistTemplates.		"transfer the templates"			
	super initialize.
! !

!GbtListUI methodsFor: 'initialization' stamp: 'hk 2/11/2016 12:15'!
initializeAuthoredMenu
	| menuItems |
	menuItems := context menuItemsWrappedWith: [:s| self notify: s].
	self menuRow addGroup: [:g| menuItems do: [:i| g addMenuItem: i]]! !

!GbtListUI methodsFor: 'initialization' stamp: 'hk 6/23/2016 10:49'!
initializeFilterLoadMenu
! !

!GbtListUI methodsFor: 'initialization' stamp: 'hk 5/19/2016 11:46'!
initializeLayout
	self pIcon icon: self contextIcon  .	"changes dynamically"
	self layout: (SpecLayout composed newColumn: [ :c | 
		self iconRowFor: c .  
		self hasSubUI 
			ifTrue: [ c add: #subUI ] 
			ifFalse: [self menuRow: c. 
						c add: #list] 
		] )  .
	self needFullRebuild: false .
! !

!GbtListUI methodsFor: 'initialization' stamp: 'hk 1/6/2017 18:15'!
initializeMenu
	context hasSimpleloadPolicy ifTrue: [self initializeSimpleLoadMenu].
	context hasFilterloadPolicy ifTrue: [self initializeFilterLoadMenu].
	self initializeAuthoredMenu .! !

!GbtListUI methodsFor: 'initialization' stamp: 'hk 1/12/2017 18:22'!
initializePresenter
	super initializePresenter .
	otherUserEdits whenChangedDo: [self resetList] .
	self textFilter whenTextChanged: [self resetList].
	context dataPending whenChangedDo: 
		[ self resetList ; reBuild ]
! !

!GbtListUI methodsFor: 'initialization' stamp: 'hk 6/23/2016 15:55'!
initializeSimpleLoadMenu
	self menuRow addGroup: [ :g| 
		g addItem: [ :i| i
				name: 'load all' ;
				action: [ context loadAll. self resetList]]]! !

!GbtListUI methodsFor: 'initialization' stamp: 'hk 1/13/2017 19:10'!
initializeWidgets
	| listW |
	super initializeWidgets .
	listW := GbtTableListUI on: context template columns: context displayColumns.
	self assign: listW to: #list .
	self list initialize.
	self assign: TextInputFieldModel new to: #textFilter	.
	self assign: MenuModel new to: #menuRow	.
	context hasAutoloadPolicy ifTrue: [context loadAll]. "list must be there"
	self resetList.
	self list resetDropDownLists. "made of loaded values"
	self pLabel label: context displayName .
	self textFilter
		autoAccept: true;
		ghostText: 'type to filter' .
	self initializeMenu .
	self focusOrder 
		add: self textFilter;
		add: self list .
	otherUserEdits := false asValueHolder.
	self initializeLayout.
	
! !

!GbtListUI methodsFor: 'testing' stamp: 'hk 1/6/2017 18:49'!
mayDelete
	^context userRight execute ! !

!GbtListUI methodsFor: 'initialization' stamp: 'hk 1/13/2017 17:37'!
menuRow: aColumn
	aColumn newRow: [ :r | r
		add: #textFilter width: self defaultWidth;
		add: #menuRow 
	] height: self singleHeight 
	
	 ! !

!GbtListUI methodsFor: 'ui actions' stamp: 'hk 3/22/2017 12:51'!
newElement    
	context userRight execute ifFalse: [^self notify: 'no right to execute'].
	context allowsAspectChoice ifTrue: [^self newElementFromAspectChoice].
	context allowsChoice ifTrue: [^self notify: 'not yet implemented' ]. 
	self addListElement
! !

!GbtListUI methodsFor: 'ui actions' stamp: 'hk 1/23/2017 12:49'!
newElementFromAspectChoice
	| dialogWindow | 
	(dialogWindow := (GbtListUI on: context choiceContext) openDialogWithSpec) 
		okAction:[self addUlistElementFromAspect: dialogWindow model selection];
		cancelAction: [ ] ;
		title: context choiceContext displayName  ;
		centeredRelativeTo: self 

! !

!GbtListUI methodsFor: 'accessing' stamp: 'hk 12/5/2016 13:26'!
otherUserEdits: aBoolean
	^otherUserEdits value: aBoolean 
! !

!GbtListUI methodsFor: 'private' stamp: 'hk 1/9/2017 16:04'!
prepareEditor! !

!GbtListUI methodsFor: 'ui actions' stamp: 'hk 8/9/2016 11:35'!
refresh  
	self resetList! !

!GbtListUI methodsFor: 'api' stamp: 'hk 12/5/2016 17:09'!
resetList  
	self list items: self filteredList! !

!GbtListUI methodsFor: 'api' stamp: 'hk 1/6/2017 19:00'!
resetSelection
	self list resetSelection! !

!GbtListUI methodsFor: 'api' stamp: 'hk 12/5/2016 16:13'!
selection
	^self list selectedItem! !

!GbtListUI methodsFor: 'api' stamp: 'hk 12/31/2016 18:50'!
setSelection: anItem   
	self list setSelectedItem: anItem! !

!GbtListUI methodsFor: 'accessing context' stamp: 'hk 4/13/2015 12:22'!
subcontext 
 	^context subcontext! !

GbtUI subclass: #GbtLoginUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtLoginUI commentStamp: 'hk 11/9/2016 15:07' prior: 0!
I am the UI for login.

I always work with the loginContext that is unique for a company!

!GbtLoginUI methodsFor: 'adding' stamp: 'hk 3/23/2017 10:37'!
addStatus: aString
	"display the limited historical status, most recent left"
	| st |
	aString ifEmpty: [ ^self ] . 
	st := aString, ' | ', self status text asString.
	st size > 200 ifTrue: [ st := (st first: 200) , ' ... ' ].
	self status text: st ! !

!GbtLoginUI methodsFor: 'initialization' stamp: 'hk 3/27/2017 21:21'!
initialize
	super initialize.
	self bizApp isCompiled ifFalse: [context compileApp]! !

!GbtLoginUI methodsFor: 'initialization' stamp: 'hk 11/18/2016 11:56'!
initializeLayout 
	"EFA efa openLogin"
	self layout: (SpecLayout composed newColumn: [:c| c 
			newRow: [ :r | r add: #status] height: self singleHeight;
			newRow: [ :r | r add: #iconButton ]  ;		
			newRow: [ :r | r add: #empty; add: #loginNameLabel width: 40; add: #loginName width: 120; add: #passwordLabel width: 70; add: #password width: 120; add: #loginButton width: 120] height: self singleHeight ;	
			newRow: [ :r | r add: #legal ]  height: self singleHeight ]). ! !

!GbtLoginUI methodsFor: 'initialization' stamp: 'hk 3/27/2017 21:21'!
initializeWidgets
	self instantiateModels: #(
		empty 				LabelModel
		iconButton 		ButtonModel
		loginNameLabel	LabelModel
		loginName			TextInputFieldModel 
		passwordLabel	LabelModel
		password			TextInputFieldModel
		loginButton		ButtonModel
		legal 				ButtonModel
		status				TextInputFieldModel
		) .
	self status enabled: false .
	self loginNameLabel label: #name: .
	self passwordLabel label: '   password:' .
	self iconButton 
			icon: (GbtIcons at: context uiKey) ;
			state: true. 
	self legal 
			state: true; 
			enabled: false;
			label: self packageVersion, '   |   ', context legalText .
	self loginButton	 
			action: [ self loginAction ];
			state: true;
			label: #login. 
	self loginName autoAccept: true .
	self password autoAccept: true .
	self title: context displayName, ' login' .
		
	self focusOrder 
		add: self loginName;
		add: self password;
		add: self loginButton.
	self needRebuild: false.
	self initializeLayout
! !

!GbtLoginUI methodsFor: 'ui actions' stamp: 'hk 3/27/2017 21:11'!
loginAction 
	| userName userApp|
	userName := self loginName text.
	(self bizApp hasUser: userName) ifFalse: [^self notify: userName, ' not registered as user'].
	self window close. 
	userApp := self bizApp registerAppFor: userName.
	(context appClass class canPerform: #configure:) ifTrue: 
		[context appClass perform: #configure: with: userApp ].
	userApp open  ! !

!GbtLoginUI methodsFor: 'error handling' stamp: 'hk 11/18/2016 12:17'!
notify: aString
	"write the status line "
	self addStatus: aString! !

GbtUI subclass: #GbtMainUI
	instanceVariableNames: 'menu chosenWidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtMainUI commentStamp: 'hk 8/3/2016 13:41' prior: 0!
I am the GloConn main window model.

My subcontext related widgets must be addressed in action methods with the uiKey authored in  the subContext.
the menu is constructed by my subcontexts (BizApps)

Instance Variables
	chosenWidget:		<Symbol | nil>		the widget to be displayed next 
	menu:				<MenuModel>		main menu

===============================================
Das  gegenwärtige Design mit chosenWidget erzwingt Neuberechnen des Layouts, wenn sich der Inhalt des Hauptfensters ändert...   -  to be changed
siehe auch: addSubcontext und addSystemContext
!

GbtMainUI subclass: #GbtGloConnMainUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtGloConnMainUI commentStamp: 'hk 8/3/2016 13:37' prior: 0!
I am the old main window model.

the menu is hand written, NOT generated from DSL text 
!

!GbtGloConnMainUI methodsFor: 'initialization - menu' stamp: 'hk 4/30/2016 18:29'!
addCommunicationButtonGroup:g	
			g addItem: [  :i | i
				icon: (self contactsIcon) ;
				description: 'show contacts' ;
				action: [ self contactsAction ] ] .
			g addItem: [  :i | i
				icon: (GbtIcons default bizNetIcon) ;
				description: 'show biz net' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (GbtIcons default crmIcon );
				description: 'show CRM' ;
				action: [  ] ]  ! !

!GbtGloConnMainUI methodsFor: 'initialization - menu' stamp: 'hk 4/30/2016 18:29'!
addInvoicingButtonGroup:g 	
			g addItem: [  :i | i
				icon: (GbtIcons default invoicingIcon) ;
				description: 'show invoicing' ;
				action: [  ] ] ! !

!GbtGloConnMainUI methodsFor: 'initialization - menu' stamp: 'hk 4/30/2016 18:29'!
addMasterDataButtonGroup:g  	
			g addItem: [  :i | i
				icon: (GbtIcons default logisticsDataIcon) ;
				description: 'show logistics data' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (GbtIcons default taxIcon) ;
				description: 'show tax' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (GbtIcons default routeIcon) ;
				description: 'show routes' ;
				action: [  ] ] ! !

!GbtGloConnMainUI methodsFor: 'initialization - menu' stamp: 'hk 11/4/2016 13:22'!
addMiscellaneousButtonGroup: g
	g	addItem: [ :i | i
				icon: (GbtIcons default userSettingsIcon) ;
				description: 'user settings';
				action: [ self calcAction] ].
	g	addItem: [ :i | i
				icon: (GbtIcons default systemSettingsIcon) ;
				description: 'system settings';
				action: [ self inspect ] ].
	g	addItem: [ :i | i
				icon: (GbtIcons default learnCenterIcon) ;
				description: 'learn center';
				action: [ self calcAction] ].
	g	addItem: [ :i | i
				icon: (GbtIcons  default userIcon) ;
				description: 'evaluation / statistics';
				action: [ self context inspect ] ]! !

!GbtGloConnMainUI methodsFor: 'initialization - menu' stamp: 'hk 4/30/2016 18:29'!
addProcessButtonGroup: g 	
			g addItem: [  :i | i
				icon: (GbtIcons default dashIcon) ;
				description: 'show dash board' ;
				action: [ self dashboardAction] ] .
			g addItem: [  :i | i
				icon: self bizProcessesIcon ;
				description: 'show biz processes' ;
				action: [ self processesAction ]] ! !

!GbtGloConnMainUI methodsFor: 'initialization - menu' stamp: 'hk 4/30/2016 18:29'!
addTourButtonGroup: g 	
			g addItem: [  :i | i
				icon: (GbtIcons default taskOrdersIcon) ;
				description: 'show task orders' ;
				action: [ self taskOrdersAction ] ] .
			g addItem: [  :i | i
				icon: (GbtIcons default projectsIcon) ;
				description: 'show projects' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (GbtIcons default tourIcon) ;
				description: 'show tours' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (self supplierBizProcessesIcon) ;
				description: 'show supplier processes' ;
				action: [ self supplierProcessesAction ] ] ! !

!GbtGloConnMainUI methodsFor: 'initialization dynamic icons' stamp: 'hk 4/30/2016 18:29'!
bizProcessesIcon
	"a little dirty - icon keys used in authoring"
	
	| sc |
	sc := context subcontexts detect: [:e| e uiKey = #bizProcesses].
	^sc hasDataPending 
		ifTrue:  [GbtIcons default bizProcessesDirtyIcon]
		ifFalse: 	[GbtIcons default bizProcessesIcon]
! !

!GbtGloConnMainUI methodsFor: 'ui actions' stamp: 'hk 9/20/2016 17:50'!
calcAction
	self chosenWidget: #userSettings .
	self reBuild! !

!GbtGloConnMainUI methodsFor: 'ui actions' stamp: 'hk 9/20/2016 18:02'!
contactsAction
	self chosenWidget: #contacts.
	self contacts resetList! !

!GbtGloConnMainUI methodsFor: 'initialization dynamic icons' stamp: 'hk 4/30/2016 18:29'!
contactsIcon
	"a little dirty - icon keys used in authoring"
	
	| sc |
	sc := context subcontexts detect: [:e| e uiKey = #contacts].
	^sc hasDataPending 
		ifTrue:  [GbtIcons default contactsDirtyIcon]
		ifFalse: 	[GbtIcons default contactsIcon]
! !

!GbtGloConnMainUI methodsFor: 'ui actions' stamp: 'hk 9/20/2016 18:02'!
dashboardAction
	self chosenWidget: #dash! !

!GbtGloConnMainUI methodsFor: 'api' stamp: 'hk 1/9/2017 18:32'!
initialExtent
	^1680 @ 1200! !

!GbtGloConnMainUI methodsFor: 'initialization' stamp: 'hk 11/7/2016 11:53'!
initializeLayout 
	self layout: (SpecLayout composed newColumn: [ :c | c
			newRow: [ :r | r add: #logoButton] height: self logoHeight ;		"logo"
			newRow: [ :r | r add: #menu ] height: self singleHeight ;				"main menu buttons"
			newRow: [ :r | r add: #status; add: #clearButton width: 40 ] height: self singleHeight ;			"status line"
			add: chosenWidget value;		 					"the widget chosen via main menu"
			newRow: [ :r | r add: #legal ] height: self reducedHeight ] ).
	self needFullRebuild: false.! !

!GbtGloConnMainUI methodsFor: 'initialization - menu' stamp: 'hk 11/7/2016 12:51'!
initializeMainMenu 	
	(menu := MenuModel new) addGroup: [ :g |
		self addProcessButtonGroup: g .
		self addMenuGap: g width: self menuGap.
		self addTourButtonGroup: g .
		self addMenuGap: g width: self menuGap.
		self addInvoicingButtonGroup: g .
		self addMenuGap: g width: self menuGap.
		self addCommunicationButtonGroup: g .
		self addMenuGap: g width: self menuGap.
		self addMasterDataButtonGroup: g .
		self addMenuGap: g width: self menuGap.
		self addMiscellaneousButtonGroup: g .
	 	self addSystemContext: g ]! !

!GbtGloConnMainUI methodsFor: 'initialization' stamp: 'hk 9/20/2016 18:09'!
initializePresenter
	"must reBuild to change the icons"

	chosenWidget whenChangedDo: [ self reBuild ].
	(context subcontexts detect: [:e| e uiKey = #bizProcesses]) dataPending whenChangedDo: 
			[(self menu menuGroups first menuItems at: 2) icon: self bizProcessesIcon . self reBuild].
	(context subcontexts detect: [:e| e uiKey = #contacts]) dataPending whenChangedDo: 
			[(self menu menuGroups first menuItems at: 11) icon: self contactsIcon . self reBuild].
	(context subcontexts detect: [:e| e uiKey = #supplierBizProcesses]) dataPending whenChangedDo: 
			[(self menu menuGroups first menuItems at: 7) icon: self supplierBizProcessesIcon . self reBuild]
	

! !

!GbtGloConnMainUI methodsFor: 'initialization' stamp: 'hk 9/20/2016 20:08'!
initializeSubcontexts
	"to be refactored away - see addSubcontext:to:"
	context subcontexts do: [ :sc | self assign: sc newUI to: sc uiKey] ! !

!GbtGloConnMainUI methodsFor: 'constants' stamp: 'hk 4/12/2015 14:21'!
logoHeight
	^ 150! !

!GbtGloConnMainUI methodsFor: 'initialization' stamp: 'hk 8/3/2016 13:50'!
menuGap
		^160! !

!GbtGloConnMainUI methodsFor: 'api' stamp: 'hk 3/14/2017 10:37'!
openWithSpec
	| res |
	res := super openWithSpec.
	self window whenClosedDo: [GbtBizNetMockUp stopPolling ] .
	^res
! !

!GbtGloConnMainUI methodsFor: 'ui actions' stamp: 'hk 9/20/2016 18:02'!
processesAction
	self chosenWidget: #bizProcesses .
	self bizProcesses resetList! !

!GbtGloConnMainUI methodsFor: 'initialization dynamic icons' stamp: 'hk 4/30/2016 18:29'!
supplierBizProcessesIcon
	"a little dirty - icon keys used in authoring"
	
	| sc |
	sc := context subcontexts detect: [:e| e uiKey = #supplierBizProcesses].
	^sc hasDataPending 
		ifTrue:  [GbtIcons default supplierBizProcessesDirtyIcon]
		ifFalse: 	[GbtIcons default supplierBizProcessesIcon]
! !

!GbtGloConnMainUI methodsFor: 'ui actions' stamp: 'hk 9/20/2016 18:02'!
supplierProcessesAction
	self chosenWidget: #supplierBizProcesses ! !

!GbtGloConnMainUI methodsFor: 'ui actions' stamp: 'hk 9/20/2016 18:03'!
taskOrdersAction
	self chosenWidget: #taskOrders ! !

!GbtMainUI methodsFor: 'initialization' stamp: 'hk 8/26/2016 12:07'!
addMenuGap: g	width: aNumber
	 g addItem: [ :i | i
		enabled: false;
		icon: (Smalltalk ui icons blankIconOfWidth: aNumber)] ! !

!GbtMainUI methodsFor: 'ui actions' stamp: 'hk 12/9/2016 15:09'!
addStatus: aString
	"display a new status message to the left"
	
	| st |
	aString ifEmpty: [ ^self ] . 
	st := aString, ' | ', self status text asString.
	st size > 200 ifTrue: [ st := (st first: 200) , ' ... ' ].
	self status text: st ! !

!GbtMainUI methodsFor: 'initialization' stamp: 'hk 10/11/2016 16:37'!
addSubcontext: sc to: aMenuGroup
	|wgt key|
	self assign: (wgt := sc newUI) to: (key := sc uiKey).
	self addMenuGap: aMenuGroup width: self menuGap.
	aMenuGroup addItem: [ :i | i
		icon:  (GbtIcons at: key) ;
		description: 'show ', sc svoName ;
		action:  [self chosenWidget: key.
					wgt resetList] ]! !

!GbtMainUI methodsFor: 'initialization' stamp: 'hk 3/15/2017 10:17'!
addSystemContext: aMenuGroup
	|subMenu mainMenu tmplEditor|
	tmplEditor :=  GbtTemplatesEditor basicNew.
	self assign: tmplEditor to: #templateEditor.
	tmplEditor initialize.
	subMenu := MenuModel new addGroup: [:g | g
			addItem: [:item | item
					name: 'templates' ; 
					action: [self chosenWidget: #templateEditor]];
			addItem: [:item| item name: #void]] .
	mainMenu := MenuItemModel new
		icon: (GbtIcons at: #settings);
		description: 'settings';
		subMenu: subMenu.
		
	self addMenuGap: aMenuGroup width: self menuGap.
	aMenuGroup addMenuItem: mainMenu .
	self addMenuGap: aMenuGroup width: 1000! !

!GbtMainUI methodsFor: 'accessing' stamp: 'hk 9/20/2016 17:48'!
chosenWidget
	^chosenWidget
! !

!GbtMainUI methodsFor: 'accessing' stamp: 'hk 9/20/2016 17:49'!
chosenWidget: aSymbol
	chosenWidget value: aSymbol
! !

!GbtMainUI methodsFor: 'ui actions' stamp: 'hk 7/28/2016 17:11'!
clearAction
		self status text: '' ! !

!GbtMainUI methodsFor: 'accessing' stamp: 'hk 11/7/2016 11:50'!
companyString
	"for the window headline"
	^([context vo company] ifError: [^'']), '   ', Date today asString, '   |   '! !

!GbtMainUI methodsFor: 'api' stamp: 'hk 1/13/2017 19:25'!
initialExtent
	"default extent when stand alone"
	^800 @ 600! !

!GbtMainUI methodsFor: 'initialization' stamp: 'hk 9/20/2016 18:01'!
initializeLayout 
	self layout: (SpecLayout composed newColumn: [ :c | c
			newRow: [ :r | r add: #menu ] height: self singleHeight ;				"main menu buttons"
			newRow: [ :r | r add: #status; add: #clearButton width: 40 ] height: self singleHeight ;			"status line"
			add: chosenWidget value	;						"the widget chosen via main menu"
			add: #legal height: self singleHeight] ). 
	self needFullRebuild: false.! !

!GbtMainUI methodsFor: 'initialization - menu' stamp: 'hk 9/20/2016 20:02'!
initializeMainMenu
	| menuGroup |
	menu := MenuModel new .
	menu addMenuGroup: (menuGroup := MenuGroupModel new) .
	context subcontexts do: [:sc | self addSubcontext: sc to: menuGroup ] .
	self addSystemContext: menuGroup ! !

!GbtMainUI methodsFor: 'initialization' stamp: 'hk 9/20/2016 18:03'!
initializePresenter
	chosenWidget whenChangedDo: [ self reBuild ]! !

!GbtMainUI methodsFor: 'initialization' stamp: 'hk 11/17/2016 12:45'!
initializeSubcontexts
	"context subcontexts do: [ :sc | self assign: sc newUI to: sc uiKey] "! !

!GbtMainUI methodsFor: 'initialization' stamp: 'hk 11/17/2016 12:46'!
initializeWidgets
		self instantiateModels: #(
		logoButton			ButtonModel
		emptyPane			ButtonModel
		legal				ButtonModel
		clearButton		ButtonModel
		status				TextInputFieldModel
		).
	self logoButton 
			icon: (GbtIcons at: context uiKey) ;
			state: true. 
	self clearButton
			action: [ self clearAction ];
			state: true;
			label: #clear .
	self legal 
			state: true; 
			enabled: false;
			label: self packageVersion, '   |   ', context legalText .
	chosenWidget := #emptyPane asValueHolder .
	self status enabled: false .
	self emptyPane 
		icon: (GbtIcons at: context uiKey) ; 
		state: true .
	self title: self titleString .
	self initializeMainMenu.
	self initializeSubcontexts .

	self initializeLayout ! !

!GbtMainUI methodsFor: 'accessing' stamp: 'hk 6/12/2016 20:18'!
menu
	^ menu! !

!GbtMainUI methodsFor: 'initialization' stamp: 'hk 8/2/2016 14:53'!
menuGap
		^(self initialExtent / (1 + context subcontexts size) / 2) x! !

!GbtMainUI methodsFor: 'error handling' stamp: 'hk 1/27/2017 14:18'!
notify: aString
	"write the status line "
	self addStatus: (aString withLineEndings: '\')! !

!GbtMainUI methodsFor: 'accessing' stamp: 'hk 11/7/2016 11:42'!
titleString
	^context displayName, '  |  ', self companyString, self userString! !

!GbtMainUI methodsFor: 'accessing' stamp: 'hk 11/7/2016 12:39'!
userString
	"for the window headline"
	^'user: ', context user! !

!GbtUI class methodsFor: 'instance creation' stamp: 'hk 4/13/2015 10:51'!
on: aContext
	^ self basicNew
		context: aContext;
		initialize! !

!GbtUI class methodsFor: 'instance creation' stamp: 'hk 1/31/2016 11:31'!
on: aContext mode: aSymbol
	^ self basicNew
		context: aContext;
		initialize! !

!GbtUI methodsFor: 'accessing' stamp: 'hk 3/23/2017 10:30'!
bizApp
	^context bizApp! !

!GbtUI methodsFor: 'api' stamp: 'hk 7/19/2016 14:12'!
clearSubUI
	"default"! !

!GbtUI methodsFor: 'accessing' stamp: 'hk 4/13/2015 10:52'!
context
	^context ! !

!GbtUI methodsFor: 'accessing' stamp: 'hk 8/26/2015 10:32'!
context: aAC
	context := aAC .
	aAC ui: self! !

!GbtUI methodsFor: 'constants' stamp: 'hk 5/19/2016 11:56'!
defaultWidth
	^self class  buttonWidth *2! !

!GbtUI methodsFor: 'accessing' stamp: 'hk 12/31/2016 18:05'!
editor
	^self editorLoop: 1 ! !

!GbtUI methodsFor: 'accessing' stamp: 'hk 12/31/2016 18:24'!
editorLoop: aCounter
	aCounter > 4 "no of modes" ifTrue: [ self notify:  'UI editor loop' ].
	^[self modeEditor on: context vo ] ifError: 
			[self toggleMode. self editorLoop: aCounter +1 ]! !

!GbtUI methodsFor: 'testing' stamp: 'hk 3/1/2016 12:06'!
hasTarget  
	^false
! !

!GbtUI methodsFor: 'initialization' stamp: 'hk 2/26/2016 14:05'!
iconRowFor: aColumn
	aColumn 	newRow: [ :r | r
				add:  #pIcon width: 24 ;
				add:  #pLabel ;
				add: #pInspect width: 80  ] height: self class toolbarHeight .
! !

!GbtUI methodsFor: 'testing' stamp: 'hk 11/21/2016 18:14'!
inEdit  
	^ mode value = #edit
! !

!GbtUI methodsFor: 'api' stamp: 'hk 1/9/2017 20:47'!
initialExtent
	"default extent when stand alone"
	^600 @ 400! !

!GbtUI methodsFor: 'mode switching' stamp: 'hk 12/14/2016 16:53'!
initializeMode
	modeToggler := Dictionary newFromPairs: #(
		diEdit 	edit 		
		edit 		text
		text 		sdBox
		sdBox 		diEdit).
	mode := #edit asValueHolder.! !

!GbtUI methodsFor: 'initialization' stamp: 'hk 2/26/2016 14:07'!
initializeWidgets
	self instantiateModels: #( 
		pIcon			ButtonModel
		pLabel			LabelModel
		pInspect		ButtonModel
		emptyLabel 	LabelModel) .				
	self pLabel label: 'undefined'.
	self pInspect
		action: [context inspect];
		state: true;
		label: 'inspect Ctxt'.
! !

!GbtUI methodsFor: 'testing' stamp: 'hk 10/31/2016 17:47'!
isGbtUi
	^true
! !

!GbtUI methodsFor: 'accessing' stamp: 'hk 11/21/2016 18:11'!
mode
	^ mode value! !

!GbtUI methodsFor: 'accessing' stamp: 'hk 11/21/2016 18:11'!
mode: aSymbol
	mode value: aSymbol! !

!GbtUI methodsFor: 'mode switching' stamp: 'hk 11/21/2016 18:30'!
modeAfter: aSymbol
	^ modeToggler at: aSymbol! !

!GbtUI methodsFor: 'ui actions' stamp: 'hk 11/23/2016 15:10'!
modeEditor
	"incomplete - GbtNoEditor needed when no read right"
	self context userRight write ifTrue: 
		[self mode = #diEdit ifTrue: [^GbtThingDiEditor].
		self mode = #edit ifTrue: [^GbtThingEditor]].
	self mode = #sdBox ifTrue: [^GbtCustomSDBoxWidget].
	mode value: #text.
	^GbtUiTextWidget! !

!GbtUI methodsFor: 'error handling' stamp: 'hk 11/8/2016 19:57'!
notify: aString
	aString ifEmpty: [^self].
	owner notify: aString! !

!GbtUI methodsFor: 'instance creation' stamp: 'hk 4/11/2016 16:25'!
open
	^self openWithSpec! !

!GbtUI methodsFor: 'accessing' stamp: 'hk 11/4/2016 17:51'!
packageVersion
	^self class package  mcPackage workingCopy versionInfo name! !

!GbtUI methodsFor: 'printing' stamp: 'hk 8/27/2015 19:38'!
printOn: aStream 	
	super printOn: aStream .
	aStream nextPutAll: ' on '; nextPutAll: context printString! !

!GbtUI methodsFor: 'api' stamp: 'hk 10/21/2015 17:54'!
reBuild
"Transcript cr; show: self className .
"	self initializeLayout.
	self needFullRebuild: false .
	self buildWithSpec
! !

!GbtUI methodsFor: 'constants' stamp: 'hk 4/13/2015 11:41'!
reducedHeight
	^self class toolbarHeight *0.8 ! !

!GbtUI methodsFor: 'ui actions' stamp: 'hk 8/11/2016 14:47'!
refresh! !

!GbtUI methodsFor: 'api' stamp: 'hk 7/19/2016 14:12'!
resetList
	"default"! !

!GbtUI methodsFor: 'constants' stamp: 'hk 4/13/2015 11:41'!
singleHeight
	^self class toolbarHeight ! !

!GbtUI methodsFor: 'ui actions' stamp: 'hk 11/21/2016 18:13'!
toggle
 	self toggleMode ; reBuild 

! !

!GbtUI methodsFor: 'mode switching' stamp: 'hk 11/21/2016 19:22'!
toggleMode   
	mode value: (self modeAfter: self mode)! !

!GbtUI methodsFor: 'accessing' stamp: 'hk 11/7/2016 12:36'!
user
	^context user ifNil: [ 'n.n.' ] ! !

GbtUI subclass: #GcCalcUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GcCalcUI methodsFor: 'initialization' stamp: 'hk 1/23/2016 15:38'!
initializeLayout
	
	self layout: (SpecLayout composed newColumn: [ :c | 
		self iconRowFor: c .
		c 	newRow: [ :r | r  
				add: #emptyLabel ;
				add: #calculator  ;
				add: #emptyLabel ] height: 6.333 * self class toolbarHeight .
		c	add: #emptyLabel  ] ).
	self needFullRebuild: false.


! !

!GcCalcUI methodsFor: 'initialization' stamp: 'hk 4/30/2016 18:29'!
initializeWidgets
	super initializeWidgets .
	self pIcon icon: (GbtIcons at: context uiKey) .
	self pLabel label: context displayName  .
	self assign: SvoCalc new to: #calculator .	
	self initializeLayout! !

GbtUI subclass: #GcDashUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GcDashUI methodsFor: 'initialization' stamp: 'hk 1/23/2016 15:38'!
initializeLayout
 	self layout: (SpecLayout composed newColumn: [ :c | 
		self iconRowFor: c .
		c add: #dashButton ] ).	
	self needFullRebuild: false.
! !

!GcDashUI methodsFor: 'initialization' stamp: 'hk 4/30/2016 18:29'!
initializeWidgets
	super initializeWidgets .
	self pIcon icon: (GbtIcons at: context uiKey ) .
	self pLabel label: context displayName  .
	self assign: (ButtonModel new
				state: false;
				icon: (GbtIcons default dashboardIcon)) to: #dashButton.
	self initializeLayout! !

DynamicComposableModel subclass: #GbtUiTextWidget
	instanceVariableNames: 'slotVO'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtUiTextWidget commentStamp: 'hk 11/9/2016 15:09' prior: 0!
I am a scrollable Text dislay that can be used in place of an editor such as GbtThingEditor!

!GbtUiTextWidget class methodsFor: 'instance creation' stamp: 'hk 11/9/2016 13:42'!
on: aVO 
	"for use instead of GcVOEditor"
	^self basicNew slotVO: aVO; initialize! !

!GbtUiTextWidget class methodsFor: 'instance creation' stamp: 'hk 2/23/2016 15:59'!
on: aVO stopSlots: anObject
	^self on: aVO ! !

!GbtUiTextWidget methodsFor: 'accessing' stamp: 'hk 7/1/2016 19:28'!
editor1
	"compatibility with GbtThingDiEditor"
	^nil! !

!GbtUiTextWidget methodsFor: 'initialization' stamp: 'hk 11/1/2016 17:25'!
initializeLayout
	self layout: (SpecLayout composed add: #text; yourself)
		! !

!GbtUiTextWidget methodsFor: 'initialization' stamp: 'hk 2/21/2017 10:10'!
initializeWidgets

	self instantiateModels:  #(text 	TextModel) .
	self  text text: slotVO asText .
	self initializeLayout .
	self needFullRebuild:  false.
	! !

!GbtUiTextWidget methodsFor: 'accessing' stamp: 'hk 7/1/2016 19:28'!
saved
	"compatibility with GbtThingEditor"
	^nil! !

!GbtUiTextWidget methodsFor: 'accessing' stamp: 'hk 1/21/2016 15:11'!
slotVO: anObject
	slotVO := anObject! !

DynamicComposableModel subclass: #SvoCalc
	instanceVariableNames: 'display button0 button1 button2 button3 button4 button5 button6 button7 button8 button9 buttonPlus buttonMinus buttonMult buttonDiv buttonEq buttonDot buttonSqr buttonLog buttonChange buttonClear previousNumber currentOperation operationPending'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Utilities'!

!SvoCalc commentStamp: 'hk 4/13/2015 17:37' prior: 0!
SvoCalc new openWithSpec

A SpoCalc is the Spec Demo Calculator enhanced.

Instance Variables
	display:				<TextInput>	the calculators input & display
	currentOperation:	<String>		the operation to be performed:  +  -  * / 
	operationPending:	<Bolean>		true after pressing +  -  * /  =
										means: new input expected
	previousNumber:	<Number | nil>	stores the first value entered
										no operation pending ifNil
			
	button0:			<Button>
	button1:			<Button>
	button2:			<Button>
	button3:			<Button>
	button4:			<Button>
	button5:			<Button>
	button6:			<Button>
	button7:			<Button>
	button8:			<Button>
	button9:			<Button>
	buttonChange:		<Button>
	buttonClear:		<Button>
	buttonDiv:			<Button>
	buttonDot:			<Button>
	buttonEq:			<Button>
	buttonLog:			<Button>
	buttonMinus:		<Button>
	buttonMult:			<Button>
	buttonPlus:			<Button>
	buttonSqr:			<Button>

!

!SvoCalc class methodsFor: 'specs' stamp: 'hk 1/5/2015 14:43'!
title 
	^ 'SVO Calculator'! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:01'!
addition
	buttonPlus
		label: '+';
		action: [ self operation: $+ ];
		state: true! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
button0
	^ button0! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
button1
	^ button1! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button2
	^ button2! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button3
	^ button3! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button4
	^ button4! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button5
	^ button5! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button6
	^ button6! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button7
	^ button7! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button8
	^ button8! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button9
	^ button9! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
buttonChange
	^ buttonChange! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
buttonClear
	^ buttonClear! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
buttonDiv
	^ buttonDiv! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
buttonDot
	^ buttonDot! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
buttonEq
	^ buttonEq! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
buttonLog
	^ buttonLog! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
buttonMinus
	^ buttonMinus! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
buttonMult
	^ buttonMult! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
buttonPlus
	^ buttonPlus! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
buttonSqr
	^ buttonSqr! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 18:02'!
changeSign
	buttonChange
		label: '+/ -';
		action: [ display label: display label asNumber negated asString ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/6/2014 16:13'!
clearDisplay
	buttonClear
		label: 'C';
		action: [ display label: '0' ];
		state: true! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/6/2014 14:56'!
defineDigitButton: aButton label: aString
	aButton
		label: aString;
		action: [ display label: (self newDisplayLabelFor: aString) asNumber asString  ];
		state: true! !

!SvoCalc methodsFor: 'button definition' stamp: 'hk 11/6/2014 14:57'!
defineDigitButtons
	button0
		label: '0' ;
		action: [ display label: (self newDisplayLabelFor: '0' )  ];
		state: true.
	self defineDigitButton: button1 label: '1'.
	self defineDigitButton: button2 label: '2'.
	self defineDigitButton: button3 label: '3'.
	self defineDigitButton: button4 label: '4'.
	self defineDigitButton: button5 label: '5'.
	self defineDigitButton: button6 label: '6'.
	self defineDigitButton: button7 label: '7'.
	self defineDigitButton: button8 label: '8'.
	self defineDigitButton: button9 label: '9'.
! !

!SvoCalc methodsFor: 'button definition' stamp: 'hk 11/5/2014 14:45'!
defineOtherButtons
	"basic arithmetic operations"
	self addition.
	self subtraction.
	self multiplication.
	self division.	
		
	"other arithmetic opertions"
	self squareRoot.
	self logarithm.
	self changeSign.	
		
	"remaining buttons"
	self clearDisplay.
	self enterDot.
	self equals! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:34'!
display
	^ display! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:06'!
division
	buttonDiv
		label: '/';
		action: [ self operation: $/ ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/6/2014 15:56'!
enterDot
	buttonDot
		label: '.';
		action: [display label: (self newDisplayLabelForDot )  ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/6/2014 16:12'!
equals
	buttonEq
		label: '=';
		action: [ operationPending := true. 
				previousNumber ifNotNil: 
					[display label: (previousNumber perform: currentOperation asSymbol with:  display label asNumber ) asString].
				previousNumber := nil ];
		state: true! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 4/13/2015 17:47'!
initialExtent
	"(4@4) is the size of the border"

	^ 251 @ 191 ! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 11/6/2014 15:36'!
initialize
	operationPending  := false.
	super initialize! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 11/5/2014 14:33'!
initializeDigitButtons
	button0 := self newButton.
	button1 := self newButton.
	button2 := self newButton.
	button3 := self newButton.
	button4 := self newButton.
	button5 := self newButton.
	button6 := self newButton.
	button7 := self newButton.
	button8 := self newButton.
	button9 := self newButton.
	self defineDigitButtons! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 1/25/2015 20:49'!
initializeLayout
	self layout: (SpecLayout composed
		newColumn: [ :column | column
						add: #display ;
						newRow: [ :row1 | row1
										add: #buttonClear;
										add: #buttonLog;
										add: #buttonChange;
										add: #buttonSqr ] height: 26;
						newRow: [ :row2 | row2
										add: #button1;
										add: #button2;
										add: #button3;
										add: #buttonDiv ] height: 26;
						newRow: [ :row3 | row3
										add: #button4;
										add: #button5;
										add: #button6;
										add: #buttonMult ] height: 26;
						newRow: [ :row4 | row4
										add: #button7;
										add: #button8;
										add: #button9;
										add: #buttonMinus ] height: 26;
						newRow: [ :row5 | row5
										add: #buttonDot;
										add: #button0;
										add: #buttonEq;
										add: #buttonPlus ] height: 26 ];
		yourself)! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 11/5/2014 14:46'!
initializeOtherButtons
	"instantiate the basic arithmetic buttons"

	buttonPlus := self newButton.
	buttonMinus := self newButton.
	buttonMult := self newButton.
	buttonDiv := self newButton.
	buttonEq := self newButton.	
		
	"instantiate the remaining buttons"
	buttonDot := self newButton.
	buttonSqr := self newButton.
	buttonLog := self newButton.
	buttonChange := self newButton.
	buttonClear := self newButton.
	
	self defineOtherButtons! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 1/25/2015 19:58'!
initializeWidgets 
	self initializeDigitButtons. 
	self initializeOtherButtons. 
	display := self newLabel.
	self initializeLayout ! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:17'!
logarithm
	buttonLog
		label: 'Log';
		action: [ display label: display label asNumber log asString ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 18:26'!
multiplication
	buttonMult
		label: 'x';
		action: [ self operation: $* ];
		state: true! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/6/2014 15:31'!
newDisplayLabelFor: aString
	^operationPending ifTrue: [operationPending  := false. aString ]  ifFalse: [ display label , aString ] ! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/6/2014 16:06'!
newDisplayLabelForDot
	^ (operationPending or: [display label isEmpty])
		ifTrue: [ operationPending := false.  '0.' ]
		ifFalse: [  (display label includes: $.) 
						ifTrue: [ display label ] 
						ifFalse:  [ display label,  '.' ] ]! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/6/2014 16:16'!
operation: aCharacter
	"Defines which operation will be performed: it can be a + / - x"

	previousNumber := display label asNumber.	
	currentOperation := aCharacter.				
	operationPending  := true.! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/5/2014 17:08'!
sqrCheck
	"checks whether we are attempting to calculate the square root of a negative
number"

	display label asNumber < 0
		ifTrue: [ display label: 'Error' ]
		ifFalse: [ display label: display label asNumber sqrt asString ]! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:07'!
squareRoot
	buttonSqr
		label: 'Sqr';
		action: [ self sqrCheck ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:05'!
subtraction
	buttonMinus
		label: '-';
		action: [ self operation: $- ];
		state: true! !

RTUMLClassBuilder subclass: #GbtDiagramBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Utilities'!

!GbtDiagramBuilder commentStamp: 'hk 5/26/2015 22:41' prior: 0!
I extend the RTUMLClassBuilder in order to show SVO classes with just the 'protocol protocol'!

!GbtDiagramBuilder class methodsFor: 'analysis' stamp: 'hk 5/23/2016 11:27'!
exampleActions
	"self exampleActions"

	TextModel new openWithSpec ; text: GbtAction documentation! !

!GbtDiagramBuilder class methodsFor: 'analysis' stamp: 'hk 11/16/2016 12:22'!
exampleAuthoringProtocol
	"self exampleAuthoringProtocol"

	TextModel new openWithSpec ; text: self new authoringProtocol! !

!GbtDiagramBuilder class methodsFor: 'analysis' stamp: 'hk 3/20/2017 18:06'!
exampleRichThings
	"self exampleRichThings -	show all selected things "

	| builder view |
	(builder := RTUMLClassBuilder new)
	 	addObjects: GbtBizAppServer default selectedNodesInHierarchy ;
		classname: #longName ;
		instanceVariables: #rtAttributes ;
		methodsNames: #rtSlots ;
		superclass: #container;
		methodselector: #yourself .
	builder	layout  tree.
"	builder lineShape arrowedLine.
"	view := builder view setDefaultMenu.
	RTZoomOutMove on: view . 
	builder build. 
	view openInWindowSized: 1600 @ 800 titled: 'Structure of Things'! !

!GbtDiagramBuilder class methodsFor: 'analysis' stamp: 'hk 3/20/2017 18:06'!
exampleShowContexts
	"create an Application first 
	self exampleShowContexts"

	| builder view |
	(builder := RTUMLClassBuilder new)
		addObjects: GbtBizAppServer default allContexts ;
		classname: #svoName ;
		instanceVariables: #rtAttributes ;
		methodsNames: #rtBehaviors ;
		methodselector: #yourself ;
		superclass: #container ;
		treeLayout.
	view := builder view setDefaultMenu.
	builder build.
	view openInWindowSized: 1600 @ 800 titled: 'Context Hierarchy'! !

!GbtDiagramBuilder class methodsFor: 'analysis' stamp: 'hk 11/16/2016 13:34'!
exampleShowSVOgui
	"self exampleShowSVOgui"

	| builder view |
	(builder := RTUMLClassBuilder new)
		addObjects: GbtUI withAllSubclasses;
		addObjects: (Array with: DynamicComposableModel) ;
		addObjects: GbtTableListUI withAllSubclasses;
		addObjects: GbtWidget withAllSubclasses;
		addObjects: GbtEmptyWidget withAllSubclasses;
		addObjects: GbtThingDiEditor withAllSubclasses;
		addObjects: GbtThingEditor withAllSubclasses;
		addObjects: GbtAddressBoxWidget withAllSubclasses;
		addObjects: GbtCustomSDBoxWidget withAllSubclasses;
		treeLayout.
	view := builder view setDefaultMenu.
	builder lineShape arrowedLine inverted.
	builder build.
	view openInWindowSized: 1200 @ 800 titled: 'GUI classes'! !

!GbtDiagramBuilder class methodsFor: 'analysis' stamp: 'hk 3/14/2017 10:37'!
exampleShowSVOmachine
	"self exampleShowSVOmachine"

	| builder view |
	(builder := RTUMLClassBuilder new)
		addObjects: GbtSVO withAllSubclasses; 
		addObjects: {GbtSlotAssociation. GbtThingLink. GbtEvent. GbtEventQueue. GbtActionPipe. GbtBizAppServer. GbtBizNetMockUp. GbtReader. GbtRootMap. GbtTransaction. GbtTransactor. GbtRole};
		addObjects: GbtAction withAllSubclasses; 
		addObjects: {TGbtSerializer}; 
		treeLayout.
	view := builder view setDefaultMenu.
	builder lineShape arrowedLine inverted.
	builder build.
	view openInWindowSized: 1200 @ 800 titled: 'GbtSVO classes'! !

!GbtDiagramBuilder methodsFor: 'accessing' stamp: 'hk 5/27/2015 11:22'!
attributesOf: object	
	^ object class methods select: [ :m | m protocol =  'authoring'] thenCollect: [ :m | m selector ]! !

!GbtDiagramBuilder methodsFor: 'authoring ' stamp: 'hk 4/30/2016 18:31'!
authoringProtocol
	| stream  |
	stream := TextStream on: (Text new: 10) .
	(GbtSVO withAllSubclasses sort: [:a :b|a name < b name]) do: 
		[ :cls |  |mths|
			mths := self methodsForClass: cls class.
			self printMethods: mths on: stream forClass: cls class.
			mths := self methodsForClass: cls.
			self printMethods: mths on: stream forClass: cls].
	^stream contents ! !

!GbtDiagramBuilder methodsFor: 'accessing' stamp: 'hk 11/17/2015 20:08'!
methodsForClass: obj
	| protocols methods |
	protocols := obj protocols select: [ :p| p beginsWith: 'authoring' ].
	methods := SortedCollection new sortBlock: [ :a :b | a selector < b selector ].
	protocols do: [ :p| methods addAll: (obj methodsInProtocol: p) ].
	^ methods! !

!GbtDiagramBuilder methodsFor: 'authoring ' stamp: 'hk 11/16/2016 13:26'!
printMethods: mths on: aStream forClass: aClass
	mths ifNotEmpty: 
				[aStream nextPutAll: aClass name asText allBold; cr].
	mths do: [ :m | |cmt | 
				aStream nextPutAll: m selector asText allItalic; cr .
				cmt := m comment ifNil: [ 'comment missing' ].
				aStream tab ; nextPutAll: cmt; cr ] ! !

!StandardFileStream methodsFor: '*GBT-DSL' stamp: 'hk 8/30/2015 18:48'!
compressFile
	"Write a new file that has the data in me compressed in GZip format."
	| zipped buffer |

	self readOnly; binary.
	zipped := (self directory / self localName, 'gz') writeStream.
	zipped binary; setFileTypeToObject.
		"Type and Creator not to be text, so can be enclosed in an email"
	zipped := GZipWriteStream on: zipped.
	buffer := ByteArray new: 50000.
	'Compressing ', self fullName displayProgressFrom: 0 to: self size
		during: [:bar |
			[self atEnd] whileFalse: [
				bar current: self position.
				zipped nextPutAll: (self nextInto: buffer)].
			zipped close.
			self close].
	^zipped! !

DateModel subclass: #GbtDateModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-VO'!

!GbtDateModel commentStamp: 'hk 8/2/2016 15:02' prior: 0!
I subclass DateModel to conform to Gbt layout!

!GbtDateModel class methodsFor: 'accessing' stamp: 'hk 7/31/2016 15:00'!
spec
	<spec: #default>
	"self example inspect"
	^ SpecLayout composed newRow: [ :row | row
			add: #dateLabel width: GbtWidget labelWidth ; 
			add: #dateModel;  
			add: #chooseDateButton width: 20] ! !

!Trait methodsFor: '*GBT-DSL' stamp: 'hk 2/6/2017 18:43'!
rtmethods
	^self methods! !

!Text methodsFor: '*GBT-DSL' stamp: 'hk 2/6/2017 18:26'!
allItalic
	"Force this whole text to be bold."
	string size = 0 ifTrue: [^self].
	self makeItalicFrom: 1 to: string size! !

!Text methodsFor: '*GBT-DSL' stamp: 'hk 2/6/2017 18:25'!
makeItalicFrom: start to: stop

	^ self addAttribute: TextEmphasis italic from: start to: stop! !

Error subclass: #GbtError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-core'!

!GbtError commentStamp: 'hk 4/30/2016 18:33' prior: 0!
I am made to show up in the debugger - indicating an authoring error.

I am usually thrown on failed checks of authoring constructs!

ThemeIcons subclass: #GbtIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Utilities'!

GbtIcons class
	instanceVariableNames: 'default'!

!GbtIcons commentStamp: 'hk 11/25/2016 18:07' prior: 0!
GcIcons is a container for the GloConn icons.

Start from a png in your 'Icons'-Directory and 
1. add the filename (without extension) to the method normalSizeNames
2.  do:    < GbtIcons default createIconMethodsFromDirectory: 'Icons' >
move the newly created icon form to the resources icons protocol

to reset  do:  <  GbtIcons initialize >

to create an icon (png, 32x32) :
 https://iconverticons.com/online/


To write a png:
self default rowingTeamIcon writePNGFileNamed: 'rowingTeam.png'!

GbtIcons class
	instanceVariableNames: 'default'!

!GbtIcons class methodsFor: 'accessing' stamp: 'hk 2/20/2017 19:33'!
at: aKey
	(aKey = #add) ifTrue: [ ^Smalltalk ui icons smallAddIcon ].
	(aKey = #back) ifTrue: [ ^Smalltalk ui icons backIcon ].
	(aKey = #blank144) ifTrue: [ ^Smalltalk ui icons blankIconOfWidth: 144 ].
	(aKey = #edit) ifTrue: [ ^Smalltalk ui icons editIcon].
	(aKey = #delete) ifTrue: [ ^Smalltalk ui icons deleteIcon ].
	(aKey = #undo) ifTrue: [ ^Smalltalk ui icons smallUndoIcon ].
	(aKey = #redo) ifTrue: [ ^Smalltalk ui icons smallRedoIcon ].
	(aKey = #refresh) ifTrue: [ ^Smalltalk ui icons refreshIcon ].
	(aKey = #view) ifTrue: [ ^Smalltalk ui icons smallInspectItIcon ].
	(aKey = #text) ifTrue: [ ^GLMUIThemeExtraIcons glamorousBrowse].
	(aKey = #save) ifTrue: [ ^Smalltalk ui icons smallSaveIcon ].
	(aKey = #ask) ifTrue: [ ^Smalltalk ui icons smallQuestionIcon ].
	^self at: aKey ifAbsent: [Smalltalk ui icons questionIcon]
	! !

!GbtIcons class methodsFor: 'accessing' stamp: 'hk 11/25/2016 15:10'!
at: anIconSymbol ifAbsent: aBlock
	| sel |
	anIconSymbol ifNil: [^aBlock value].
	sel :=  (anIconSymbol, #Icon) asSymbol .
	(default respondsTo: sel) ifFalse: [^aBlock value].
	^default perform: sel! !

!GbtIcons class methodsFor: 'accessing' stamp: 'hk 11/25/2016 15:09'!
default
	^default ! !

!GbtIcons class methodsFor: 'class initialization' stamp: 'hk 11/25/2016 15:09'!
initialize
	default := self new! !

GbtIcons initialize!

!GbtIcons class methodsFor: 'class initialization' stamp: 'hk 10/12/2016 14:56'!
initializeImageIcon
	"replace the Pharo image by GloConn -  self initializeImageIcon "
	
	(World submorphs detect: [ :sm | sm isKindOf: ImageMorph ]) image: self default headerIcon! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
activity16Icon
	"Private - Generated method"
	^self icons 
			at: #activity16Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self activity16IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 3/1/2016 15:24'!
activity16IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/activity16.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAAAMZJREFU
eJyckFkOgkAMhntJDSBbTIzeT3FBcb+AMQqn0HdtwXZARSWyNP+8fDNfpzOQ1Czg5boOx3Fs
27ZMs2MYuqa1C2EmPCsu6vgNmwhx3ZHiP/2KH137DQ1/CTdAO6C9JLlfy0fCFeAaWMMtJLdL
BSEAXEKqlQgUDdAHnAMuVAIJhW7WKIW868P7Bor6OAWcCeXQyWKWCb7ivDvJCeKEPUYcOuqv
0yIoiGNA71MQ59ylQyt/WgQPcKQy/BGq1AMAAP//AwAs9HOnEOo38QAAAABJRU5ErkJggg=='! !

!GbtIcons methodsFor: 'private - utilities from Pharo4' stamp: 'hk 11/4/2016 16:25'!
base64ContentsOfFileNamed: aString 
	"Private - convenient method"
	
	| file base64Contents |
	file := FileStream readOnlyFileNamed: aString.
	base64Contents := (Base64MimeConverter mimeEncode: file binary) contents.
	file close.
	^ base64Contents! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 15:48'!
beitragsMgmt16Icon
	"Private - Generated method"
	^self icons 
			at: #beitragsMgmt16Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self beitragsMgmt16IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 12/18/2016 15:36'!
beitragsMgmt16IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo5.0.app/Contents/Resources/Icons/beitragsMgmt16.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAADAFBMVEWeu1uhvmCfvF2VtFL+
/v79/f2dulmTsk+auFahvV+buVaMrEmZt1WOrkumwWePr0yNrE2gvF2XtlSrxW+HqUWux3SL
rEiTslCEp0KqxGytxnOXtVOux3OYtlSeu1qMrEyrxXGMrE2gvV6WtFOjv2OXtVSKq0iqxG6L
q0uow2mFqEOJqkjH2aaXtFjZ5b6YtlWJqkaSsU+ux3XI2aeIqkaGqEOWtVOUs1GwyXaVtFev
x3iIqUexyXuRsU+jv2LY5Lypw2udu1qlwGSivmGDpkGnwmiculiNrUqQsE3///8AAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAp
ZfUcAAABAHRSTlP/////////////////////////////////////////////////////////
/////////////////////////////////////////wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA9YbN
KwAAAM5JREFUeF4ti9V2wzAUBK9kZggzp5gys2xL1v7/D9WpO287Z5bm67KQo870ZdoZyaJc
k8gagT9+GpGRzb/NuBVn5hXjpMh8O1mOe3e98fLD9Ih8AbYtYillXGzBBYUKGb7aD0NzyF0Q
91hZlszjUC4ZMyhQWwi4MxoYCH1li7mwlY/cIO3gCWFbXOPZoUhjYGwmu3w32Ri41dSvoeG0
xSeSmh72qKNEH0kiBHs671qv/aA+Ehysmy5Vw0sL/1j3j0Oqqur9dLFK03S1uGjGLwcCLeh4
Dt1XAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
bizNetIcon
	"Private - Generated method"
	^self icons 
			at: #bizNetIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self bizNetIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
bizNetIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/bizNet.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
bizProcessesDirtyIcon
	"Private - Generated method"
	^self icons 
			at: #bizProcessesDirtyIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self bizProcessesDirtyIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
bizProcessesDirtyIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/bizProcessesDirty.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAAAjlJREFU
eJxcke1PUmEYxp+/LZXEEN8KaSu1D33oa8JBDSFeVCwy1xwrixLBrfpQwTly8PCOkCViKuNF
bH1AjWYtai0dA6LrcJBNn11jz/3c1+9+OZBEtjBwL3xlMtRvCl+djly7vzrwIDr0MHZjNjY4
E7tujhJCarVa85fIp4J9xmATMDg2b82tDc5Ebz56DxJ8w1c//L1b7wdweSIomwrJp8N2btfy
dgeAzr755etvG5sl5w6AXkMAgNwUjmwdVqr/UAbAUfG4dnrOdOjS+Xr0gT5j4FPuCDEACID5
1dab8OeTUuX8DtK7vm6df4HNIEZ65vX2EreL8QQhFEo8ZdJq6zqqk06NF8zewS8AL/05YR+7
J/vCncZl0ZMRhsRiQ+ZIp9ZLJOOcbCJAPV47/PFXvxDvMQSeL6eF0eFGCFNTEg1HOtQrYJrq
0vlt7gZgZVKY1uRIfPt5PG5d79X7LqlXiHiM7Tf60RGOUrkKk1TrfUangGFUVF3iskjl9otw
i+94yMURN2WJPXEmK9UqxjU5NvhWGl7zzuTk4sZJqcx3cyVRun2UJSLVMpj2UXcoka9/qLLN
ndJaP7QpmVK5gip4jGcKsMIGM2lV0m0UgxsKxNMFYfqD738A1P+WajCR7xhjYRBRDB5Jy7Cr
VUE3MIqZf7e9t19UWaLIYTFIRDWs8LQoXERMuS7cdgJD0CCVtFTNwiHTccq5Vf5RQfOGYadY
5SIfd/KSERqMoHrirE5TsMH8HwAA//8DAIen1LwgTsTSAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
bizProcessesIcon
	"Private - Generated method"
	^self icons 
			at: #bizProcessesIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self bizProcessesIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 16:34'!
bizProcessesIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/bizProcessesPane.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAAAlpJREFU
eJxUketTEmEUxt+/LZXEFC8kYpOXPvShrymLGmJcBSRrGocpi1LBmepDBayg3HeFLBFTGK42
ffBGY03UNOkwQPQsS8y0c2b2Pec8v+c9Z5fEs4VhE9OvDw8YmEEje31uc/heZPR+9MaD6Mh8
dMgcuWZipUZWMhsemWMhJtLZkFgbagIa++6tha2R+cjNh+9AgucAAwPgqi40ZGJIjzoAAAlK
UiNj8+YsbxIAVLbdz6c/lz1ZuMBLog+LdaFeTZAD+jRBALBh904q1T+1Wg3AWfG8Vn/iubNB
I9Ov4wbpVQdJt8qPl1gb/Jg/QxsAAoD55d5r5tNFqYJiJHEKe/jCnYju+ntUgSVPBg2051/t
r3pzGI8PpLzFEzqtsG7DnXQpfWAOjn8AeBHI8/vY1rPP3WkcVtYz/JBYbNTMds34SOe0V6IL
Uo+2Tr79Vi/FsNaztTQ/PdRIIWpGp9JLOhQbYJrRrQosuxuAlU5hWoM9/uX7+bR1u0/tv6LY
IMIpz4A2gBuhKJWrEIlmfE9dKWAYFa6r3ixa+aMi1MI76+TyhJuyRB87kpVqFeMa7DvcVUou
Fh1J/crORanM3eZMwrp90kME8jUw7ZPucPyw/qHKy+7UjPV9m4wulStwQTGWKUAKGcSkVeZq
o2icYBBLF/jpj7/+AlD/LdVQ/LBjygOBgKJRJC1jztZxVwOj6MW3+wdHRbklgh4WQwiohhSa
lnEnEVLOS7cdwJA0SJlLpPBAIVF5ZQubXHHcxQnGHEK5k3xIHHZOuMDwUW/8H/9akEH8FwAA
//8DALeE6UShyxMRAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
bizoffer16Icon
	"Private - Generated method"
	^self icons 
			at: #bizoffer16Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self bizoffer16IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 3/1/2016 15:24'!
bizoffer16IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/bizoffer16.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAS9QTFRFVVVUUYK9U4S+Z5TIVYa/SXq2ToC7QXGv8fX5Rne0
P2+tWInAXV1bRHSyapfJY5LGf6DLYpHFVoe/X47EUoS+Pm6s9vj7QXCvXFxbS3y4Y2NiP26t
S324TH24P22sZZPHTX+6WorBY2NhRXazSHm1YY3BXV1cW1tZV4jAP2+uZGRieJvIT3+6z9vs
TH65R3i1Q3SxXIzCWoa8e53KUHy09fj7f6XPmLXZa5jKk7HWmrfa2uTwfKPPT4G7TH259vn7
eZvIUHu03+jzcp3NYWFgk7LXztvsZJDDpL/dfZ/Lf6bQXIi98vX5YI/ESnq2p8HeXY3DSXu3
You+RXWyVFRTW4vCbprL0t7taJXI2+XxPm2s0d3tfKLO4OjzianQkbDWh6fPYYq9lrTXQnKw
////uMR96QAAANlJREFUeNo0j9dSAkEURO9sDuScs0TFrCAoSlSQoGQUEPb+/ze4YznnqetU
P3QDmjRf64tWf7ylGRB990M7b6vYePtDg4rb70u3M86v+LjTfeczxT6fxH8myQ5CzSPoTMx1
YQ1VwrmwnQoVQynUXdwRTiTCsYbAkR5EnySCuYAlawmgh0inMPqIJFjjMRGJwtW5GMQZULAc
FAfwM1UzrCFm1B18GdY0E2raugS8lg0mLow3c6lyKPhlgyL7P9/pOaW08YY1TQt7n5W/t4hd
x0ssduM4o/lXgAEAeVw9p/dQn/oAAAAASUVORK5CYII='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
bizorder16Icon
	"Private - Generated method"
	^self icons 
			at: #bizorder16Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self bizorder16IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 3/1/2016 15:24'!
bizorder16IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/bizorder16.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAW5QTFRFVYa/QnKwTX+6U4S+Rne0SXq2WorBS3y4WInAToC7
XY3DSHm15ez1UoS+P2+t8fX5R3i1YI/EV4jAQXGvTH24RXazW4vCPm6sQXCvP26tRHSyRHWy
fqLMVIW+YpHFQ3SxVoe/9vj7Z5TIS324f6DLT4G7Y5LGP22sX47ESnu3apfJTH65ianQWYi/
UHu0h6fP7PH4P2+u/v//YY3B2uXwfKDMTH253+jzRXWzT3+6mLXZtsvk2eTw8/b6z9vsfKPP
You+ztvssMbhSXu3eZvI0t7t9fj7UoO9YYq9a5jKWoa8fKLORXWy2uTwf6XPp8He9vn7k7LX
fZ/Ld57Ly9rrlbLXcp3Ne5/LWInB4OjzUHy0tMnhd5/M8PT4k7HWpL/d2+XxbprL0t/uPm2s
mrbYXIzCapLDYo/Escfgdp7NlrTXkbDWf6bQ8vX5dJ3L0d3tmrfaZJDDe53KSnq2eJvI8vb6
xtbpXIi9UYK9////3ao5iwAAAPZJREFUeNocj9OSRFEQBPvaHttc27btmbXt03+/5249ZWTU
QxUgTf/p+Pne0/qhz4CYHXJKudpiLVd62/DF3PJ1JfWj6/p9qrKWpeLRFVWnh5ZPHFXcRFg1
QA6pI1S8qCEZzqBJuIws7iB23YpyhnuAboVw4E4hdhy4wJF3CPQpxEjuIl5A0iDKIHxO59ki
2UYcnidFNh+AJVuQ6mwr4pXC1iXhF9pXeE2oSg3slaqCxrfAKxML8vZNIrGv2XwwNgv44THp
+DHi6EA8zWzRpdZCZ8S7Q/xmvMjEs3/O+roMR03TjIZnrP+3iJOFtnL5qDDm858AAwBtODzh
zhVjRQAAAABJRU5ErkJggg=='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
bizrequest16Icon
	"Private - Generated method"
	^self icons 
			at: #bizrequest16Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self bizrequest16IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 3/1/2016 15:24'!
bizrequest16IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/bizrequest16.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAYBQTFRFfKPPz9vslrPXTH24eZvIP22sYI/FUHy0ToC7TX+6
U4S+SXq2QnKwVYa/Rne08fX5R3i1SHm1UoS+WorBS3y4P2+tQXGv8vb6fqLMV4jAP26tRHWy
Snu3Y5LGZ5TITH65apfJRXazQ3SxPm6sT4G7RHSyXY3Df6DL9vj7QXCvS324nrraX47EYou+
u8/m2uTwT3+6/v//RXWz9Pf6SXu38vX5/f7+YpHF+Pv8f6XPmLXZXIzCWIjAWInBSnq2ZZHF
0d3th6fPWoe9yNjrTHq0XYzDVoe/ZJDDvtHme53KWInAXIi9ianQiq3Uk7HWsMfhlrTXpL/d
8fX6f6bQ/P3+fZ/L4OjzP2+ubJPD1N/uYY3BapXHVIW+3+jzkbDWlbPYk7LXUoO99fj7a5jK
bprLVYO8mrfaVoO7RXWy7/T5cJfFT323cp3Np8HedJ3LxtfpWYnBja7T3ObyS3u2/v7+rsXg
9vn7ZpPGnrvbW4vB0t7tapbIXo3EYYq9UYK9////pEwR9wAAAP1JREFUeNocj1V3wlAYBD88
TggQ3F1a6q7U3d3djbrd/esl3ac587RDqG9viU5vV+7WDSYg32OPROMn8Wjk/M0Qx9Rbntu6
Wq59dJa783WxH3AfNKPLBzRm3YegiiZ/+vDwbi8B99NyheaZMDhS+x7L/qziaVxYpG2OCXKg
/9G9gI4dgU2QxcIxbVfumwRKGuOaaKCtyKfZ0StezCzNFy1UVUVPjOdaYeb4mEecoeFLxSWG
z4CqJyy6lFkakjIJRX32+y9cqpLIfBGmdCkZugGuW0JJaa3+1Pm7UdBHgU1JLzS0G3FOqy0V
9Hq9wZTV+V8LmHIOm82RMxn8J8AAZv1BA75Za2gAAAAASUVORK5CYII='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
constrGreenIcon
	"Private - Generated method"
	^self icons 
			at: #constrGreenIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self constrGreenIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 7/5/2016 20:16'!
constrGreenIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/constrGreen.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
constrRedIcon
	"Private - Generated method"
	^self icons 
			at: #constrRedIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self constrRedIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 7/5/2016 20:16'!
constrRedIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/constrRed.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
constrYellowIcon
	"Private - Generated method"
	^self icons 
			at: #constrYellowIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self constrYellowIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 7/5/2016 20:16'!
constrYellowIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/constrYellow.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
contactsDirtyIcon
	"Private - Generated method"
	^self icons 
			at: #contactsDirtyIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self contactsDirtyIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
contactsDirtyIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/contactsDirty.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
contactsIcon
	"Private - Generated method"
	^self icons 
			at: #contactsIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self contactsIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
contactsIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/contacts.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - utilities from Pharo4' stamp: 'hk 11/6/2016 13:06'!
createIconMethodsFromDirectory: directory 
	"Create the methods for the icons.
	(self createIconMethodsFromDirectory: '')."
	| normalSize smallSize |
	normalSize := self normalSizeNames.
	smallSize := self smallSizeNames.
	normalSize , smallSize
		do: [:each | self createIconMethodsFromFile: each directory: directory]! !

!GbtIcons methodsFor: 'private - utilities from Pharo4' stamp: 'hk 11/25/2016 14:11'!
createIconMethodsFromFile: aFileNamePrefix directory: directory 
	"Create the methods for the icon.
	aFileNamePrefix is the png file name prefix (without the .png suffix)
	directory is where the png file is"
	| iconContentsSourceTemplate iconSourceTemplate png base64 contentsSelector selector |
	iconContentsSourceTemplate := '{1}IconContents
	"Private - Method generated with the content of the file {2}"
	^ ''{3}'''.
	iconSourceTemplate := '{1}
	"Private - Generated method"
	^self icons 
			at: #{1}
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self {1}Contents readStream) ].'.
	png :=( directory asFileReference / aFileNamePrefix , 'png') fullName.
	[base64 := self base64ContentsOfFileNamed: png ]
		on: Error
		do: [base64 := nil].
	base64
		ifNotNil: [contentsSelector := (aFileNamePrefix , 'IconContents') asSymbol.
			((self respondsTo: contentsSelector)
					and: [(self perform: contentsSelector)
							= base64])
				ifFalse: [| contentsSource |
					contentsSource := iconContentsSourceTemplate format: {aFileNamePrefix. png. base64}.
					self class compile: contentsSource classified: '*Graphics-Resources-Theme-Icons'].
			selector := (aFileNamePrefix , 'Icon') asSymbol.
			(self respondsTo: selector)
				ifFalse: [| source |
					source := iconSourceTemplate format: {selector}.
					self class compile: source classified: 'private - icons']]! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
crmIcon
	"Private - Generated method"
	^self icons 
			at: #crmIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self crmIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
crmIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/crm.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
dashIcon
	"Private - Generated method"
	^self icons 
			at: #dashIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self dashIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
dashIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/dash.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0
WE1MOmNvbS5hZG9iZS54bXAAAAAAADw/eHBhY2tldCBiZWdpbj0i77u/IiBpZD0iVzVNME1w
Q2VoaUh6cmVTek5UY3prYzlkIj8+Cjx4OnhtcG1ldGEgeG1sbnM6eD0iYWRvYmU6bnM6bWV0
YS8iIHg6eG1wdGs9IlhNUCBDb3JlIDUuMS4yIj4KICAgPHJkZjpSREYgeG1sbnM6cmRmPSJo
dHRwOi8vd3d3LnczLm9yZy8xOTk5LzAyLzIyLXJkZi1zeW50YXgtbnMjIj4KICAgICAgPHJk
ZjpEZXNjcmlwdGlvbiByZGY6YWJvdXQ9IiIvPgogICA8L3JkZjpSREY+CjwveDp4bXBtZXRh
PgogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgIAogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAK
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgIAogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAgICAgICAgCjw/
eHBhY2tldCBlbmQ9InciPz4s45Y3AAABiElEQVR4nHSPu0oDURCG5xnsLCStYCmWFqKv4CvY
iSB22oqdgrW21prL5h4TTTa7uRjE2Mh6CRJN40oUjeiZs56ZPZuNBJdhOTvzfXP+BawAmoAW
oA1YB2wAXgC2QF7Sm84N7tvMmABYHhOajPrV/E+ocqvGs/asfNyWL8fee10+7cv7derbzGih
wh98iewdemOP7GzRtEok4Hl4iXSTGnmzZHdPdnelm/Y+rjVtEgmipC+Rzore97BJAYY1pCu+
UARxRifvq0N4v6zjWQE6QisSRIGdWkSvv9ugsQneTz/8h6tFn1YkiDw52JoPZguU0JoY/Wms
R1Ry2ltQQhZETt0wo2fOKm3iQmeNWt+vhJ5ylpwS0iAydPIGDo0Ht8KaIqII+HxAHTdHaJ73
ZpSQBJGiE7aXwxBuJszT2SE0y3tTSkiAMLSGrSXv8+ZP+t6RMKcpRYoZQwkxEPERTVVpEu05
VQSlgqbBTFwJJ1y+5pu+bARQIhjFiAwEv6LcHa9oyPwCAAD//wMACOoHVq2oL0QAAAAASUVO
RK5CYII='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
dashboardIcon
	"Private - Generated method"
	^self icons 
			at: #dashboardIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self dashboardIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 5/1/2015 18:55'!
dashboardIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo3.0.app/Contents/Resources/Icons/dashboard.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAA+gAAAH0CAIAAAAhSpB6AAAAAXNSR0IArs4c6QAA6ZZJREFU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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
downIcon
	"Private - Generated method"
	^self icons 
			at: #downIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self downIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 5/1/2015 18:55'!
downIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo3.0.app/Contents/Resources/Icons/down.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAAAAZ0Uk5T
AP8A/wD/N1gbfQAAAEJJREFUeJxi+E8iYBg+GhjWMBGD6KmBGD1YPE1QNZZQwq8ae7DiUY1d
A7IeLFJYNUD0YBfHpQGnQaRqAAAAAP//AwDrSk/69sF0oQAAAABJRU5ErkJggg=='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
efaIcon
	"Private - Generated method"
	^self icons 
			at: #efaIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self efaIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 11/4/2016 17:25'!
efaIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo5.0.app/Contents/Resources/Icons/efa.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAAfQAAABkCAMAAABHGTJPAAADAFBMVEUAAAAlJSUPDw8zMzMH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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
evaluationIcon
	"Private - Generated method"
	^self icons 
			at: #evaluationIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self evaluationIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
evaluationIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/evaluation.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 1/13/2017 19:38'!
gotoIcon
	"Private - Generated method"
	^self icons 
			at: #gotoIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self gotoIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 10/31/2015 17:34'!
gotoIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/goto.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAAXNSR0IArs4c6QAAAFFJREFU
eJxi+P//PwMlmCLNeA1ISk36D8IUuYAYQwg6kZAhRPkTnyFEBxYuQ0gKcWyGkBxt6IbQzwUU
hQFFsUBROqAoJVIlLxCDAQAAAP//AwDrwud9sF5rPAAAAABJRU5ErkJggg=='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
headerIcon
	"Private - Generated method"
	^self icons 
			at: #headerIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self headerIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 1/23/2016 16:20'!
headerIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/header.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAABkAAAACQCAYAAABQ4qeyAAAAAXNSR0IArs4c6QAAPdlJREFU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'! !

!GbtIcons methodsFor: 'initialization' stamp: 'hk 11/25/2016 15:10'!
initialize
	super initialize.
	name := #default! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
inspectIcon
	"Private - Generated method"
	^self icons 
			at: #inspectIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self inspectIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 19:55'!
inspectIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/inspect.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAAXNSR0IArs4c6QAAAaZJREFU
eJyUU01LQlEQNfEfiNHOhQR9UEaLSoICUQgDScKFgUhQG0kod27exk3RQrRNgaJJixamZCal
+VWGC+0tEoQgK3/Jqbn6zO9y4PC4w8x558ydKxI1wul0YhiIWsPj8eA5n0e5XP4XeJ6H1+uF
TqcD+zM112o1vFerXfj4qjXwyb6Uo1oicrlcdQI6dDZSjoiTvjOkDnYZKlf+thpSzghIUi+C
mxM37pbnUBwVo6AQI6EeB395+jcBSaRceMeCtFSMlHYJJeMCStMSpPfNzM5AgtefcyGbwbXF
iFuZBBGdGvmNFfCKEeRsW/0VvFUqyLqPETPpETWuIWZcRWJWxlSQjUflGPjTo+YwmwTCEMlz
ckrOikludEaKuEmDpF6Np00NsoccU9eXIGqte2YN2+uM5N5mRjGXYzWksOctCAQRu5V5Di8q
UdDO40UuQcqx19yHzptqmwEVxAPniKommp4fVJPIBH09F6xLgbBdMX8AcYedIXkRZJ4HEnAc
xxT0W+VeaFtlCnoYwhxa13rQgwqFQjAYDL+vktiGgdD8DQAA//8DAFho6hka/5odAAAAAElF
TkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
invoicingIcon
	"Private - Generated method"
	^self icons 
			at: #invoicingIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self invoicingIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
invoicingIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/invoicing.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
learnCenterIcon
	"Private - Generated method"
	^self icons 
			at: #learnCenterIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self learnCenterIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
learnCenterIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/learnCenter.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
logisticsDataIcon
	"Private - Generated method"
	^self icons 
			at: #logisticsDataIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self logisticsDataIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
logisticsDataIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/logisticsData.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
minusIcon
	"Private - Generated method"
	^self icons 
			at: #minusIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self minusIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 5/6/2015 17:44'!
minusIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo3.0.app/Contents/Resources/Icons/minus.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAAA8AAAAPCAIAAAC0tAIdAAAAAXNSR0IArs4c6QAAAAZ0Uk5T
AP8A/wD/N1gbfQAAADVJREFUeJxi+A8HDAw4EVwJAXWoekhVTaRSMKK5aiIBHVQPkjChZcwj
eRmPOggAAAAA//8DADPQVbk+AZ3EAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'accessing' stamp: 'hk 12/18/2016 15:38'!
normalSizeNames
	^#(#activity16 					#beitragsMgmt16 				#bizNet 					#bizProcesses 
		#bizProcessesDirty 		#bizoffer16 						#bizorder16 				#bizrequest16 
		#constrGreen 				#constrRed 						#constrYellow 			#contacts 
		#contactsDirty 				#crm 								#dash 						#dashboard 
		#down 							#efa 								#evaluation 				#goto 
		#header 						#inspect 							#invoicing 				#learnCenter 
		#logisticsData 				#minus 							#plus 						#projects 
		#right 						#route 							#rower 					#rowingBoat 
		#rowingTeam 					#saveTemplate 					#servicedata16 			#settings 
		#statistics 					#statisticsE 					#supplierBizProcesses #supplierBizProcessesDirty 
		#supplierBizSubProcesses #supplierBizSubProcessesDirty 							#systemSettings 	
		#taskOrders 					#tax 								#toggle 					#tour 	
		#userSettings 				#walletBig 						#wallet
	)! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
plusIcon
	"Private - Generated method"
	^self icons 
			at: #plusIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self plusIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 5/6/2015 17:44'!
plusIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo3.0.app/Contents/Resources/Icons/plus.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAAAAZ0Uk5T
AP8A/wD/N1gbfQAAAGVJREFUeJxi+E8iYICzmA4w4EcoGtDkfoPB199fMfUwYDX7NwxgSlFJ
w48fP4Cqv//+TpoN+DRAvAhEcO/CXYUsiKKBGECBBiLjgXrBSm0NmHp+/v4JVA0ksaclklIr
AAAA//8DAAPZuC+nylbiAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
projectsIcon
	"Private - Generated method"
	^self icons 
			at: #projectsIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self projectsIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
projectsIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/projects.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 10/31/2015 17:32'!
rightIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/right.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAAXNSR0IArs4c6QAAAExJREFU
eJxi+P//PwMlmCLNOA1gWMP0H4YpNoCQIUQZgM8Qog3AZQhJBmAzhGQD0A0hywBkQ+jvgoGL
hYFLifg04zSAFAwAAAD//wMAy0mar7IWWmkAAAAASUVORK5CYII='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
routeIcon
	"Private - Generated method"
	^self icons 
			at: #routeIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self routeIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
routeIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/route.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
rowerIcon
	"Private - Generated method"
	^self icons 
			at: #rowerIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self rowerIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 7/11/2016 18:39'!
rowerIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/rower.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAACeklEQVR42qVTS0+TQRT9IsaA
EWMEpQj4SDBRK1DAUmriTlOVd3xrJGotxH+BIW4EF75QQqkkNBVbAXe0X99Nn9BWWdZABDal
XXRJArTfce4s2ijGmHiSydzJnHPm3pk7QndnV+9niyXjcbvhEO2S0+7A70O0ibCLIsWcQ1zS
kFYwT00lwSAx4J9Q4JJWcDmctJC2t7eRy+V2DEI4HMby0jII2WwWxCUNaQWWEgicXEBBHAqh
tLgErUolNjY28iYE0gpU198MFr8tQq1sge6RFpubm5R+fo+0fzTIZXmMCEv9Qut53LlxE1/j
8TyP9ncYbG1t5esjAsVXNRoc2FeKalkljlVVoV+nw9rqGs+iYODIZ/BLfWOjo6goK0dVhQwT
BgNS6+tou3wF6hYV1llMoKcVPC434iy9jyYTvszMYnZmhj3PJzQrGlHDTlbU1WN2ehoupxOp
VAqvX76CyWjkJj6PF8JCZB7jej0EQcDhg2WQlR/iJ9dUHkHt8RM4VXsSxUW7oX3wEE/6+vn+
nl1FmPgwgVg0CsHtcoHQ2daO+jNyErJ6q6FsasZRNu8v2Ys+7WM8HRjgRi2NTfwAw5gesVgM
+T5Ip9P4nkjA6/Eg4Pdj5ccKgsEgWLMgzVIPh8JUM2uoJUQXFpBMJuGlEgL+ABJMqFap0Nyg
wK1r19HT0YkG+Vl0tXfgNnvC+tNyaC5ewv2796A6p0RjXQPo7kLBEBn4pbXVVcmgH+dd92Jo
GCNv3mI+EsH7kXcYfj6EMCMaJyfxbHAQPp+XX2I0GpWCgYD0/5+pp6u712I2Z6gfRJtNss1Z
Ic7ZYLeJfKY1j60stlqJQ1+enjpD2p98LRel1b3ibgAAAABJRU5ErkJggg=='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
rowingBoatIcon
	"Private - Generated method"
	^self icons 
			at: #rowingBoatIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self rowingBoatIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 7/11/2016 18:42'!
rowingBoatIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/rowingBoat.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAAAAAA6mKC9AAAAkklEQVR4nGL49/ffv7//b97/
/+8/GDCAiD+/1l35/+cnRKDd0cM+IM/AyVR7z/8/IIE6BhEBX1V2dq5yqJZv3/a3vn3+9s2n
/3AzUI1lgIgjjAUKIBsLFkA1Fijw7RuyMQxA/ArZGJChr5CNgdiCZAxEAMl1YAGgMRb7/v8F
sv7CHPbq1n+gRf+AbgUAAAD//wMAc7LJd8YDaOkAAAAASUVORK5CYII='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 15:49'!
rowingTeamIcon
	"Private - Generated method"
	^self icons 
			at: #rowingTeamIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self rowingTeamIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 12/18/2016 15:36'!
rowingTeamIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo5.0.app/Contents/Resources/Icons/rowingTeam.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABIAAAASCAMAAABhEH5lAAADAFBMVEUAAAAAAAATExMUFBQc
HBw+Pj4oKCgpKSk7Ozs8PDwmJiZdXV1LS0tWVlZXV1dISEhzc3NpaWlhYWFgYGB6enpfX19u
bm58fHyVlZWBgYGQkJCampqUlJSNjY2Pj4+Tk5OXl5ecnJydnZ2zs7O8vLy7u7u4uLiurq6j
o6OqqqqkpKS0tLStra2xsbHR0dHMzMy/v7/Dw8PAwMDW1tbBwcHX19fIyMjKysrGxsba2trV
1dXd3d3Y2Njb29vc3NzJycn9/f36+vr+/v77+/v8/Pz5+fnu7u74+Pjy8vLs7Ozx8fHt7e3r
6+vw8PDp6eno6Oji4uL09PTg4ODn5+fv7+////8AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAABe
z1SeAAABAHRSTlMA////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////wAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAlCb4
RAAAAMVJREFUeF5jwAZC0QBJQg6ODiDKydkFtyqHUD1u/VAHp1BXAYlQJ6CQk4NjqCCjUChQ
kwEjkxtMlSGPsruHp5e3sCRYo5GUCC83K5u+tCQ3Hw+zDEjIR9ZLRVjVOFRN3VdU0tgPrNFf
jp+f3T80VJVflEUu1AUoZGLKIebPwmlmLs8VIMmoYQEUsrTyU9AMtLa0DLIR9/OztYM41UXL
J9QJaLG+NpACucvJJTRY0TkUROuYgc0CeTHUXjcU5EsXpZBQbAEIAHhxQBQgfcIRAAAAAElF
TkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
saveTemplateIcon
	"Private - Generated method"
	^self icons 
			at: #saveTemplateIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self saveTemplateIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 7/31/2016 14:27'!
saveTemplateIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/saveTemplate.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAAA8AAAAPCAMAAAAMCGV4AAADAFBMVEUAAP/P2utbeaq6y+S3
yeP3+flbeqpkgKeJm57kz51beavC0ufs8/nJ1uj4+Py/zuXh7fjJ1un+/fq1zvLh6PCXstjn
7PLs8PRee6q/z+Xc6fLh7faxvb+ls67b6PPV3+zb6fJwh6XO2uqKm5zV3+1zi6Tb5O/w8/Xw
8vV/k6Hz9fZgfqm7zORng6e+z+Zrhabs8/jr8/jP2+tbeqtkf6i5xdNhfamyw9vi7fdogqf2
+fnD0ue6zOTO2uvI1uhaeatYdZHC0ubc4+9shabb4+/P2+rs7/Ti6PCFl5/m7PN7kKJ3jaOD
lp/P2upwg4Z3jqN8kKK3w8aClaCGmJ+HmZ/P09gAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACD
DaLkAAAA0ElEQVR4nDTN11bCYBRE4SHJn3PSSE/ovWPBLqAoxQoKiL7/qxhY+l3tuRrgT6Hw
ycw//xOe5217vW+8dtqAEGIkBHfaO6ziZ8A0B2emyXH8he5bBDiOc5vPcxR18f4SAKVKrpSr
cBBssGy1AO2AZ4s1mo0ywAc35UYT1acU8FFLJe7Pa1XMLddyac+auNYphuOpQemERoZhHOPS
trMUhmG9TtkTm3Aty3fk+36xSLJ81EdGURRKzh41SiqDqwtJ1XXpQVdVSVelXwAAAP//AwDn
SBQv1S+HzgAAAABJRU5ErkJggg=='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
servicedata16Icon
	"Private - Generated method"
	^self icons 
			at: #servicedata16Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self servicedata16IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 3/1/2016 15:24'!
servicedata16IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/servicedata16.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAANJQTFRF/ckA/LoA/LcAVVVU/cgA/cYA/LwA/ccA/coA/cQA
/csA///+//vv/L0A///9/LQA/LsA/L8A/LUA//ru/LkA/uF7YGBf/cUA/MAA//vw/c4e/LgA
/csZ/MEA/dhn/uys/coYVFRT/dFV/ddl/dhoXl5dWFhW/uB4/dNZ/c0c/uKC/u2u/uF+//vx
/L4AU1NS/cwb/cMA/LMA/ddg/LYAX19e/uB6/u2w/MIA//njTk5N/u60/dZiUFBO/c8f/uF8
/uOGUlJQWlpZ/dVdXFxb////0uKfMQAAAK9JREFUeNpcz9cOwjAMBdAkpSPQ0snoYu+99wb/
/y9RB4ki/JDIRze2QuCvCB63Qg6vY9AfChho2SvKRSMRwihDtCxmApKpJbCRVZQuwHYWVRPQ
dZT9+DtUgpKsqn6xuG6/Hh0xlPOS7P+ujeec6ykcwC7HO1eSpPr0fhYJY2KX3TTRopaiGMYS
QFEsiolK6FH6zANQL2TiSZOxXtIDYyvn87lTA3twTHPxgd96CzAAoh0uPJvuvM4AAAAASUVO
RK5CYII='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
settingsIcon
	"Private - Generated method"
	^self icons 
			at: #settingsIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self settingsIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 8/2/2016 14:28'!
settingsIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/settings.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAADAFBMVEX////N4MxnAADk+/9Q
AAAAAC/H4Ou3vbcAAAAAAHJwb5nb+//u7vJdAAD///svAADz4a7v17udzev85rvTkjg/b5pM
iL8ALi6lq7j3//94l8r/+98sW4PdpmFCAABZpNn/9/LPih+SXFsAAFDu7uX7+ND//NBviXnT
pmFuqtRxQSwATnulq8P7///M8v/mw5X7+/+3sZeIsat6LSz38vLH8v9Ll9S+n3dkmKYAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAADN
+a3qAAAAmElEQVR4nFzOxwKCMBBF0QEJvAioiAUroNh79/+/TCYmLJjlWdw35NWOPCKaLLqk
j+EyXjlpp9moYAa0p670DWQFgCHcwECOOdD3IF4aouSw32Cgy9yILXu3XeoyQ09adln+Pu6h
9Blao7WTFR+1Ffwfo2cOobaEBoqSm9o6GqA4VFunCrhcbp0r4PKbrvxH7X4AAAD//wMAK1sM
W0E51ZQAAAAASUVORK5CYII='! !

!GbtIcons methodsFor: 'accessing' stamp: 'hk 5/1/2015 18:41'!
smallSizeNames
	^#()! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
statisticsEIcon
	"Private - Generated method"
	^self icons 
			at: #statisticsEIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self statisticsEIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 7/12/2016 18:59'!
statisticsEIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/statisticsE.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAADAFBMVEX////9CAsAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAADZ
U1skAAABAHRSTlP//wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAKmfX
xgAAACxJREFUeJxiYMAEjCQJMOIQYIRzUQQYUQUYUQUYqS2A6TlkgCkNAAAA//8DAB1qAEZN
asOFAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
statisticsIcon
	"Private - Generated method"
	^self icons 
			at: #statisticsIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self statisticsIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 7/8/2016 17:47'!
statisticsIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/statistics.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAADAFBMVEX///8VoQUAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAADy
MgkXAAABAHRSTlP//wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAKmfX
xgAAACxJREFUeJxiYMAEjCQJMOIQYIRzUQQYUQUYUQUYqS2A6TlkgCkNAAAA//8DAB1qAEZN
asOFAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
supplierBizProcessesDirtyIcon
	"Private - Generated method"
	^self icons 
			at: #supplierBizProcessesDirtyIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self supplierBizProcessesDirtyIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 3/1/2016 15:42'!
supplierBizProcessesDirtyIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/supplierBizProcessesDirty.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
supplierBizProcessesIcon
	"Private - Generated method"
	^self icons 
			at: #supplierBizProcessesIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self supplierBizProcessesIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 3/1/2016 15:42'!
supplierBizProcessesIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/supplierBizProcesses.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
supplierBizSubProcessesDirtyIcon
	"Private - Generated method"
	^self icons 
			at: #supplierBizSubProcessesDirtyIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self supplierBizSubProcessesDirtyIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 3/1/2016 15:42'!
supplierBizSubProcessesDirtyIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/supplierBizSubProcessesDirty.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
supplierBizSubProcessesIcon
	"Private - Generated method"
	^self icons 
			at: #supplierBizSubProcessesIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self supplierBizSubProcessesIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 3/1/2016 15:42'!
supplierBizSubProcessesIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/supplierBizSubProcesses.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
systemSettingsIcon
	"Private - Generated method"
	^self icons 
			at: #systemSettingsIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self systemSettingsIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
systemSettingsIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/systemSettings.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
taskOrdersIcon
	"Private - Generated method"
	^self icons 
			at: #taskOrdersIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self taskOrdersIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
taskOrdersIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/taskOrders.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
taxIcon
	"Private - Generated method"
	^self icons 
			at: #taxIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self taxIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
taxIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/tax.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
toggleIcon
	"Private - Generated method"
	^self icons 
			at: #toggleIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self toggleIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 1/29/2016 16:30'!
toggleIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/toggle.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAAAXNSR0IArs4c6QAAAEdJREFU
eJxiYACD+v/YIEQKBP/XM2CFQHF80mA5hv9AAkT+xwRgORIUYIUkKSDbDQwM0ADBAujlBoJB
TTCyCEU3AAAA//8DAMb8Gr/iPQwfAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
tourIcon
	"Private - Generated method"
	^self icons 
			at: #tourIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self tourIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
tourIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/tour.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
userSettingsIcon
	"Private - Generated method"
	^self icons 
			at: #userSettingsIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self userSettingsIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
userSettingsIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/userSettings.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 12/18/2016 15:38'!
walletBigIcon
	"Private - Generated method"
	^self icons 
			at: #walletBigIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self walletBigIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 12/18/2016 15:47'!
walletBigIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo5.0.app/Contents/Resources/Icons/walletBig.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAAJgAAACYCAMAAAAvHNATAAAACXBIWXMAABcSAAAXEgFnn9JS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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 12/18/2016 15:38'!
walletIcon
	"Private - Generated method"
	^self icons 
			at: #walletIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self walletIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 12/18/2016 15:58'!
walletIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo5.0.app/Contents/Resources/Icons/wallet.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAACMElEQVR42o1T20pqURTd/+o3
+KZvlQrSi4ipICpeIG+U2/JSYlAImhh5R1+0EFS8oaZlNmJMzhbO0zkDFnuvy5xrjDHnUk5P
T3F/fw9VVXFzc/NnpJBKpbjGwX9tXb6qmkQul8PJyQmUbDYL4nA44H+hnWWswhuI1WqF9XqN
/X6P7+9v9Pt9dLtd9Ho97snabrfDz8+PzIvFInw+HxRSIrhJDAYD3N3dwe/34/r6GkajEefn
55pMoX55eYmXlxdQvkJ9xGg0QiaTQSKRgN1uRzQakSTPz2UUCgW0220J9Hq9eH9/x2w2g8lk
gnhQr9fh8XgQiUSE1sXFBT4/PxEMBdFsNsS4s7Mz2Z/P5yDK5TJcLhcUm80Gt9uN29tbPDw8
IBqNysGnpyc4HA7odDro9Xo8Pj6KeV9fX+JBPp8XSYrFYmGZxINqtQqn04nX11eYzWY5wAtI
mdhsNiDIuFQqiTQlHA6jVquh0WiI5qurK7LhnDQlGcEK8fbtdotAIECJ4plCd5ltOByCoFn8
55fuT6dTHmZ5mYC6hT4hElgWOspEmjlvb28IBoPChmDt5/MZ/WF/aI1Ec4+NJHSWyyWazSZa
rRYMBgMmkwkINhSDx+OxJueY4NgHnU5HnCZoZCgUAkGG6XQaHx8f7EZ+ZRCM1RjQHGYU/Var
VVo1FovRcW2fVWDwkQFjpZE0LBYLcB6Px1GpVGjavx+T9pyTySR94CIp02mW869nnjo+Z1Vi
GPsLGEFqmtmfG6sAAAAASUVORK5CYII='! !

!RTHTML5Exporter class methodsFor: '*GBT-DSL' stamp: 'hk 5/27/2015 15:55'!
export: aView  
	self new export: aView ! !

Object subclass: #GBTKnowHow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Utilities'!

!GBTKnowHow commentStamp: 'CC 7/8/2016 14:06' prior: 0!
Place to collect knwo how snipptes on using the GBTauthoring and modeling appropriately.!

!GBTKnowHow class methodsFor: 'classDeletion' stamp: 'CC 7/12/2016 10:43'!
classDeletion

"if a class X is removed, it may still have references to its methods which are directed to ObsleteX class. 
Importing class X anew might leave the references to methods of X pointing to ObsolteX. Try
Smalltalk fixObsoleteReferences"! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 3/14/2017 13:01'!
columns1
	"self columns1 edit"
	
	^GbtThing struct: 'Columns1' define: {
		{ #c1 . #val: . 'value11'}.
		{ #c2 . #val: . 'value12'}.
	} full: {
	}
! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 3/14/2017 13:01'!
columns2
	"self columns2 edit"
	
	^GbtThing struct: 'Columns2' define: {
		{ #c1 . #val: . 'value21'}.
		{ #c2 . #val: . 'value22'}.
	} full: {
	}
! !

!GBTKnowHow class methodsFor: 'icons' stamp: 'CC 7/8/2016 18:28'!
createIcons

"
x. Convert an icon to 32x32 pixels online through https://iconverticons.com/online/
1. create an iconName.png in Pharo subdirectory 'icon'. iconName.png should display as 32x32pixel imagecategory (download from somewhere, or use an icon editor).
2. In GbtIcons normalSizeNames 
add #iconName (in case of 16x16, add to smallSizeNames)
3. Create a resource method in GbtIcons using the expession found in the class comment





"! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 3/14/2017 10:36'!
exampleTableTestXRun
	"initialize, build main table test context, add policies for various core data, open ui"

	| ui ctx |
	GbtBizAppServer initialize.
	GbtSVO initialize.
	ctx := self tableTestXMain.
	ctx addPolicy: #TableRowNoPolicy prefix: 'R'.
	ctx addPolicy: #TableColumnNoPolicy prefix: 'C'.
	(ui:= ctx ui) title: ('TableTestX', ui title); open. 
! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 3/14/2017 13:01'!
lookupTestTabelle1
	"self lookupTestTabelle1 editD"
	"Note that a) slots evaluate to thing name userName:T47v2 or strings
	b) accessing slots with their name needs to convert strings into symbols using asSymbol
	c) table to be looked up needs reference to serve in calc or constraint expressions"
	
	^GbtThing struct: 'Lookup1' define: {
		{ #tabelle1 . #thing: . self tabelle1}.
		{ #tabelle2 . #calc: . 'ref #tabelle1'}.
		{ #row . #enum: . #(#r2)}.
		{ #column . #enum: . #(c1)}.
		"Works"
		{ #constraintSlot . #constraint: .	'( GbtThing typed: #tabelle2 ) contains: ''Schmidt5'' at: ''r3''' }.
		{ #lookupSlot1 . #calc: .	'( GbtThing typed: #tabelle2 ) slotAt: ''r3'' asSymbol '}. "geht"
		{ #lookupSlot2 . #calc: .	'((( GbtThing typed: #tabelle2 ) slotAt: #row asSymbol) slotAt: #column asSymbol)'}. "geht"		
		{ #lookupSlot3 . #calc: .	' ( GbtThing typed: #tabelle2 ) r3'}. "geht"
		{ #lookupSlot33 . #calc: .	'( ( GbtThing typed: #tabelle2 ) perform: #row )perform: #column'}. "geht"
		{ #lookupSlot4 . #calc: .	' ( GbtThing typed: #tabelle2 ) tableValueAtRow: #row atColumn: #column '}. "geht"
		"Does not work"
		{ #lookupSlot10 . #calc: .	' ( GbtThing typed: #tabelle2 ) slotAt: r3 asString'}. "geht nicht"
		{ #lookupSlot11 . #calc: .	' ( GbtThing typed: #tabelle2 ) slotAt: r3 '}. "geht nicht"
		{ #lookupSlot12 . #calc: .	' ( GbtThing typed: #tabelle2 ) #row asSymbol'}. "geht nicht"

	} full: {
	}
! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 3/14/2017 13:01'!
tabelle1
	"self tabelle1 editD"
	
	^GbtThing struct: 'Tabelle1' define: {
		{ #r1 . #thing: . self columns1}.
		{ #r2 . #thing: . self columns2}.
		{ #r3 . #val: . 'Schmidt5'}.
	} full: {
	}
! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 3/22/2017 13:14'!
tableTestXContext
	"comment stating purpose of message"
	
	^GbtPlainAC struct: 'TableTestContext' define: {
		{#displayAs: . 'TableTestX'  } .
		{#uiSpec:icon: . #GbtItemUI . #beitragsMgmt16}.
		{#vo: . self tableX} .
		{#loadPolicy: . #autoload } .
		{#menu:items: . #Beitragsmanagement . #(#'Do Something 1' #'Do Something 2') }.
		}
! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 3/14/2017 13:01'!
tableTestXMain
	"self tableTestX" 
	^GbtPlainAC struct: 'TableTestXMainContext' define: {
		{#aspect:on: . self tableTestXContext . nil  } .
		{#uiSpec:icon: . #GbtMainUI . #main} }! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 3/14/2017 13:01'!
tableX
	"self tableX editD"
	
	^GbtThing struct: 'TableX' define: {
		{ #info1 . #val: . ' #tableRows '}.
		{ #tableRows . #listOf: . self tableXColumn }.
		{ #tableRowsRef . #calc: . 'ref #tableRows' }.
		{ #rowIndex . #val: . '' }.
		{ #columnIndex . #val: . '' }.
		{ #cellValue . #calc: . '(( (GbtUlist typed: #tableRowsRef ) perform: #rowIndex ) perform: #columnIndex ) cell ' }.
	} full: {
	}
! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 3/14/2017 13:01'!
tableXCell
	"self cell1 edit"
	
	^GbtThing struct: 'TableXCell' define: {
		{ #summary . '#cell' }.
		{ #idNumberPolicy . #TableColumnNoPolicy }.
		{ #cell . #calc: . ' '}.
	} full: {
	}
! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 3/14/2017 13:01'!
tableXColumn
	"self tableXColumn edit"
	
	^GbtThing struct: 'TableXColumn' define: {
		{ #idNumberPolicy . #TableRowNoPolicy }.
		{ #tableColumns . #listOf: . self tableXCell }.
	} full: {
	}
! !

Object subclass: #GbtAction
	instanceVariableNames: 'pipe params'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtAction commentStamp: 'hk 12/16/2016 14:31' prior: 0!
Each behavior is made out of actions.
Actions - executed by my doOn: method - are chained with a pipe.
The position of a named variable in the signature of an action is relevant. The variable name may be: 
- a global thingName of thing, context, or declarative or 
- one of these special names: thing, context, contextVO, pool
(thing = pipe thing, context = pipe context, contextVO = pipe context vo, pool = add to pipe context pool )
-  the variable content may be a Thing, another SVO  or a global name, that will be resolved

    Instance Variables
	params:		<Array of String>		my parameters
	pipe:		<GbtActionPipe>		I am working on. Contains context, thing & variables
					
    special conventions:
when called, 
	pipe context 		always contains the context I am executed in 
	pipe thing 		eventually contains an argument
	pipe getVar: 		more arguments may be found in my (named) varaibles
when irrelevant use 'void'!

!GbtAction class methodsFor: 'instance creation' stamp: 'hk 1/4/2017 17:40'!
actionNames
	^#(GbtActionRefresh 		REFRESH
	GbtActionHalt 				HALT
	GbtActionCheck 				CHECK
	#GbtActionCommit			COMMIT
	"creating things"
	GbtActionAssureVO			ASSUREVO
	GbtActionAssureThing 		ASSURETH
	GbtActionNewVO				NEWVO		
	GbtActionConstraints		CONSTRAINTS
	GbtActionBehaviors			BEHAVIORS
	"messaging actions"
	GbtActionGetEvent			GETEVENT
	GbtActionPushTo 			PUSHTO
	GbtActionMatch 				MATCH
	GbtActionEmbed 				EMBED 
	GbtActionToList 			TOLIST
	GbtActionCompose 			COMPOSE 
	GbtActionSendTo 			SENDTO 
	"processing"
	GbtActionContext 			CONTEXT 
	GbtActionTransform			TRANSFORM
	GbtActionBehavior			BEHAVIOR
	GbtActionAssign				ASSIGN
	#GbtActionReadSlot			READSLOT
	GbtActionAssignDateToday	ASSIGNTODAY
	GbtActionAssignUser		ASSIGNUSER
	GbtActionSetSaveCtxt		SAVECONTEXT
	GbtActionAssignDecl		ASSIGNDECL
	GbtActionAssignVal			ASSIGNVAL
	GbtActionWriteSlot			WRITESLOT
	GbtActionAddToList			ADD2L
	GbtActionAskFrom 			ASKFROM			
	"map / reduce (list processing)"
	GbtActionMapBigList		MAPBL
	GbtActionMap					MAP
	GbtActionAlter				ALTER
	GbtActionApply				APPLY
	GbtActionAskTemplate		ASKTMPL
	GbtActionAskElement		ASKELEM
	GbtActionAskRole			ASKROLE
	GbtActionFilter				FILTER
	GbtActionFreeze				FREEZE
	GbtActionReduce 			REDUCE
	GbtActionReduceAdd			REDADD
	GbtActionAddToBigList		ADDBL
	"for constraints"
	GbtActionSlot	 			SLOT
	"service calls"			
	GbtActionPDF					TOPDF
	GbtActionEdit 				EDIT
	)! !

!GbtAction class methodsFor: 'private' stamp: 'hk 1/1/2016 19:39'!
classDict
	^Dictionary newFromPairs: self actionNames reversed! !

!GbtAction class methodsFor: 'documentation' stamp: 'hk 6/2/2016 11:21'!
documentation
	"self documentation"
	| stream dict comment index |
	(stream := TextStream on: (Text new: 10)) 
		nextPutAll: self name asText allBold; cr; 
		nextPutAll: self comment; cr.
	stream nextPutAll: GbtActionPipe name asText allBold; cr; 
		nextPutAll: GbtActionPipe comment; cr; cr.
	(dict := self classDict) keysSortedSafely do: [ :k |  |clsname|
		clsname := dict at: k .
		comment := (Smalltalk at: clsname) comment.
		(index := comment findString: 'Instance Variables') > 0
			ifTrue: [ comment := comment first: index -1] .
		stream nextPutAll: (k, ' : class ', clsname) asText allBold; cr;
				nextPutAll: comment trimRight; cr; cr].
	^stream contents! !

!GbtAction class methodsFor: 'instance creation' stamp: 'hk 12/8/2015 13:31'!
for: aParameter
	^self new for: aParameter! !

!GbtAction class methodsFor: 'private' stamp: 'hk 1/1/2016 19:38'!
nameDict
	^Dictionary newFromPairs: self actionNames! !

!GbtAction class methodsFor: 'instance creation' stamp: 'hk 8/22/2016 14:45'!
newFor: aSourceArray
	| classname |
	classname := self classDict at: aSourceArray first 
			ifAbsent: [self error: 'action ', aSourceArray  first, ' not provided'] .  
	^(Smalltalk at: classname) for: aSourceArray second
! !

!GbtAction methodsFor: 'executing' stamp: 'hk 9/25/2016 14:30'!
abort: aString
	aString ifNil: [^pipe abort: ''].
	GbtLogger log: #ABORT text: {self actionName . aString}.
	^pipe abort: self actionName, ' ', aString! !

!GbtAction methodsFor: 'accessing' stamp: 'hk 1/6/2016 13:21'!
actionName
	"ActionAspect new actionName"
	^self class nameDict at: self className! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 1/4/2017 13:55'!
bigListContext: aCtxtNameOrVar 
	"answer the big list context named by aCtxtNameOrVar"
	| ctxt |
	(ctxt := self context: aCtxtNameOrVar).
	^(ctxt ifNil: [^nil]) isBigListAc ifTrue: [ctxt] ifFalse: []! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 3/17/2017 17:18'!
context: aCtxtNameOrVar 
	"answer the context named by aCtxtNameOrVar or nil"
	| ctxt |
	(aCtxtNameOrVar = #context) ifTrue: 
		[^pipe context ifNil: []].
	^(ctxt := self getVar: aCtxtNameOrVar) ifString: 
		[pipe context bizApp contextNamed: ctxt].
	! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 10/12/2016 12:45'!
declFromVar: aParameter 
	^(pipe getVar: aParameter) ifNil: [GbtDeclarative definedAs: aParameter].
! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 10/12/2016 12:45'!
declsFromVar: aParameterOrArray 
	| decls param |
	(decls := pipe getVar: aParameterOrArray) ifNotNil: [^decls].
	(param := aParameterOrArray) isSymbol ifTrue: [param := {aParameterOrArray}].
	^param collect: [:p| GbtDeclarative definedAs: p].
! !

!GbtAction methodsFor: 'executing' stamp: 'hk 12/8/2015 16:57'!
doOn: aPipe
	^self subclassResponsibility ! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 8/30/2016 11:32'!
ensurePath: pathOrSymbol
	^pathOrSymbol ifString: [{pathOrSymbol}]! !

!GbtAction methodsFor: 'error handling' stamp: 'hk 4/30/2016 18:31'!
error: aString
	^GbtSVO error: aString! !

!GbtAction methodsFor: 'instance creation' stamp: 'hk 8/22/2016 14:45'!
for: aStringOrArray
	aStringOrArray isString ifTrue: 
		[params := {aStringOrArray}. ^self].
	aStringOrArray isArray ifTrue:
		[params := aStringOrArray]! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 8/29/2016 13:09'!
getVar: aSymbol 	
	^(pipe getVar: aSymbol asSymbol) ifNil: [aSymbol] ! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 1/4/2017 13:43'!
listContext: aCtxtNameOrVar 
	"answer the big list context named by aCtxtNameOrVar"
	| ctxt |
	(ctxt := self context: aCtxtNameOrVar) ifNil: [^nil] .
	^(ctxt isListAc) ifTrue: [ctxt] ifFalse: [] ! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 11/2/2016 16:15'!
plainContext: aCtxtNameOrVar 
	"answer the plain context named by aCtxtNameOrVar"
	| ctxt |
	ctxt := self context: aCtxtNameOrVar.
	^(ctxt isListAc) ifFalse: [ctxt] ifTrue: []
! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 12/16/2016 14:18'!
setVar: aVariable to: aThing
	(aVariable = #thing) ifTrue: [^pipe thing: aThing].
	(aVariable = #contextVO) ifTrue: [^pipe context vo: aThing].
	(aVariable = #pool) ifTrue: [^pipe context addPoolThing: aThing].
	^pipe setVar: aVariable to: aThing.	
! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 3/2/2017 16:08'!
thingFromVar: aParameter 
	"answer the thing named by aParameter or nil. role names preceed parameters"
	(aParameter = #thing) ifTrue: [^pipe thing]. 				"may be nil"
	(aParameter = #contextVO) ifTrue: [^pipe context vo]. 	"may be nil"
	(pipe context hasTxThing: aParameter) ifTrue: [^pipe context txThingAt: aParameter].
	^(self getVar: aParameter)ifString: [GbtThing definedAs: aParameter].
! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 2/14/2017 20:38'!
thingsFromVar: aParameterOrArray 
	"answer an array of things from either #thing or #contextVO or #variable or #(Name1 Name2 ..)"
	| thing param |
	(aParameterOrArray = #thing) ifTrue: [^{pipe thing}]. 					"may be nil"
	(aParameterOrArray = #contextVO) ifTrue: [^{pipe context vo}]. 		"may be nil"
	thing := pipe getVar: aParameterOrArray. 
	thing ifNotNil: [^thing isArray ifTrue: [thing] ifFalse: [{thing}]].	"not a var"
	(param := aParameterOrArray) isSymbol ifTrue: [param := {aParameterOrArray}].
	^param collect: [:p| GbtThing definedAs: p].
! !

GbtAction subclass: #GbtActionAddToBigList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionAddToBigList commentStamp: 'hk 8/29/2016 15:26' prior: 0!
I add all processed  list elements to the bigList of  context.
context is the global name of a Context or a variable holding a context.

Syntax: 	ADDBL   context !

!GbtActionAddToBigList methodsFor: 'executing' stamp: 'hk 2/2/2017 12:58'!
doOn: aPipe
	| ctxt  list context |
	pipe := aPipe copy.
	list := pipe list. 
	context := params first.
	ctxt := (self bigListContext: context) ifNil: 
		[^self abort: context, ' no big list context found' ] .
	list do: [:e|  ctxt newEntry: e . e store].
	ctxt refreshUI.  
	^ pipe! !

GbtAction subclass: #GbtActionAlter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionAlter commentStamp: 'hk 8/29/2016 16:41' prior: 0!
I transform the list using the declarative with a fixed source: thing.
If the thing is not found, all sources of the declarative are cleared.

Syntax: 	ALTER   #( thing declarative )
	
related to TRANSFORM!

!GbtActionAlter methodsFor: 'executing' stamp: 'hk 2/2/2017 12:47'!
doOn: aPipe
	|decl in out th  |
	pipe := aPipe copy. 
	(decl := self declFromVar: params second) ifNil: 
		[^self abort: params second, ' not found'].
	th := self thingFromVar: params first.
	in := pipe list.   
	decl sources: th.	"clears the sources if th isNil" 
	out := GbtService list: in transformedWith: decl. 
	^ pipe list: out! !

GbtActionAlter subclass: #GbtActionTransform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionTransform commentStamp: 'hk 8/29/2016 16:41' prior: 0!
I make a 'varDecl copyWithSource: varThing' and assign it to varRes

Syntax: 	TRANSFORM  varThing varDecl varRes 
	
related to ALTER!

!GbtActionTransform methodsFor: 'executing' stamp: 'hk 12/16/2016 21:21'!
doOn: aPipe
	|comb thing |
	pipe := aPipe copy.
	thing := (self thingFromVar: params first)
		ifNil: [^self abort: params first, ' not found' ] .  
	comb := (self declFromVar: params second) ifNil: 
		[^pipe abort: params second,' not found'].  
	self setVar: params third to: (comb copyWithSource: thing).
	^pipe! !

GbtAction subclass: #GbtActionApply
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionApply commentStamp: 'hk 9/25/2016 14:42' prior: 0!
I call the behavior in the context with each list element in turn as an argument arg1. 
list elements are replaced by the results of the behavior.

Syntax: 	APPLY   #(context behavior { arg2 arg3 ...  } )  	{ arg2 arg3 ...  }  = optional
		
related to BEHAVIOR!

!GbtActionApply methodsFor: 'executing' stamp: 'hk 8/29/2016 15:19'!
doOn: aPipe
	|behav ctxt in out behavior arguments |
	pipe := aPipe copy.  
	(ctxt := self plainContext: params first) ifNil:
		[^self abort: ctxt, ' not plain or not found']. 
	behavior := params second.
	behav := ctxt behaviors at: behavior ifAbsent: 
		[^pipe abort: behavior, ' missing']. 
	arguments := (params allButFirst:2) collect: [:p|self getVar: p].
	in := pipe list.  
	out := in collect: [:e| |res|
		res := behav execute:  {e}, arguments . 
		(res = #aborted) ifTrue: [^self abort: behavior, ' aborted' ] .
		res].  
	^ pipe list: out! !

GbtActionApply subclass: #GbtActionBehavior
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionBehavior commentStamp: 'hk 8/29/2016 16:45' prior: 0!
I execute the behaviour named by key , as defined in context.

Syntax: 	BEHAVIOR  #(context key  {arg1 arg 2 ...} )       {arg1 arg 2 ...} = optional
	
related to APPLY!

!GbtActionBehavior methodsFor: 'executing' stamp: 'hk 8/29/2016 15:49'!
doOn: aPipe
	| key args e ctxt |
	pipe := aPipe copy.
	ctxt := (self plainContext: params first) ifNil: 
		[^self abort: params first,' not found'  ] . 
	key := self getVar: params second.
	args := (params allButFirst:2) collect: [:p|self getVar: p].
	e := pipe thing.
	ctxt doBehavior: key withArgs: ({e}, args) .
	^pipe ! !

GbtAction subclass: #GbtActionAskTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionAskTemplate commentStamp: 'hk 12/17/2016 13:15' prior: 0!
I assign one of the templates of a big list context to the variable .
When the context has more than one template, the user is asked.

Syntax: 	 ASKTMPL   #(context  variable )     or 
		ASKTMPL   #(context  selVar   variable ) 	where  selVar contains a selector !

GbtActionAskTemplate subclass: #GbtActionAskElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionAskElement commentStamp: 'hk 12/17/2016 13:15' prior: 0!
I assign one of the elements of a big list context to  a variable.
When the context has more than one element, the user is asked.

Syntax: 	  ASKELEM   #(context   variable ) or 
		  ASKELEM   #(context  selVar   variable ) 	where  selVar contains a selector !

!GbtActionAskElement methodsFor: 'executing' stamp: 'hk 1/23/2017 13:05'!
getElementsFrom: ctxt
	^ctxt getList ifEmpty: [' no elements found'] ! !

GbtActionAskTemplate subclass: #GbtActionAskFrom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionAskFrom commentStamp: 'hk 9/27/2016 16:23' prior: 0!
I assign one of the elements of 
- the array in variable or 
- the pipe:thing:slotname-list  to the  variable.
When the list has more than one element, the user is asked.

Syntax: 	 ASKFROM  #( array  variable ) 			array = variable | slotname!

!GbtActionAskFrom methodsFor: 'executing' stamp: 'hk 1/23/2017 13:06'!
getList
	"^a list or String if Error"
	| thing var slot slotname | 
	slotname := params first asSymbol.
	var := self getVar: slotname.
	(var = slotname) ifFalse: [^var].
	thing := pipe thing ifNil: [^'no pipe thing'] .
	slot := [thing perform: slotname] ifError: 
					[^slotname, ' not found' ] .
	^[slot getList] ifError: [^slotname, ' is not a list']
		! !

GbtActionAskTemplate subclass: #GbtActionAskRole
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionAskRole commentStamp: 'hk 12/17/2016 13:36' prior: 0!
I assign one of the elements of a big list context to  a role.
When the context has more than one element, the user is asked.

Syntax: 	  ASKROLE   #(context   role ) or 
		  ASKROLE   #(context  selVar   role ) 	where  selVar contains a selector !

!GbtActionAskRole methodsFor: 'as yet unclassified' stamp: 'hk 1/23/2017 13:06'!
getElementsFrom: ctxt
	^ctxt getList ifEmpty: [' no elements found'] ! !

!GbtActionAskRole methodsFor: 'executing' stamp: 'hk 3/2/2017 16:07'!
writeElement: elem
	"no copy to a role"
	(pipe context knowsTxThing: params last) 
		ifTrue: [pipe context assign: elem toTxThing: params last]! !

!GbtActionAskTemplate methodsFor: 'executing' stamp: 'hk 1/5/2017 13:39'!
askUser: elements
	^UIManager default 
		chooseFrom: (elements collect: [:t| t summaryEnriched] )
		values: elements
		title: elements first contextName! !

!GbtActionAskTemplate methodsFor: 'executing' stamp: 'hk 12/17/2016 14:20'!
doOn: aPipe
	| elements elem selector|
	pipe := aPipe copy.
	(elements := self getList) ifString: [^self abort: elements]. 
	params size = 3 ifTrue: 
		[selector := self getVar: params second.
		elements := elements select: [:e|e contains: selector]].
	elements ifEmpty: [^self abort: 'no element found in ',params first].
	elem := (elements size = 1)
		ifTrue:  [elements anyOne]
		ifFalse: [(self askUser: elements) ifNil: [^self abort:'']].
	self writeElement: elem.
	^ pipe! !

!GbtActionAskTemplate methodsFor: 'executing' stamp: 'hk 1/4/2017 13:46'!
getElementsFrom: ctxt
	^ctxt templates ifEmpty: [^' no template found'] ! !

!GbtActionAskTemplate methodsFor: 'executing' stamp: 'hk 12/17/2016 12:55'!
getList
	| ctxt |
	(ctxt := self bigListContext: params first) ifNil: 
		[^params first, ' not found or no big list' ] .
	^self getElementsFrom: ctxt! !

!GbtActionAskTemplate methodsFor: 'executing' stamp: 'hk 12/17/2016 13:34'!
writeElement: elem
	self setVar: params last asSymbol to: elem copy! !

GbtAction subclass: #GbtActionAssign
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionAssign commentStamp: 'hk 12/15/2016 16:58' prior: 0!
I assign  things  to a var 

Syntax: 	ASSIGN   #( things   var)  		things may be  one thing or an array of things!

!GbtActionAssign methodsFor: 'executing' stamp: 'hk 9/27/2016 17:26'!
doOn: aPipe
	| th |
	pipe := aPipe copy.
	th := self thingsFromVar: params first .
	(th size = 1) ifTrue: [th := th first].
	self setVar: params second to: th.
	^ pipe! !

GbtActionAssign subclass: #GbtActionAssignDateToday
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionAssignDateToday commentStamp: 'hk 12/15/2016 16:48' prior: 0!
I write Date today in  the given slot of thing or pipe thing or contextVO to the given value 

Syntax: 	ASSIGNTODAY  #( thing path)  or 
		ASSIGNTODAY #( path)  ,    			where path  =  slot  |  {slot1 slot2 ... }
	!

!GbtActionAssignDateToday methodsFor: 'executing' stamp: 'hk 12/16/2016 17:21'!
doOn: aPipe
	| thing path setter |
	pipe := aPipe copy.
	path := self ensurePath: params last.
	setter := path last.
	path := path allButLast.
	thing := params size > 1 
		ifTrue: [self thingFromVar: params first]
		ifFalse: [pipe thing ifNil: [pipe context vo]].
	thing := thing getOnPath: path.
	thing perform: setter asMutator with: Date today asString.
	^ pipe! !

GbtActionAssign subclass: #GbtActionAssignDecl
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionAssignDecl commentStamp: 'hk 8/30/2016 10:42' prior: 0!
I assign a declarative  to a variable.

Syntax: 	ASSIGNDECL   #( decl variable)!

!GbtActionAssignDecl methodsFor: 'executing' stamp: 'hk 9/27/2016 16:51'!
doOn: aPipe
	|  decls |
	pipe := aPipe copy.
	decls := (self declsFromVar: params first asSymbol) .
	(decls size =1) ifTrue: [decls := decls first].
	pipe setVar: params second to: decls.	
	^ pipe! !

GbtActionAssign subclass: #GbtActionAssignUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionAssignUser commentStamp: 'hk 1/4/2017 16:32' prior: 0!
I write the context user  in  the given slot of thing or pipe thing or contextVO to the given value 

Syntax: 	ASSIGNUSER  #( thing path)  or 
		ASSIGNUSER  #( path)  ,    			where path  =  slot  |  {slot1 slot2 ... }
	!

!GbtActionAssignUser methodsFor: 'executing' stamp: 'hk 1/4/2017 16:39'!
doOn: aPipe
	| thing path setter |
	pipe := aPipe copy.
	path := self ensurePath: params last.
	setter := path last.
	path := path allButLast.
	thing := params size > 1 
		ifTrue: [self thingFromVar: params first]
		ifFalse: [pipe thing ifNil: [pipe context vo]].
	thing := thing getOnPath: path.
	thing perform: setter asMutator with: pipe context user.
	^ pipe! !

GbtActionAssign subclass: #GbtActionAssignVal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionAssignVal commentStamp: 'hk 8/30/2016 11:43' prior: 0!
I mutate the given slot of thing or pipe thing or contextVO to the given value 

Syntax: 	ASSIGNVAL  #(val thing path)  or 
		ASSIGNVAL #(val path)  ,    			where path  =  slot  |  {slot1 slot2 ... }
	!

!GbtActionAssignVal methodsFor: 'executing' stamp: 'hk 11/9/2016 15:17'!
doOn: aPipe
	| thing   value path setter |
	pipe := aPipe copy.
	value := self getVar: params first.
	path := self ensurePath: params last.
	setter := path last.
	path := path allButLast.
	thing := params size > 2 
		ifTrue: [self thingFromVar: params second]
		ifFalse: [pipe thing ifNil: [pipe context vo]].
	thing := thing getOnPath: path.
	thing perform: setter asMutator with: value.
	^ pipe! !

GbtActionAssign subclass: #GbtActionReadSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionReadSlot commentStamp: 'hk 12/16/2016 18:32' prior: 0!
I assign the slotName content  of the thing or pipe thing to a variable.

Syntax: 	READSLOT   #( thing  path  variable)        path = slot |  # (slot 2 slot 3 ... )
or 		READSLOT   #( path  variable)        		   path = slot |  #( slot 2 slot 3 ... )
!

!GbtActionReadSlot methodsFor: 'executing' stamp: 'hk 12/16/2016 16:08'!
doOn: aPipe
	| context thing path |
	pipe := aPipe copy.
	context := aPipe context.
	thing := params size > 2
		ifTrue: [self thingFromVar: params first] 
		ifFalse: [pipe thing ifNil: [context vo]].
	path := params at: params size -1.
	path := path ifString: [{path}].
	self setVar: params last to: (thing getOnPath: path).
	^ pipe! !

GbtActionAssign subclass: #GbtActionSetSaveCtxt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionSetSaveCtxt commentStamp: 'hk 1/4/2017 17:33' prior: 0!
I change the saveContext of thing

Syntax: 	SAVECONTEXT  #( thing context)  !

!GbtActionSetSaveCtxt methodsFor: 'executing' stamp: 'hk 1/4/2017 17:39'!
doOn: aPipe
	| thing ctxt |
	pipe := aPipe copy.
	thing := (self thingFromVar: params first) ifNil: 
		[^self abort: params first, ' not found' ] ..
	ctxt := (self context: params second) ifNil: 
		[^self abort: params second,' not found'].
	thing saveContext: ctxt.
	^ pipe! !

GbtActionAssign subclass: #GbtActionWriteSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionWriteSlot commentStamp: 'hk 12/15/2016 18:12' prior: 0!
I copy  a variable  to the  slot given by thing and path.
	
Syntax: 	WRITESLOT   #(var thing path)  or 
		WRITESLOT   #(var path)  ,    			where path  =  slot  |  {slot1 slot2 ... }!

GbtActionWriteSlot subclass: #GbtActionAddToList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionAddToList commentStamp: 'hk 9/23/2016 14:02' prior: 0!
I add  a variable  to the  listSlot of the context vo.
the variable contains a thing or a thingName 

Syntax: 	ADD2L   #(variable  listSlot)!

!GbtActionAddToList methodsFor: 'executing' stamp: 'hk 9/23/2016 14:03'!
doOn: aPipe
	| content cvo slotName list |
	pipe := aPipe copy.
	(content := self thingFromVar: params first) ifNil:
		 [^self abort: content,' neither thing nor list'].
	slotName := self getVar: params second.
	cvo := pipe context vo ifNil: [^self abort: 'no context VO'].
	[list := cvo perform: slotName] ifError: [^self abort: slotName, ' is no Ulist'].
	(list isKindOf: GbtUlist) ifFalse: [^self abort: slotName, ' is no Ulist'].
	list newEntry: content copy.
	^ pipe! !

!GbtActionWriteSlot methodsFor: 'executing' stamp: 'hk 2/15/2017 11:52'!
doOn: aPipe
	| content path setter th |
	pipe := aPipe copy.
	path := self ensurePath: params last.
	setter := path last.
	path := path allButLast.
	th := params size > 2 
		ifTrue: [self thingFromVar: params second]
		ifFalse: ["pipe thing ifNil: ["pipe context vo"]"].
	th ifNil: [^self abort: 'no thing or context VO'].
	th := th getOnPath: path. 
	content := self getVar: params first.  
	th perform: setter asMutator with: content copy.
	^ pipe! !

GbtAction subclass: #GbtActionAssureThing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionAssureThing commentStamp: 'hk 9/25/2016 14:50' prior: 0!
I set the thing to be the contextVO ifNil

Syntax: 	ASSURETH  void  !

!GbtActionAssureThing methodsFor: 'executing' stamp: 'hk 9/25/2016 14:54'!
doOn: aPipe
	"assure my thing"
	pipe := aPipe copy.
	pipe thing ifNotNil: [^pipe].
	pipe context vo ifNil: [self abort: 'no context vo'].
	^pipe thing: pipe context vo! !

GbtAction subclass: #GbtActionAssureVO
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionAssureVO commentStamp: 'hk 8/29/2016 12:51' prior: 0!
I assign the context vo using aspect and the container context

Syntax: 	ASSUREVO  void  !

!GbtActionAssureVO methodsFor: 'executing' stamp: 'hk 9/22/2016 19:35'!
assureVOfor: aContext
	aContext vo ifNotNil: [^self].
	(aContext container isListAc) 
		ifFalse: [aContext setVOFromContainer]
		ifTrue: [self newVOfor: aContext]
! !

!GbtActionAssureVO methodsFor: 'executing' stamp: 'hk 8/29/2016 12:52'!
doOn: aPipe
	"assure my context vo"
	pipe := aPipe copy.
	self assureVOfor: pipe context.
	^pipe ! !

!GbtActionAssureVO methodsFor: 'instance creation' stamp: 'hk 8/29/2016 12:08'!
newVOfor: aContext
	(aContext container isListAc) 
		ifFalse: [^nil].
	aContext vo: (aContext container newEntry) 
! !

GbtActionAssureVO subclass: #GbtActionNewVO
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionNewVO commentStamp: 'hk 8/29/2016 15:40' prior: 0!
I  create a new list element in  the context's container 
and assign that new element to my context vo

Syntax: 	NEWVO  void !

!GbtActionNewVO methodsFor: 'executing' stamp: 'hk 10/11/2016 16:37'!
doOn: aPipe
	"create a new vo for the context "
	pipe := aPipe copy.
	(self newVOfor: pipe context) ifNil: 
		[^self abort: pipe context svoName,' not a list context'].
	^pipe ! !

GbtActionAssureVO subclass: #GbtActionSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionSlot commentStamp: 'hk 8/29/2016 15:46' prior: 0!
I assure my context vo, thing and getter of the pipe. 
 -   Used for constraints.

Syntax: 	SLOT  getter 			
	!

!GbtActionSlot methodsFor: 'executing' stamp: 'hk 8/29/2016 13:09'!
doOn: aPipe
	"assure thing and getter in the pipe"
	| getter ctxt |
	pipe := aPipe copy.
	getter := self getVar: params first.
	ctxt := pipe context.
	self assureVOfor: ctxt.
	pipe thing: ctxt vo.
	^pipe slot: getter.
! !

GbtAction subclass: #GbtActionBehaviors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionBehaviors commentStamp: 'hk 8/29/2016 15:52' prior: 0!
I execute the named (by keys) parameterless behaviours of the contex.
(only the same pipe thing is available in all called behaviors)

Syntax: 	BEHAVIORS  #(key1 key2 key3 ... )!

!GbtActionBehaviors methodsFor: 'executing' stamp: 'hk 8/23/2016 14:32'!
doOn: aPipe
	pipe := aPipe copy.
	pipe context doBehaviors: params.
	^pipe ! !

GbtActionBehaviors subclass: #GbtActionConstraints
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionConstraints commentStamp: 'hk 8/29/2016 15:52' prior: 0!
I execute the  constraints named by keys

Syntax: 	CONSTRAINTS  #(key1 key2 key3 ...)!

!GbtActionConstraints methodsFor: 'executing' stamp: 'hk 8/23/2016 14:32'!
doOn: aPipe
	pipe := aPipe copy.
	pipe context doConstraints: params.
	^pipe ! !

GbtAction subclass: #GbtActionCheck
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionCheck commentStamp: 'hk 12/16/2016 15:44' prior: 0!
I check the consistency of pipe thing and abort if not consistent

Syntax: 	CHECK  hint
!

!GbtActionCheck methodsFor: 'executing' stamp: 'hk 12/19/2016 18:03'!
doOn: aPipe
	| hint |
	pipe := aPipe copy. 
	hint := self getVar: params first.
	pipe thing checkConstraints .
	pipe thing isConsistent ifTrue: [^pipe].  
	^self abort: pipe thing constraintViolationString! !

GbtAction subclass: #GbtActionCommit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionCommit commentStamp: 'hk 12/16/2016 17:26' prior: 0!
I save the contexts workspace, ie context vo and all role things 

Syntax: 	COMMIT  void !

!GbtActionCommit methodsFor: 'as yet unclassified' stamp: 'hk 12/16/2016 16:21'!
doOn: aPipe
	pipe := aPipe copy.
	pipe context store.
	^ pipe! !

GbtAction subclass: #GbtActionCompose
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionCompose commentStamp: 'hk 12/16/2016 18:05' prior: 0!
I compose the sources:  
- context vo  and 
- all context pool Things 
- all things in vars 
using the declarative

Syntax: 	COMPOSE   declarative   or
		COMPOSE  #(declarative   vars)   where  vars =  var1 { var2 var 3 ... }!

!GbtActionCompose methodsFor: 'executing' stamp: 'hk 12/16/2016 18:13'!
doOn: aPipe
	|vo comb ctxt srcs |
	pipe := aPipe copy.
	ctxt := aPipe context.
	comb := (self declFromVar: params first) ifNil: 
		[^self abort: params first,' not found'].
	srcs := params allButFirst collect: [:p| self thingFromVar: p ].
	comb sources: (ctxt allPoolThings addAll: srcs; yourself). 
	vo := comb copyWithSource: ctxt vo.
	^pipe thing: vo ! !

GbtAction subclass: #GbtActionContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionContext commentStamp: 'hk 8/29/2016 16:19' prior: 0!
I set the new context.

Syntax: 	CONTEXT  context
!

!GbtActionContext methodsFor: 'executing' stamp: 'hk 8/29/2016 16:21'!
doOn: aPipe
	| context  |  
	pipe := aPipe copy.
	context := (self context: params first) ifNil: 
		[^self abort: params first,' not found' ] .
	^pipe context: context! !

GbtAction subclass: #GbtActionEdit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionEdit commentStamp: 'hk 8/29/2016 16:21' prior: 0!
I open an editor on the thing  in variable

Syntax: 	EDIT  variable
	!

!GbtActionEdit methodsFor: 'executing' stamp: 'hk 8/30/2016 11:21'!
doOn: aPipe
	|thing |
	pipe := aPipe copy.
	thing := (self thingFromVar: params first) ifNil: 
		[^self abort: params first, ' not found'] .
	thing edit.
	^pipe ! !

GbtAction subclass: #GbtActionEmbed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionEmbed commentStamp: 'hk 8/29/2016 16:26' prior: 0!
I embed the thing data into the context vo using combinator

Syntax: 	EMBED  #(variable combinator )!

!GbtActionEmbed methodsFor: 'executing' stamp: 'hk 8/30/2016 11:24'!
doOn: aPipe
	|thing comb  |
	pipe := aPipe copy.
	thing := (self thingFromVar: params first) ifNil: 
		[^self abort: params first, ' not found'] .
	comb := (self declFromVar: params second) ifNil: 
		[^self abort: params second,' not found'].
	pipe context vo embed: thing with: comb.  
	^pipe! !

GbtAction subclass: #GbtActionFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionFilter commentStamp: 'hk 8/22/2016 13:45' prior: 0!
I filter the list with the  constraint

Syntax: 	FILTER   constraint !

!GbtActionFilter methodsFor: 'executing' stamp: 'hk 3/25/2017 16:52'!
doOn: aPipe
	| filter res list  |
	pipe := aPipe copy.
	(filter := self thingFromVar: params first) ifNil: 	
		[^self abort: filter, ' not found'].
	list := pipe  list. 
	res := GbtService list: list filteredBy: filter.  
	^ pipe list: res! !

GbtAction subclass: #GbtActionFreeze
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionFreeze commentStamp: 'hk 2/11/2017 16:12' prior: 0!
I freeze all calc slots of my input, i.e. make val slots of these
if I work on a list, the result list is frozen.
If I work on a thing, the result is in pipe thing

Syntax: 	FREEZE   target          target =   list  | thing   |  contextVO  |  a variable ...!

!GbtActionFreeze methodsFor: 'executing' stamp: 'hk 2/11/2017 16:23'!
doOn: aPipe
	|th|
	pipe := aPipe copy. 
	params first = #list ifTrue:
		[^pipe list: (pipe list collect: [:e| e copyFreeze])] .
	th := self thingFromVar: params first.
	^pipe thing: th copyFreeze
! !

GbtAction subclass: #GbtActionGetEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionGetEvent commentStamp: 'hk 8/29/2016 16:52' prior: 0!
I read the event with content of type in thingVar and put it into the pipe

Syntax: 	GETEVENT  thingVar!

!GbtActionGetEvent methodsFor: 'executing' stamp: 'hk 8/29/2016 16:51'!
doOn: aPipe
	| context thing ext type|
	pipe := aPipe copy.
	type := self getVar: params first.
	context := aPipe context.
	context eventQueue forType: type do: 
		[:evt| thing := evt content. ext := evt isExternal].
	thing ifNil: [^self abort: nil "empty event" ].  
	^pipe thing: thing ; external: ext! !

GbtAction subclass: #GbtActionHalt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionHalt commentStamp: 'hk 12/16/2016 15:48' prior: 0!
I am used for debugging

Syntax: 	HALT  hint
!

!GbtActionHalt methodsFor: 'executing' stamp: 'hk 12/16/2016 15:47'!
doOn: aPipe
	| hint |
	pipe := aPipe copy. 
	hint := self getVar: params first.
	pipe halt: hint, pipe printString. 
	^pipe ! !

!GbtActionHalt methodsFor: 'instance creation' stamp: 'hk 12/16/2016 15:45'!
xfor: anArg
	hint := anArg asSymbol! !

GbtAction subclass: #GbtActionMapBigList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionMapBigList commentStamp: 'hk 8/29/2016 16:54' prior: 0!
I assign the bigList of a context to my list.

Syntax: 	MAPBL  context 
	
related to MAP!

GbtActionMapBigList subclass: #GbtActionMap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionMap commentStamp: 'hk 8/29/2016 16:57' prior: 0!
I assign the Ulist slot of varThing to my list.

Syntax: 	MAP   #(varThing  slot)
	
related to MAPBL!

!GbtActionMap methodsFor: 'executing' stamp: 'hk 11/2/2016 16:28'!
doOn: aPipe
	|  slotname thing ulist |
	pipe := aPipe copy.
	thing := (self thingFromVar: params first) ifNil:
		[^self abort: params first,' not found'].
	slotname := self getVar: params second.  
	ulist := [thing perform: slotname] ifError: [thing].
	^pipe list: ulist list! !

!GbtActionMapBigList methodsFor: 'executing' stamp: 'hk 1/23/2017 13:06'!
doOn: aPipe
	| context |
	pipe := aPipe copy.
	context := (self bigListContext: params first) 
		ifNil: [^self abort: params first,' not found'].
	^pipe list: context getList! !

GbtAction subclass: #GbtActionMatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionMatch commentStamp: 'hk 8/30/2016 10:04' prior: 0!
I match the bizId in the slot of  thing with my list context's list elements. 
If none is found, I create a new list element. 

Syntax: 	MATCH #( thing  slot) 				slot holds  a bizId to match!

!GbtActionMatch methodsFor: 'executing' stamp: 'hk 8/30/2016 11:21'!
doOn: aPipe
	|context subcontext bizID thing|
	pipe := aPipe copy.
	thing := (self thingFromVar: params first) ifNil: 
		[^self abort: params first,' not a thing'].
	bizID := [thing perform: params second asSymbol] ifError: [].
	context := (self listContext: #context) ifNil: 
		[^self abort: 'no list context']. 
	"find the process with bizID or create it and assign it to subcontext"
	subcontext := self subcontextWith: bizID of: context .
	^pipe context: subcontext! !

!GbtActionMatch methodsFor: 'executing' stamp: 'hk 12/19/2016 17:30'!
subcontextWith: bizID of: context
	"side effects for pipe new and the process found"
	| subcontext found process  |
	subcontext := context subcontext.
	found := context processWithBizId: bizID. 	"bizId may be nil"
	process := found first.
	subcontext vo: process.
	found second ifTrue: [subcontext createHook: process] .  
	(pipe external = true) ifTrue:	
		[process setDataPending].
	pipe new: found second.
	^subcontext! !

GbtAction subclass: #GbtActionPDF
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionPDF commentStamp: 'hk 8/23/2016 13:20' prior: 0!
I fill a given (source) pdf form with the data from my inThing and create target

Syntax: TOPFD  #( filename   slotnameOfLabelStickerThing)
!

!GbtActionPDF methodsFor: 'executing' stamp: 'hk 2/17/2017 16:06'!
doOn: aPipe
	| thing target pdfContent |  
	pipe := aPipe copy.
	target := params first.
	pdfContent := params second.
	thing := pipe thing.
	thing ifNil: [^self abort: self actionName,' nothing to paste'].   
	GbtService 
		pdfLabel: target 
		with: ((thing slotSVOAt: pdfContent) leafSVOs collect: [:s| s val]).
	^ pipe! !

GbtAction subclass: #GbtActionPushTo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionPushTo commentStamp: 'hk 8/30/2016 10:28' prior: 0!
I attach a new event with the thing or pipe thing to the  context eventQueue .

Syntax: 	PUSHTO  context    or   PUSHTO  #(thing  context)!

!GbtActionPushTo methodsFor: 'executing' stamp: 'hk 11/9/2016 15:17'!
doOn: aPipe
	| thing context ext|  
	pipe := aPipe copy.
	thing := (params size > 1)
		ifTrue: [self thingFromVar: params first] 
		ifFalse: [pipe thing].
	thing ifNil: [^self abort: ' no thing to push']. 
	context := (self context: params last) ifNil: 
		[^self abort: 'no target context' ] .
	ext := aPipe external.
	context receive: ((GbtEvent command: thing) external: ext).
	^pipe context: context ! !

GbtAction subclass: #GbtActionReduce
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionReduce commentStamp: 'hk 8/30/2016 11:02' prior: 0!
I assign  the list elements to the Ulist slotName of the thing or the  context vo.
see also ActionAddToBigList

Syntax: 	REDUCE  #(thing slotname)!

!GbtActionReduce methodsFor: 'executing' stamp: 'hk 2/17/2017 15:50'!
doOn: aPipe
	| context list thing slotname |
	pipe := aPipe copy.
	slotname := params second asSymbol.
	context := aPipe context.
	thing := (self thingFromVar: params first) ifNil: 
		[^self abort: params first,' not found'] .
	list := pipe list.
	pipe list do: [:e| (thing slotSVOAt: slotname) newEntry: e].
	context refreshUI. 
	^ pipe! !

GbtActionReduce subclass: #GbtActionReduceAdd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionReduceAdd commentStamp: 'hk 8/30/2016 11:12' prior: 0!
I add  the list elements to the Ulist slotName of the thing
see also ActionAddToBigList

Syntax: 	REDADD #(thing slotname)!

!GbtActionReduceAdd methodsFor: 'executing' stamp: 'hk 8/30/2016 11:22'!
doOn: aPipe
	| thing slotname ulist  |
	pipe := aPipe copy.
	slotname := params second asSymbol.
	thing := (self thingFromVar: params first) ifNil: 
		[^self abort: params first,' not found'] .
	ulist := thing perform: slotname .
	pipe list do: [:e| ulist newEntry: e].
	thing save.
	pipe context refreshUI. 
	^ pipe! !

GbtAction subclass: #GbtActionRefresh
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionRefresh commentStamp: 'hk 8/25/2016 14:16' prior: 0!
I update the GUI for current context .

Syntax: 	REFRESH   void !

!GbtActionRefresh methodsFor: 'executing' stamp: 'hk 8/25/2016 14:16'!
doOn: aPipe
	pipe := aPipe copy.
	pipe context refreshUI.
	^ pipe! !

GbtAction subclass: #GbtActionSendTo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionSendTo commentStamp: 'hk 8/22/2016 19:41' prior: 0!
final action - I bizNet send a new event with my thing to the receiver as defined  by the path on my context vo.
a prototype hack. has to be unified with sendTo.

Syntax: 	SENDTO  #(path )  		path = slot1 slot2 slot3 ... 
				
to do: 
in BizNet the receiver is identified not by its company  name but its bizNetID
what about an internal sendTo ?  one might specify a contexct !!!

!GbtActionSendTo methodsFor: 'executing' stamp: 'hk 3/14/2017 10:37'!
doOn: aPipe
	| thing rec ev path |  
	pipe := aPipe copy.
	path := params.
	((thing := pipe thing) isKindOf: GbtThing) ifFalse: 
		[^self abort: self actionName,' nothing to send'].
	rec := aPipe context vo getOnPath: path.
	ev := (GbtEvent command: thing) receiver: rec.
	pipe context notify: (GbtBizNetMockUp send: ev) .
	^pipe! !

GbtAction subclass: #GbtActionToList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionToList commentStamp: 'hk 8/30/2016 11:46' prior: 0!
I am a final action for external events - add the var to the current context's list
I mark context and thing as changed.

Syntax: 	TOLIST  var
	!

!GbtActionToList methodsFor: 'executing' stamp: 'hk 8/30/2016 11:22'!
doOn: aPipe
	| thing |
	pipe := aPipe copy.
	thing := (self thingFromVar: params first) ifNil:
		[^self abort: params first,' missing'].
	pipe context isListAc ifFalse: 
		[^self abort: ' no list context'].
	pipe context newEntry: thing.
	(pipe external = true) ifTrue: [thing setDataPending].
	^pipe! !

Object subclass: #GbtActionPipe
	instanceVariableNames: 'context new external abort thing variables list slot userName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions'!

!GbtActionPipe commentStamp: 'hk 11/7/2016 19:53' prior: 0!
I define the action pipe objects .
Context, new, external must always be there.

    Instance Variables
	context:		<ActiveContextVO>		to be operated in, includes context vo
	external:		<Boolean|nil>			origin of this action, true if external
	new:		<Boolean|nil>			for matches: no hit --> creation; new = true
	thing:		<ThingVO|nil|String>		 content to be processed
	slot: 		<Symbol | nil>			a slotname - used for constraints
	list:			<Coll of ThingVO|nil|>		list to be processed
	abort: 		<String|nil>				error string;         self abort = Boolean
	variables: 	<OrderedIdentityDictionary>	of named stored Things or values (arguments)
	userName:  	<String>					 aName !

!GbtActionPipe class methodsFor: 'instance creation' stamp: 'hk 11/7/2016 19:53'!
thing: aThing context: aContext new: bool1 ext: bool2 
	^self new 	
		thing: aThing;
		context: aContext;
		user: aContext user;
		new: bool1;
		external: bool2! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 1/6/2016 12:54'!
abort
	^abort isNotNil! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 1/6/2016 13:59'!
abort: aString
	abort := aString.
	aString ifNotEmpty: [context notify: aString]! !

!GbtActionPipe methodsFor: 'accessing arguments' stamp: 'hk 8/24/2016 17:22'!
addArgs: argArray for: nameArray
	argArray ifEmpty: [^self].
	nameArray size < argArray size ifTrue: [^self notify: 'not enough arguments defined'].
	1 to: argArray size do: [:i| self setVar: (nameArray at: i) to: (argArray at: i)].
! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 12/30/2015 14:04'!
context
	^ context! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 12/30/2015 14:10'!
context:  anActiveContextVO
	context  := anActiveContextVO! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 12/30/2015 14:04'!
external
	^ external! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 12/30/2015 14:09'!
external: aBoolean
	external := aBoolean! !

!GbtActionPipe methodsFor: 'accessing variables' stamp: 'hk 7/27/2016 17:50'!
getVar: aName 
	^self variables at: aName ifAbsent: []! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 8/18/2016 11:28'!
list
	^ list! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 8/18/2016 13:07'!
list: aListOfThings
	list := aListOfThings ! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 12/30/2015 14:04'!
new
	^ new! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 12/30/2015 14:09'!
new: aBoolean
	new := aBoolean! !

!GbtActionPipe methodsFor: 'printing' stamp: 'hk 10/11/2016 16:37'!
printString 
	^ 'Context: ', context svoName, variables printString! !

!GbtActionPipe methodsFor: 'accessing variables' stamp: 'hk 8/24/2016 17:23'!
setVar: aName to: anObject
	self variables add: aName asSymbol -> anObject! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 8/23/2016 13:32'!
slot
	^ slot! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 8/23/2016 13:32'!
slot: aSymbol
	slot := aSymbol asSymbol! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 6/1/2016 10:39'!
thing
	^ thing! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 8/18/2016 11:27'!
thing: aGbtThing
	thing := aGbtThing! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 11/8/2016 09:37'!
user
	^userName ifNil: [ '' ]! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 11/7/2016 19:52'!
user: aName
	userName := aName ! !

!GbtActionPipe methodsFor: 'accessing variables' stamp: 'hk 7/27/2016 17:49'!
variables
	^variables ifNil: [ variables := OrderedIdentityDictionary new ]! !

Object subclass: #GbtBizApp
	uses: TGbtProgramStore
	instanceVariableNames: 'user userRole programStore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-BizApp'!

!GbtBizApp commentStamp: 'hk 3/21/2017 13:58' prior: 0!
I am the central store of a users app instance. 
I hold the program:
- contexts with policies,
- declaratives  and
- fullThings
and I hold a cache of all things read from the db and created anew.

I come to life on log in and die on  log out

    Instance Variables
	programStore:	<GbtProgramStore > 	
	user:			<String>			userName
	userRole:		<GbtRole>
			
initializeForUserApp  simulates the network transport of the programStore!

GbtBizApp class
	uses: TGbtProgramStore classTrait
	instanceVariableNames: ''!

!GbtBizApp methodsFor: 'program store' stamp: ''!
add: anSVO full: aFullVO
	self programStore add: anSVO full: aFullVO! !

!GbtBizApp methodsFor: 'program store' stamp: ''!
addAC: anAC 
	^self programStore addAC: anAC ! !

!GbtBizApp methodsFor: 'program store' stamp: ''!
addDecl: anSVO 
	^self programStore addDecl: anSVO ! !

!GbtBizApp methodsFor: 'program store' stamp: ''!
allContexts
	^self programStore allContexts! !

!GbtBizApp methodsFor: 'program store' stamp: ''!
contextNamed: anACname  
	^self contextNamed: anACname ifAbsent: []! !

!GbtBizApp methodsFor: 'program store' stamp: ''!
contextNamed: anACname  ifAbsent: absentBlock
	^self programStore contextNamed: anACname  ifAbsent: absentBlock! !

!GbtBizApp methodsFor: 'program store' stamp: ''!
contextNoPolicyOf: anACname getter: aSelector
	"set the getter"
	(self programStore contextNoPolicyOf: anACname) getter: aSelector ! !

!GbtBizApp methodsFor: 'program store' stamp: ''!
contextNoPolicyOf: anACname prefix: aString
	"set the prefix"
	(self programStore contextNoPolicyOf: anACname) prefix: aString! !

!GbtBizApp methodsFor: 'program store' stamp: ''!
declarativeNamed: aName ifAbsent: absentBlock
	^self programStore declarativeNamed: aName ifAbsent: absentBlock! !

!GbtBizApp methodsFor: 'program store' stamp: ''!
fsvoEntry: aSvoName ifAbsent: aBlock
	^self programStore fsvoEntry: aSvoName ifAbsent: aBlock! !

!GbtBizApp methodsFor: 'initialization' stamp: 'hk 3/29/2017 15:41'!
initializeForUserApp: aProgramStore
	programStore := STON fromString:(STON toString: aProgramStore).  
	programStore tecNoPolicy prefix: user.
	self allContexts do: [:ctxt| 
		ctxt 
			user: self user; 
			userRight: (userRole rightOf: ctxt svoName);
			bizApp: self].
	self allThings do: [:th |
		th bizApp: self ]! !

!GbtBizApp methodsFor: 'program store' stamp: ''!
nextIdOfContextNoPolicy: anACname  
	^(self contextNoPolicyOf: anACname) nextID! !

!GbtBizApp methodsFor: 'api' stamp: 'hk 3/22/2017 12:08'!
open
	(self contextNamed: programStore mainCtxtName) open ! !

!GbtBizApp methodsFor: 'accessing' stamp: 'hk 3/16/2017 12:38'!
programStore
	^programStore
	! !

!GbtBizApp methodsFor: 'initialization' stamp: 'hk 3/24/2017 21:05'!
stonConvert: aProgramStore
	"this is for a programStore, cf. GbtTransactor"
	^STON fromString:(STON toString: aProgramStore)! !

!GbtBizApp methodsFor: 'accessing' stamp: 'hk 3/21/2017 16:34'!
user
	^user ! !

!GbtBizApp methodsFor: 'accessing' stamp: 'hk 3/14/2017 13:10'!
user: aName
	user := aName! !

!GbtBizApp methodsFor: 'accessing' stamp: 'hk 3/14/2017 15:44'!
userRole
	^userRole ! !

!GbtBizApp methodsFor: 'accessing' stamp: 'hk 3/14/2017 13:15'!
userRole: aRole
	userRole :=  aRole! !

Object subclass: #GbtBizAppServer
	uses: TGbtProgramStore
	instanceVariableNames: 'transactor rootMapDict programStore appName userDict appDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-BizAppServer'!

GbtBizAppServer class
	uses: TGbtProgramStore classTrait
	instanceVariableNames: 'default namedInstances'!

!GbtBizAppServer commentStamp: 'hk 3/23/2017 11:17' prior: 0!
I am the central app component (server) for all  user apps: 
- I hold the  users (configured) with user roles & rights and the userApps already started
- I am responsible for the technical  thing id policy,
- I hold the compiled Gbt program (that is copied to the user app on startup)
- I also hold the transactor that writes things and informs other users about thing changes

I come to life with the first user and die after the last user has logged out

In Test and Development I also serve as the bizApp for the unknown user ''

 Instance Variables
	appName: 		<String>				appName
	transactor: 		<GbtTransactor>		similar to a Datomic transactor
	programStore: 	<GbtProgramStore>	will be copied on user app start
	userDict:		<Dictionary> 			of Name -> userRole 
	appDict:			<Dictionary> 			of Name -> bizApp
	rootMapDict: 	<Dictionary> 			of svoName ->  GbtRootMap	(= rootMap file cache)
	
Class Variables 
	default: 			<String>				name of current (default) instance
	namedInstances: <Dictionary of GbtBizAppServer> 	
	
Persistence (via GbtTransactor):
	users
	programStore
	own config parameters
	bizApp config parameters
	!

GbtBizAppServer class
	uses: TGbtProgramStore classTrait
	instanceVariableNames: 'default namedInstances'!

!GbtBizAppServer class methodsFor: 'class initialization' stamp: 'hk 3/16/2017 15:06'!
clearStore
	self thingsDir ensureDeleteAllChildren.
	self txDir ensureDeleteAllChildren.
	self default initialize! !

!GbtBizAppServer class methodsFor: 'instance management' stamp: 'hk 3/16/2017 14:38'!
default
	^namedInstances at: default ! !

!GbtBizAppServer class methodsFor: 'class initialization' stamp: 'hk 3/16/2017 14:36'!
initialize
	default := #default.
	namedInstances := Dictionary newFromPairs: {#default . self new}! !

GbtBizAppServer initialize!

!GbtBizAppServer class methodsFor: 'instance creation' stamp: 'hk 3/17/2017 17:09'!
new: anAppName
	^namedInstances at: anAppName put: (self new appName: anAppName) ! !

!GbtBizAppServer class methodsFor: 'accessing' stamp: 'hk 3/14/2017 12:33'!
rootMapOf: svoNameDir
	"answer the directoryEntries of all things with svoName"
	| rootMapFile res |
	(rootMapFile := svoNameDir / 'rootMap') asFileReference exists 
		ifTrue: [rootMapFile readStreamDo: [:str| res := str contents]]
		ifFalse: [res := ''].
	^GbtRootMap fromString: res.
! !

!GbtBizAppServer class methodsFor: 'instance management' stamp: 'hk 3/16/2017 14:48'!
setDefault: anAppName
	default := anAppName .
	namedInstances at: default ifAbsent: [self new: anAppName]! !

!GbtBizAppServer class methodsFor: 'accessing' stamp: 'hk 1/23/2017 15:15'!
thingsDir
	^(FileSystem workingDirectory / 'things') ensureCreateDirectory ! !

!GbtBizAppServer class methodsFor: 'api-transactions' stamp: 'hk 3/16/2017 15:06'!
transact: anArrayOfPathOfThings as: aUser
	self default transactor transact: anArrayOfPathOfThings as: aUser! !

!GbtBizAppServer class methodsFor: 'accessing' stamp: 'hk 1/23/2017 15:15'!
txDir
	^(FileSystem workingDirectory / 'tx') ensureCreateDirectory ! !

!GbtBizAppServer methodsFor: 'accessing' stamp: 'hk 3/23/2017 11:07'!
activeUsers
	^appDict keys! !

!GbtBizAppServer methodsFor: 'api ' stamp: 'hk 3/23/2017 11:04'!
addUser: aName withRole: aRole
	userDict at: aName put: aRole
! !

!GbtBizAppServer methodsFor: 'accessing' stamp: 'hk 3/23/2017 14:26'!
appAt: aUser
	aUser = '' ifTrue: [^self].
	^appDict at: aUser ifAbsent: []! !

!GbtBizAppServer methodsFor: 'accessing' stamp: 'hk 3/17/2017 17:09'!
appName: anAppName
	appName := anAppName ! !

!GbtBizAppServer methodsFor: 'accessing' stamp: 'hk 3/23/2017 11:08'!
appUsers
	^userDict keys! !

!GbtBizAppServer methodsFor: 'accessing' stamp: 'hk 3/23/2017 11:08'!
hasUser: aUserName
	^userDict includesKey: aUserName! !

!GbtBizAppServer methodsFor: 'initialize' stamp: 'hk 3/23/2017 11:15'!
initialize    
	transactor := GbtTransactor new. 
	programStore := GbtProgramStore  new.
	userDict := Dictionary new.
	appDict := Dictionary new.
	rootMapDict := Dictionary new.! !

!GbtBizAppServer methodsFor: 'initialize' stamp: 'hk 3/23/2017 11:09'!
initializeUsers: aCollOfPairs
	"pairs of user - role"
	userDict addAll: (Dictionary newFromPairs: aCollOfPairs) .
! !

!GbtBizAppServer methodsFor: 'accessing' stamp: 'hk 3/16/2017 12:40'!
programStore
	^programStore
	! !

!GbtBizAppServer methodsFor: 'api ' stamp: 'hk 3/23/2017 11:14'!
registerAppFor: userName
	| role bizApp| 
	role := userDict at: userName.
	appDict at: userName ifPresent: [self error: 'cant run twice'].
	bizApp := GbtBizApp new
		user: userName;
	 	userRole: role.
	appDict at: userName put: bizApp.
	^bizApp initializeForUserApp: self programStore
! !

!GbtBizAppServer methodsFor: 'api ' stamp: 'hk 3/23/2017 11:12'!
removeUser: aName 
	userDict removeKey: aName ifAbsent: [] .
! !

!GbtBizAppServer methodsFor: 'accessing' stamp: 'hk 3/23/2017 11:12'!
roleOf: aUserName
	^(userDict at: aUserName) userRole! !

!GbtBizAppServer methodsFor: 'accessing' stamp: 'hk 2/1/2017 16:46'!
rootMapAt: aSvoName
	^rootMapDict at: aSvoName ifAbsentPut: [self rootMapFromFileFor: aSvoName]  ! !

!GbtBizAppServer methodsFor: 'accessing' stamp: 'hk 2/1/2017 16:46'!
rootMapFromFileFor: aSvoName
	| dir res |
	dir := (self class thingsDir / aSvoName) ensureCreateDirectory .
	(dir / 'rootMap') asFileReference exists 
		ifFalse: [ res := '' ]
		ifTrue: [(dir / 'rootMap') readStreamDo: 
						[ :stream | res := stream contents ]].
	^GbtRootMap fromString: res.
! !

!GbtBizAppServer methodsFor: 'accessing' stamp: 'hk 1/23/2017 14:34'!
transactor
	^transactor ! !

Object subclass: #GbtBizNetMockUp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Messaging'!

GbtBizNetMockUp class
	instanceVariableNames: 'pollProcess pollProcesses'!

!GbtBizNetMockUp commentStamp: 'hk 11/11/2016 13:41' prior: 0!
I am the BizNet mockup.

protocol:
-  register (in order to receive events) 
-  send  (events)

    class instance variables:
	pollProcesses 		<Coll of Process> 		per company
											started on registering (at app startup), 
											receives all events!

GbtBizNetMockUp class
	instanceVariableNames: 'pollProcess pollProcesses'!

!GbtBizNetMockUp class methodsFor: 'accessing' stamp: 'hk 6/7/2015 13:58'!
messageDir
	^(FileSystem workingDirectory / 'messageDir') ensureCreateDirectory ! !

!GbtBizNetMockUp class methodsFor: 'error handling' stamp: 'hk 11/1/2016 14:59'!
notifyA: anArrayOfString
	self notify: (String withAll: (anArrayOfString flatCollect: [:s|s]))
! !

!GbtBizNetMockUp class methodsFor: 'protocol' stamp: 'hk 3/27/2017 20:41'!
poll: aCompany to: aContext
	| processedFiles |
	processedFiles := OrderedCollection new.
	(self messageDir / aCompany ) children do: 
		[ :c |   |fileContent th|
		fileContent := c readStreamDo: [ :stream | stream contents ] .
		[th := (GbtThing fromString: fileContent).
		th content registerWith: aContext bizApp.
		aContext receive: th.
		processedFiles add: c ] 
			ifError: [self notifyA: {'could not process message: '. c basename. #from. c creationTime asString}]].
	processedFiles copy do: [ :c | (processedFiles remove: c) delete ]! !

!GbtBizNetMockUp class methodsFor: 'accessing' stamp: 'hk 11/10/2016 14:54'!
pollProcesses
	^pollProcesses ifNil: [pollProcesses := Dictionary new]! !

!GbtBizNetMockUp class methodsFor: 'protocol' stamp: 'hk 2/5/2017 14:24'!
registerCompany: aCompany with: aContext
	"self register: 'ABCcompany' 
	received things are put in the contextVOs of aContext"
	
	(self messageDir / aCompany) ensureCreateDirectory .	
	self pollProcesses add: aCompany -> [[true] whileTrue: 
		[(Delay forSeconds: 1) wait. self poll: aCompany to: aContext]
			] fork

! !

!GbtBizNetMockUp class methodsFor: 'protocol' stamp: 'hk 12/16/2015 12:14'!
send: anEvent 
	| dir rec |
	anEvent external: true.
	(rec := anEvent receiver) isString ifFalse: [ ^ 'receiver not a String' ] .
	(rec := anEvent receiver) isEmpty ifTrue: [ ^ 'receiver is empty' ] .
	(dir := self messageDir / rec ) exists ifTrue: [ self write: anEvent to: dir ] ifFalse: [ ^rec, ' is not registered'  ].
	^'done'
! !

!GbtBizNetMockUp class methodsFor: 'protocol' stamp: 'hk 11/10/2016 14:56'!
stopPolling
	"BizNet stopPolling"
	self pollProcesses valuesDo: [:p| p terminate].
	pollProcesses := nil! !

!GbtBizNetMockUp class methodsFor: 'protocol' stamp: 'hk 2/6/2017 20:32'!
write: anEvent to: aFileReference
	"serialize aThing and write it to the directory aFileReference"   
	(aFileReference / anEvent eventType)  writeStreamDo: [ :stream | stream nextPutAll: anEvent toString ].! !

Object subclass: #GbtCodeSize
	instanceVariableNames: 'vars methods loc classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Utilities'!

!GbtCodeSize commentStamp: 'hk 3/28/2017 11:08' prior: 0!
I help counting classes, LOC,ThGCMains and variables.
I can be added and subtracted.  

Instance Variables
	classes:			<Integer>
	loc:				<Integer>
	methods:		<Integer>
	vars:			<Integer>

Thing:
  (GbtCodeSize newOn: GbtThing)
 a GbtCodeSize: 1 Klassen; 969 LOC; 20 Variablen; 212 Methoden

Things:
 (GbtCodeSize newOnCategoryOf: GbtSVO) + (GbtCodeSize newOnCategoryOf: GbtThing)
 a GbtCodeSize: 17 Klassen; 1711 LOC; 56 Variablen; 451 Methoden 

Context & Behavior:
 (GbtCodeSize  newOnCategoryOf:  GbtActiveContext) + 
(GbtCodeSize  newOnCategoryOf:  GbtAction) +
(GbtCodeSize  newOnCategoryOf:  GbtDeclarative) 
 a GbtCodeSize: 58 Klassen; 1733 LOC; 69 Variablen; 397 Methoden 

Machine - UI:
 (GbtCodeSize newOnCategoryOf: GbtSVO) + 
(GbtCodeSize newOnCategoryOf: GbtThing) +
(GbtCodeSize  newOnCategoryOf:  GbtActiveContext) + 
(GbtCodeSize  newOnCategoryOf:  GbtAction) +
(GbtCodeSize  newOnCategoryOf:  GbtEvent) +
(GbtCodeSize  newOnCategoryOf:  GbtDeclarative) +
(GbtCodeSize  newOnCategoryOf:  GbtBizApp) +
(GbtCodeSize  newOnCategoryOf:  GbtBizAppServer ) +
(GbtCodeSize  newOnCategoryOf:  GbtBizNetMockUp) +
(GbtCodeSize  newOn:  { GbtLogger . GbtService } )
 a GbtCodeSize: 91 Klassen; 4155 LOC; 178 Variablen; 1036 Methoden

UI:
 (GbtCodeSize  newOnCategoryOf:  GbtMainUI ) +
( GbtCodeSize  newOnCategoryOf:  GbtVoWidget)
 a GbtCodeSize: 33 Klassen; 2133 LOC; 58 Variablen; 426 Methoden 

Machine with UI:
 (GbtCodeSize newOnCategoryOf: GbtSVO) + 
(GbtCodeSize newOnCategoryOf: GbtThing) +
(GbtCodeSize  newOnCategoryOf:  GbtActiveContext) + 
(GbtCodeSize  newOnCategoryOf:  GbtAction) +
(GbtCodeSize  newOnCategoryOf:  GbtDeclarative) +
(GbtCodeSize  newOnCategoryOf:  GbtEvent) +
(GbtCodeSize  newOnCategoryOf:  GbtTransactor) +
(GbtCodeSize  newOn:  { GbtLogger . GbtService } ) +
(GbtCodeSize  newOnCategoryOf:  GbtMainUI ) +
( GbtCodeSize  newOnCategoryOf:  GbtWidget)
 a GbtCodeSize: 119 Klassen; 6129 LOC; 223 Variablen; 1419 Methoden 

Tools:
 GbtCodeSize newOn: {GbtDiagramBuilder . GbtCodeSize }
 a GbtCodeSize: 2 Klassen; 145 LOC; 4 Variablen; 24 Methoden 

Icons:
 GbtCodeSize newOn: GbtIcons 
 a GbtCodeSize: 1 Klassen; 3600 LOC; 1 Variablen; 110 Methoden 

Tests:
 (GbtCodeSize  newOnCategoryOf:  GbtTests) + 
(GbtCodeSize  newOnCategoryOf:  GbtGUITests) +
(GbtCodeSize  newOnCategoryOf:  GbtClearPermanentTraces )
 a GbtCodeSize: 35 Klassen; 2749 LOC; 1 Variablen; 235 Methoden 

App InsideTransport:
 (GbtCodeSize  newOnCategoryOf: GCMain) + (GbtCodeSize  newOnCategoryOf: GCDeclaratives )  
 a GbtCodeSize: 34 Klassen; 2233 LOC; 1 Variablen; 270 Methoden

App Rolodex:
 (GbtCodeSize  newOn: Rolodex  ) 
 a GbtCodeSize: 1 Klassen; 51 LOC; 0 Variablen; 8 Methoden 

App LittleCompany + HelloWorld:
 (GbtCodeSize  newOnCategoryOf: Rolodex )  
 a GbtCodeSize: 4 Klassen; 133 LOC; 0 Variablen; 22 Methoden 

InsideTransport AppTests:
GbtCodeSize  newOnCategoryOf: GbtApplicationTest
 a GbtCodeSize: 4 Klassen; 641 LOC; 2 Variablen; 114 Methoden 

App EFA:
 (GbtCodeSize  newOnCategoryOf: EFA) 
 a GbtCodeSize: 15 Klassen; 1152 LOC; 0 Variablen; 108 Methoden 

App BuddyWallet:
 (GbtCodeSize  newOnCategoryOf: BuddyWallet )  
 a GbtCodeSize: 1 Klassen; 233 LOC; 0 Variablen; 32 Methoden 

App Forum:
 (GbtCodeSize  newOnCategoryOf: GbtForumA  )  
 a GbtCodeSize: 2 Klassen; 90 LOC; 0 Variablen; 12 Methoden 

!

!GbtCodeSize class methodsFor: 'instance creation' stamp: 'hk 5/6/2015 11:22'!
newOn: aClassOrCollectionOfClasses

	| size |
	(aClassOrCollectionOfClasses isCollection) 
		ifFalse: [^self new sizeOfClass: aClassOrCollectionOfClasses].
	size := self newOn: (aClassOrCollectionOfClasses first).
	aClassOrCollectionOfClasses allButFirst do: [:cls| size + (self newOn: cls)].
	^size! !

!GbtCodeSize class methodsFor: 'instance creation' stamp: 'hk 5/13/2010 14:48'!
newOnCategoryOf: aClass

	^self new sizeOfCategory: aClass! !

!GbtCodeSize class methodsFor: 'instance creation' stamp: 'hk 9/20/2016 12:31'!
newOnHierarchyOf: aClass
	^(self newOn: aClass) + (self new sizeOfSubclassesOf: aClass)! !

!GbtCodeSize methodsFor: 'arithmetic' stamp: 'hk 2/10/2015 13:25'!
+ anSvoCodeSize

	vars := vars + (anSvoCodeSize vars).
	methods  := methods + (anSvoCodeSize methods).
	loc := loc + (anSvoCodeSize loc).
	classes := classes + (anSvoCodeSize classes).! !

!GbtCodeSize methodsFor: 'arithmetic' stamp: 'hk 2/10/2015 13:25'!
- anSvoCodeSize

	vars := vars - (anSvoCodeSize vars).
	methods  := methods - (anSvoCodeSize methods).
	loc := loc - (anSvoCodeSize loc).
	classes := classes - (anSvoCodeSize classes).! !

!GbtCodeSize methodsFor: 'accessing' stamp: 'hk 5/10/2010 23:42'!
classes
	^classes! !

!GbtCodeSize methodsFor: 'initialization' stamp: 'hk 9/20/2016 11:31'!
initialize
	super initialize.
	loc := 0.
	vars := 0.
	methods := 0.
	classes := 0.
! !

!GbtCodeSize methodsFor: 'accessing' stamp: 'hk 5/10/2010 19:18'!
loc
	^loc! !

!GbtCodeSize methodsFor: 'accessing' stamp: 'hk 5/10/2010 19:17'!
methods
	^methods! !

!GbtCodeSize methodsFor: 'printing' stamp: 'hk 11/9/2016 15:14'!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: ': ';
		nextPutAll: classes printString, ' Klassen; ';
		nextPutAll: loc printString, ' LOC; ';
		nextPutAll: vars printString, ' Variablen; ';
		nextPutAll: methods printString, ' Methoden'
	! !

!GbtCodeSize methodsFor: 'initialization' stamp: 'hk 11/9/2016 13:30'!
sizeOfCategory: aClass

	(SystemOrganization listAtCategoryNamed: aClass category)
		do: [:cls | self + (self class newOn:(Smalltalk at: cls)) ].
! !

!GbtCodeSize methodsFor: 'initialization' stamp: 'hk 11/9/2016 14:47'!
sizeOfClass: aClass
	loc := aClass linesOfCode .  
	vars := ((aClass instVarNames size) + (aClass classVarNames size) + (aClass class instVarNames size)).
	methods := aClass numberOfMethods .
	classes := 1.! !

!GbtCodeSize methodsFor: 'initialization' stamp: 'hk 11/9/2016 13:30'!
sizeOfSubclassesOf: aClass

	aClass subclassesDo: [:cls |self + (self class newOn: cls)]! !

!GbtCodeSize methodsFor: 'accessing' stamp: 'hk 5/10/2010 19:17'!
vars
	^vars ! !

Object subclass: #GbtEvent
	uses: TGbtSerializer
	instanceVariableNames: 'msgType eventType sender receiver content replyContext external'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Messaging'!

!GbtEvent commentStamp: 'hk 12/7/2015 15:18' prior: 0!
I am an event / a message  in an ActiveService or in BizNet.

    Instance Variables
	content:		<ThingVO>
	msgType:	<String>		#request, #reply, #command, #notification
	eventType:	<String>		Thing userName
	receiver:		<String>		e.g. Company Name or BizNetId
	sender:		<String>		e.g. Company Name or BizNetId
	replyContext:<String>		(request, reply only)  local context userName
	external: 	<Boolean> !

GbtEvent class
	uses: TGbtSerializer classTrait
	instanceVariableNames: ''!

!GbtEvent class methodsFor: 'instance creation' stamp: 'hk 10/11/2016 16:37'!
command: aThing
	^self new 	
		content: aThing;
		msgType: #command;
		eventType: aThing svoName ! !

!GbtEvent class methodsFor: 'instance creation' stamp: 'hk 10/11/2016 16:37'!
notification: aThing
	^self new 	
		content: aThing;
		msgType: #notification;
		eventType: aThing svoName ! !

!GbtEvent class methodsFor: 'instance creation' stamp: 'hk 10/11/2016 16:37'!
request: aThing
	^self new 	
		content: aThing;
		msgType: #request;
		eventType: aThing svoName ! !

!GbtEvent class methodsFor: 'instance creation' stamp: 'hk 10/11/2016 16:37'!
response: aThing
	^self new 	
		content: aThing;
		msgType: #response;
		eventType: aThing svoName ! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
content
	^ content! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 3/27/2017 20:34'!
content: anObject
	content := anObject copyForSton! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
eventType
	^ eventType! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
eventType: anObject
	eventType := anObject! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 12/7/2015 15:18'!
external: aBoolean
	external := aBoolean ! !

!GbtEvent methodsFor: 'testing' stamp: 'hk 11/2/2016 15:26'!
isExternal
	^external ifNil: [false]! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
msgType
	^ msgType! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
msgType: anObject
	msgType := anObject! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
receiver
	^ receiver! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
receiver: anObject
	receiver := anObject! !

!GbtEvent methodsFor: 'save - retrieve - remove' stamp: 'hk 11/29/2016 16:49'!
registerWithStore
	"not for events"! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
replyContext
	^ replyContext! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
replyContext: anObject
	replyContext := anObject! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
sender
	^ sender! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
sender: anObject
	sender := anObject! !

Object subclass: #GbtEventQueue
	instanceVariableNames: 'queue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Messaging'!

!GbtEventQueue commentStamp: 'hk 10/25/2015 19:03' prior: 0!
I am the eventQueue of a context.
Preliminary I am implemented with an OrderedCollection!

!GbtEventQueue methodsFor: 'queue' stamp: 'hk 12/9/2015 12:20'!
forType: typeName do: aBlock 
	"execute and consume the event"
	| evt |
	evt := queue detect: [:ev | ev eventType = typeName] ifNone: [^self].
	aBlock value: evt.
	queue remove: evt! !

!GbtEventQueue methodsFor: 'initialization' stamp: 'hk 10/24/2015 16:56'!
initialize
	super initialize.
	queue :=	OrderedCollection new .
! !

!GbtEventQueue methodsFor: 'queue' stamp: 'hk 12/7/2015 15:16'!
push: aSVOEvent
	queue add: aSVOEvent .! !

Object subclass: #GbtLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Utilities'!

GbtLogger class
	instanceVariableNames: 'started indent tokenDict'!

!GbtLogger commentStamp: 'hk 4/30/2016 18:42' prior: 0!
I log to the transcript:
- with time
- allowing a log token
- and a log text
- and indenting the log!

GbtLogger class
	instanceVariableNames: 'started indent tokenDict'!

!GbtLogger class methodsFor: 'accessing' stamp: 'hk 1/11/2016 19:08'!
indent
	^indent ifNil: [indent := 0]! !

!GbtLogger class methodsFor: 'logging' stamp: 'hk 1/11/2016 19:11'!
log: aToken text: aStringOrArray
	| logArray |
	logArray := aStringOrArray isString ifTrue: [{aStringOrArray}] ifFalse: [aStringOrArray] .
	Transcript cr; show: Time now print24.
	self indent timesRepeat: [Transcript tab] .
	Transcript show: aToken; tab.
	logArray do: [ :s | Transcript show: s printString; tab].
! !

!GbtLogger class methodsFor: 'logging' stamp: 'hk 1/11/2016 19:07'!
logBegin: aToken text: aStringOrArray
	| nooft |
	started = true ifFalse: [ ^self ]. 
	nooft := (self tokenDict at: aToken ifAbsentPut: [0]).
	self tokenDict at: aToken put: nooft +1 .
	indent := self indent +1 .
	self log: 'BEGIN.',aToken text: aStringOrArray! !

!GbtLogger class methodsFor: 'logging' stamp: 'hk 11/1/2016 13:15'!
logEnd: aToken text: aStringOrArray
	| nooft |
	started = true ifFalse: [ ^self ]. 
	nooft := self tokenDict at: aToken ifAbsent: [^Transcript cr; show: 'error: no BEGIN of '; show: aToken].
	self tokenDict at: aToken put: nooft - 1 .
	self log: 'END ',aToken text: aStringOrArray.
	indent := self indent - 1 .! !

!GbtLogger class methodsFor: 'logging' stamp: 'hk 11/8/2016 17:26'!
start
	"SVOLogger start"
	self transcriptWindows ifEmpty:
		[Transcript open 
			setLabel: 'SVO LOG';
			extent: 600 @ 900].
	started := true.
	indent := 0.! !

!GbtLogger class methodsFor: 'logging' stamp: 'hk 11/1/2016 13:16'!
stop
	"SVOLogger stop"
	Transcript cr; show: Time now print24; tab; show: 'STOPPED, indent = '; show: indent asString .
	started := false! !

!GbtLogger class methodsFor: 'accessing' stamp: 'hk 1/11/2016 15:23'!
tokenDict
	^tokenDict ifNil: [tokenDict := Dictionary new]! !

!GbtLogger class methodsFor: 'accessing' stamp: 'hk 11/8/2016 17:24'!
transcriptWindows
	^SystemWindow allInstances select: [:w| w model isKindOf:  ThreadSafeTranscript ]! !

Object subclass: #GbtProgramStore
	instanceVariableNames: 'declaratives contexts fullThings policies thingCache tecNoPolicy reader mainCtxtName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-BizAppServer'!

!GbtProgramStore commentStamp: 'hk 3/22/2017 12:10' prior: 0!
I hold all artefacts generated by compiling a Gbt program and the thing Cache.
I am filled on compile and copied to the user BizApp on start of a user app.

    Instance Variables
	declaratives:		<Dictionary > 	svoName 	->  	GbtDeclarative
	contexts:		<Dictionary > 	svoName 	->  	GbtActiveContext 
	fullThings:		<Dictionary > 	svoName 	->  	GbtThing  (full things only)
	policies: 			<Dictionary > 	context svoName 	->  	 GbtNoPolicy  (filled by default)
	thingCache:		<Dictionary > 	svoName 	->  	Collection of GbtThing  by id and version
	tecNoPolicy: 		<GbtNoPolicy >	for the technical thing id
	reader: 			<GbtReader>		similar to a Datomic reader
	mainCtxtName: 	<String> 		svoName of main context (to be opened)!

!GbtProgramStore methodsFor: 'program store' stamp: 'hk 3/17/2017 20:01'!
add: anSVO full: aFullVO
	" Things only "
	(self thingsAt: anSVO svoName) addLast: anSVO.  
	fullThings at: aFullVO svoName 
		ifPresent: [self inform: aFullVO svoName, ' created again'] 
		ifAbsent: [fullThings at: aFullVO svoName put: aFullVO] 
! !

!GbtProgramStore methodsFor: 'program store' stamp: 'hk 3/24/2017 20:49'!
addAC: anAC 
	contexts at: anAC svoName ifPresent: 
		[self error: 'context exists'].		
	mainCtxtName  := anAC svoName. "the last entry wins"
	^contexts  at: anAC svoName put: anAC 
! !

!GbtProgramStore methodsFor: 'program store' stamp: 'hk 3/24/2017 20:49'!
addDecl: anSVO 
	declaratives at: anSVO svoName ifPresent: 
		[self error: 'declarative exists'].		
	^declaratives at: anSVO svoName put: anSVO 
! !

!GbtProgramStore methodsFor: 'program store' stamp: 'hk 3/15/2017 15:12'!
allContexts
	^contexts values asOrderedCollection! !

!GbtProgramStore methodsFor: 'template editor' stamp: 'hk 3/15/2017 15:21'!
allFsvosWithTemplates
	"answer all full things with templates for the template editor"
	^fullThings values
		select: [ :th | th slots anySatisfy: [ :a | a templates isNotEmpty ] ]! !

!GbtProgramStore methodsFor: 'program store' stamp: 'hk 3/21/2017 12:53'!
allThings
	^thingCache values flatCollect: #yourself as: OrderedCollection! !

!GbtProgramStore methodsFor: 'program store' stamp: 'hk 3/15/2017 15:13'!
contextNamed: anACname  ifAbsent: absentBlock
	^contexts at: anACname ifAbsent: [^absentBlock value].! !

!GbtProgramStore methodsFor: 'private' stamp: 'hk 3/15/2017 15:23'!
contextNoPolicyOf: anACname  
	^policies at: anACname ifAbsentPut: [GbtNoPolicy new]! !

!GbtProgramStore methodsFor: 'program store' stamp: 'hk 3/15/2017 15:19'!
declarativeNamed: aName ifAbsent: absentBlock
	^declaratives at: aName ifAbsent: [^absentBlock value]! !

!GbtProgramStore methodsFor: 'program store' stamp: 'hk 3/15/2017 15:22'!
fsvoEntry: aSvoName ifAbsent: aBlock
	^fullThings at: aSvoName ifAbsent: aBlock ! !

!GbtProgramStore methodsFor: 'initialization' stamp: 'hk 3/29/2017 15:21'!
initialize    
	contexts := Dictionary new: 4 .
	policies := Dictionary new: 4 .
	declaratives := Dictionary new: 4 .
	fullThings := Dictionary new: 4 .
	thingCache := Dictionary new: 4 .
	tecNoPolicy := GbtNoPolicy  new 	
		last: SmallInteger maxVal;
		yourself .
	reader := GbtReader new. 

! !

!GbtProgramStore methodsFor: 'accessing' stamp: 'hk 3/22/2017 12:07'!
mainCtxtName
	^mainCtxtName! !

!GbtProgramStore methodsFor: 'accessing' stamp: 'hk 3/21/2017 13:59'!
reader
	^reader  ! !

!GbtProgramStore methodsFor: 'analysis' stamp: 'hk 3/20/2017 12:49'!
rootFullThings
	"self rootFullThings"
	^(thingCache values flatCollect: [ :c | c collect: [:e|e fullThing]] as: Set)
		select: [:e| e isNotNil and: [e container isNil]]
	
! !

!GbtProgramStore methodsFor: 'analysis' stamp: 'hk 3/20/2017 12:51'!
selectedNodesInHierarchy
	"user selects one tree - or all "
	"self selectedNodesInHierarchy"
	| sel roots |
	roots := self rootFullThings asArray.
	sel := UIManager default 
				chooseFrom: (roots collect: [:e|e svoName]) 
				values:  roots 
				message: 'select a root full Thing or all'.
	sel ifNotNil: [roots := {sel}].
	^roots flatCollect: [:n| n allStructureNodes  ]! !

!GbtProgramStore methodsFor: 'accessing' stamp: 'hk 3/20/2017 17:41'!
tecNoPolicy
	^tecNoPolicy! !

!GbtProgramStore methodsFor: 'thing cache' stamp: 'hk 3/20/2017 12:42'!
thingDefinedAs: aName ifAbsent: absentBlock
	"answer the svo with aName = svoName:id-version or svoName(with lowest id-version)"

	|thingColl nm idv arr |
	nm := aName. 
	idv := nil.
	aName ifNotNil: 
		[arr := aName substrings: ':'.
		arr size > 1 ifTrue: 
			[nm := arr first.
			idv := arr second]].
	thingColl := (self thingsAt: nm) ifEmpty: [^absentBlock value].
	idv ifNil: [^thingColl first].		"^ the oldest one"
	^thingColl detect: [:e| e autoName = idv asSymbol] ifNone: [absentBlock value]
	! !

!GbtProgramStore methodsFor: 'initialization' stamp: 'hk 3/20/2017 12:27'!
thingsAt: aSvoName
	^thingCache at: aSvoName ifAbsentPut: [OrderedCollection new]! !

!GbtProgramStore methodsFor: 'thing cache' stamp: 'hk 3/20/2017 12:41'!
withBizId: aBizId
	"answer the thing with aBizId and the highest version"
	|coll|
	coll := OrderedCollection new. 
	thingCache valuesDo: [:c| coll addAll: (c select: [:e| e bizId = aBizId])]. 
	^coll 
		ifEmpty: [nil] 
		ifNotEmpty: [(coll sorted: [:a :b | b version <= a version]) first] .
! !

Object subclass: #GbtReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-BizApp'!

!GbtReader commentStamp: 'hk 2/6/2017 20:11' prior: 0!
I am the reader for Things - similar to Datomic reader.
reading does not interfere with  transactions (writing))
!

!GbtReader methodsFor: 'private' stamp: 'hk 2/26/2017 13:50'!
lineThingFrom: aCollOfLongNames
	"the first name is name of the root thing"
	| nodes|  
	nodes := aCollOfLongNames collect: [:sn| self loadNode: sn].
	self resolve: nodes first with: nodes allButFirst .
	^nodes first buildContainerHierarchy
	! !

!GbtReader methodsFor: 'api' stamp: 'hk 3/21/2017 13:57'!
loadList: svoName 
	"load all most recent versions from the subFolders of folder userName"
	| dir all rootMap|
	dir := (GbtBizAppServer thingsDir / svoName) ensureCreateDirectory.
	rootMap := GbtBizAppServer rootMapOf: dir.
	all := rootMap lines values collect: [:line| self lineThingFrom: line asOrderedCollection]. 
	^all reject: [:th| th deleted]
! !

!GbtReader methodsFor: 'private' stamp: 'hk 2/5/2017 14:30'!
loadNode: longName
	"load all most recent versions from the subFolders of folder userName"
	^self loadNode: (GbtRootMap svoNameOf: longName) 
			id: (GbtRootMap classInitialAndIdOf: longName) 
			version: (GbtRootMap versionOf: longName)! !

!GbtReader methodsFor: 'private' stamp: 'hk 3/21/2017 13:56'!
loadNode: svoName id: aClassInitialAndId version: aVersionString
	"basic load all most recent versions from the subFolders of folder userName"
	| dir file|
	dir := (GbtBizAppServer thingsDir / svoName / aClassInitialAndId) 
					ensureCreateDirectory.
	(file := dir / aVersionString) asFileReference exists ifFalse: 
		[^self error: svoName, ':', aClassInitialAndId, aVersionString, ' not found' ].
	^GbtThing fromString: file readStream contents
! !

!GbtReader methodsFor: 'private' stamp: 'hk 2/17/2017 16:02'!
resolve: aThing with: aCollOfNodes
	aCollOfNodes ifEmpty: [^self].  
	aThing slotNames do: [:sn| |longName |
		longName := aThing slotSVOAt: sn.                 
		aCollOfNodes 
			detect:  [:n| n longName = longName]
			ifFound: [:n| 			"do not set dirty"
						(aThing slotAt: sn) value: n.	
						self resolve: n with: (aCollOfNodes copy remove: n; yourself)]]
! !

Object subclass: #GbtRole
	instanceVariableNames: 'read write execute filter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Contexts'!

!GbtRole commentStamp: 'hk 1/4/2017 17:03' prior: 0!
I represent a group of  rights and filters for various contexts.
I am associated to a user such that a context on regristration will receive a GbtRight.


    Instance Variables
	filter:		<Dictionary> 				of ACname ->  FilterThing,  e.g. for filtering lists
	read: 		<Collection  of Symbol> 	the AC's svoNames
	write: 		<Collection  of Symbol> 	special symbols are 
	execute: 	<Collection  of Symbol> 	#all   and  #none!

GbtRole subclass: #GbtRight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Contexts'!

!GbtRight commentStamp: 'hk 11/22/2016 21:19' prior: 0!
I represent the  rights and filters for a context's user.

 Instance Variables redefined
	filters:		<GbtThing| nil> 		the filterThing, e.g. for filtering lists
	read: 		<Boolean> 		
	write: 		<Boolean> 		
	execute: 	<Boolean> 		
Accessors of the superclass are used!

!GbtRight methodsFor: 'accessing' stamp: 'hk 1/4/2017 17:05'!
allowedSubColl: aCollOfThing
	^aCollOfThing select: [:th| self allows: th]! !

!GbtRight methodsFor: 'accessing' stamp: 'hk 1/4/2017 18:28'!
allows: aThing
	"true, false or nil in case of error"    
	^aThing testWith: filter ! !

!GbtRight methodsFor: 'accessing' stamp: 'hk 11/22/2016 09:45'!
execute
	^execute ! !

!GbtRight methodsFor: 'accessing' stamp: 'hk 1/4/2017 17:03'!
filterThing: aFilterThing
	filter := aFilterThing ! !

!GbtRight methodsFor: 'initialization' stamp: 'hk 11/22/2016 21:19'!
initialize
	read := true.
	write := true.
	execute := true.
! !

!GbtRight methodsFor: 'accessing' stamp: 'hk 11/22/2016 09:45'!
read
	^read ! !

!GbtRight methodsFor: 'accessing' stamp: 'hk 11/22/2016 09:45'!
write
	^write ! !

!GbtRole class methodsFor: 'instance creation' stamp: 'hk 11/21/2016 16:54'!
forExecute
	^self new ! !

!GbtRole class methodsFor: 'instance creation' stamp: 'hk 11/21/2016 16:56'!
forRead
	^self new writeNone! !

!GbtRole class methodsFor: 'instance creation' stamp: 'hk 11/21/2016 17:12'!
forRead: coll1 
	^self forRead: coll1 write: #() 
! !

!GbtRole class methodsFor: 'instance creation' stamp: 'hk 11/21/2016 17:11'!
forRead: coll1 write: coll2 
	^self forRead: coll1 write: coll2 execute: #()
! !

!GbtRole class methodsFor: 'instance creation' stamp: 'hk 11/21/2016 17:10'!
forRead: coll1 write: coll2 execute: execColl
	| writeColl readColl |
	(writeColl := coll2 asSet) addAll: execColl.
	(readColl := coll1 asSet) addAll: writeColl.
	^self new 
		read: readColl;
		write: writeColl;
		execute: execColl;
		yourself! !

!GbtRole class methodsFor: 'instance creation' stamp: 'hk 11/21/2016 16:55'!
forWrite
	^self new executeNone! !

!GbtRole class methodsFor: 'instance creation' stamp: 'hk 11/21/2016 17:12'!
forWrite: coll1 
	^self forRead: coll1 write: coll1
! !

!GbtRole methodsFor: 'api' stamp: 'hk 1/4/2017 17:03'!
addFilter: aStringWithTags for: anACname
	| filterThing key |
	filterThing := filter at: anACname 
		ifAbsentPut: [GbtThing basicNew initialize].
	key := (filterThing slots size +1) asString asSymbol.
	filterThing	define: key constraint: aStringWithTags! !

!GbtRole methodsFor: 'accessing' stamp: 'hk 11/21/2016 17:04'!
execute: aCollOfACnames
	execute := aCollOfACnames! !

!GbtRole methodsFor: 'accessing' stamp: 'hk 11/21/2016 16:55'!
executeNone
	execute := #(none)! !

!GbtRole methodsFor: 'initialization' stamp: 'hk 1/4/2017 17:03'!
initialize
	read := #(#all).
	write := #(all).
	execute := #(all).
	filter := Dictionary new.! !

!GbtRole methodsFor: 'testing' stamp: 'hk 11/21/2016 16:53'!
mayExecute: anACname
	^(execute includes: #all) 
		or: [execute includes: anACname]! !

!GbtRole methodsFor: 'testing' stamp: 'hk 11/21/2016 16:52'!
mayRead: anACname
	^(self mayWrite: anACname) or: 
		[(read includes: #all) 
			or: [read includes: anACname]]! !

!GbtRole methodsFor: 'testing' stamp: 'hk 11/21/2016 16:53'!
mayWrite: anACname
	^(self mayExecute: anACname) or: 
		[(write includes: #all) 
			or: [write includes: anACname]]! !

!GbtRole methodsFor: 'accessing' stamp: 'hk 11/21/2016 17:03'!
read: aCollOfACnames
	read := aCollOfACnames! !

!GbtRole methodsFor: 'accessing' stamp: 'hk 11/21/2016 16:56'!
readNone
	self writeNone.
	read := #(none)! !

!GbtRole methodsFor: 'api' stamp: 'hk 1/4/2017 17:03'!
rightOf: anACname
	^GbtRight new  
		execute: (self mayExecute: anACname);
		write: (self mayWrite: anACname) ;
		read: (self mayRead: anACname) ;
		filterThing: (filter at: anACname ifAbsent: [])
		! !

!GbtRole methodsFor: 'accessing' stamp: 'hk 11/21/2016 17:03'!
write: aCollOfACnames
	write := aCollOfACnames! !

!GbtRole methodsFor: 'accessing' stamp: 'hk 11/21/2016 16:56'!
writeNone
	self executeNone.
	write := #(none)! !

Object subclass: #GbtRootMap
	uses: TGbtAccessSerialized
	instanceVariableNames: 'lines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-BizAppServer'!

!GbtRootMap commentStamp: 'hk 2/6/2017 20:21' prior: 0!
I represent a rootMap file in a GbtStore.
The rootMap file declares the newest versions of all rootThings of a given svoName.
I am  used to update the rootMap file in a write transaction and to read all parts of the current  thing in a retrieval.
I may be  created by reading the file; then I'm updated and I am written to the file  .
This file is organized as one line per rootThing.
Each line starts with the longName of the root thing, followed by all node longNames.


    Instance Variables
	lines:		<Dictionary> 		of classInitialAndId  -> Coll of longNames
!

GbtRootMap class
	uses: TGbtAccessSerialized classTrait
	instanceVariableNames: ''!

!GbtRootMap class methodsFor: 'instance creation' stamp: 'hk 1/27/2017 15:20'!
fromString: aMultiLineString
	^self new fromString: aMultiLineString ! !

!GbtRootMap methodsFor: 'adding' stamp: 'hk 3/21/2017 17:27'!
addRoot: aPathOfSerializedThings
	"update the line for aPathOfThings"
	| key newValues oldValues |
	key := (self classInitialAndIdOf: aPathOfSerializedThings first) asSymbol.
	newValues := aPathOfSerializedThings collect: [:sn| self longNameOf: sn].
	oldValues := (lines at: key ifAbsent: [#(dummy)]) allButFirst. 
	lines at: key put: (self merge: oldValues into: newValues)
	! !

!GbtRootMap methodsFor: 'accessing' stamp: 'hk 1/30/2017 14:30'!
at: aKey
	"answer the line for key aKey"
	^lines at: aKey ! !

!GbtRootMap methodsFor: 'accessing serialized node' stamp: ''!
classInitialAndIdOf: aSerializedNode 
	"aSerializedNode classInitialAndId "
	| searchString |
	searchString := '#id\s\:\s\''(\w+)\''\,'.
	^ 'T',	((searchString asRegex search: aSerializedNode; yourself) subexpression: 2) ! !

!GbtRootMap methodsFor: 'reading' stamp: 'hk 1/30/2017 15:08'!
fromString: aMultiLineString
	"read the file content"
	aMultiLineString linesDo: [:line|  |words|
		words := line substrings.
		lines at: (self class classInitialAndIdOf: words first) put: words]
	! !

!GbtRootMap methodsFor: 'initialization' stamp: 'hk 1/30/2017 14:13'!
initialize
	lines := OrderedIdentityDictionary new! !

!GbtRootMap methodsFor: 'accessing' stamp: 'hk 1/30/2017 14:28'!
keys
	^lines keys ! !

!GbtRootMap methodsFor: 'accessing' stamp: 'hk 1/28/2017 12:39'!
lines
	^ lines! !

!GbtRootMap methodsFor: 'accessing serialized node' stamp: ''!
longNameOf: aSerializedNode
	"aSerializedNode longName"
	^(self svoNameOf: aSerializedNode), ':', (self classInitialAndIdOf: aSerializedNode), (self versionStringOf: aSerializedNode)! !

!GbtRootMap methodsFor: 'adding' stamp: 'hk 1/30/2017 15:20'!
merge: oldValues into: newValues
	"keep all old values whose classInitialAndId is NOT replaced by a new value
	the long name of the root thing remains in first place"
	| res ciids |
	res := newValues.
	ciids := newValues collect: [ :nv| self class classInitialAndIdOf: nv ].
	oldValues do: [:ov| 
		(ciids includes: (self class classInitialAndIdOf: ov))
			ifFalse: [ res add: ov ] ].
	^res
	
	

	! !

!GbtRootMap methodsFor: 'accessing serialized node' stamp: ''!
svoNameOf: aSerializedNode
	"aSerializedNode svoName"
	^('#svoName\s\:\s[''|#](\w+)' asRegex search: aSerializedNode; yourself) subexpression: 2 ! !

!GbtRootMap methodsFor: 'writing' stamp: 'hk 1/30/2017 13:38'!
toString
	"create the file content"
	| str |
	str := WriteStream with: ''.
	lines keysAndValuesDo: [:k :v|  
		v do: [:e| str nextPutAll: e; ensureASpace].
		str cr	].
	^str contents
	
	! !

!GbtRootMap methodsFor: 'accessing serialized node' stamp: ''!
versionStringOf: aSerializedNode 
	"aSerializedNode versionString"
	^ 'v',	(('#version\s\:\s([0-9]+)' asRegex search: aSerializedNode; yourself) subexpression: 2)! !

Object subclass: #GbtSVO
	instanceVariableNames: 'version id container dataPending dirty previous bizApp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-core'!

GbtSVO class
	instanceVariableNames: 'lastID'!

!GbtSVO commentStamp: 'hk 3/17/2017 12:00' prior: 0!
I am an abstract Smart Value Object, domain as well as program objects. 

My names consists of 2 parts separated by a colon: 
1.  svoName (or 'default' ) .  
2. The autoName is technical and consists of Id and version
     Id starts with (T,  U , D ,  L,  P,  B,  AC) for Thing, Ulist, Declarative, Leaf, Policy, Behavior, pushActiveContext 
     followed by a running integer
     version (starts with a 'v' followed by a running integer'

This way it is easy to select: 
- a specific VO (instance) 
- all VO with a given svoName 
- the actual VO of a given userName with the lowest id (i.e. the mother of all copies) 
- etc.

class instance variables: 
	lastID: 			<SmallInteger>				initialize to 0 
	asvoDict: 		<Dictionary of OrderedColl> 	by svoName & autoName

Instance Variables
	app:			<GbtBizApp>			the application I am part of
	container:		<GbtSVO | nil>		used in hierarchies
	id:				<Integer>			unique for instances of class
	version:			<Integer>			starting at '0'
	dataPending: 	<NewValueHolder> 	on true or false	
	dirty: 			<NewValueHolder|nil> 	on true or false	!

GbtSVO class
	instanceVariableNames: 'lastID'!

GbtSVO subclass: #GbtActiveContext
	instanceVariableNames: 'uiSpec displayName uiKey targetSlotname menuBehaviors choiceContext createBehaviors ui constraintBehaviors eventQueue receiveBehaviors choiceSlot behaviors voChange pool choiceDict displayColumns loadPolicy loaded saveBehaviors editBehaviors removeBehaviors svoName user templates noPolicy userRight extent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Contexts'!

!GbtActiveContext commentStamp: 'hk 3/17/2017 12:00' prior: 0!
I am a ACM Case Folder or DCI Context.
My pool things constitute dynamic context data.

I am normally not copied .

Instance Variables
	svoName:			<String>					semantic part of name
	displayName: 		<String>					for the GUI
	displayColumns: 		<Array of Symbol>		for display in lists
	ui:					<GbtUI>					my UISpecModel 
	uiSpec:				<Symbol>				my Spec class name
	uiKey:				<Symbol>				key for Spec & Icon lookup
	targetSlotname: 		<Symbol>				slot of the container vo for subcontext 	
	pool: 				<OrderedCollection of GbtThing>		
	eventQueue:			<GbtEventQueue>		the FIFO queue of events
	policy: 				<GbtDefaultPolicy|nil> 	for bizId
my behaviors						
	behaviors: 			<Dictionary of Symbol -> GbtBehavior>
	menuBehaviors: 		<Dictionary of #menu -> #submenus>
	saveBehaviors:		<OrderedCollection of Symbol> 	executed on save of vo
	deleteBehaviors:		<OrderedCollection of Symbol> 	executed on delete of vo
	editBehaviors:		<OrderedCollection of Symbol> 	executed on edit of vo
	receiveBehaviors:	<OrderedCollection of Symbol> 	executed on receive of an event
	createBehaviors:		<OrderedCollection of Symbol> 
	constraintBehaviors:	<OrderedCollection of Symbol>
for choice in Ulists of Things								
	choiceContext: 		<AcList>					from which to choose an  element
 	extent: 				<Point> 					extent for ui  window
	choiceSlot:			<Symbol> 				for which to choose an  element
	voChange: 			<#addOnly | #addyRemove | #none | nil>
for choice of vo of subcontext				
	choiceDict:			<IdentityDictionary> 		of slot -> {nil | Symbol | Declarative . Context} 
	loadPolicy: 			<Symbol>				autoload simpleload filterload
	loaded: 				<Boolean>				vo or list loaded from db
	user: 				<String>					name of user
	userRight: 			<GbtRight>				rights  of user 
													
the inherited elder slot is used:
	container:									embedding context!

GbtActiveContext subclass: #GbtAbstractListAC
	instanceVariableNames: 'subcontext filterSlots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Contexts'!

!GbtAbstractListAC commentStamp: 'hk 1/12/2017 12:36' prior: 0!
I am an abstract  list context.
AcPlain is the subContexts for any copy.

Instance Variables
	subcontext:		<AcPlain>				context of a list item
	filterSlots: 		<Collection of String> 		!

!GbtAbstractListAC methodsFor: 'private' stamp: 'hk 12/5/2016 19:57'!
addToList: aThing
	self subclassResponsibility ! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 2/14/2017 20:40'!
checkDirty
	self list detect: [ :sc | sc hasDataPending ] ifNone: [ self setDataNotPending ].
	 container ifNotNil: [:c|c checkDirty]
! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 11/30/2016 12:03'!
deleteListElement: aVO
	^self subclassResponsibility 
	! !

!GbtAbstractListAC methodsFor: 'accessing' stamp: 'hk 1/13/2017 15:54'!
displayColumns
	^displayColumns ifNil: [#()]! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 10/16/2015 20:08'!
doConstraints
	"no constraints in list contexts"! !

!GbtAbstractListAC methodsFor: 'authoring' stamp: 'hk 1/12/2017 18:18'!
filterBy:	 oneOrMoreSlotName
	"creates a filter for each given slot"
	
	filterSlots := self checkStringMakeColl: oneOrMoreSlotName. 
! !

!GbtAbstractListAC methodsFor: 'accessing' stamp: 'hk 1/12/2017 12:38'!
filterSlots
	^filterSlots ifNil: [^#()]
! !

!GbtAbstractListAC methodsFor: 'accessing' stamp: 'hk 1/23/2017 13:04'!
filteredListfrom: aString
	"use the St String pattern matcher to answer a part of my list"
	aString ifEmpty: [^self getList] .
	^self getList select: [:elem| elem contains: '*',aString,'*']
! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 1/23/2017 13:02'!
getList
	^self list! !

!GbtAbstractListAC methodsFor: 'testing' stamp: 'hk 1/5/2017 14:09'!
hasSubcontext
	^subcontext isNotNil! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 3/2/2017 16:07'!
hasTxThing: aSymbol
	^false! !

!GbtAbstractListAC methodsFor: 'testing' stamp: 'hk 9/15/2015 17:10'!
isListAc
	^true! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 9/17/2015 12:30'!
list
	^self subclassResponsibility ! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 11/2/2016 15:56'!
newEntry
	self subclassResponsibility ! !

!GbtAbstractListAC methodsFor: 'authoring' stamp: 'hk 1/4/2017 12:07'!
newEntry: aThing   
	self addToList: (aThing context: self; ensureBizId). 
	ui ifNotNil: [ui resetList].
	^aThing! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 12/5/2016 19:59'!
newEntrySelect
	| res |
	res := self newEntry. 
	self uiSelection: res.
	^res! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 2/15/2017 15:37'!
newEntrySelect: aThing   
	self newEntry: aThing.
	self uiSelection: aThing.
	^aThing
! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 2/17/2017 16:24'!
newEntryWithChoice: aSelectedThing   
	^self newEntry slotExpandAt: choiceSlot put: aSelectedThing copy ensureBizId

! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 1/5/2016 14:33'!
processWithBizId: identifier
	"find the list element whose bizId matches the identifier"

	|  process new |
	process := self list detect: [:e| identifier = e bizId ] ifNone: [].
	new := process ifNil: [process := self newEntry. true ] ifNotNil: [false]	.
	^Array with: process with: new
! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 8/9/2016 11:31'!
refreshUI
	ui refresh.
	self subcontext refreshUI! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 2/1/2016 14:31'!
setUlistTemplates
	"take the authored template and assign it to the UlistVO"
! !

!GbtAbstractListAC methodsFor: 'accessing' stamp: 'hk 8/19/2015 15:36'!
subcontext
	^subcontext! !

!GbtAbstractListAC methodsFor: 'authoring' stamp: 'hk 5/11/2016 14:19'!
subcontext:	aCfPlainVO
	"tell the context for my list elements"
	
	self check: [ aCfPlainVO isKindOf: GbtPlainAC ] toBe: #aCfPlainVO .
	
	aCfPlainVO  container: self .
	subcontext :=	aCfPlainVO! !

!GbtAbstractListAC methodsFor: 'accessing' stamp: 'hk 10/27/2015 14:42'!
template
	^self subclassResponsibility ! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 11/30/2016 12:24'!
uiSelection
	^(ui ifNil: [^nil]) selection! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 2/15/2017 15:53'!
uiSelection: anItem   
	(ui ifNil: [^self]) setSelection: anItem.! !

!GbtAbstractListAC methodsFor: 'accessing' stamp: 'hk 1/12/2017 19:25'!
valuesOf: aFilterSlotName
	^(self list collect: [:e| [e perform: aFilterSlotName] ifError: []] as: Set) asArray
! !

GbtAbstractListAC subclass: #GbtBigListAC
	instanceVariableNames: 'list userAdds userChanges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Contexts'!

!GbtBigListAC commentStamp: 'hk 12/9/2016 19:38' prior: 0!
I am bound to a big list, represented by the copies of my asvo.


Instance Variables
	templates:		<Coll of GbtThing | nil>			filled in authoring or by user
	list: 				<OrderedCollection of GbtThing>	sort by bizId ?
	userAdds  		<OrderedCollection of GbtThing> 	added by other users
	userChanges		<OrderedCollection of Pair> 		of newThing (version) & oldThing (version))
										
================TODOs================
template-Semantik unklar:
- nicht obligatorisch
- aber erforderlich für newEntry und retrieval (thingName)
- mehrere templates für Menüs !!?    -    das erforderliche 1. Template taucht dann in den Menüs auf ...
- templates können hinzugefügt werden, was ist der Effekt?
- Identifikation über Namen oder summary oder ...
!

!GbtBigListAC methodsFor: 'private' stamp: 'hk 12/13/2016 17:25'!
addToList: aThing
	^self list add: aThing! !

!GbtBigListAC methodsFor: 'api' stamp: 'hk 1/9/2017 15:49'!
deleteListElement: aVO
	"remove my list element aVO"
	self removeHook: aVO.
	^aVO delete! !

!GbtBigListAC methodsFor: 'api' stamp: 'hk 1/23/2017 13:03'!
getList
	^list reject: [:e| e deleted]! !

!GbtBigListAC methodsFor: 'initialization' stamp: 'hk 7/21/2016 17:33'!
initialize
	super initialize.
	list := OrderedCollection new! !

!GbtBigListAC methodsFor: 'testing' stamp: 'hk 11/2/2016 16:13'!
isBigListAc
	^true! !

!GbtBigListAC methodsFor: 'api' stamp: 'hk 7/21/2016 17:37'!
list
	^list! !

!GbtBigListAC methodsFor: 'api' stamp: 'hk 3/17/2017 12:13'!
loadAll 
	|theList| 
	loaded ifNotNil: [ ^self ].
	self template ifNil: [^self].  
	theList := self userRight allowedSubColl: (self bizApp loadList: self template svoName).
	theList do: [ :e| self newEntry: e ]. 
	loaded := true
! !

!GbtBigListAC methodsFor: 'api' stamp: 'hk 12/5/2016 17:00'!
newEntry
	^self newEntry: self template copy 
! !

!GbtBigListAC methodsFor: 'private' stamp: 'hk 1/5/2017 12:04'!
newMarkedEntry: aThing
	"make a new entry, copy aThing's data, and mark it"
	self newEntry: aThing .
	aThing setOtherUserEdits: true! !

!GbtBigListAC methodsFor: 'private' stamp: 'hk 12/2/2016 14:26'!
replace: oldThing by: newThing   
	| i |
	i := list indexOf: oldThing ifAbsent: [^oldThing ].
	newThing context: self; ensureBizId.
	^list at: i put: newThing
! !

!GbtBigListAC methodsFor: 'private' stamp: 'hk 1/5/2017 13:46'!
replaceBigThing: oldThing by: newThing
	"check if subcontexts hold oldThing, too"
	oldThing id = newThing id ifFalse: [^self].
	oldThing version < newThing version ifFalse: [^self].
	self uiSelection = oldThing 
		ifTrue: [self uiSelection: newThing].
	self replace: oldThing by: newThing . 
	newThing setOtherUserEdits: true.	"this updates the GUI"
! !

!GbtBigListAC methodsFor: 'analysing' stamp: 'hk 10/11/2016 16:37'!
rtAttributes
	| arr |
	arr := OrderedCollection 
		with: 'template: ', (self template  ifNil: '' ifNotNil: [self template svoName]) 
		with: 'list size = ', list size printString.
	arr addAll: super rtAttributes.
	^arr  ! !

!GbtBigListAC methodsFor: 'accessing' stamp: 'hk 10/25/2016 15:55'!
template
	^(templates ifNil: [^nil]) first! !

!GbtBigListAC methodsFor: 'accessing' stamp: 'hk 8/5/2016 18:52'!
templates
	^templates ifNil: [templates := OrderedCollection new]! !

!GbtBigListAC methodsFor: 'authoring' stamp: 'hk 1/12/2017 12:27'!
templates: oneOrMoreThings
	"tell the templates "

	templates := self checkThingMakeColl: oneOrMoreThings .
! !

!GbtBigListAC methodsFor: 'api' stamp: 'hk 3/25/2017 14:07'!
updateBigThing: aThing
	"aThing is new in self list or is a new version of a list element"
	| oldThing |   
	oldThing := self list detect: 
		[:elem| elem svoName = aThing svoName and: [elem id = aThing id]] ifNone: [].
	aThing context: self.
	aThing bizApp: self bizApp.
	oldThing 
		ifNil: [self newMarkedEntry: aThing]
		ifNotNil: [self replaceBigThing: oldThing by: aThing]
! !

GbtAbstractListAC subclass: #GbtUlistAC
	instanceVariableNames: 'uListSlotname template'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Contexts'!

!GbtUlistAC commentStamp: 'hk 6/27/2016 18:46' prior: 0!
I am bound to a little list, represented by a UlistVO and its template.

Instance Variables
	uListSlotname: 	<String>			slotname of uList in container  vo
	template:		<GbtThing>		from which to draw a copy
!

!GbtUlistAC methodsFor: 'private' stamp: 'hk 12/13/2016 17:25'!
addToList: aThing     
	^self uList newEntry: aThing! !

!GbtUlistAC methodsFor: 'api' stamp: 'hk 2/17/2017 15:59'!
deleteListElement: aVO
	"remove my list element aVO"
	self removeHook: aVO.
	^self uList removeSlot: aVO .
	! !

!GbtUlistAC methodsFor: 'api' stamp: 'hk 2/1/2016 15:14'!
list
	^self uList list
			! !

!GbtUlistAC methodsFor: 'api' stamp: 'hk 12/5/2016 17:04'!
newEntry
	^self newEntry: template copy ! !

!GbtUlistAC methodsFor: 'analyzing' stamp: 'hk 8/30/2015 12:46'!
rtAttributes
	^Array with: ('list: ', #aUlist ) withAll: super rtAttributes   ! !

!GbtUlistAC methodsFor: 'api' stamp: 'hk 1/21/2017 15:21'!
setUlistTemplates
	"take the authored templates and assign it to the UlistVO"

	(self uList ifNil: [^self error: self svoName, ' cannot find list slot in container vo']) templates: template
			! !

!GbtUlistAC methodsFor: 'accessing' stamp: 'hk 10/27/2015 14:41'!
template
	^template! !

!GbtUlistAC methodsFor: 'authoring' stamp: 'hk 8/19/2015 14:12'!
template: aThing for: slotName
	"tell the slotName that holds my list"
	
	self check: [ slotName isSymbol] toBe: #aSymbol.
	self check: [ aThing isNode] toBe: #aThing.
	
	template := aThing .
	uListSlotname := slotName
	! !

!GbtUlistAC methodsFor: 'accessing' stamp: 'hk 8/11/2016 17:12'!
templates
	^template asOrderedCollection ! !

!GbtUlistAC methodsFor: 'accessing' stamp: 'hk 2/17/2017 15:50'!
uList
	"my container is a plain context, I represent the aspect uListSlotname"
	
	^(container vo ifNil: [self error: self svoName, ' no container vo'  ]) slotSVOAt: uListSlotname 
			! !

!GbtActiveContext class methodsFor: 'depricated' stamp: 'hk 11/8/2016 09:53'!
definedAs: aName 
	^self shouldNotImplement ! !

!GbtActiveContext class methodsFor: 'depricated' stamp: 'hk 3/21/2017 17:49'!
definedAs: aName for: userName 
	^(GbtBizAppServer default appAt: userName) contextNamed: aName ! !

!GbtActiveContext class methodsFor: 'depricated' stamp: 'hk 3/21/2017 16:10'!
new: aString define: definitionArray
	^(GbtBizAppServer default) addAC: (self basicNew 
		svoName: aString ; 
		initialize; 
		setID; 
		defineFrom: definitionArray)
		! !

!GbtActiveContext class methodsFor: 'depricated' stamp: 'hk 3/21/2017 16:15'!
struct: aString define: definitionArray
	"answer the context typed aString. If new, define it. do not make a copy"
	
	^(GbtBizAppServer default) contextNamed: aString ifAbsent: [self new: aString define: definitionArray]  
		! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 12/16/2016 14:18'!
addPoolThing: aGbtThing
	self poolThings add: aGbtThing! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 12/13/2016 14:04'!
allPoolThings
	"answer all GbtThings from the pool
	include pools of all contexts above"
	
	|res|
	res := self poolThings copy.
	self isContainerRoot ifFalse: [res addAll: self container allPoolThings].
	^res! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 11/2/2016 15:30'!
allowsAdd
	^voChange = #addOnly | (voChange = #addyRemove)! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 2/27/2016 16:22'!
allowsAspectChoice
	^choiceContext isNotNil & choiceSlot isNotNil! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 2/25/2016 15:19'!
allowsChoice
	^choiceContext isNotNil! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 2/25/2016 15:18'!
allowsRemove
	^voChange = #addyRemove! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 12/18/2016 11:58'!
behavior: aGbtBehavior
	self check: [ aGbtBehavior isKindOf: GbtBehavior ] toBe: #aGbtBehavior.
	
	behaviors add: aGbtBehavior actionName -> (aGbtBehavior  container: self)! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 8/8/2016 14:21'!
behavior: aName actions: definitionArray
	"tell a behavior "

	self behavior: aName arguments: #() actions: definitionArray! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 12/18/2016 12:12'!
behavior: aName arguments: argArray actions: definitionArray
	"tell a behavior "
	
	self behavior: (GbtBehavior newStruct: aName arguments: argArray define: definitionArray) ! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 8/9/2016 12:02'!
behavior: aName reuse: oldName modify: definitionArray 
	"reuse a behavior "
	| oldBeh newBeh |
	self check: [ aName isString ] toBe: #aString .
	self check: [ oldName isString ] toBe: #aString .
	self check: [ definitionArray isArray ] toBe: #anArray .
	self check: [ (oldBeh := behaviors at: oldName) isKindOf: GbtBehavior ] toBe: #aBehavior .
	
	newBeh := oldBeh copy rename: aName modify: definitionArray.
	behaviors add: aName -> (newBeh container: self)! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/9/2016 13:00'!
behaviors
	"not the constraints"
	^behaviors reject: [:e| (e isGbtConstraint) ]! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 11/9/2016 13:07'!
checkDirty
	self subclassResponsibility ! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 6/9/2015 12:52'!
choiceContext
	^choiceContext ! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 6/14/2016 15:05'!
choiceContextAt: aSlotName ifAbsent: absentBlock
	"answer the context to choose a thing"
	^self choiceDict at: aSlotName ifAbsent: absentBlock! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 6/13/2016 11:27'!
choiceDict
	^choiceDict ifNil: [ choiceDict := IdentityDictionary new ]! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 2/25/2016 15:20'!
choiceSlot
	^ choiceSlot! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 2/27/2016 14:54'!
chooseFor: aSlotName 
	"aSlotName is the slot to which the view transformed selection will be attached"
	self check: [ aSlotName isSymbol ] toBe: #aSymbol.
	
	choiceSlot := aSlotName! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 12/14/2016 12:06'!
chooseFor: aSlotName from: aChoiceContext 
	"aSlotName is the slot to which the selection will be attached"
	
	self chooseFor: aSlotName use: nil from: aChoiceContext ! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 12/14/2016 12:59'!
chooseFor: aSlotName use: aDeclarativeOrSymbol from: aChoiceContext 
	"aSlotName shall be filled 
	- either with the value of the chosen things slot named aDeclarativeOrSymbol  
	- or with the chosen thing transformed by the Declarative aDeclarativeOrSymbol
	- or with the chosen thing itself (when aDeclarativeOrSymbol isNil) "
	
	self check: [aDeclarativeOrSymbol isNil or: [aDeclarativeOrSymbol isSymbol or: [aDeclarativeOrSymbol isKindOf: GbtDeclarative]]] toBe: #aDeclarativeOrSymbol.
	self check: [ aSlotName isSymbol ] toBe: #aSymbol.
	self check: [aChoiceContext isKindOf: GbtAbstractListAC] toBe: #aListContext.
	
	self choiceDict add: aSlotName -> {aDeclarativeOrSymbol . aChoiceContext}! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 5/11/2016 14:19'!
chooseWith: aChoiceContext 
	"tell the context and herewith editor used to choose new content"
	self check: [aChoiceContext isKindOf: GbtAbstractListAC] toBe: #aListContext.
	
	choiceContext := aChoiceContext.
! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 6/22/2016 16:16'!
classInitial
	^#AC! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 6/3/2016 14:33'!
constraint: aName left: definitionArray right: anotherArray
	"tell a behavior "
	self check: [ aName isString ] toBe: #aString .
	self check: [ definitionArray isArray ] toBe: #anArray .
	self check: [ anotherArray isArray ] toBe: #anArray .
	
	behaviors add: aName -> ((GbtConstraint new defineLeft: definitionArray right: anotherArray named: aName) container: self)
! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/9/2016 13:00'!
constraints

	^behaviors select: [:e| e isGbtConstraint ]! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 5/11/2016 14:19'!
constraints: arrayOfSymbol 
	"tell the create behaviors"
	self check: [ arrayOfSymbol isArray ] toBe: #anArray.
	self check: [ self isKindOf: GbtPlainAC ] toBe: #aPlainContext.
	
	constraintBehaviors addAll: arrayOfSymbol
! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 5/11/2016 14:19'!
createBehaviors: arrayOfSymbol 
	"tell the create behaviors"
	self check: [ arrayOfSymbol isArray ] toBe: #anArray.
	self check: [ self isKindOf: GbtPlainAC ] toBe: #aPlainContext.
	
	createBehaviors addAll: arrayOfSymbol
! !

!GbtActiveContext methodsFor: 'hooks' stamp: 'hk 9/23/2016 13:50'!
createHook: aThing
"	createBehaviors do: [:e| ((self behaviors at: e) execute: {aThing})]"
	
	createBehaviors do: [:e| (behaviors at: e) execute].
	constraintBehaviors do: [:e| (self constraints at: e) execute]! !

!GbtActiveContext methodsFor: 'initialization' stamp: 'hk 1/7/2016 14:09'!
defineFrom: definitionArray
	definitionArray do: 
		[ :elem | |sel|
		sel := elem first asSymbol.
		(self respondsTo: sel) ifFalse: [self error: 'no such define: ',sel].
		self perform: elem first asSymbol withArguments: elem allButFirst]! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 7/1/2016 13:44'!
display: anArrayOfSymbol 
	"tell the array defining my list columns "
	self check: [anArrayOfSymbol allSatisfy: [:e| e isSymbol or: [e first isSymbol & e second isSymbol]]] toBe: #anArrayOfSymbolOrPairOfSymbol.
	
	displayColumns := anArrayOfSymbol ! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 2/27/2016 15:15'!
displayAs: aString
	"tell the GUI display string"
	self check: [ aString isString ] toBe: #aString.
	
	displayName := aString! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/7/2016 11:19'!
displayName
	^displayName ifNil: [self svoName]! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 9/23/2016 13:42'!
doBehavior: key withArgs: args
	"do the behavior key with args"
	^(self behaviors at: key) execute: args
! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 9/23/2016 13:42'!
doBehaviors: aCollOfKeys 
	"do the behaviors aCollOfKeys"
	
	(self behaviors keys intersection: aCollOfKeys) do: [:e| (self behaviors at: e) execute]
! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 9/23/2016 13:42'!
doConstraints: aCollOfKeys

	(self constraints keys intersection: aCollOfKeys) do: [:e| (self constraints at: e) execute]! !

!GbtActiveContext methodsFor: 'hooks' stamp: 'hk 9/23/2016 13:38'!
editHook: aThing
	editBehaviors do: [:beh| ((self behaviors at: beh) execute: {aThing})]! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 10/24/2015 16:49'!
eventQueue
	^eventQueue! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 12/14/2016 17:39'!
extent
	^extent! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 12/14/2016 17:20'!
extent: aPoint
	"tell the window extent"
	self check: [aPoint isKindOf: Point] toBe: #aPoint.
	
	extent := aPoint! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 7/29/2016 12:28'!
hasAutoloadPolicy
	^loadPolicy = #autoload! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 7/29/2016 12:28'!
hasFilterloadPolicy
	^loadPolicy = #filterload! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 7/29/2016 12:28'!
hasSimpleloadPolicy
	^loadPolicy = #simpleload! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 1/5/2017 14:11'!
hasSubcontext
	^false! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 12/16/2016 18:56'!
hasTemplates
	^self templates isNotEmpty! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 3/2/2017 16:07'!
hasTxThing: aSymbol
	self subclassResponsibility ! !

!GbtActiveContext methodsFor: 'initialization' stamp: 'hk 11/14/2016 16:19'!
initialize
	super initialize.
	behaviors := Dictionary new.
	menuBehaviors := OrderedCollection new.
	saveBehaviors := OrderedCollection new.
	removeBehaviors := OrderedCollection new.
	editBehaviors := OrderedCollection new.
	receiveBehaviors := OrderedCollection new.
	createBehaviors := OrderedCollection new.
	constraintBehaviors := OrderedCollection new.
	eventQueue :=	GbtEventQueue new . 
! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 11/9/2016 12:58'!
isActiveContext
	^true! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 11/2/2016 16:13'!
isBigListAc
	^false! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 10/19/2016 16:40'!
isMainAC
	^false! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 10/11/2016 16:37'!
key
	"synonym for template editor"
	^self svoName ! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 7/29/2016 12:29'!
loadPolicy: aSymbol
	"one of autoload simpleload filterload"
	
	self check: [#(autoload simpleload filterload) includes: aSymbol] toBe: #autoOrSimpleOrFilterload .
	loadPolicy := aSymbol ! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 7/28/2016 17:05'!
menu: aSymbol 
	"tell a menu of a behavior"
	self check: [ aSymbol isString] toBe: #aString.
	
	menuBehaviors add: aSymbol asSymbol
! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 2/27/2016 15:15'!
menu: aSymbol items: anArrayOfSymbol
	"tell a menu of several behaviors"
	self check: [ aSymbol isSymbol] toBe: #aSymbol.
	self check: [ anArrayOfSymbol isArray] toBe: #anArray.
	
	menuBehaviors add: aSymbol -> anArrayOfSymbol 
! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 8/5/2016 16:40'!
menuFor: aMB wrapWith: aBlock
	"answer my menu items. aMB is either aSymbol or anArray of Symbol"
	
	|menuItem|
	menuItem := MenuItemModel new.
	aMB isSymbol "either a symbol or an association"
		ifTrue: 	[menuItem 
						name: aMB;
						action: [aBlock value: ((behaviors at: aMB) execMenu)]] 
		ifFalse:	[menuItem "aMB is an association  key -> Array of Symbol"
						name: aMB key;
						subMenu: (MenuModel new addGroup: 
							[:g | aMB value do: 
								[:k | g addItem: 
									[:item | item
									name: k ; 
									action: [aBlock value: ((behaviors at: k) execMenu)]]]])].
	^menuItem
						
						
			
! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 2/11/2016 12:08'!
menuItemsWrappedWith: aBlock
	"answer my menu items"

	^menuBehaviors collect: [:mb| self menuFor: mb wrapWith: aBlock]
! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 11/9/2016 13:08'!
newEntry: aThing
	self subclassResponsibility ! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 4/13/2015 10:39'!
newUI
	^(Smalltalk at: uiSpec) on: self! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 1/31/2016 11:32'!
newUI: aSymbol
	^(Smalltalk at: uiSpec) on: self mode: aSymbol! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 3/29/2017 14:43'!
nextBizID
	"bizID is company-app global. Thus the AppServer is responsible"
	^ GbtBizAppServer default nextIdOfContextNoPolicy: svoName ! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 3/17/2017 17:23'!
noPolicyGetter: aSelector
	self check: [ aSelector isSymbol ] toBe: #aSymbol.
	^self bizApp contextNoPolicyOf: svoName getter: aSelector
! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 3/17/2017 17:23'!
noPolicyPrefix: aString
	self check: [ aString isString ] toBe: #aString.
	^self bizApp contextNoPolicyOf: svoName prefix: aString
! !

!GbtActiveContext methodsFor: 'error handling' stamp: 'hk 11/8/2016 19:57'!
notify: aString
	"delegate notification to the ui"
	aString ifEmpty: [^self].
	(ui ifNil: [container]) notify: aString! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 9/21/2016 15:35'!
onEditDo: arrayOfSymbol 
	"tell the receive behaviors"
	self check: [arrayOfSymbol allSatisfy: [:e| e isSymbol]] toBe: #anArrayOfSymbol.
	
	editBehaviors addAll: arrayOfSymbol
! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 2/27/2016 15:18'!
onReceiveDo: arrayOfSymbol 
	"tell the receive behaviors"
	self check: [arrayOfSymbol allSatisfy: [:e| e isSymbol]] toBe: #anArrayOfSymbol.
	
	receiveBehaviors addAll: arrayOfSymbol
! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 9/22/2016 18:51'!
onRemoveDo: arrayOfSymbol 
	"tell the receive behaviors"
	self check: [arrayOfSymbol allSatisfy: [:e| e isSymbol]] toBe: #anArrayOfSymbol.
	
	removeBehaviors addAll: arrayOfSymbol
! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 9/21/2016 15:34'!
onSaveDo: arrayOfSymbol 
	"tell the receive behaviors"
	self check: [arrayOfSymbol allSatisfy: [:e| e isSymbol]] toBe: #anArrayOfSymbol.
	
	saveBehaviors addAll: arrayOfSymbol
! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 12/13/2016 14:04'!
poolThings
	"create the pool if necessary"
	^pool ifNil: [ OrderedCollection new]! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 1/12/2017 12:27'!
poolThings: aCollOfThings
	"define the pool Things"
	
	pool := self checkThingMakeColl: aCollOfThings! !

!GbtActiveContext methodsFor: 'copying' stamp: 'hk 5/10/2015 14:15'!
postCopy
	super postCopy .
	self inform: 'contexts should not be copied'! !

!GbtActiveContext methodsFor: 'printing' stamp: 'hk 10/11/2016 16:37'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPut: $ ; nextPutAll: self svoName! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 8/5/2016 16:30'!
receive: anEvent
	eventQueue push: anEvent .
	receiveBehaviors do: [ :e | (behaviors at: e ifAbsent: [self error: 'no behavior ',e]) execute ] ! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 8/9/2016 11:36'!
refreshUI
	"automatic behaviors may need to update the GUI"
	self subclassResponsibility ! !

!GbtActiveContext methodsFor: 'initialization' stamp: 'hk 3/27/2017 13:00'!
release
	super release.
	behaviors valuesDo: #release
! !

!GbtActiveContext methodsFor: 'hooks' stamp: 'hk 9/23/2016 13:38'!
removeHook: aThing
	removeBehaviors do: [:beh| ((self behaviors at: beh) execute: {aThing})]! !

!GbtActiveContext methodsFor: 'analyzing' stamp: 'hk 11/15/2016 20:49'!
rtAttributes
	^{ 'uiSpec: ', (self uiSpec ifNil: #nil) . 'user: ', self user}! !

!GbtActiveContext methodsFor: 'analyzing' stamp: 'hk 12/18/2016 11:51'!
rtBehaviors
	| bs |
	bs := OrderedCollection new.
	behaviors do: [ :pB | bs add: pB actionName ].
	^bs! !

!GbtActiveContext methodsFor: 'hooks' stamp: 'hk 9/23/2016 13:38'!
saveHook: aThing
	saveBehaviors do: [:beh| ((self behaviors at: beh) execute: {aThing})]! !

!GbtActiveContext methodsFor: 'pending data' stamp: 'hk 6/1/2016 14:25'!
setDataPending
	super setDataPending .
	(self container ifNil: [ ^self ]) setDataPending ! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 1/5/2017 14:07'!
setOtherUserEdits: aBoolean     
	" update gui"
	(ui isKindOf: GbtListUI) 
		ifTrue: [^ui otherUserEdits: aBoolean].
	((container ifNil: [^self]) ui isKindOf: GbtListUI) 
		ifTrue: [container ui otherUserEdits: aBoolean]
	! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 10/20/2016 21:17'!
svoName
	^ svoName ifNil: [super svoName]! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 10/11/2016 16:40'!
svoName: aString
	svoName := aString ! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 5/6/2015 14:50'!
targetSlotname
	^ targetSlotname! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 5/6/2015 14:50'!
targetSlotname: aSymbol
	targetSlotname := aSymbol! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/9/2016 13:15'!
templates
	^self subclassResponsibility ! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 3/21/2017 14:51'!
ui
	^ui ifNil: [self uiSpecClass on: self] ! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 8/26/2015 10:40'!
ui: aGcUI
	ui := aGcUI ! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 4/13/2015 10:31'!
uiKey
	^ uiKey! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/7/2016 11:02'!
uiSpec
	^uiSpec ifNil: [ self error: 'uiSpec not authored' ]! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 9/19/2015 13:04'!
uiSpec: aClassName icon: aUikey
	"tell the Spec model of this context. 
	aUikey identifies the icon shown"
	
	uiSpec := aClassName .
	uiKey := aUikey asSymbol! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/7/2016 11:09'!
uiSpecClass
	^Smalltalk at: self uiSpec ! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 12/8/2016 12:32'!
updateBigThing: aThing
	"delegate the update from item context to big list context"

	(container ifNil: [^self notify: 'failed: updateBigThing in ',self svoName]) updateBigThing: aThing! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/8/2016 10:07'!
user
	^user ifNil: [ '' ]! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/7/2016 12:44'!
user: aName    
	user := aName! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 3/14/2017 14:49'!
userRight
	^userRight ifNil: [ "default" GbtRight new]! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/22/2016 09:43'!
userRight: aGbtRight
	userRight := aGbtRight ! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 2/27/2016 15:16'!
voChange: aSymbol
	self check: [ aSymbol isSymbol ] toBe: #aSymbol.
	
	voChange  := aSymbol! !

GbtActiveContext subclass: #GbtPlainAC
	instanceVariableNames: 'subcontexts blackboardAspect legaltext txThings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Contexts'!

!GbtPlainAC commentStamp: 'hk 3/27/2017 13:06' prior: 0!
I am a normal (plain) context.
For execution things are bound to me with roles. 
A special role is contextVO, that holds the thing to be edited by the user.
Further roles may be authored. Behaviors access all role things by the role name.
Since there may be many different views on my contextVO, 
I hold a subcontext for each (view) aspect of my contextVO

Instance Variables
	txThings:		<Dictionary>				holding all tx relevant  things including contextVO
	templates:		<OrderedCollection of GbtThing>				from which to draw a copy
	subcontexts: 	<OrderedCollection of GbtActiveContext>		GbtPlainAC | GbtUlistAC of aspects
	sendViews: 		<Dictionary of GbtDeclarative>					for bizNet receives &  sends: 
																- view userName used for sends: 
																- dict key used for receives
	blackboardAspect:	<aString>								vo slotName of blackboard
	legaltext: 			<String>
!

GbtPlainAC subclass: #GbtLoginAC
	instanceVariableNames: 'appClass appSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Contexts'!

!GbtLoginAC commentStamp: 'hk 11/6/2016 14:26' prior: 0!
I am used for login. 
I exist once for all users of a company.
I store the informatin which app shall be startet.
The app contexts exist per user.

    Instance Variables
	appClass:		<Classname>		where the app is authored
	appSelector:		<Symbol> 		of the app method
!

!GbtLoginAC class methodsFor: 'as yet unclassified' stamp: 'hk 3/21/2017 16:14'!
struct: aString define: definitionArray
	"create the logincontext without storing it"
	
	^self basicNew 
		svoName: aString ; 
		initialize; 
		setID; 
		defineFrom: definitionArray! !

!GbtLoginAC methodsFor: 'accessing' stamp: 'hk 11/6/2016 14:38'!
appClass
	^appClass ifString: [^Smalltalk at: appClass]! !

!GbtLoginAC methodsFor: 'authoring' stamp: 'hk 11/8/2016 09:49'!
appClass: aClass selector: aSelector
	"the method that starts the app"
	appClass := aClass. 
	appSelector := aSelector ! !

!GbtLoginAC methodsFor: 'accessing' stamp: 'hk 11/17/2016 18:34'!
appContextFor: userName
	"userName is needed on creation to store the context"
	^self appClass perform: appSelector withArguments: {userName}! !

!GbtLoginAC methodsFor: 'api' stamp: 'hk 3/23/2017 10:33'!
compileApp
	^self appClass perform: appSelector ! !

!GbtLoginAC methodsFor: 'api' stamp: 'hk 1/23/2017 13:18'!
open
	(self ui extent: self extent; yourself) openWithSpec centered! !

!GbtLoginAC methodsFor: 'accessing' stamp: 'hk 11/6/2016 15:40'!
uiSpec
	^uiSpec ifNil: [#GbtLoginUI]! !

!GbtPlainAC methodsFor: 'accessing' stamp: 'hk 5/12/2016 17:01'!
addTemplate: aGbtThing
	"tell the thing template from which to draw a copy"
	
	templates add: aGbtThing! !

!GbtPlainAC methodsFor: 'authoring' stamp: 'hk 12/31/2016 15:41'!
aspect: aCf on: aSlotName
	"tell a subcontext of one of my VO's aspects / subnodes).
	and to which slot of my VO it belongs "
	self check: [aCf isActiveContext] toBe: #aContext.
	self check: [aSlotName isNil or: [aSlotName isString]] toBe: #aString .

	aCf container: self .
	aCf targetSlotname: aSlotName .
	subcontexts add: aCf! !

!GbtPlainAC methodsFor: 'accessing' stamp: 'hk 2/23/2016 16:03'!
aspectSlots
	^subcontexts collect: [ :sc| sc targetSlotname ]! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 3/2/2017 16:07'!
assign: aThing toTxThing: aSymbol
	
	(self knowsTxThing: aSymbol) ifFalse: [^self notify: aSymbol, ' is not a role']. 
	txThings add: aSymbol -> aThing! !

!GbtPlainAC methodsFor: 'authoring' stamp: 'hk 1/27/2016 17:29'!
blackboardAspect
	
	^blackboardAspect ! !

!GbtPlainAC methodsFor: 'authoring' stamp: 'hk 1/27/2016 17:21'!
blackboardAspect: aCf on: aSlotName
	"tell the aspect / slot of my header info"
	
	blackboardAspect := aSlotName .
	self aspect: aCf on: aSlotName! !

!GbtPlainAC methodsFor: 'accessing' stamp: 'hk 2/29/2016 13:17'!
blackboardContext
	^self subcontextFor:  blackboardAspect ! !

!GbtPlainAC methodsFor: 'authoring' stamp: 'hk 2/29/2016 18:39'!
blackboardSlot
	
	^blackboardAspect ifNil: [ #nil ]! !

!GbtPlainAC methodsFor: 'authoring' stamp: 'hk 12/31/2016 14:57'!
blackboardSlot: aSlotName
	"tell the blackboard slotName"
	self check: [aSlotName isString] toBe: #aString .
	
	blackboardAspect := aSlotName! !

!GbtPlainAC methodsFor: 'changes' stamp: 'hk 2/15/2017 10:25'!
checkDirty

	|  scDirty  bothEQ |		
	scDirty := bothEQ := true .
	subcontexts detect: [ :sc | sc hasDataPending ] ifNone: [ scDirty := false ]. 
	self vo ifNotNil: [:th| bothEQ := scDirty = th hasDataPending ] .
	
	self hasDataPending 
		ifTrue: [ (bothEQ & scDirty not ) ifTrue: [ ^self setDataNotPending ] ] 
		ifFalse: [ bothEQ ifFalse: [ ^self setDataPending ] .
				 (bothEQ & scDirty ) ifTrue: [ ^self setDataPending ] ].
	 container ifNotNil: [container checkDirty]
! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 1/23/2016 15:16'!
hasBlackboard
	
	^blackboardAspect isNotNil ! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 3/2/2017 16:07'!
hasTxThing: aSymbol
	
	^(self knowsTxThing: aSymbol) and: [(txThings at: aSymbol) isNotNil]! !

!GbtPlainAC methodsFor: 'initialize-release' stamp: 'hk 3/2/2017 16:04'!
initialize
	super initialize .
	templates := OrderedCollection new .
	subcontexts := OrderedCollection new.
	txThings := Dictionary newFromPairs: { #contextVO . nil } .
! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 3/2/2017 16:07'!
knowsTxThing: aSymbol
	
	^txThings keys includes: aSymbol! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 11/9/2016 16:01'!
legalText
	^legaltext ifNil: ''

! !

!GbtPlainAC methodsFor: 'authoring' stamp: 'hk 12/31/2016 14:55'!
legalText: aString 
	self check: [aString isString] toBe: #aString .

	legaltext := aString 

! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 3/22/2017 17:47'!
loadVO
	| theList |
	loaded ifNotNil: [ ^self ].
	theList := self userRight allowedSubColl: (self bizApp loadList: self vo svoName).
	theList do: [ :e| self newEntry: e ].  "should only be one"
	loaded := true

! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 12/19/2016 17:31'!
newEntry: aThing   
	"for load strategy"
	self vo: aThing
	! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 3/21/2017 14:51'!
open
	ui := self ui.
	(ui extent: self extent; yourself) openWithSpec centered.
	self registerWithBizNet! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 8/9/2016 11:32'!
refreshUI
	(ui ifNil: [^self]) refresh.
	self subcontexts do: [:sc| sc refreshUI]! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 3/15/2017 11:43'!
registerWithBizNet
	[GbtBizNetMockUp registerCompany: self vo company with: self] ifError:
		[self notify: 'no BizNet' ]! !

!GbtPlainAC methodsFor: 'initialize-release' stamp: 'hk 3/27/2017 13:05'!
release
	super release .
	templates do: #release .
	txThings valuesDo: #release
! !

!GbtPlainAC methodsFor: 'analyzing' stamp: 'hk 10/11/2016 16:37'!
rtAttributes
	^Array with: 'vo: ', (self vo  ifNil: #nil ifNotNil: [self vo svoName]) 
		withAll: super rtAttributes   ! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 2/17/2017 15:50'!
setVOFromContainer
	| aspect |
	container ifNil: [^self error: 'no container'] .
	container vo ifNil: [^self error: 'no vo in container'] .
	aspect := container vo slotSVOAt: targetSlotname ifAbsent: [].
	self vo: aspect .
	^aspect! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 3/14/2017 10:36'!
store
	"store all things possibly involved by the tx"
	GbtBizAppServer  
		transact: (self txThings collect: [:th| th serializedNodes]) 
		as: self user ! !

!GbtPlainAC methodsFor: 'accessing' stamp: 'hk 1/27/2016 17:49'!
subcontextFor: aSlot
	^subcontexts detect: [ :sc | sc targetSlotname = aSlot ] ifNone: [  ]! !

!GbtPlainAC methodsFor: 'accessing' stamp: 'hk 4/13/2015 10:37'!
subcontexts
	^subcontexts! !

!GbtPlainAC methodsFor: 'accessing' stamp: 'hk 11/2/2016 16:02'!
tabcontexts
	^subcontexts reject: [:sc| (sc targetSlotname = blackboardAspect)]! !

!GbtPlainAC methodsFor: 'accessing' stamp: 'hk 8/11/2016 17:13'!
templates
	"the DomainVO template from which to draw a copy"
	^templates ifNil: [templates := OrderedCollection new]! !

!GbtPlainAC methodsFor: 'authoring' stamp: 'hk 1/12/2017 12:27'!
templates: singleOrCollOfGbtThing
	"tell the thing template from which to draw a copy"
	
	templates := self checkThingMakeColl: singleOrCollOfGbtThing! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 3/2/2017 16:08'!
txThingAt: aSymbol
	^txThings at: aSymbol ! !

!GbtPlainAC methodsFor: 'accessing' stamp: 'hk 3/2/2017 16:08'!
txThings
	^txThings values select: [:v| v isNotNil]! !

!GbtPlainAC methodsFor: 'authoring' stamp: 'hk 3/2/2017 16:04'!
txThings: arrayOfSymbol
	"tell my thing - nil or thing allowed"
	self check: [arrayOfSymbol isEmpty or: [arrayOfSymbol first isSymbol]] toBe: #arrayOfSymbol .
	
	arrayOfSymbol do: [:k| txThings add: k -> nil]! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 2/17/2017 15:50'!
updateBlackboardWith: aTabContext
	"show the tab blackboard content, else the process blackboard content"
	| bbThing ctxt|  
	ctxt := (aTabContext isListAc or: [aTabContext vo isNil or: [aTabContext = self]]) 
		ifTrue: [self]
		ifFalse: [aTabContext]. 
	bbThing := ctxt vo slotSVOAt: ctxt blackboardSlot ifAbsent: [^self].
	self blackboardContext vo: bbThing ! !

!GbtPlainAC methodsFor: 'accessing' stamp: 'hk 3/14/2017 14:56'!
userRight
	^(container ifNil: [^super userRight] ) userRight! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 3/2/2017 16:04'!
vo
	^txThings at: #contextVO! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 3/2/2017 16:06'!
vo: aVO
	"tell my contextVO - thing|nil"
	self check: [aVO isNil or: [aVO isThing]] toBe: #aThingOrNil .
	
	aVO ifNotNil: [aVO context: self] .
	self assign: aVO toTxThing: #contextVO.

	(ui isNil not and: [ui hasTarget]) ifTrue: [ ui target: aVO ].
	(aVO ifNil: [ ^self ]) context: self ! !

GbtSVO subclass: #GbtBehavior
	instanceVariableNames: 'actions actionName arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Contexts'!

!GbtBehavior commentStamp: 'hk 9/21/2016 14:54' prior: 0!
I represent a behavior made from actions (ActionVO).

    Instance Variables
	actions: 			<OrderedCollection>		of Pairs (ActionName params)
	actionName 		<Symbol>				name
	arguments:		<Array of Symbol>		!

!GbtBehavior class methodsFor: 'instance creation' stamp: 'hk 12/18/2016 12:09'!
newStruct: aName arguments: argArray define: definitionArray
	^self new define: aName arguments: argArray actions: definitionArray! !

!GbtBehavior methodsFor: 'accessing' stamp: 'hk 12/18/2016 11:50'!
actionName
	^actionName! !

!GbtBehavior methodsFor: 'accessing' stamp: 'hk 2/10/2016 14:24'!
actions 
	^actions ifNil: [ actions := OrderedCollection new ]! !

!GbtBehavior methodsFor: 'accessing' stamp: 'hk 8/8/2016 14:13'!
arguments
	^arguments ifNil: [#()]! !

!GbtBehavior methodsFor: 'accessing' stamp: 'hk 6/22/2016 16:16'!
classInitial
	^#B! !

!GbtBehavior methodsFor: 'define' stamp: 'hk 12/18/2016 12:08'!
define: aName arguments: argArray actions: definitionArray
	"create the actions defined in aSourceString"
	|  source |
	self check: [ aName isString ] toBe: #aString.
	self check: [ definitionArray isArray ] toBe: #anArray.
	self check: [ argArray isArray ] toBe: #anArray.

	actionName :=	aName asSymbol.
	source := definitionArray asOrderedCollection .
	arguments := argArray.
	[source isNotEmpty] whileTrue: 
		[self actions add: (source removeFirst: 2 )]
! !

!GbtBehavior methodsFor: 'executing' stamp: 'hk 2/14/2017 13:50'!
exec: collOfActions with: argArray
	"answer aString 'aborted' in case of error or {GbtThing . slotName} - used for constraints"	
	| pipe acts |
	acts := collOfActions collect: [:a| GbtAction newFor: a] .
	self logBegin: ''.
	pipe := GbtActionPipe thing: nil context: container new: false ext: false.	"container = context"
	argArray ifNotEmpty: 
		[pipe thing: argArray first.	
		pipe addArgs: argArray allButFirst for: self arguments].
	acts do: [ :a | pipe abort ifFalse: [pipe := a doOn: pipe] ]. 
	self logEnd: (pipe abort ifTrue: ['aborted'] ifFalse: ['']).    
	^pipe abort 
		ifTrue: [ {#aborted . #void} ] 
		ifFalse: [{pipe thing . (pipe slot)}]
! !

!GbtBehavior methodsFor: 'executing' stamp: 'hk 8/9/2016 10:23'!
execMenu
	"the notify block that wraps the menu expects aString"
	| res |
	res := self execute.
	^res isString ifTrue:[res] ifFalse: ['']! !

!GbtBehavior methodsFor: 'executing' stamp: 'hk 11/22/2016 09:48'!
execute
	container userRight execute ifFalse: [^'no right to execute'].
	^self execute: #()! !

!GbtBehavior methodsFor: 'executing' stamp: 'hk 12/15/2016 16:24'!
execute: argArray
	"^ theThing only"
	^(self exec: self actions with: argArray ) first! !

!GbtBehavior methodsFor: 'testing' stamp: 'hk 11/9/2016 13:00'!
isGbtBehavior
	^true! !

!GbtBehavior methodsFor: 'executing' stamp: 'hk 8/8/2016 13:30'!
logBegin: aText 
	GbtLogger logBegin: self class name,' : ', actionName text: aText.
! !

!GbtBehavior methodsFor: 'executing' stamp: 'hk 8/8/2016 13:31'!
logEnd: aText 
	GbtLogger logEnd: self class name, ' : ', actionName text: aText.
! !

!GbtBehavior methodsFor: 'copying' stamp: 'hk 6/5/2016 13:44'!
postCopy
	super postCopy .
	actions := actions copy! !

!GbtBehavior methodsFor: 'define' stamp: 'hk 8/9/2016 12:02'!
rename: aSymbol modify: aSourceArray 
	"modify the actions. same sequence required"

	| source |
	actionName := aSymbol asSymbol.
	source := aSourceArray asOrderedCollection.
	actions := actions collect: [ :arr| |act parms|
		act := source at: 1 ifAbsent: [] .
		parms := source at: 2 ifAbsent: [] . 
		arr first = act 
			ifTrue: [source removeFirst: 2.
						{ act . parms }]
			ifFalse: [arr] ].
! !

!GbtBehavior methodsFor: 'accessing' stamp: 'hk 12/18/2016 11:51'!
xbehaviors
	^{actionName}! !

GbtBehavior subclass: #GbtConstraint
	instanceVariableNames: 'rightActions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Contexts'!

!GbtConstraint commentStamp: 'hk 2/11/2016 12:58' prior: 0!
I am a binary constraint .
I hold  2 sequences of actions.
I execute these actions and compare the results.

predicate
I test the 2 arguments on equality 
& operator
I replace a nil argument by the other one

====================================
proposed refaktoring:
- hold a BehaviorVO for each constraint leg instead of subclassing
!

!GbtConstraint methodsFor: 'private' stamp: 'hk 9/20/2016 17:20'!
assign: aThingOrValue to: aNode with: aSlotName
	"assign aThingOrValue to an empty slot"
	| setter |
	setter := (aSlotName, ':') asSymbol.
	(aThingOrValue isKindOf: GbtThing) ifTrue: 
		[^ aNode define: aSlotName  thing: aThingOrValue ].
	aNode perform: setter with: aThingOrValue.
! !

!GbtConstraint methodsFor: 'define' stamp: 'hk 11/2/2016 16:08'!
defineLeft: aSourceArray right: anotherArray named: aSymbol
	"create the actions defined in aSourceString"

	| source |
	self define: aSymbol arguments: #() actions: aSourceArray.
	source := anotherArray asOrderedCollection.
	[ source isNotEmpty] whileTrue: [ self rightActions add: (source removeFirst: 2) ]! !

!GbtConstraint methodsFor: 'executing' stamp: 'hk 8/24/2016 16:45'!
execLeft
	"^ anArray of thing and slot"
	^self exec: actions with: #()! !

!GbtConstraint methodsFor: 'executing' stamp: 'hk 8/24/2016 16:45'!
execRight
	"^ anArray of thing and slot"
	^self exec: rightActions with: #()! !

!GbtConstraint methodsFor: 'executing' stamp: 'hk 11/1/2016 13:08'!
execute 
	"binary constraints: eval left & right actions. 
	if only one is empty, fill it such that the contraint is obeyed.
	notify if left & right are not equal"

	| left right res getterLeft  resLeft getterRight  resRight  evalLeft evalRight |	
	self logBegin: ''.
	(evalLeft := self execLeft)
		isString ifTrue: [GbtLogger logEnd: self class name,' : ', actionName text: 'no execution'. ^evalLeft] .
	(evalRight := self execRight)
		isString ifTrue: [GbtLogger logEnd: self class name,' : ', actionName text: 'no execution'. ^evalRight].
	resLeft := evalLeft first. 			resRight := evalRight first. 
	getterLeft := evalLeft second. 	getterRight := evalRight second. 
		
	left := self nilOrSlot: getterLeft of: resLeft.
	right := self nilOrSlot: getterRight of: resRight.
	res := 'fulfilled'.
	left isNil
		ifTrue:  [right ifNil: [GbtLogger logEnd: self class name,' : ', actionName text: 'nil'. ^res ] ]
		ifFalse: [(right isNotNil and: [left = right]) ifTrue: 
							[GbtLogger logEnd: self class name,' : ', actionName text: 'ok'. ^res ]] .
	res := #violated.
	left ifNil: [self assign: right copy to: resLeft with: getterLeft.
					res := 'assigned left' ].  
	right  ifNil: [self assign: left copy to: resRight with: getterRight.
					res := 'assigned right'].	
	self logEnd: res.	
	res = #violated ifTrue: [self notifyA: {#CONSTRAINT. actionName. #on. self container svoName. #violated}].
	^res
! !

!GbtConstraint methodsFor: 'testing' stamp: 'hk 11/9/2016 13:00'!
isGbtConstraint
	^true! !

!GbtConstraint methodsFor: 'private' stamp: 'hk 2/17/2017 16:02'!
nilOrSlot: getter of: aVO
	"test the getter. answer the content, if present, nil else"
	| slotA |
	getter ifNil: [^nil].
	aVO ifNil: [^nil].
	(aVO respondsTo: getter)	ifTrue: [^aVO perform: getter].
	(slotA := aVO slotAt: getter) ifNil: [^nil].
	slotA isFilled ifFalse: [^nil].
	slotA isLeaf ifTrue: [^slotA value val].
	slotA isNode ifTrue: [^slotA value ].
	(slotA isLink) ifTrue: [ ^nil ].	"oder das Link-Target?"
	self error: 'something missed'! !

!GbtConstraint methodsFor: 'accessing' stamp: 'hk 2/10/2016 16:12'!
rightActions 
	^rightActions ifNil: [ rightActions := OrderedCollection new ]! !

GbtSVO subclass: #GbtDeclarative
	instanceVariableNames: 'slots sources idNumberPolicy summary svoName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Declarative'!

!GbtDeclarative commentStamp: 'hk 2/17/2017 16:57' prior: 0!
I am 
- a view on a thing. 
- a transformer from a source thing structure into a target thing (=my own) structure.
- a reader of target data (of my own structure) to be copied into my source. 
- a combiner of more than one thing.
In a mathematical sense I am - together with my source - a combinator functional.
In this implementation I am normally not copied , but my sources are replaced.

I define a tree structure just like a thing. 
However,  my slot values  (=tags) refer to nodes or leaves of my sources. 
the tags should be unique, only the first tag is found.

Instance variables:
	slots:			<OrderedCollection of GbtAssociation> 		with: GbtDeclarative | Symbol | Array
						sub-Declarative | tag | tag and Declarative for list transformation
	svoName: 		<String>				of the thing taken or created by targetCopy
	sources: 			<Coll of Thing>		of sourceCopy
	context: 			<String> 			userName of ActiveContextVO
	summary: 		<String> 			new summary for the copy
	idNumberPolicy 	<String> 			a new idNumberPolicy  for the copy
	
								
			
all my source access gains the slot values, not the associations.
This is why I loose tags and purpose ...

I may contain ordinary slots, however , no authoring or tests yet.!

!GbtDeclarative class methodsFor: 'retrieving' stamp: 'hk 11/16/2016 16:06'!
definedAs: aName
	"answer the Declarative with aName "
	
	^ self definedAs: aName ifAbsent: [] ! !

!GbtDeclarative class methodsFor: 'retrieving' stamp: 'hk 3/17/2017 17:30'!
definedAs: aName ifAbsent: absentBlock
	"answer the lowest or specified id-version of the thing named svoName"
	
	^GbtBizAppServer default declarativeNamed: aName ifAbsent: absentBlock! !

!GbtDeclarative class methodsFor: 'instance creation' stamp: 'hk 3/17/2017 17:31'!
new: aString define: definitionArray
	"answer the declarative typed aString. If new, define it"

	^GbtBizAppServer default addDecl: (self basicNew svoName: aString; initialize; setID; defineFrom: definitionArray) 
		! !

!GbtDeclarative class methodsFor: 'authoring' stamp: 'hk 3/17/2017 17:31'!
struct: aString define: definitionArray
	"answer the declarative typed aString. If new, define it"

	^GbtBizAppServer default declarativeNamed: aString ifAbsent: [self new: aString define: definitionArray] 
		! !

!GbtDeclarative methodsFor: 'accessing' stamp: 'hk 6/22/2016 16:17'!
classInitial
	^#D! !

!GbtDeclarative methodsFor: 'initialization' stamp: 'hk 9/2/2015 11:55'!
clearSources
	sources := OrderedCollection new! !

!GbtDeclarative methodsFor: 'copying' stamp: 'hk 2/14/2017 20:42'!
copyBuildinSlotsOn: emptyThing
	idNumberPolicy ifNotNil: [emptyThing idNumberPolicy: idNumberPolicy].
	summary ifNotNil: [:s| emptyThing summary: s].! !

!GbtDeclarative methodsFor: 'copying' stamp: 'hk 10/11/2016 16:37'!
copySources
	"answer a copy of all sources"

	^self new: self svoName withSource: #()
! !

!GbtDeclarative methodsFor: 'copying' stamp: 'hk 2/17/2017 17:04'!
copySourcesOn: emptyThing
	"paste all projected source slots into emptyThing"

	self copyBuildinSlotsOn: emptyThing.	
	self slots do: [:sa| 
		(self publicSlotSVOAt: sa key) ifNotNil: [:t| 		"ignore slots not found"
			emptyThing updateSlot: (GbtSlotAssociation 
				key: sa key 
				value: t copy)]] .
	^emptyThing 
! !

!GbtDeclarative methodsFor: 'copying' stamp: 'hk 8/10/2016 14:24'!
copyWithSource: aThing
	"answer a copy of aThing respecting all assigned sources"
	
	| res oldSrces|
	self check: [ aThing isNode ] toBe: #aThing.
	oldSrces := sources copy.
	sources addFirst: aThing .	"sequence is critical"
	res :=self copySources.
	self sources: oldSrces.
	^res! !

!GbtDeclarative methodsFor: 'authoring' stamp: 'hk 7/30/2015 17:12'!
define: aSlotName 
	"define a slot projecting from a slotName"
	
	self define: aSlotName tag: aSlotName asSymbol! !

!GbtDeclarative methodsFor: 'authoring' stamp: 'hk 7/25/2016 12:38'!
define: slotName decl: aDeclarative
	"define a slot projecting from a tag"
	
	self check: [slotName isString] toBe: #StringOrSymbol.
	self check: [aDeclarative isDeclarative] toBe: #aView.

	slots add: (GbtSlotAssociation key: slotName asSymbol value: aDeclarative)! !

!GbtDeclarative methodsFor: 'authoring' stamp: 'hk 8/25/2016 17:30'!
define: slotName list: anArray
	"define a slot for transforming a list"
	
	self check: [slotName isString] toBe: #StringOrSymbol.
	self check: [(anArray first isString)&(anArray second isDeclarative)] toBe: #anArrayOfTagAndDeclarative.
	self check: [(anArray at: 3 ifAbsent: [GbtThing new]) isThing] toBe: #aThingOrNil.

	slots add: (GbtSlotAssociation key: slotName asSymbol value: anArray)! !

!GbtDeclarative methodsFor: 'authoring' stamp: 'hk 5/11/2016 14:14'!
define: slotName tag: aSymbol
	"define a slot projecting from a tag"
	
	self check: [slotName isString] toBe: #StringOrSymbol.
	self check: [aSymbol isNil or: [aSymbol isSymbol] ] toBe: #SymbolOrNil.

	slots add: (GbtSlotAssociation key: slotName asSymbol value: aSymbol)! !

!GbtDeclarative methodsFor: 'define' stamp: 'hk 10/11/2016 16:37'!
defineElementFrom: elem   
	elem first = #idNumberPolicy ifTrue: [^self idNumberPolicy: elem second].
	elem first = #summary ifTrue: [^self summary: elem second].
	elem second = #tag: ifTrue: [^self perform: #define:tag: withArguments: (elem copyWithoutIndex: 2)].
	elem second = #decl: ifTrue: [^self perform: #define:decl: withArguments: (elem copyWithoutIndex: 2)].
	elem second = #list: ifTrue: [^self perform: #define:list: withArguments: (elem copyWithoutIndex: 2)].
	self error: 'unknown define for ', self svoName! !

!GbtDeclarative methodsFor: 'define' stamp: 'hk 5/18/2016 16:45'!
defineFrom: definitionArray   
	definitionArray do: [ :elem | elem size = 1 
		ifTrue: [ self perform: #define:  withArguments: elem ]
		ifFalse: [self defineElementFrom: elem  ] ]! !

!GbtDeclarative methodsFor: 'reflective operations' stamp: 'hk 2/17/2017 17:02'!
doesNotUnderstand: aMessage 
	"answer the slot res the value named by aMessage 
	or change a valueSlot"
	
	| sel getter result |
	sel := aMessage selector.
	getter := (sel trimRight: [ :c | c = $: ]) asSymbol .
	result := self slotSVOAt: getter ifAbsent: "not my node"
			[^super doesNotUnderstand: aMessage] .	
	sel isKeyword ifTrue:		"is setter"
		[ ^result isValue 		"GbtLeaf"
			ifTrue: [ result inputValue:  aMessage argument ] 
			ifFalse: [super doesNotUnderstand: aMessage]  ].

	^result isValue ifTrue: [ result val ] ifFalse: [ result]
	! !

!GbtDeclarative methodsFor: 'api' stamp: 'hk 2/17/2017 18:17'!
embed: aThing in: target
	"fill target with data of aSource:
	remove all public slots referenced by aView,
	then copy data from aThing"

	self tagSlots do: 
		[ :s | |oldSlot k t | 
		k := s key. t := s value.
		t isSymbol "or aView"
			ifFalse: [ t embed: (aThing perform: k) in: target ] 
			ifTrue: 
				[([aThing perform: k] ifError: ["no source"]) copy ifNotNil: [:newSlot| 
					oldSlot := target slotSVOAt: t. 		
					((newSlot isKindOf: GbtThing) and:[oldSlot isKindOf: GbtThing])
						ifTrue: [newSlot embedPrivateSlotsOf: oldSlot].
					target perform: t asMutator with: newSlot ]]]! !

!GbtDeclarative methodsFor: 'accessing' stamp: 'hk 8/11/2016 16:23'!
idNumberPolicy: aPolicy
	idNumberPolicy := aPolicy 
	! !

!GbtDeclarative methodsFor: 'initialization' stamp: 'hk 2/17/2017 16:32'!
initialize
	super initialize.
	slots := OrderedCollection new.
	self clearSources! !

!GbtDeclarative methodsFor: 'testing' stamp: 'hk 5/18/2016 16:28'!
isDeclarative
	^true! !

!GbtDeclarative methodsFor: 'private' stamp: 'hk 7/25/2016 11:56'!
listSlotAt: arrayOfTagAndDeclAndFilter ifAbsent: aBlock public: aBoolean
	"the tag target is a Ulist. answer a transformed (by decl) Ulist"
	
	| tag decl uList filter |  
	tag := arrayOfTagAndDeclAndFilter first.
	decl := arrayOfTagAndDeclAndFilter second.
	filter := arrayOfTagAndDeclAndFilter at: 3 ifAbsent: [].
	uList := self sourceSlotAt: tag ifAbsent: [^aBlock] public: aBoolean.
	(uList isKindOf: GbtUlist) ifFalse: [^aBlock].
	^decl newList: uList withSources: sources filteredBy: filter
	! !

!GbtDeclarative methodsFor: 'api' stamp: 'hk 3/17/2017 17:23'!
new: aName withSource: oneOrMoreThings 
	"create the full & smart thing of type aName from oneOrMoreThings"
	|  smartThing oldSrces|
	self check: [ aName isString ] toBe: #aString.
	self checkThingMakeColl: oneOrMoreThings .
 
	smartThing := self bizApp addThing: (GbtThing copy: aName ifAbsent: [GbtThing struct: aName]).
	oldSrces := sources copy.
	sources addAllFirst: oneOrMoreThings.
	self copySourcesOn: smartThing. 
	summary ifNil: [smartThing summary: (sources collect: [:s|s summaryEnriched]) asCommaString] .
	sources := oldSrces .
	^smartThing.
	! !

!GbtDeclarative methodsFor: 'api' stamp: 'hk 11/2/2016 15:24'!
newList: uList withSources: oneOrMoreThings filteredBy: aFilterThing
	"answer a new Ulist with elements transdformed by me"
	| newList declName|
	newList := GbtUlist new.
	self sources: oneOrMoreThings.
	declName := svoName.
	uList list do: 	[:e|  	"need a unique name for each declarative / list element ..."
		self svoName: declName, e bizId . 
		newList newEntry: (self copyWithSource: e )].
	self svoName: declName.
	^newList
	! !

!GbtDeclarative methodsFor: 'printing' stamp: 'hk 8/3/2015 15:46'!
printOn: aStream
	aStream nextPutAll: self longName "substrings first" ! !

!GbtDeclarative methodsFor: 'api' stamp: 'hk 2/17/2017 17:04'!
publicSlotSVOAt: aSlotName
	"answer either the leaf or thing found or
	if a tag found: the source leaf or node if not private, 
	if a Declarative found: the result of its application"

	^self publicSlotSVOAt: aSlotName ifAbsent: [^nil]

	
! !

!GbtDeclarative methodsFor: 'api' stamp: 'hk 2/17/2017 16:59'!
publicSlotSVOAt: aSlotName ifAbsent: aBlock
	"answer either the leaf or thing found or
	if a tag found: the source leaf or node if not private, 
	if a Declarative found: the result of its application"

	^self slotAt: aSlotName ifAbsent: aBlock public: true
	
! !

!GbtDeclarative methodsFor: 'accessing' stamp: 'hk 2/17/2017 16:40'!
slotAt: aSlotName
	^(slots detect: [:s| s key = aSlotName] ifNone: [^nil] ) value
	! !

!GbtDeclarative methodsFor: 'private' stamp: 'hk 2/17/2017 16:44'!
slotAt: aSlotName ifAbsent: aBlock public: aBoolean
	"source access"
	| tag |
	tag := self slotAt: aSlotName .
	tag isSymbol ifTrue: [^self sourceSlotAt: tag ifAbsent: aBlock public: aBoolean].	"answer the source leaf or node if not private"
	tag isArray ifTrue: [^self listSlotAt: tag ifAbsent: aBlock public: aBoolean].		"answer a transformed list node"
	tag isDeclarative ifTrue: [^tag new: tag svoName withSource: sources].				"answer a transformed node "
	(tag isLeaf | tag isNode) ifTrue: [^tag] .														"answer leaf or node (thing structure allowed)"


	
! !

!GbtDeclarative methodsFor: 'api' stamp: 'hk 2/17/2017 15:50'!
slotSVOAt: aSlotName
	"for compatibility with Things.
	answers the slot VO, i.e. target node if not own node"

	^ self slotSVOAt: aSlotName ifAbsent: [ ]! !

!GbtDeclarative methodsFor: 'api' stamp: 'hk 2/17/2017 15:50'!
slotSVOAt: aSlotName ifAbsent: aBlock 
	"for compatibility with Things.
	answer the slot VO, i.e. own node or source node.
	note that a further source node with same name will be masked"
	
	^self slotAt: aSlotName ifAbsent: aBlock public: false

  ! !

!GbtDeclarative methodsFor: 'accessing' stamp: 'hk 5/18/2016 12:05'!
slots
	^slots! !

!GbtDeclarative methodsFor: 'private' stamp: 'hk 7/15/2016 16:00'!
sourceSlotAt: tag ifAbsent: aBlock public: aBoolean
	"answer the slot VO (if not private), i.e. own node or source node.
	note that a further source node with same name will be masked"
	
	|  path |  
	sources do: [ :s | 
			(s respondsTo: tag) ifTrue: [^GbtValueLeaf withValue: (s perform: tag)].	"for direct attributes like bizId"
			path := s pathTo: tag . 
			(path isNil or: [aBoolean and: [ (s nodeAndSlotAssocOnPath: path) second isPrivate] ]) 
				ifFalse: [^s slotOnPath: path]].
	 ^aBlock value
  ! !

!GbtDeclarative methodsFor: 'initialization' stamp: 'hk 1/12/2017 12:27'!
sources: oneOrMoreThing   
	"set a single source or a list thereof. clear with nil"
	
	oneOrMoreThing ifNil: [^self clearSources].	
	sources := (self checkThingMakeColl: oneOrMoreThing) ! !

!GbtDeclarative methodsFor: 'accessing' stamp: 'hk 8/25/2016 17:53'!
summary: aString
	summary := aString
	! !

!GbtDeclarative methodsFor: 'accessing' stamp: 'hk 10/20/2016 21:17'!
svoName
	^ svoName ifNil: [super svoName]! !

!GbtDeclarative methodsFor: 'accessing' stamp: 'hk 10/11/2016 16:40'!
svoName: aString
	svoName := aString! !

!GbtDeclarative methodsFor: 'accessing' stamp: 'hk 2/17/2017 16:39'!
tagSlots
	^slots select: [ :s | s isTag  or: [s isDeclarative] ]
	! !

GbtSVO subclass: #GbtLeaf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Things'!

!GbtLeaf commentStamp: 'hk 4/10/2015 12:44' prior: 0!
I am an abstract leaf in a VO tree.

!

GbtLeaf subclass: #GbtEnumLeaf
	instanceVariableNames: 'list selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Things'!

!GbtEnumLeaf commentStamp: 'hk 2/12/2017 15:07' prior: 0!
I represent an enumeration with a selection.
The first item of the enumeration is the default selection.
My collection may be sorted alphabetically.

Instance Variables
	list:			<OrderedCollection of String>		items may be added
	selection:	<String | Number | ByteSymbol>
!

!GbtEnumLeaf class methodsFor: 'accessing' stamp: 'hk 5/11/2016 12:40'!
uiClass
	^GbtChoiceWidget! !

!GbtEnumLeaf class methodsFor: 'instance creation' stamp: 'hk 1/12/2017 15:22'!
withList: arrayOfString 
	"input used in authoring is protected here"
	
	^self new list: (self checkStringMakeColl: arrayOfString)! !

!GbtEnumLeaf methodsFor: 'comparing' stamp: 'hk 2/20/2017 12:57'!
= anotherEnumVO
	^super = anotherEnumVO and: [self list = anotherEnumVO list]! !

!GbtEnumLeaf methodsFor: 'comparing' stamp: 'hk 11/9/2016 12:30'!
hash
	^self list hash! !

!GbtEnumLeaf methodsFor: 'accessing' stamp: 'hk 2/12/2017 15:23'!
inputValue
	^self selection ! !

!GbtEnumLeaf methodsFor: 'accessing' stamp: 'hk 2/15/2017 12:53'!
inputValue: aNewOrOldItem
	self selection: aNewOrOldItem 
! !

!GbtEnumLeaf methodsFor: 'testing' stamp: 'hk 11/2/2016 11:22'!
isFilled
	"used for constraints"
	^selection isNotNil and: [selection isNotEmpty]! !

!GbtEnumLeaf methodsFor: 'testing' stamp: 'hk 4/29/2015 17:33'!
isValue
	^true! !

!GbtEnumLeaf methodsFor: 'accessing' stamp: 'hk 4/4/2015 13:33'!
list
	^list! !

!GbtEnumLeaf methodsFor: 'accessing' stamp: 'hk 11/5/2015 11:02'!
list: arrayOfString
	list := arrayOfString asOrderedCollection 	! !

!GbtEnumLeaf methodsFor: 'copying' stamp: 'hk 3/2/2017 14:33'!
postCopy
	super postCopy.
	list := list copy .
	selection := selection copy .
! !

!GbtEnumLeaf methodsFor: 'printing' stamp: 'hk 2/23/2017 11:50'!
printOn: aStream
	super printOn: aStream .
	aStream nextPutAll: self selection printString.
	aStream nextPutAll: ' of '.
	self list printElementsOn: aStream! !

!GbtEnumLeaf methodsFor: 'printing' stamp: 'hk 8/16/2016 17:19'!
printVal
	^self list printString! !

!GbtEnumLeaf methodsFor: 'authoring' stamp: 'hk 2/12/2017 15:22'!
selection
	^(selection ifNil: [(list ifEmpty: [^'']) first])! !

!GbtEnumLeaf methodsFor: 'authoring' stamp: 'hk 2/20/2017 18:19'!
selection: anItem
	| item |
	item := anItem asString.
	self selection = item ifTrue: [^self].
	(list includes: item) ifFalse: [list addFirst: item].
	selection := item.
! !

!GbtEnumLeaf methodsFor: 'accessing' stamp: 'hk 2/12/2017 15:23'!
val
	^self selection! !

!GbtLeaf class methodsFor: 'accessing' stamp: 'hk 1/14/2016 18:57'!
uiClass
	"the widget class for the default thing editor (GcNewVoEditor)"
	^self subclassResponsibility ! !

!GbtLeaf methodsFor: 'comparing' stamp: 'hk 2/20/2017 12:48'!
= anotherLeaf
	^anotherLeaf class = self class
! !

!GbtLeaf methodsFor: 'accessing' stamp: 'hk 6/22/2016 16:17'!
classInitial
	^#L! !

!GbtLeaf methodsFor: 'comparing' stamp: 'hk 11/9/2016 12:44'!
hash
	^self subclassResponsibility ! !

!GbtLeaf methodsFor: 'accessing' stamp: 'hk 2/12/2017 14:30'!
inputValue
	^self subclassResponsibility ! !

!GbtLeaf methodsFor: 'accessing' stamp: 'hk 2/12/2017 14:51'!
inputValue: aValue
	^self subclassResponsibility ! !

!GbtLeaf methodsFor: 'testing' stamp: 'hk 12/3/2015 20:59'!
isLeaf
	^true! !

!GbtLeaf methodsFor: 'printing' stamp: 'hk 2/23/2017 11:55'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ': '! !

!GbtLeaf methodsFor: 'printing' stamp: 'hk 11/2/2016 11:21'!
printVal
	^self subclassResponsibility ! !

!GbtLeaf methodsFor: 'accessing' stamp: 'hk 1/23/2016 19:27'!
uiClass
	^self defaultUiClass! !

!GbtLeaf methodsFor: 'accessing' stamp: 'hk 11/2/2016 11:19'!
val
	^self subclassResponsibility ! !

GbtLeaf subclass: #GbtValueLeaf
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Things'!

!GbtValueLeaf commentStamp: 'hk 4/9/2015 12:28' prior: 0!
I am a value - leaf in a VO tree

Instance Variables
	value:		<String>

!

GbtValueLeaf subclass: #GbtDateLeaf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Things'!

!GbtDateLeaf commentStamp: 'hk 9/20/2016 11:54' prior: 0!
I hold a date string as my value


====== Tests ======  see Date class

GbtDateVO new date: '2012.06.15'
GbtDateVO new date: '6.15.2012'
GbtDateVO new date: '6/15/2012'
GbtDateVO new date: '15 June 2012'
GbtDateVO new date: 'June 15 2012'
GbtDateVO new date: ' 6 15 2012'
GbtDateVO new date: '2012-06-15'
GbtDateVO new date: '2012 06 15'

GbtDateVO new date: Date today
!

!GbtDateLeaf class methodsFor: 'accessing' stamp: 'hk 5/11/2016 12:41'!
uiClass
	^GbtDateWidget! !

!GbtDateLeaf class methodsFor: 'instance creation' stamp: 'hk 2/22/2017 12:15'!
withDate: aStringOrDate
	"input used in authoring is protected here"

	^ self new inputValue: (self checkDateMakeString: aStringOrDate)! !

!GbtDateLeaf methodsFor: 'accessing' stamp: 'hk 2/22/2017 12:30'!
val
	^ ([Date fromString: value] ifError: [ Date fromString:  '1000-01-01'  ]) asString! !

GbtValueLeaf subclass: #GbtExpressionLeaf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Things'!

!GbtExpressionLeaf commentStamp: 'hk 2/11/2017 15:27' prior: 0!
I represent a calculated value of: 
- a Smalltalk Expression  (keyword eval or none) 
- a sum or product over all slots  with a given tag or slotName 
- a reference to a slot with a given smartPath
- a lookup reference that calculates the reference smartpath from the contents of the given slots.
  the arguments (given slots ) may be tags or smartPaths

Examples:  
	define: #slot calc: '7 + 3 * #slot2'
	define: #slot calc: 'eval 7 + 3 * #slot2'
	define: #slot calc: 'sum  #tag2'
	define: #slot calc: 'prod  #tag2'
	define: #slot calc: 'ref  #tag2'
	define: #slot calc: 'ref  #slot1:slot2:slot3'
	define: #slot calc: 'lookup  #tag3 #slot4'
	define: #slot calc: 'lookup  #slot1:slot2:slot3  #slot1:slot4  #slot5'
!

GbtExpressionLeaf subclass: #GbtConstraintLeaf
	instanceVariableNames: 'violationString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Things'!

!GbtConstraintLeaf commentStamp: 'hk 12/19/2016 17:42' prior: 0!
I am a GbtCalcLeaf used as Constraint on Values (Strings and Numbers)

the expression (my rawValue) shall  evaluate to true or false. 
In case of Error it results in the enriched String

 

    Instance Variables
	violationString:		<String>
!

!GbtConstraintLeaf methodsFor: 'calc values' stamp: 'hk 2/26/2017 14:08'!
calcValue 
		^self compile: (container globalRoot enrichFromTagsQuoted: value)
! !

!GbtConstraintLeaf methodsFor: 'accessing' stamp: 'hk 7/8/2016 14:29'!
ghostText
	^'constraint'! !

!GbtConstraintLeaf methodsFor: 'testing' stamp: 'hk 11/9/2016 13:00'!
isGbtConstraint
	^true! !

!GbtConstraintLeaf methodsFor: 'accessing' stamp: 'hk 12/20/2016 12:28'!
violationString
	^violationString ifNil: self printVal! !

!GbtConstraintLeaf methodsFor: 'accessing' stamp: 'hk 12/19/2016 17:41'!
violationString: aString
	violationString := aString! !

!GbtExpressionLeaf class methodsFor: 'as yet unclassified' stamp: 'hk 2/11/2017 14:36'!
uiClass
	^ GbtCalcWidget ! !

!GbtExpressionLeaf methodsFor: 'calculating' stamp: 'hk 2/11/2017 15:40'!
calcValue
	| vss | 
	(vss := value substrings) ifEmpty: [^self eval: value].
	vss first = #eval ifTrue: 	[^self eval: (value withoutPrefix: #eval)].
	vss first = #sum ifTrue: 	[^self sum: vss second allButFirst asSymbol].
	vss first = #prod ifTrue: 	[^self prod: vss second allButFirst asSymbol].
	vss first = #ref ifTrue: 	[^self ref: vss second allButFirst asSymbol].
	vss first = #lookup ifTrue: [^self lookup: (value withoutPrefix: #lookup)].
	^self eval: value 
! !

!GbtExpressionLeaf methodsFor: 'private' stamp: 'hk 2/11/2017 15:41'!
compile: expr     
	^[OpalCompiler evaluate: expr] 
		on: Error, SyntaxErrorNotification
		do:  ['cannot eval: ',expr]! !

!GbtExpressionLeaf methodsFor: 'calculating' stamp: 'hk 2/10/2017 21:38'!
eval: aString
	^self compile: (container globalRoot enrichFromTags: aString)! !

!GbtExpressionLeaf methodsFor: 'accessing' stamp: 'hk 2/11/2017 13:18'!
ghostText
	^'calculation'! !

!GbtExpressionLeaf methodsFor: 'testing' stamp: 'hk 2/11/2017 14:22'!
isCalc
	^true! !

!GbtExpressionLeaf methodsFor: 'testing' stamp: 'hk 2/11/2017 13:19'!
isFilled
	"used for constraints"
	^true! !

!GbtExpressionLeaf methodsFor: 'calculating' stamp: 'hk 2/11/2017 13:17'!
lookup: aString
	^self ref: (self localRoot resolveToSmartPath: aString)
! !

!GbtExpressionLeaf methodsFor: 'private' stamp: 'hk 2/10/2017 19:38'!
multiplyNumbers: aColl
	^ aColl  inject: 1 into: [ :prod :e | prod * e ]
	! !

!GbtExpressionLeaf methodsFor: 'calculating' stamp: 'hk 2/10/2017 19:47'!
prod: aString
	^(self multiplyNumbers: ((container ifNil: [^'error']) numbersTaggedWith: aString) ) asString! !

!GbtExpressionLeaf methodsFor: 'calculating' stamp: 'hk 2/10/2017 19:54'!
ref: aString
	| res |  
	res := self localRoot testAndResolveTag: aString.
	res ifString: [^res].		"if not it's a node's value"
	^(res ifNil: [^#nil]) longName! !

!GbtExpressionLeaf methodsFor: 'calculating' stamp: 'hk 3/25/2017 14:49'!
sum: aString  
	^(((container ifNil: [^'container error']) numbersTaggedWith: aString) sumNumbers: [ :e | e ]) asString! !

!GbtExpressionLeaf methodsFor: 'accessing' stamp: 'hk 2/11/2017 13:12'!
val
	^self calcValue asString! !

GbtValueLeaf subclass: #GbtNumberLeaf
	instanceVariableNames: 'min max input'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Things'!

!GbtNumberLeaf commentStamp: 'hk 11/5/2015 14:05' prior: 0!
I am a range - leaf in a VO tree
my value is a string, containing my number or an error text

Instance Variables
	max:		<Number>
	min:		<Number>
	input: 		the original input
===============================

	((ThingVO newOfType: #bla)
		define: #no no:  7 from: 2 to: 7 ) edit
		
	(ThingVO newOfType: 'GCDimensions' define: { 
	{ #lenght . #no:from:to:tag: . 2 . 0 . nil . #dimensionVolume}.
	{ #hight . #no:tag: . 3 . #dimensionVolume}.
	{ #breadth . #no:from:to:tag: . 0 . 0 . 1 . #dimensionVolume}.
	{ #volume . #prod: . #dimensionVolume}} ) editVO!

!GbtNumberLeaf class methodsFor: 'accessing' stamp: 'hk 2/15/2017 11:39'!
uiClass
	^ GbtNumberWidget ! !

!GbtNumberLeaf methodsFor: 'accessing' stamp: 'hk 11/2/2016 11:56'!
ghostText
	| str |
	str := WriteStream on: ''. 
	min ifNotNil: [str nextPutAll: 'min: '; nextPutAll: min asString].
	max ifNotNil: [str nextPutAll: ' max:'; nextPutAll: max asString]. 
	str isEmpty ifTrue: [ str nextPutAll: 'unlimited' ].
	^str contents! !

!GbtNumberLeaf methodsFor: 'testing' stamp: 'hk 2/26/2017 11:59'!
isFilled
	"used for constraints"
	[value asNumber] ifError: [^false].
	^value isNotNil and: [value asNumber isZero not]! !

!GbtNumberLeaf methodsFor: 'accessing' stamp: 'hk 11/5/2015 16:41'!
max
	^max ! !

!GbtNumberLeaf methodsFor: 'accessing' stamp: 'hk 1/12/2017 16:29'!
max: aNumber
	max := self checkNoMakeString: (aNumber ifNil: [^self])! !

!GbtNumberLeaf methodsFor: 'accessing' stamp: 'hk 11/5/2015 16:23'!
min 
	^min ! !

!GbtNumberLeaf methodsFor: 'accessing' stamp: 'hk 1/12/2017 16:29'!
min: aNumber
	min := self checkNoMakeString: (aNumber ifNil: [^self])! !

!GbtNumberLeaf methodsFor: 'copying' stamp: 'hk 4/29/2015 11:53'!
postCopy
	super postCopy  .
	min := min copy .
	max := max copy! !

GbtValueLeaf subclass: #GbtTextLeaf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Things'!

!GbtTextLeaf commentStamp: 'hk 8/16/2016 12:08' prior: 0!
I hold a Text!

!GbtTextLeaf class methodsFor: 'accessing' stamp: 'hk 5/11/2016 12:41'!
uiClass
	^GbtTextWidget! !

!GbtTextLeaf methodsFor: 'printing' stamp: 'hk 2/21/2017 17:31'!
printString
	^self printStringLimitedTo: 50! !

!GbtValueLeaf class methodsFor: 'accessing' stamp: 'hk 5/11/2016 12:41'!
uiClass
	^ GbtValueWidget ! !

!GbtValueLeaf class methodsFor: 'instance creation' stamp: 'hk 2/12/2017 14:51'!
withValue: aString
	"input used in authoring is protected here"
	self check: [aString isString] toBe: #aString.
	^ self new inputValue: aString! !

!GbtValueLeaf methodsFor: 'comparing' stamp: 'hk 2/20/2017 12:49'!
= anotherValueVO
	^super = anotherValueVO and: [self inputValue = anotherValueVO inputValue]! !

!GbtValueLeaf methodsFor: 'comparing' stamp: 'hk 2/12/2017 14:30'!
hash
	^self inputValue hash! !

!GbtValueLeaf methodsFor: 'accessing' stamp: 'hk 2/12/2017 14:30'!
inputValue
	^value ! !

!GbtValueLeaf methodsFor: 'accessing' stamp: 'hk 2/20/2017 12:42'!
inputValue: aString
	value = aString asString ifTrue: [^self].
	value := aString asString
	! !

!GbtValueLeaf methodsFor: 'testing' stamp: 'hk 11/2/2016 11:23'!
isFilled
	"used for constraints"
	value ifNil: [^false].
	value isNumber ifTrue: [^value isZero not].
	value isString ifTrue: [^value isNotEmpty].
	^true! !

!GbtValueLeaf methodsFor: 'testing' stamp: 'hk 4/4/2015 14:11'!
isValue
	^true! !

!GbtValueLeaf methodsFor: 'copying' stamp: 'hk 3/2/2017 14:32'!
postCopy
	super postCopy.
	value := value copy! !

!GbtValueLeaf methodsFor: 'printing' stamp: 'hk 2/23/2017 11:51'!
printOn: aStream
	super printOn: aStream .
	aStream nextPutAll: (value ifNil: [''])! !

!GbtValueLeaf methodsFor: 'printing' stamp: 'hk 2/21/2017 17:34'!
printVal
	^value ifNil: [ '' ]! !

!GbtValueLeaf methodsFor: 'accessing' stamp: 'hk 2/12/2017 14:30'!
val
	^self inputValue asString ! !

GbtSVO subclass: #GbtNoPolicy
	instanceVariableNames: 'prefix getter last bareID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-core'!

!GbtNoPolicy commentStamp: 'hk 3/29/2017 15:17' prior: 0!
I represent any number policy.
My default uses nextStringID without prefix.
next gives the next integer.

    Instance Variables
	bareID:		<Integer>
	last: 		<Integer> 		99 max SmallInteger maxValue
	prefix : 		<String> 		 instance specific for technical id
	getter : 		<Selector>
	svoName: 	<String> 		semantic part of name
!

!GbtNoPolicy methodsFor: 'comparing' stamp: 'hk 8/27/2015 11:15'!
< aPolicyNo
	^self number < aPolicyNo number! !

!GbtNoPolicy methodsFor: 'accessing' stamp: 'hk 3/30/2017 12:21'!
adaptTo: anID   
	"used while reading from a database"
	bareID := bareID max: anID squeezeOutNumber		"a very simple strategy"! !

!GbtNoPolicy methodsFor: 'protocol' stamp: 'hk 3/29/2017 15:03'!
alphaCapID
	^self nextAlphaID:  65 
	
	"|gen res| 
	gen := self new getter: #alphaCapID.
	res := gen nextID.
	36 timesRepeat: [res := res,gen nextID].
	res "
! !

!GbtNoPolicy methodsFor: 'protocol' stamp: 'hk 3/29/2017 15:04'!
alphaSmallID
	^self nextAlphaID: 97 
		
	"|gen res| 
	gen := self new getter: #alphaSmallID.
	res := gen nextID.
	36 timesRepeat: [res := res,gen nextID].
	res "! !

!GbtNoPolicy methodsFor: 'accessing' stamp: 'hk 6/22/2016 16:17'!
classInitial
	^#P! !

!GbtNoPolicy methodsFor: 'accessing' stamp: 'hk 2/20/2016 16:06'!
getter: aSymbol 
	getter := aSymbol! !

!GbtNoPolicy methodsFor: 'initialization' stamp: 'hk 11/17/2016 16:53'!
initialize 
	super initialize.
	bareID := 0.
	self last: 9999.
	prefix := ''.
	getter := #nextStringID! !

!GbtNoPolicy methodsFor: 'testing' stamp: 'hk 7/17/2015 17:35'!
isNoPolicy
	^true! !

!GbtNoPolicy methodsFor: 'accessing' stamp: 'hk 11/17/2016 16:43'!
last
 	^last! !

!GbtNoPolicy methodsFor: 'accessing' stamp: 'hk 11/17/2016 16:43'!
last: anInteger
 	last := anInteger ! !

!GbtNoPolicy methodsFor: 'accessing' stamp: 'hk 11/17/2016 17:07'!
next   
	^bareID := (bareID + 1) \\last! !

!GbtNoPolicy methodsFor: 'protocol' stamp: 'hk 3/29/2017 14:54'!
nextAlphaID: offset
	"turn the number into Alpha. offset = 97 (small) and 65 (Caps)"
	
	| int running resid res char |
	int := self next -1. 	"start with 0"
	running := int \\ 26.	"26 Chars"
	resid := int // 26.	"that many times"
	res := ''.
	char := Character value:  running + offset .
	resid +1 timesRepeat: [res := res, char asString].
	^res
	
	"|gen res| 
	gen := self new.
	res := gen nextAlphaID: 97. 52 timesRepeat: [res := res,gen nextID].
	res "
! !

!GbtNoPolicy methodsFor: 'protocol' stamp: 'hk 11/9/2016 17:07'!
nextID
	^self perform: getter! !

!GbtNoPolicy methodsFor: 'protocol' stamp: 'hk 3/29/2017 15:01'!
nextStringID
	^prefix, self next asString
	
	"|gen res| 
	gen := self new prefix: #abc.
	res := gen nextAlphaID: 97. 
	12 timesRepeat: [res := res,gen nextStringID].
	res "
! !

!GbtNoPolicy methodsFor: 'accessing' stamp: 'hk 11/17/2016 16:52'!
number 
	^bareID ! !

!GbtNoPolicy methodsFor: 'copying' stamp: 'hk 11/17/2016 16:52'!
postCopy
	super postCopy.
	bareID := bareID copy.
	prefix := prefix copy.
	getter := getter copy.
! !

!GbtNoPolicy methodsFor: 'accessing' stamp: 'hk 11/17/2016 16:36'!
prefix: aString
	prefix := aString.
	getter := #nextStringID! !

!GbtSVO class methodsFor: 'checking' stamp: 'hk 1/7/2016 16:19'!
check: aBlock toBe: aSymbol	
	[aBlock value ifFalse: [ self error ] ] 
		ifError: [ ^self error: aSymbol , ' expected'].
! !

!GbtSVO class methodsFor: 'checking' stamp: 'hk 1/13/2017 17:48'!
checkDateMakeString: aStringOrDate
	aStringOrDate ifString: [aStringOrDate ifEmpty: [^aStringOrDate]].
	self check: [aStringOrDate asDate asString isString] toBe: #aDateOrString.
	^aStringOrDate asString! !

!GbtSVO class methodsFor: 'checking' stamp: 'hk 1/12/2017 16:17'!
checkNoMakeString: aStringOrNumber
	self check: [aStringOrNumber asString asNumber isNumber] toBe: #aNumberString.
	^aStringOrNumber asString! !

!GbtSVO class methodsFor: 'checking' stamp: 'hk 1/12/2017 18:15'!
checkStringMakeColl: oneOrMoreStrings
	| coll |
	oneOrMoreStrings ifString: [^{oneOrMoreStrings}].
	[coll := oneOrMoreStrings	collect: [:e| e asString]]	ifError: [ ^self error: 'one or more Strings expected'].
	^coll! !

!GbtSVO class methodsFor: 'checking' stamp: 'hk 1/12/2017 12:27'!
checkThingMakeColl: oneOrMoreThings
	| coll |
	coll := oneOrMoreThings asOrderedCollection.
	self check: [coll allSatisfy: [ :e | e isNode] ] toBe: #aCollectionOfThings.
	^coll! !

!GbtSVO class methodsFor: 'error handling' stamp: 'hk 5/12/2016 21:20'!
error: aString
	^GbtError signal: aString! !

!GbtSVO class methodsFor: 'class initialization' stamp: 'hk 11/1/2016 14:06'!
initialize
	lastID  := 0.
	self subclassesDo: [:cls| cls initialize ]! !

GbtSVO initialize!

!GbtSVO class methodsFor: 'accessing' stamp: 'hk 10/12/2016 15:44'!
nextID
	"answer a smallInteger - modulo largest integer"
	^ lastID := (lastID + 1) \\ SmallInteger maxVal! !

!GbtSVO class methodsFor: 'authoring' stamp: 'hk 3/14/2017 13:02'!
struct: aString 
	"answer the context typed aString. If new, create it"

	^self struct: aString define: #()
		! !

!GbtSVO class methodsFor: 'authoring' stamp: 'hk 3/14/2017 13:01'!
struct: aString define: anArray
	^self subclassResponsibility 
		! !

!GbtSVO class methodsFor: 'accessing' stamp: 'hk 9/3/2015 18:26'!
uiClass
	^nil! !

!GbtSVO methodsFor: 'printing' stamp: 'hk 9/30/2016 18:22'!
autoName
	^(self classInitialAndId , self versionString) asSymbol! !

!GbtSVO methodsFor: 'pending data' stamp: 'hk 2/15/2017 15:52'!
beDirty  
	dirty := true. 
	container ifNotNil: [:c| c beDirty ]! !

!GbtSVO methodsFor: 'accessing' stamp: 'hk 3/23/2017 14:35'!
bizApp
	"the GbtBizApp for my user is my programStore"
	^bizApp ifNil: [GbtBizAppServer default]! !

!GbtSVO methodsFor: 'accessing' stamp: 'hk 3/23/2017 14:35'!
bizApp: aGbtBizApp
	bizApp := aGbtBizApp ! !

!GbtSVO methodsFor: 'checking' stamp: 'hk 1/7/2016 16:20'!
check: aBlock toBe: aSymbol	
	self class check: aBlock toBe: aSymbol	
! !

!GbtSVO methodsFor: 'checking' stamp: 'hk 1/12/2017 16:23'!
checkNoMakeString: aStringOrNumber
	^self class checkNoMakeString: aStringOrNumber! !

!GbtSVO methodsFor: 'checking' stamp: 'hk 1/12/2017 12:28'!
checkStringMakeColl: oneOrMoreStrings
	^self class checkStringMakeColl: oneOrMoreStrings! !

!GbtSVO methodsFor: 'checking' stamp: 'hk 1/12/2017 12:27'!
checkThingMakeColl: oneOrMoreThings
	^self class checkThingMakeColl: oneOrMoreThings! !

!GbtSVO methodsFor: 'accessing' stamp: 'hk 6/22/2016 16:18'!
classInitial
	^self subclassResponsibility ! !

!GbtSVO methodsFor: 'accessing' stamp: 'hk 6/22/2016 17:12'!
classInitialAndId
	^self classInitial , id asString ! !

!GbtSVO methodsFor: 'accessing' stamp: 'hk 5/28/2015 14:53'!
container
	^ container! !

!GbtSVO methodsFor: 'accessing' stamp: 'hk 2/3/2017 15:26'!
container: anObjectOrNil
	(self isSmart and: [anObjectOrNil isNotNil and: [container isNotNil]]) ifTrue: 
			[self inform: 'double used in ', anObjectOrNil svoName] . 
	container := anObjectOrNil! !

!GbtSVO methodsFor: 'pending data' stamp: 'hk 11/1/2016 16:27'!
dataPending
	^dataPending ifNil: [dataPending := false asValueHolder]! !

!GbtSVO methodsFor: 'accessing' stamp: 'hk 1/23/2016 19:15'!
defaultUiClass
	"default widget class"
	^self class uiClass! !

!GbtSVO methodsFor: 'utility' stamp: 'hk 4/30/2016 16:48'!
edit
	(GbtThingEditor on: self) openWithSpec! !

!GbtSVO methodsFor: 'utility' stamp: 'hk 4/30/2016 16:48'!
editD
	(GbtThingDiEditor on: self) openWithSpec! !

!GbtSVO methodsFor: 'error handling' stamp: 'hk 1/7/2016 16:20'!
error: aString
	^self class error: aString! !

!GbtSVO methodsFor: 'copying' stamp: 'hk 3/2/2017 14:30'!
evolve
	"is called before writing a slot. Also see GbtWidget.write"
	previous := self shallowCopy.
	self postCopySlots.
	container ifNotNil: [previous replaceContainer: container evolve].
	self beDirty .
	^previous

! !

!GbtSVO methodsFor: 'accessing' stamp: 'hk 12/13/2016 15:21'!
globalRoot
	"answer the root of the complete container hierarchy"
	
	^(container ifNil: [^self]) globalRoot! !

!GbtSVO methodsFor: 'pending data' stamp: 'hk 6/8/2015 15:39'!
hasDataPending
	^self dataPending value = true! !

!GbtSVO methodsFor: 'testing' stamp: 'hk 1/23/2016 19:17'!
hasUI
	^self defaultUiClass isNotNil! !

!GbtSVO methodsFor: 'accessing' stamp: 'hk 8/26/2015 16:42'!
id
	^ id! !

!GbtSVO methodsFor: 'initialization' stamp: 'hk 7/27/2015 20:23'!
initialize
	super initialize.
	self initializeFields! !

!GbtSVO methodsFor: 'initialization' stamp: 'hk 3/1/2017 17:22'!
initializeFields
	container := nil .
	self resetVersion .
	dataPending := nil .
	dirty := false.
	previous := nil! !

!GbtSVO methodsFor: 'testing' stamp: 'hk 11/9/2016 12:58'!
isActiveContext
	^false! !

!GbtSVO methodsFor: 'testing' stamp: 'hk 2/11/2017 14:22'!
isCalc
	^false! !

!GbtSVO methodsFor: 'testing' stamp: 'hk 11/29/2016 13:33'!
isContainerRoot
	^container isNil! !

!GbtSVO methodsFor: 'testing' stamp: 'hk 5/18/2016 16:28'!
isDeclarative
	^false! !

!GbtSVO methodsFor: 'testing' stamp: 'hk 12/31/2015 13:49'!
isFilled
	"used for constraints"
	^false! !

!GbtSVO methodsFor: 'testing' stamp: 'hk 11/9/2016 12:59'!
isGbtBehavior
	^false! !

!GbtSVO methodsFor: 'testing' stamp: 'hk 11/9/2016 13:00'!
isGbtConstraint
	^false! !

!GbtSVO methodsFor: 'testing' stamp: 'hk 12/3/2015 20:59'!
isLeaf
	"used for slot navigation in DomainVO"
	^false! !

!GbtSVO methodsFor: 'testing' stamp: 'hk 9/15/2015 17:10'!
isListAc
	^false! !

!GbtSVO methodsFor: 'testing' stamp: 'hk 7/17/2015 17:35'!
isNoPolicy
	^false! !

!GbtSVO methodsFor: 'testing' stamp: 'hk 4/15/2015 17:15'!
isNode
	"used for slot navigation in DomainVO"
	^false! !

!GbtSVO methodsFor: 'testing' stamp: 'hk 12/1/2015 21:02'!
isSmart
	"used to identify a smart thing"
	^false  ! !

!GbtSVO methodsFor: 'testing' stamp: 'hk 7/4/2016 15:27'!
isSumLeaf
	"used for slot navigation in DomainVO"
	^false! !

!GbtSVO methodsFor: 'testing' stamp: 'hk 1/24/2016 12:50'!
isThing
	^false! !

!GbtSVO methodsFor: 'testing' stamp: 'hk 10/25/2016 14:56'!
isUlist
	^false! !

!GbtSVO methodsFor: 'testing' stamp: 'hk 4/15/2015 17:14'!
isValue
	"used for slot navigation in DomainVO"
	^false! !

!GbtSVO methodsFor: 'accessing' stamp: 'hk 1/20/2017 14:53'!
localRoot
	"answer the root of the fixed container hierarchy"
	
	(container ifNil: [^self]) isUlist ifTrue: [^self].
	^container localRoot! !

!GbtSVO methodsFor: 'printing' stamp: 'hk 11/1/2016 16:30'!
longName
	^String withAll: ({self svoName. ':'. self autoName} flatCollect: [:s|s])! !

!GbtSVO methodsFor: 'saving' stamp: 'hk 4/5/2015 13:20'!
nextVersion
	^version := version  +1! !

!GbtSVO methodsFor: 'error handling' stamp: 'hk 11/4/2016 13:06'!
notify: aString
	container notify: aString! !

!GbtSVO methodsFor: 'error handling' stamp: 'hk 11/1/2016 15:00'!
notifyA: anArrayOfString
	self notify: (String withAll: (anArrayOfString flatCollect: [:s|s]))
! !

!GbtSVO methodsFor: 'copying' stamp: 'hk 3/1/2017 16:25'!
postCopy
	self setID .
	self initializeFields! !

!GbtSVO methodsFor: 'accessing' stamp: 'hk 2/20/2017 19:13'!
previous
	"answer what was here (in my container) before"

	^previous ! !

!GbtSVO methodsFor: 'accessing' stamp: 'hk 2/18/2017 18:56'!
previous: predecessorThing
	"remember what was here before"

	previous := predecessorThing ! !

!GbtSVO methodsFor: 'accessing' stamp: 'hk 3/17/2017 17:22'!
programStore
	"the initial programStore is GbtBizAppServer default"
	^self bizApp! !

!GbtSVO methodsFor: 'initialization' stamp: 'hk 3/27/2017 12:52'!
release
	super release.
	container := nil 
! !

!GbtSVO methodsFor: 'copying' stamp: 'hk 2/21/2017 16:18'!
removePrevious
	previous := nil.
! !

!GbtSVO methodsFor: 'accessing' stamp: 'hk 2/15/2017 10:57'!
replaceContainer: anObjectOrNil
	container := anObjectOrNil! !

!GbtSVO methodsFor: 'private' stamp: 'hk 4/5/2015 13:20'!
resetVersion
	version := 0! !

!GbtSVO methodsFor: 'analyzing' stamp: 'hk 6/7/2015 13:31'!
rtAttributes
	^{ ( 'id: ', self id asString) . ( 'version: ', self version asString)}! !

!GbtSVO methodsFor: 'analyzing' stamp: 'hk 5/28/2015 13:13'!
rtSlots
	^#()! !

!GbtSVO methodsFor: 'pending data' stamp: 'hk 6/1/2016 15:14'!
setDataNotPending
	"the final implementation needs a kind of reference count"
	self dataPending value ifTrue: [self dataPending value: false]! !

!GbtSVO methodsFor: 'pending data' stamp: 'hk 6/20/2016 16:37'!
setDataPending
	"the final implementation needs a kind of reference count in contexts"
	self dataPending value ifFalse: [self dataPending value: true]
! !

!GbtSVO methodsFor: 'initialization' stamp: 'hk 3/29/2017 15:47'!
setID
	id := self bizApp tecNoPolicy nextID ! !

!GbtSVO methodsFor: 'accessing' stamp: 'hk 10/20/2016 21:16'!
svoName
	^#default! !

!GbtSVO methodsFor: 'accessing' stamp: 'hk 4/3/2015 18:11'!
version
	^version! !

!GbtSVO methodsFor: 'accessing' stamp: 'hk 6/22/2016 17:14'!
versionString
	^'v', self version asString! !

GbtSVO subclass: #GbtThing
	uses: TGbtSerializer + TGbtThingMeta
	instanceVariableNames: 'slots copies summary bizId context purposes smart widgetClass idNumberPolicy fullVO searchStrategy deleted consistent constraintViolationString svoName defaultPolicy depth originalSmart otherUserEdits saveContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Things'!

!GbtThing commentStamp: 'hk 2/17/2017 18:37' prior: 0!
I am a thing (Domain Value Object) or a node in a thing. 
My slots are  GbtSlotAssociations with leaves (LeafVO) or other nodes (GbtThing or GbtThingLink)  

If a view has at least one target, a copy of mine induces a targetCopies of that view.

Instance variables:
	svoName:		<String>							semantic part of name
	summary: 		<String>							short description (for GUI)
	purposes: 		<OrderedCollection of String>		usage of the thing
	bizId:			<nil | String>						application ID
	idNumberPolicy:	<String>							name of policy for appID
	slots:			<OrderedCollection of GbtSlotAssociation>				
	previous:		<ThingVO | nil>					previous object in the slot I am in (history)
	context: 			<Array | nil> 						of {AC svoName  .  AC user}
	saveContext: 	<Array | nil> 						same for save location
	searchStrategy 	<nil | Symbol>					nil: breadth search, notNil: depth first
	fullVO 			<#self | Array of Symbol | nil>		Array of svoName autoName
	originalSmart: 	<GbtThing | nil>					full thing only:  original smart thing 
	deleted: 			<Boolean>						willbe saved but not be read in
	consistent: 		<nil|Boolean>					after testing constraints 
	constraintViolationString	<String>					All violations
	otherUserEdits: 	<Boolean>						true if edited/created by  other  user			
	depth: 			<Number>						depth of hierarchy (full things only) for analysis
								
the longName is of the form  svoName,':', autoname =   \w+:[T|U][0-9]+v[0-9]+!

GbtThing class
	uses: TGbtSerializer classTrait + TGbtThingMeta classTrait
	instanceVariableNames: ''!

!GbtThing class methodsFor: 'retrieving' stamp: 'hk 3/21/2017 14:09'!
copy: aName ifAbsent: absentBlock
	^(self definedAs: aName ifAbsent: [^absentBlock value]) copy
		
! !

!GbtThing class methodsFor: 'retrieving' stamp: 'hk 11/16/2016 16:05'!
definedAs: aName
	"answer the thing with aName = svoName:id-version or svoName(with lowest id-version)"
	
	^ self definedAs: aName ifAbsent: [] ! !

!GbtThing class methodsFor: 'retrieving' stamp: 'hk 3/20/2017 12:56'!
definedAs: aName ifAbsent: absentBlock
	"answer the lowest or specified id-version of the thing named svoName"
	
	^GbtBizAppServer default thingDefinedAs: aName ifAbsent: absentBlock! !

!GbtThing class methodsFor: 'instance creation' stamp: 'hk 3/17/2017 17:30'!
new: smartName define: smartDefArray full: restOfDefArray
	"define a new smart thing together with its full thing"
	
	| fullName fullThing smartThing|
	fullName := 'F', smartName.
	smartThing := self basicNew svoName: smartName; initialize; setID; smart: true.
	fullThing := self basicNew svoName: fullName; initialize; setID; originalSmart: smartThing.
	GbtBizAppServer default add: smartThing full: fullThing.  
	smartThing fullVO: fullName.
	fullThing fullVO: fullName.			"refers to itself"
	^smartThing defineSmart: smartDefArray defineFull: restOfDefArray! !

!GbtThing class methodsFor: 'authoring' stamp: 'hk 3/14/2017 13:01'!
struct: aString define: definitionArray
	"answer a copy of the thing typed aString - create and define the copy master if new"

	^self struct: aString define: definitionArray full: #()! !

!GbtThing class methodsFor: 'authoring' stamp: 'hk 3/17/2017 20:06'!
struct: aString define: smartDefArray full: restDefArray
	"answer a copy of the thing typed aString - create and define the copy master if new"

	^(self definedAs: aString ifAbsent: 
		[self new: aString define: smartDefArray full: restDefArray]) copy! !

!GbtThing class methodsFor: 'accessing' stamp: 'hk 5/11/2016 12:44'!
uiClass
	^ GbtVoWidget ! !

!GbtThing methodsFor: 'comparing' stamp: 'hk 2/20/2017 12:57'!
= anotherThing
	"compares values on slot level" 
	(anotherThing class = self class) ifFalse: [^false].
	(slots size = anotherThing slots size) ifFalse: [^false].
	1 to: slots size do: [:i|
		((slots at: i) value = ((anotherThing slots at: i) value))
			ifFalse: [^false]].
	^true! !

!GbtThing methodsFor: 'accessing slots basic write' stamp: 'hk 2/22/2017 15:23'!
addSlot: aGbtSlotAssociation
	self evolve.
	^slots add: (aGbtSlotAssociation newValueContainer: self)

! !

!GbtThing methodsFor: 'smart' stamp: 'hk 2/17/2017 16:12'!
addSlotsFor: definitionArray
	definitionArray do: [:sn | self smartAddSlotSVO: sn] 
			! !

!GbtThing methodsFor: 'accessing leaf slots' stamp: 'hk 2/17/2017 16:08'!
allConstraintSVOs
	"answer all GbtConstraintLeafs in my hierarchy!!"
	| coll |
	coll := self leafSVOs select: [:s| s isGbtConstraint].
	self subnodes do: [:sn| coll addAll: (sn allConstraintSVOs)] .
	^ coll! !

!GbtThing methodsFor: 'accessing leaf slots' stamp: 'hk 2/17/2017 16:06'!
allLeafSVOs
	| coll |
	coll := self leafSVOs.
	self subnodes do: [ :sn | coll addAll: (sn allLeafSVOs)] .
	^ coll! !

!GbtThing methodsFor: 'ui helper' stamp: 'hk 2/16/2017 15:06'!
allSlotAssocsWithTemplates
	"GbtThing allFsvosWithTemplates"
	^self slots select: [:a| a isNode and: [a templates isNotEmpty]] ! !

!GbtThing methodsFor: 'accessing slots' stamp: 'hk 2/17/2017 16:09'!
allSlotSVOsWith: aTag
	"answer a collection of all slot values (SVO) with tag or slotName aTag"

	| coll |
	coll := (slots select: [:s| s hasKeyOrTag: aTag]) collect: [:s| s value].
	self subnodes do: [ :sn | coll addAll: (sn allSlotSVOsWith: aTag)].
	^ coll! !

!GbtThing methodsFor: 'analysing' stamp: 'hk 11/16/2016 14:08'!
allStructureNodes
	"answer a collection of all structure nodes (full things for analysis)"
	
	^(self structureNodes flatCollect: [:n| n allStructureNodes] as: OrderedCollection) add: self; yourself
! !

!GbtThing methodsFor: 'ui helper' stamp: 'hk 11/2/2016 12:42'!
asText
	^self asTextIndented: 0 aspect: ''! !

!GbtThing methodsFor: 'ui helper' stamp: 'hk 2/17/2017 16:28'!
asTextIndented: int aspect: key

	| txt |
	txt := TextStream on: (Text new: 10) .
	txt tab: int ; nextPutAll: ((key, '  ', self svoName) asText addAttribute: TextEmphasis italic) .
	self leafCollBy3 do:  [ :ar3 | 
			txt crtab: (int + 2) . 
			1 to: ar3 size do: 
			[ :i | txt nextPutAll: ((ar3 at: i) at: 1) ; nextPut: $: ; space:2 ; nextPutAll: ((ar3 at: i) at: 2) ; tab; tab  ]  ] .
	txt cr.
	self nodeSlots do: [ :s | txt nextPutAll:  (s value asTextIndented: int + 1 aspect: s key) ].
	^txt contents
	! !

!GbtThing methodsFor: 'save - retrieve - remove' stamp: 'hk 3/25/2017 12:57'!
askForNewTemplateSummary
	^UIManager default request: 'Please type new summary' initialAnswer: self summary
! !

!GbtThing methodsFor: 'accessing slots basic write' stamp: 'hk 3/2/2017 12:24'!
basicRemoveSlot: aSlot
	| prev |
	prev := self evolve.
	slots remove: (aSlot newValueContainer: prev)! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 2/11/2016 19:30'!
bizId
	^bizId asString! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 11/29/2016 14:05'!
bizId: aBizId
	bizId := aBizId! !

!GbtThing methodsFor: 'save - retrieve - remove' stamp: 'hk 3/24/2017 18:37'!
buildContainerHierarchy
	"use the top down slot relations to write all bottom up container relations
	1. after read from disk, where only the slot relations are stored
	2. in case of undo/redo in editors, because evolve only keeps the slot history"
	slots do: [:sa| 
		sa value replaceContainer: self. 
		sa value isNode ifTrue: [sa value buildContainerHierarchy]]! !

!GbtThing methodsFor: 'constraints' stamp: 'hk 2/26/2017 13:52'!
checkConstraints
	"fill the constraintViolationString and answer true, if consistent, false or nil"
	| constraints fulfilled violated errors stream |
	fulfilled := OrderedCollection new.
	violated := OrderedCollection new.
	errors := OrderedCollection new. 
	(constraints := self allConstraintSVOs) do:
		[:c| 
		(c val = #true) ifTrue: [fulfilled add: c].
		(c val = #false) ifTrue: [violated add: c].
		(c val = #true | (c val = #false)) ifFalse: [errors add: c]].  
	consistent := errors 
		ifEmpty: [fulfilled size = constraints size]
		ifNotEmpty: [consistent := nil].
	stream := WriteStream with: 'violated:'.
	violated do: 
		[:c| stream << String cr << c violationString].
	constraintViolationString := stream contents.
	^consistent
! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 6/22/2016 16:17'!
classInitial
	^#T! !

!GbtThing methodsFor: 'constraints' stamp: 'hk 7/6/2016 17:18'!
constraintViolationString
	^constraintViolationString ifNil: [ '' ]! !

!GbtThing methodsFor: 'testing' stamp: 'hk 2/17/2017 16:06'!
contains: aString
	^(self allLeafSVOs select: [:leaf| aString match: leaf val]) isNotEmpty! !

!GbtThing methodsFor: 'XLS helper' stamp: 'hk 2/17/2017 16:09'!
contains: aValue at: aTag
	"answer true if any slot with tag or slotName aTag contains aValue"
	^(self allSlotSVOsWith: aTag) 
		anySatisfy: [:e| e isValue and: [e val = aValue]]! !

!GbtThing methodsFor: 'accessing context' stamp: 'hk 12/13/2016 15:55'!
context
	^context! !

!GbtThing methodsFor: 'accessing context' stamp: 'hk 11/8/2016 10:04'!
context: anAC
	context := {anAC svoName . anAC user}! !

!GbtThing methodsFor: 'accessing context' stamp: 'hk 1/5/2017 13:39'!
contextName
	^(context ifNil: [^'']) first! !

!GbtThing methodsFor: 'accessing context' stamp: 'hk 3/17/2017 12:12'!
contextVO
	"ctxt = #(svoName  user)"
	| ctxt |
	ctxt := self nextUptreeContext ifNil: [^nil]. 
	^self bizApp contextNamed: ctxt first ! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 11/2/2016 13:43'!
copy
	"needs to show up in authoring protocol"
	
	^super copy ! !

!GbtThing methodsFor: 'copying' stamp: 'hk 3/25/2017 12:50'!
copyForSton
	^self shallowCopy postCopyForSton! !

!GbtThing methodsFor: 'copying' stamp: 'hk 2/13/2017 18:33'!
copyFreeze
	"freeze all GbtCalcLeafs - freezes a calculation"
	| res |
	res := self copy.  
	self freezeSlotsOf: res.
	^res

! !

!GbtThing methodsFor: 'copying' stamp: 'hk 11/2/2016 13:26'!
copyWith: declarative
	"creates a 'projection' using the declarative"
	^declarative 
		ifNil:  [self copy]
		ifNotNil: [declarative copyWithSource: self]! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 10/11/2016 16:39'!
copyWithName: aUserName
	"answer a copy with another userName aName"
	
	| un cp |
	un := svoName.
	svoName := aUserName.
	cp := self copy .		"inserts in asvoDict with userName"
	svoName := un .
	^cp

! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 11/17/2016 16:21'!
defaultPolicy
	"any Ulist needs a default policy"

	^defaultPolicy ifNil: [defaultPolicy := GbtNoPolicy new]! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 2/11/2017 13:50'!
define: slotName  calc: aStringWithTags 
	"define a slot that calculates from tagged slots"

	self define: slotName calc: aStringWithTags for: #() tag: nil ! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 2/11/2017 13:50'!
define: slotName  calc: aStringWithTags for: aColl
	"define a slot that calculates from tagged slots"

	self define: slotName  calc: aStringWithTags for: aColl tag: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 3/2/2017 16:20'!
define: slotName calc: aStringWithTags for: anArray tag: aSymbol 
	"define a slot that calculates from tagged slots"
	
	self check: [slotName isString] toBe: #StringOrSymbol.
	self check: [aStringWithTags isString] toBe: #String.
	self check: [aSymbol isNil or: [aSymbol isSymbol] ] toBe: #SymbolOrNil.
	self check: [anArray isCollection & (anArray isString not)] toBe: #aCollection.
	
	self addSlot: ((GbtSlotAssociation 
					key: slotName asSymbol 
					value: (GbtExpressionLeaf withValue: aStringWithTags))
					purposes: anArray;
					tags:  aSymbol )! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 2/11/2017 13:50'!
define: slotName  calc: aStringWithTags tag: aSymbol 
	"define a slot that calculates from tagged slots"
	
	self define: slotName calc: aStringWithTags for: #() tag: aSymbol ! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 12/19/2016 17:44'!
define: slotName constraint: aStringWithTags
	self define: slotName constraint: aStringWithTags ifViolated: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 2/17/2017 16:01'!
define: slotName constraint: aStringWithTags ifViolated: aString
	"define a slot that calculates from tagged slots"
	
	self check: [slotName isString] toBe: #StringOrSymbol.
	self check: [aStringWithTags isString] toBe: #String.
	
	self addSlot: ((GbtSlotAssociation 
					key: slotName asSymbol 
					value: ((GbtConstraintLeaf withValue: aStringWithTags) violationString: aString))
					purposes: #();
					tags:  nil )! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 10/31/2015 18:29'!
define: slotName date: aStringOrDate
	"define a date slot"
	
	self define: slotName  date: aStringOrDate for: #() tag: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 10/31/2015 18:30'!
define: slotName date: aStringOrDate for: aColl 
	"define a date slot"
	
	self define: slotName  date: aStringOrDate for: aColl tag: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 1/4/2016 21:11'!
define: slotName  date: aStringOrDate for: anArray tag: aSymbol
	"define a tagged date slot"

	self define: slotName  date: aStringOrDate for: anArray tag: aSymbol private: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 2/17/2017 16:01'!
define: slotName  date: aStringOrDate for: anArray tag: aSymbol private: aBool
	"define a date slot"

	self check: [slotName isString] toBe: #StringOrSymbol.
	self check: [aSymbol isNil or: [aSymbol isSymbol] ] toBe: #SymbolOrNil.
	self check: [anArray isCollection & (anArray isString not)] toBe: #aCollection.
	
	self addSlot: ((GbtSlotAssociation 
					key: slotName asSymbol 
					value: (GbtDateLeaf withDate: aStringOrDate))
					purposes: anArray;
					tags:  aSymbol ;
					private: aBool)! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 1/4/2016 21:12'!
define: slotName date: aStringOrDate private: aBool
	"define a date slot"
	
	self define: slotName  date: aStringOrDate for: #() tag: nil private: aBool! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 10/31/2015 18:29'!
define: slotName  date: aStringOrDate tag: aSymbol
	"define a tagged date slot"

	self define: slotName  date: aStringOrDate for: #() tag: aSymbol! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 10/31/2015 18:30'!
define: slotName enum: arrayOfString
	"define a enumeration slot"
	
	self define: slotName  enum: arrayOfString for: #() tag: nil ! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 10/31/2015 18:30'!
define: slotName enum: arrayOfString for: aColl
	"define a enumeration slot"
	
	self define: slotName  enum: arrayOfString for: aColl tag: nil ! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 1/4/2016 21:10'!
define: slotName  enum: arrayOfString for: anArray tag: aSymbol 
	"define a tagged enumeration slot"
	
	self define: slotName  enum: arrayOfString for: anArray tag: aSymbol private: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 2/17/2017 16:01'!
define: slotName  enum: arrayOfString for: anArray tag: aSymbol private: aBool
	"define a enumeration slot"
	
	self check: [slotName isString] toBe: #StringOrSymbol.
	self check: [aSymbol isNil or: [aSymbol isSymbol] ] toBe: #SymbolOrNil.
	self check: [anArray isCollection & (anArray isString not)] toBe: #aCollection.

	self addSlot: ((GbtSlotAssociation 
					key: slotName asSymbol 
					value: (GbtEnumLeaf withList: arrayOfString) )
					purposes: anArray;
					tags:  aSymbol ;
					private: aBool)! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 1/4/2016 21:11'!
define: slotName enum: arrayOfString private: aBool
	"define a enumeration slot"
	
	self define: slotName  enum: arrayOfString for: #() tag: nil private: aBool! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 10/31/2015 18:30'!
define: slotName  enum: arrayOfString tag: aSymbol 
	"define a tagged enumeration slot"
	
	self define: slotName  enum: arrayOfString for: #() tag: aSymbol ! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 2/7/2017 15:43'!
define: slotName enumSelect: aStringOrNumber
	"select an enum item as default"
	self check: [slotName isString] toBe: #StringOrSymbol.
	self check: [aStringOrNumber isString | aStringOrNumber isNumber] toBe: #aStringOrNumber.

	((self slotNamed: slotName) ifNil: [^self inform: slotName,' not found'])
		selection: aStringOrNumber
	
	
	 ! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 2/17/2017 16:01'!
define: slotName linkTo: aSmartPath
	"define a link slot to a thing using a smartPath"

	self check: [ slotName isString ] toBe: #StringOrSymbol.
	self addSlot: (GbtSlotAssociation 
		key: slotName asSymbol 
		value: (GbtThingLink for: aSmartPath in: self))! !

!GbtThing methodsFor: 'define' stamp: 'hk 2/17/2017 16:01'!
define: slotName  list: element of: template display: anArray for: aColl tag: aSymbol private: aBool
	"define a tagged list slot with elements and templates"
	
	| list elements templates coll|
	self check: [slotName isString] toBe: #StringOrSymbol.
	elements := element asCollection.
	templates := template asCollection.
	anArray ifNotNil: 
		[self check: [anArray asCollection allSatisfy: [:e|e isSymbol]] toBe: #anArrayOfSymbols].
	coll := aColl ifNil: [ #() ].
	self check: [coll isCollection & (coll isString not)] toBe: #aCollection.
	self check: [elements  allSatisfy: [:e| e isKindOf: GbtThing ]] toBe: #aCollectionOfThings.
	self check: [templates allSatisfy: [:e| e isKindOf: GbtThing ]] toBe: #aCollectionOfThings.
	self check: [aSymbol isNil or: [aSymbol isSymbol] ] toBe: #SymbolOrNil.

	list :=  (GbtUlist withTemplates: templates) displayColumns: anArray .
	elements do: [ :e |list newEntry: e ] .
	self addSlot: ((GbtSlotAssociation 
					key: slotName asSymbol 
					value:  list  )
					purposes: coll;
					tags:  aSymbol ;
					private: aBool ) ! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 1/7/2016 16:39'!
define: slotName listOf: oneOrMoreAsvo 
	"define a list slot of a single type or union type"

	self define: slotName listOf: oneOrMoreAsvo for: nil ! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 1/7/2016 16:38'!
define: slotName listOf: oneOrMoreAsvo display: anArray
	"define a list slot of a single type or union type"

	self define: slotName listOf: oneOrMoreAsvo for: nil display: anArray! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 6/30/2016 13:06'!
define: slotName listOf: oneOrMoreAsvo for: aPurposeColl 
	"define a list slot of a single type or union type"
	self define: slotName listOf: oneOrMoreAsvo for: aPurposeColl display: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 1/7/2016 16:37'!
define: slotName listOf: oneOrMoreAsvo for: aColl display: anArray
	"define a list slot of a single type or union type"

	self define: slotName list: #() of: oneOrMoreAsvo asOrderedCollection display: anArray for: aColl tag: nil private: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 10/31/2015 15:21'!
define: slotName no: aNumber 
	"define an interval slot"
	
	self define: slotName no: aNumber tag: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 10/31/2015 18:32'!
define: slotName no: aNumber for: aColl
	"define an interval slot"

	self define: slotName no: aNumber for: aColl tag: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 10/31/2015 18:32'!
define: slotName no: aNumber for: aColl tag: aSymbol
	"define an interval slot"
	
	self define: slotName no: aNumber from: nil to: nil for: aColl tag: aSymbol! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 11/5/2015 13:01'!
define: slotName no: aNumber from: floor  to: ceiling 
	"define a tagged interval slot"
	
	self define: slotName no: aNumber from: floor  to: ceiling for: #() tag: nil ! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 2/26/2017 11:45'!
define: slotName no: aNumber from: floor  to: ceiling for: anArray tag: aSymbol 
	"define a tagged interval slot"
	
	self check: [slotName isString] toBe: #StringOrSymbol.
	self check: [aSymbol isNil or: [aSymbol isSymbol] ] toBe: #SymbolOrNil.
	self check: [anArray isCollection & (anArray isString not)] toBe: #aCollection.
	self check: [aNumber isNil or: [aNumber isString or: [aNumber isNumber]]] toBe: #aNumberOrString.

	self addSlot: ((GbtSlotAssociation 
					key: slotName asSymbol 
					value: (GbtNumberLeaf new min: floor; max: ceiling; inputValue: aNumber))
					purposes: anArray;
					tags:  aSymbol  )! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 10/31/2015 18:31'!
define: slotName no: aNumber from: floor  to: ceiling tag: aSymbol 
	"define a tagged interval slot"
	
	self define: slotName no: aNumber from: floor  to: ceiling for: #() tag: aSymbol ! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 10/31/2015 15:16'!
define: slotName no: aNumber tag: aSymbol
	"define an interval slot"
	
	self define: slotName no: aNumber from: nil to: nil tag: aSymbol! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 7/15/2015 18:15'!
define: slotName text: aText
	"define a text slot"
	
	self define: slotName text: aText tag: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 10/31/2015 18:40'!
define: slotName text: aText for: aColl
	"define a text slot"
	
	self define: slotName text: aText for: aColl tag: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 1/4/2016 21:03'!
define: slotName  text: aText for: anArray tag: aSymbol 
	"define a tagged text slot"
	self define: slotName  text: aText for: anArray tag: aSymbol private: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 2/17/2017 16:01'!
define: slotName  text: aText for: anArray tag: aSymbol private: aBoolean
	"define a text slot"
	
	self check: [slotName isString] toBe: #StringOrSymbol.
	self check: [aSymbol isNil or: [aSymbol isSymbol] ] toBe: #SymbolOrNil.
	self check: [anArray isCollection & (anArray isString not)] toBe: #aCollection.


	self addSlot: ((GbtSlotAssociation 
					key: slotName asSymbol 
					value: (GbtTextLeaf withValue: aText) )
					purposes: anArray;
					tags:  aSymbol ;
					private: aBoolean)! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 1/4/2016 21:04'!
define: slotName text: aText private: aBoolean
	"define a text slot"
	
	self define: slotName text: aText for: #() tag: nil private: aBoolean! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 10/31/2015 18:40'!
define: slotName  text: aText tag: aSymbol 
	"define a tagged text slot"
	
	self define: slotName  text: aText for: #() tag: aSymbol 
! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 5/12/2016 17:07'!
define: slotName thing: aGbtThing
	"define a subnode slot"
	
	self define: slotName thing: aGbtThing tag: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 5/12/2016 17:07'!
define: slotName thing: aGbtThing for: aColl
	"define a subnode slot"
	
	self define: slotName thing: aGbtThing for: aColl tag: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 1/4/2016 21:01'!
define: slotName  thing: aSmartThing for: anArray tag: aSymbol 
	"define a tagged subnode slot in a master (full thing) tree "
	
	self define: slotName  thing: aSmartThing for: anArray tag: aSymbol private: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 2/17/2017 16:01'!
define: slotName  thing: oneOrMoreThings for: anArray tag: aSymbol private: aBoolean
	"define a subnode slot in a master (full thing) tree "
	
	| node templates thing assoc |
	self check: [slotName isString] toBe: #StringOrSymbol.
	self check: [aSymbol isNil or: [aSymbol isSymbol] ] toBe: #SymbolOrNil.
	self check: [anArray isCollection & (anArray isString not)] toBe: #aCollection.
	templates := self checkThingMakeColl: oneOrMoreThings .
	thing := templates first.
	node := self isSmart ifTrue: [thing] ifFalse: [thing fullThing].
	
	assoc := (GbtSlotAssociation 								
					key: slotName asSymbol 
					value: node)
					purposes: anArray;
					tags:  aSymbol ;
					private: aBoolean.
	self isSmart ifFalse: [assoc templates: templates].
	self addSlot: assoc! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 5/12/2016 17:07'!
define: slotName thing: aGbtThing private: aBoolean
	"define a subnode slot"
	
	self define: slotName thing: aGbtThing for: #() tag: nil private: aBoolean! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 5/12/2016 17:07'!
define: slotName  thing: aGbtThing tag: aSymbol 
	"define a tagged subnode slot"
	
	self define: slotName  thing: aGbtThing for: #() tag: aSymbol 
! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 6/30/2015 20:11'!
define: slotName val: aString
	"define a value slot"
	
	self define: slotName val: aString tag: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 1/13/2016 15:16'!
define: slotName val: aString for: aColl
	"define a value slot for purposes aColl"
	
	self define: slotName  val: aString for: aColl tag: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 1/4/2016 21:05'!
define: slotName  val: aString for: anArray tag: aSymbol 
	"define a tagged value slot"
	
	self define: slotName  val: aString for: anArray tag: aSymbol private: nil! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 2/17/2017 16:01'!
define: slotName  val: aString for: anArray tag: aSymbol private: aBool
	"define a value slot"
	
	self check: [slotName isString] toBe: #StringOrSymbol.
	self check: [aSymbol isNil or: [aSymbol isSymbol] ] toBe: #SymbolOrNil.
	self check: [anArray isCollection & (anArray isString not)] toBe: #aCollection.

	self addSlot: ((GbtSlotAssociation 
					key: slotName asSymbol 
					value: (GbtValueLeaf withValue: aString) )
					purposes: anArray;
					tags:  aSymbol ;
					private: aBool)! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 1/4/2016 21:05'!
define: slotName val: aString private: aBool
	"define a value slot"
	
	self define: slotName val: aString for: #() tag: nil private: aBool! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 10/31/2015 18:39'!
define: slotName  val: aString tag: aSymbol 
	"define a tagged value slot"
	
	self define: slotName  val: aString for: #() tag: aSymbol ! !

!GbtThing methodsFor: 'define' stamp: 'hk 8/27/2015 13:12'!
defineFrom: definitionArray
	"all slots and #special strings"
	definitionArray do: [:elem | self defineWith: elem] 
			! !

!GbtThing methodsFor: 'define' stamp: 'hk 2/22/2017 15:50'!
defineSmart: smartDefArray defineFull: restOfDefArray
	"define the smart & full thing. this code is executed only once"
	
	| fullThing  |
	fullThing := self fullThing.
	smartDefArray do: [ :spec|  
			self defineWith: spec .
			fullThing defineWith: spec].
	restOfDefArray do: [ :spec| 
			fullThing defineWith: spec].
	self removePrevious 
		! !

!GbtThing methodsFor: 'define' stamp: 'hk 6/30/2016 16:57'!
defineWith: defArray
	"one slot"
	defArray first = #name ifTrue: [self error: '<name> not allowed as slotName'].		"Spec constraint"
	defArray first = #label ifTrue: [self error: '<label> not allowed as slotName'].	"Spec constraint"
		
	defArray first = #ensureBizId ifTrue: [^self ensureBizId].
	defArray first = #summary ifTrue: [^self summary: defArray second].
	defArray first = #purpose ifTrue: [^self purpose: defArray second].
	defArray first = #purposes ifTrue: [^self purposes: defArray second].
	defArray first = #idNumberPolicy ifTrue: [^self idNumberPolicy: defArray second].
	defArray first = #widgetClass ifTrue: [^self widgetClass: defArray second].
	self perform: #define: dsl: defArray.
			! !

!GbtThing methodsFor: 'save - retrieve - remove' stamp: 'hk 2/15/2017 11:49'!
delete
	deleted := true.
	self  store! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 6/30/2016 14:38'!
deleted
	^deleted ifNil: [false]! !

!GbtThing methodsFor: 'ui helper' stamp: 'hk 1/13/2017 16:54'!
displayArrayFrom: displayColumns

	displayColumns ifEmpty: 
		[^Array with: self displayId with: self summaryEnriched].
	^Array with: self displayId withAll: (self resolvedArrayFrom: displayColumns)
! !

!GbtThing methodsFor: 'ui helper' stamp: 'hk 12/5/2016 13:22'!
displayId
	| pre post |
	pre := otherUserEdits ifTrue: ['*'] ifFalse: [' '].
	post := (self hasDataPending or: [self isDirty]) ifTrue: [ '* ' ] ifFalse: [ ' ' ].
	^pre, self bizId, post ! !

!GbtThing methodsFor: 'meta' stamp: 'hk 2/17/2017 16:23'!
doesNotUnderstand: aMessage
	"answer the slot named by aMessage or change a value slot resp. node slot.
	the changed thing is not saved, the history of a node slot is not recorded"

	| sel node slotName nsa failBlock |  
	failBlock := [super doesNotUnderstand: aMessage].
	sel := aMessage selector asSymbol.		"may be a slotName or a tag"
	nsa := self nodeAndSlotAssocOf: sel.
	node := nsa first.
	slotName  := nsa second key.
	sel isKeyword ifTrue: [  	"= setter:"
		(node slotSVOAt: slotName) ifNil: [^failBlock] .
		node slotAt: slotName value: aMessage argument].
	^(node slotValueAt: slotName) ifNil: [^failBlock]			! !

!GbtThing methodsFor: 'embedding' stamp: 'hk 2/22/2017 15:24'!
embed: aThing
	"copy all slots of aThing into myself.
	in case of structure mismatch a leaf of self may be overridden by a node of aThing" 
	
	self slots do: [ :a | 
			a value: (aThing slotSVOAt: a key) copy.
			a newValueContainer: self ]! !

!GbtThing methodsFor: 'embedding' stamp: 'hk 2/16/2017 16:10'!
embed: aThing with: aView
	"fill a new version of myself with data of aThing: 
	remove all public slots referenced by aView but keep the private ones,
	then copy data from aThing"
	
	aView embed: aThing in: self! !

!GbtThing methodsFor: 'embedding' stamp: 'hk 2/17/2017 18:22'!
embedPrivateSlotsOf: aThing
	"copy all private slots of aThing into myself.
	in case of structure mismatch a leaf of self may be overridden by a node of aThing" 
	
	aThing slots do: [:sa|   
		sa isPrivate 
			ifTrue: [self addSlot: sa copyValue] 
			ifFalse: [(sa isNode and: [sa value privateSlots isNotEmpty]) ifTrue: 
					[self slotAt: sa key ifAbsent: [self addSlot: (sa copy value: sa value smartCopy; yourself)].
					(self slotSVOAt: sa key) embedPrivateSlotsOf: sa value ]]]! !

!GbtThing methodsFor: 'tag substitution' stamp: 'hk 10/31/2016 17:24'!
enrichFromTags: aString 
	"find the tags in my container node and replace these by corresponding slot values. Answer a single line
	aString may contain space separated substrings of colon separated strings"
	
	| stream |
	stream := WriteStream on: ''.
	aString substrings do: 
		[:str| str first = $# 
					ifFalse: [ stream nextPutAll: str]
					ifTrue: 	[stream nextPutAll: (self resolveTag2String: str allButFirst)].
		stream space ].  
	^stream contents
	 ! !

!GbtThing methodsFor: 'tag substitution' stamp: 'hk 10/31/2016 15:29'!
enrichFromTagsQuoted: aString 
	"find the tags in my container node and replace these by corresponding slot values. Answer a single line
	aString may contain space separated substrings of colon separated strings"
	
	| stream |
	stream := WriteStream on: ''.
	aString substrings do: 
		[:str| str first = $# 
					ifFalse: [ stream nextPutAll: str]
					ifTrue: 	[stream nextPutAll: (self resolveTag2String: str allButFirst) printString].
		stream space ].
	^stream contents
	 ! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 2/27/2016 16:17'!
ensureBizId   
	"bizId is never changed"
	bizId ifNil: [self setBizId] ! !

!GbtThing methodsFor: 'smart' stamp: 'hk 2/17/2017 16:17'!
expandSVO: aGetter
	^self slotSVOAt: aGetter ifAbsent: [self smartAddSlotSVO: aGetter]
! !

!GbtThing methodsFor: 'copying' stamp: 'hk 3/2/2017 14:53'!
freezeSlotsOf: aTarget
	"let all GbtCalcLeafs of aTarget become GbtValueLeafs
	we need access to all calc slots until finished"
	1 to: slots size do: [:i| |slot frozenSlot|
		slot := slots at: i.
		slot value isCalc ifTrue: 
			[frozenSlot := slot copy value: (GbtValueLeaf withValue: slot value val).
			aTarget slots at: i put: frozenSlot].
		slot value isNode ifTrue: 
			[ slot value freezeSlotsOf: (aTarget slots at: i) value]] ! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 3/17/2017 19:35'!
fullThing
	"anyOne - there should be only one element"  
	fullVO = #self ifTrue: [^self].
	^self bizApp fsvoEntry: fullVO ifAbsent: [GbtBizAppServer default fsvoEntry: fullVO ifAbsent: []]! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 10/11/2016 16:37'!
fullThing: aThing
	fullVO := aThing svoName ! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 8/2/2016 17:06'!
fullVO: aFullThingName
	fullVO := aFullThingName! !

!GbtThing methodsFor: 'testing' stamp: 'hk 8/30/2015 12:12'!
hasSubnodes
	^self subnodes isNotEmpty! !

!GbtThing methodsFor: 'comparing' stamp: 'hk 11/9/2016 13:44'!
hash
	^self class hash bitXor: slots hash ! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 8/10/2016 16:24'!
idNumberPolicy
	^idNumberPolicy! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 2/19/2016 19:23'!
idNumberPolicy: aName
	self check: [ aName isString ] toBe: #aString.
	idNumberPolicy := aName asSymbol  . ! !

!GbtThing methodsFor: 'initialization' stamp: 'hk 2/17/2017 18:36'!
initialize
	super initialize.
	otherUserEdits := false.
	self initializeSlots.
! !

!GbtThing methodsFor: 'initialization' stamp: 'hk 2/16/2017 13:02'!
initializeSlots
	slots := OrderedCollection new! !

!GbtThing methodsFor: 'constraints' stamp: 'hk 7/25/2016 12:57'!
isConsistent
	"true | false | nil (in case of error)"
	^consistent! !

!GbtThing methodsFor: 'testing' stamp: 'hk 11/2/2016 13:12'!
isDirty
	^dirty ifNil: [false]! !

!GbtThing methodsFor: 'testing' stamp: 'hk 9/3/2015 18:22'!
isNode
	^true! !

!GbtThing methodsFor: 'testing' stamp: 'hk 11/25/2015 14:44'!
isSmart
	^smart ifNil: [ false ]! !

!GbtThing methodsFor: 'testing' stamp: 'hk 1/24/2016 12:49'!
isThing
	^true! !

!GbtThing methodsFor: 'ui helper' stamp: 'hk 11/22/2016 16:25'!
leafCollBy3
"GcExample initSVO. GcExample email valueCollBy3"
	| res size ar |  
	res := OrderedCollection new.
	ar := self leafPairsColl asArray.
	size := ar size . 
	1 to: size by: 3 do: 
		[ :a |  | o arr | 
		o := (a+3) min: (size+1) .
		arr := Array new: (o - a) .
		a to: o-1 do: [ :i | arr at: (i-1 \\ 3 +1) put: (ar at: i) ] .
		res add: arr ] .
	 ^res! !

!GbtThing methodsFor: 'accessing leaf slots' stamp: 'hk 2/17/2017 16:07'!
leafNames
	^ self leafs collect: [:s| s key]! !

!GbtThing methodsFor: 'ui helper' stamp: 'hk 2/17/2017 16:07'!
leafPairsColl
	| ar |
	ar := OrderedCollection new .
	self leafs  do: [:s| ar add: {s key . s value val}].  
	 ^ar ! !

!GbtThing methodsFor: 'accessing leaf slots' stamp: 'hk 2/17/2017 16:07'!
leafSVOs
	^ self leafs collect: [:s| s value]! !

!GbtThing methodsFor: 'accessing leaf slots' stamp: 'hk 2/17/2017 16:07'!
leafs
	^ slots select: [ :s | s value isKindOf: GbtLeaf]  ! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 6/30/2016 13:22'!
listIndex
	^(self purposes ifEmpty: [^self bizId ]) first! !

!GbtThing methodsFor: 'accessing context' stamp: 'hk 12/13/2016 15:12'!
nextUptreeContext
	"the context of the thing I am node of"
	^context ifNil: [(container ifNil: [^nil]) nextUptreeContext ]! !

!GbtThing methodsFor: 'meta-slot resolution' stamp: 'hk 2/17/2017 16:02'!
nodeAndSlotAssocOnPath: aPath
	"answer the subNode slot aSlotName. aPath is valid and isNotEmpty"

	| res eld |
	res := self. 
	aPath do: [ :edge | 
		eld := res value. 
		res := (eld slotAt: edge asSymbol)].
	^{ eld . res }! !

!GbtThing methodsFor: 'accessing subnodes' stamp: 'hk 2/17/2017 16:28'!
nodeNames
	^ self nodeSlots collect: [:s| s key ] ! !

!GbtThing methodsFor: 'accessing subnodes' stamp: 'hk 2/17/2017 16:28'!
nodeSlots
	^ slots select: [ :s | s value isKindOf: GbtThing ]! !

!GbtThing methodsFor: 'meta-slot aggregation' stamp: 'hk 2/17/2017 16:09'!
numbersTaggedWith: aTag
	"answer a collection of all numerical slot values with aTag"
	
	| coll |  
	coll := (self allSlotSVOsWith: aTag) select: 
		[ :e | [e val asNumber isNumber] ifError: [false] ] .
	^coll collect: [ :e | e val asNumber ]! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 2/8/2017 16:55'!
originalSmart
	^originalSmart ifNil: [originalSmart := self smartCopy]! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 11/22/2016 16:55'!
originalSmart: aSmartThng
	originalSmart := aSmartThng! !

!GbtThing methodsFor: 'define' stamp: 'hk 2/9/2016 14:13'!
perform: aSelector dsl: subArr
	| sel args |
	sel := aSelector.
	args := subArr .
	subArr size > 1 ifTrue: 	
		[sel := (sel, (subArr at: 2)) asSymbol.
		args := subArr copyWithoutIndex: 2 ].
	(self respondsTo: sel) ifFalse: [self error: 'cannot author ', sel].
	self perform: sel asSymbol withArguments: args asArray! !

!GbtThing methodsFor: 'copying' stamp: 'hk 3/25/2017 15:30'!
postCopy
	"copy the nodes only . leafs are subject to evolve"
	super postCopy.
	svoName := svoName copy.
	context := nil.
	purposes := purposes copy.
	self postCopySlots.
	1 to: slots size do: [:i | |sl| 
		sl := slots at: i.
		sl isNode ifTrue: [slots at: i put: sl copyValue].
		sl isCalc ifTrue: [slots at: i put: sl copyValue].
		(slots at: i) value replaceContainer: self ].
	self bizApp addThing: self! !

!GbtThing methodsFor: 'copying' stamp: 'hk 3/25/2017 14:21'!
postCopyForSton
	"postCopy for STON: remove container and bizApp"
	context := nil.
	container := nil.
	dataPending := nil.
	originalSmart := nil. 
	previous := nil.
	bizApp := nil.
	self postCopySlots .
	1 to: slots size do: [:i | |sl vc| 
		sl := slots at: i.
		sl isNode 
			ifTrue: [vc := sl value copyForSton]
			ifFalse: [vc := sl value copy replaceContainer: nil] .
		slots at: i put: (sl copy value: vc)]
! !

!GbtThing methodsFor: 'copying' stamp: 'hk 3/23/2017 14:41'!
postCopyForStore
	"postCopy for store: replace nodes by longName strings, remove container and bizApp"
	context := nil.
	container := nil.
	dataPending := nil.
	originalSmart := nil. "full thing only"
	previous := nil.
	bizApp := nil.
	slots := slots collect: [:sa| (sa value isKindOf: GbtThing) 
		ifTrue: [sa copy value: sa value longName]
		ifFalse: [sa copy value: (sa value copy container: nil)]].
! !

!GbtThing methodsFor: 'copying' stamp: 'hk 3/2/2017 14:30'!
postCopySlots
	slots := slots copy.! !

!GbtThing methodsFor: 'printing' stamp: 'hk 8/11/2015 16:46'!
printOn: aStream
	aStream nextPutAll: self longName ! !

!GbtThing methodsFor: 'accessing slots' stamp: 'hk 2/17/2017 16:01'!
privateSlots
	^ slots select: [:a |a isPrivate and: [a value isNotNil] ]! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 2/7/2017 17:42'!
purpose: aString
	"put the purpose aString first"
	self check: [ aString isString ] toBe: #aString.
	self purposes 
		remove: aString ifAbsent: [];
		addFirst: aString! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 11/13/2015 17:49'!
purposes 
	^purposes ifNil: [purposes := OrderedCollection new]! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 2/7/2017 17:40'!
purposes: anArrayOfString
	purposes := anArrayOfString asOrderedCollection! !

!GbtThing methodsFor: 'save - retrieve - remove' stamp: 'hk 3/24/2017 16:38'!
registerWith: anApp
	"add self & all subnodes to asvo dictionary"
	anApp addThing: self . 
	self bizApp: anApp.
	self subnodes do: [:sn| sn registerWith: anApp]! !

!GbtThing methodsFor: 'save - retrieve - remove' stamp: 'hk 2/17/2017 16:03'!
remember: aValOrThing at:  aSlotName
	"used twofold: for thing templates and used values"
	(self fullThing slotAt: aSlotName ifAbsent: [^self]) addTemplate: aValOrThing
! !

!GbtThing methodsFor: 'save - retrieve - remove' stamp: 'hk 2/17/2017 15:59'!
remove  
	"remove self & save container "
	container ifNil: [ ^self ].
	container removeSlot: self ; save.! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 12/3/2016 15:06'!
removeBizId
	bizId := nil! !

!GbtThing methodsFor: 'pending data' stamp: 'hk 12/5/2016 13:22'!
removeOtherUserEdits
	otherUserEdits ifTrue: [self setOtherUserEdits: false].
	
	! !

!GbtThing methodsFor: 'copying' stamp: 'hk 2/21/2017 16:21'!
removePrevious
	super removePrevious.
	slots do: [:sl| sl value removePrevious ]! !

!GbtThing methodsFor: 'accessing slots writing' stamp: 'hk 2/22/2017 15:01'!
removeSlot: aSVO   
	| slot |
	slot := slots detect: [:s| s value == aSVO] ifNone: [^nil].
	self basicRemoveSlot: slot .
	^aSVO

! !

!GbtThing methodsFor: 'accessing slots writing' stamp: 'hk 2/22/2017 15:03'!
removeSlotAt: aSlotName   
	| slot |
	slot := self slotAt: aSlotName ifAbsent: [^nil] .
	self basicRemoveSlot: slot
! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 2/26/2017 14:50'!
removeSmart: aSlotName
	"remove the first slot aSlotName found in hierarchy"

	(self nodeAndSlotAssocOf: aSlotName) first slots remove: ((self nodeAndSlotAssocOf: aSlotName) second)
		
! !

!GbtThing methodsFor: 'tag substitution' stamp: 'hk 2/7/2017 15:48'!
resolveTag2String: aSmartPath
	"replace aTag by its string representation"

	| val |  
	val := (self slotOn: aSmartPath).
	((val isKindOf: GbtThing) or: [ val isKindOf: GbtThingLink ])
		ifTrue: [ val := val enrichFromTags: val summary ].	  
	^val ifNil: ['-' printString]
! !

!GbtThing methodsFor: 'tag substitution' stamp: 'hk 1/20/2017 18:47'!
resolveToSmartPath: aLookupString 
	"replace the substrings by their corresponding slot values and construct a smartPath. 
	first substring may be special: #R for 'root'"
	
	| root reducedString smartPath |
	root := aLookupString substrings first = '#R'.
	reducedString := root
		ifTrue: [self globalRoot enrichFromTags: (aLookupString copyReplaceTokens: '#R' with: ' ')]
		ifFalse: [self enrichFromTags: aLookupString]. 
	smartPath := reducedString withBlanksCondensed copyReplaceAll: ' ' with: ':' asTokens: false.
	^(root ifTrue: ['R:'] ifFalse: ['']), smartPath
	 ! !

!GbtThing methodsFor: 'ui helper' stamp: 'hk 8/19/2016 12:34'!
resolvedArrayFrom: displayColumns
	| arr | 
	arr := Array new:  (displayColumns ifNil: [ #() ] )  size .
	1 to: arr size do: [ :i | arr at: i put: (([self resolveTag2String: (displayColumns at: i)] ifError: ['--- ? ---']))].
	^arr! !

!GbtThing methodsFor: 'accessing context' stamp: 'hk 3/17/2017 12:12'!
rootContextVO
	"ctxt = #(svoName  user)"
	| ctxt |
	ctxt := self globalRoot context ifNil: [^nil]. 
	^self bizApp contextNamed: ctxt first ! !

!GbtThing methodsFor: 'analysing' stamp: 'hk 7/27/2016 11:12'!
rtSlots
	^self slotNames
! !

!GbtThing methodsFor: 'save - retrieve - remove' stamp: 'hk 3/25/2017 14:06'!
save
	"used in a context"
	self isDirty ifFalse: [^self].
	self saveHook.
	(self rootContextVO ifNil: [self]) store! !

!GbtThing methodsFor: 'save - retrieve - remove' stamp: 'hk 3/25/2017 12:57'!
saveAsBigListTemplate
	"save & store me as template in my big list"
	| ctxt smmry| 
	ctxt := (self contextVO ifNil: [^self]) container.
	(ctxt isKindOf: GbtBigListAC) ifFalse: [^self]. 
	smmry := self askForNewTemplateSummary ifNil: [^self] .
	ctxt templates add: (self copy summary: smmry) ! !

!GbtThing methodsFor: 'save - retrieve - remove' stamp: 'hk 3/23/2017 16:02'!
saveAsTemplate
	"save & store me as template in full thing"
	container 
		ifNil: [self saveAsBigListTemplate]
		ifNotNil: [container saveTemplate: self]
! !

!GbtThing methodsFor: 'accessing context' stamp: 'hk 1/4/2017 17:40'!
saveContext: anAC
	saveContext := {anAC svoName . anAC user}! !

!GbtThing methodsFor: 'accessing context' stamp: 'hk 3/25/2017 12:05'!
saveContextName
	saveContext ifNil: [^nil].
	^saveContext first! !

!GbtThing methodsFor: 'accessing context' stamp: 'hk 1/4/2017 18:08'!
saveContextNames
	| res |
	res := OrderedCollection new.
	context ifNotNil: [res add: context first].
	saveContext ifNotNil: [res add: saveContext first].
	^res! !

!GbtThing methodsFor: 'save - retrieve - remove' stamp: 'hk 11/10/2016 14:31'!
saveHook 
	^(self contextVO ifNil: [^self]) saveHook: self
! !

!GbtThing methodsFor: 'save - retrieve - remove' stamp: 'hk 2/16/2017 14:39'!
saveTemplate: aThing   
	| key |
	key := (slots detect: [:s| s value = aThing]) key.
	self remember: aThing copy askForNewTemplateSummary at: key
! !

!GbtThing methodsFor: 'save - retrieve - remove' stamp: 'hk 2/17/2017 16:07'!
saveValueTemplates
	self leafs do: [:a| self remember: a value val at: a key]
! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 2/7/2017 16:07'!
searchStrategy
	^ searchStrategy! !

!GbtThing methodsFor: 'save - retrieve - remove' stamp: 'hk 12/14/2016 15:20'!
setAllDirty
	self beDirty.
	self subnodes do: [:sn| sn setAllDirty ]! !

!GbtThing methodsFor: 'initialization' stamp: 'hk 12/13/2016 15:48'!
setBizId   
	self contextVO ifNil: [bizId := self defaultPolicy nextID. ^self].
	bizId  := self contextVO nextBizID
! !

!GbtThing methodsFor: 'pending data' stamp: 'hk 6/1/2016 15:11'!
setDataPending
	super setDataPending .
	(self contextVO ifNil: [ ^self ]) setDataPending 
	! !

!GbtThing methodsFor: 'pending data' stamp: 'hk 1/5/2017 14:13'!
setOtherUserEdits: aBoolean
	"update the correspondig list.
	set the other users edit mark only when in edit"
	| cVO |       
	cVO := self contextVO ifNil: [^self].  
	cVO hasSubcontext ifTrue: [otherUserEdits := aBoolean]. "eigentlich: werde ich gerade editiert?"
	cVO setOtherUserEdits: aBoolean .
! !

!GbtThing methodsFor: 'accessing slots' stamp: 'hk 2/17/2017 16:03'!
slotAt: aSlotName 
	"answer the slot, i.e. the Association"
	^self slotAt: aSlotName ifAbsent: []
! !

!GbtThing methodsFor: 'accessing slots' stamp: 'hk 2/17/2017 16:03'!
slotAt: aSlotName ifAbsent: aBlock
	"answer the slot, i.e. the Association"
	^slots detect: [:s| s key = aSlotName] ifNone: [aBlock value].
	! !

!GbtThing methodsFor: 'accessing slots writing' stamp: 'hk 2/23/2017 18:52'!
slotAt: aSlotName value: aThingOrValue
	(self slotSVOAt: aSlotName ifAbsent: [^nil]) isLeaf 
		ifTrue:  [self  updateLeaf: aSlotName with: aThingOrValue ]
		ifFalse: [self updateNode: aSlotName with: aThingOrValue ]! !

!GbtThing methodsFor: 'accessing slots writing' stamp: 'hk 2/20/2017 14:05'!
slotExpandAt: aSlotName put: aThingOrGbtValueLeaf
	"set the slotAssociation value"
	self expandSVO: aSlotName.
	self slotAt: aSlotName value: aThingOrGbtValueLeaf
	
! !

!GbtThing methodsFor: 'accessing slots' stamp: 'hk 2/24/2017 19:12'!
slotIndexOf: aSVO
	"answer the index of the slot with value aSVO"
	1 to: slots size do: [:i| (slots at: i) value == aSVO ifTrue: [^i]].
	^0! !

!GbtThing methodsFor: 'meta-slot resolution' stamp: 'hk 2/17/2017 15:50'!
slotNamed: aSlotNameOrTag
	"answer the slot named by aMessage - nil if not found"

	| path |
	^self slotSVOAt: aSlotNameOrTag ifAbsent: 
		[(path := self pathTo: aSlotNameOrTag) ifNil: [^ nil].
		self slotOnPath: path ].
! !

!GbtThing methodsFor: 'accessing slots' stamp: 'hk 2/16/2017 14:44'!
slotNames
	^ slots collect: [:s| s key]! !

!GbtThing methodsFor: 'accessing slots' stamp: 'hk 2/17/2017 16:04'!
slotSVOAt: aSlotName 
	"answer the slot value (SVO) or nil"
	^self slotSVOAt: aSlotName ifAbsent: []
! !

!GbtThing methodsFor: 'accessing slots' stamp: 'hk 2/17/2017 16:04'!
slotSVOAt: aSlotName ifAbsent: aBlock
	"answer the slot value (SVO)"
	^(self slotAt: aSlotName ifAbsent: [^aBlock value]) value! !

!GbtThing methodsFor: 'accessing slots' stamp: 'hk 2/17/2017 16:19'!
slotSVOExpandAt: aSlotName 
	"answer the slot SVO or nil"
	^self slotSVOAt: aSlotName ifAbsent: [self expandSVO: aSlotName]
! !

!GbtThing methodsFor: 'accessing slots' stamp: 'hk 2/17/2017 16:03'!
slotValueAt: aSlotName 
	"get the slot value if possible, ^nil otherwise, also see #slotAt:"
	| assoc val |
	assoc := self slotAt: aSlotName ifAbsent: [^nil].
	val := assoc value ifNil: [^nil].
	^val isLeaf ifTrue: [val val] ifFalse: [val]
	
! !

!GbtThing methodsFor: 'accessing slots' stamp: 'hk 4/3/2015 17:39'!
slots
	^ slots! !

!GbtThing methodsFor: 'smart' stamp: 'hk 11/25/2015 14:43'!
smart: aBoolean
	smart := aBoolean! !

!GbtThing methodsFor: 'smart' stamp: 'hk 2/17/2017 16:12'!
smartAddBranch: aSlotName 

	| startNode refNode path|
	startNode := self.
	refNode := self fullThing. 
	path := (refNode pathTo: aSlotName) ifNil: [ self error: 'no path to ',aSlotName ].
	path do: [ :slotn |  |sn |
			sn := slotn asSymbol.
			startNode := startNode slotSVOAt: sn ifAbsent: [startNode smartAddSlotSVO: sn].
			refNode := refNode slotSVOAt: sn]
	! !

!GbtThing methodsFor: 'smart' stamp: 'hk 2/17/2017 16:12'!
smartAddSlotSVO: aSlotName
	"add the full things slot aSlotName. 
	if its contains a node, take the node's original smart content"
	
	| sn sa newSlotAssoc node |
	sn := aSlotName asSymbol.
	sa := self fullThing slotAt: sn ifAbsent: [ self error: self svoName , ' has no master slot: ' , aSlotName ].
	node := sa value ifNil: [ self error: 'no master content in ' , aSlotName ].
	newSlotAssoc := sa copy.
	node isNode ifTrue: [newSlotAssoc value: node originalSmart copy].
	self addSlot: newSlotAssoc.	
	^ self slotSVOAt: aSlotName! !

!GbtThing methodsFor: 'copying' stamp: 'hk 11/2/2016 13:52'!
smartCopy
	^self copy initializeSlots smart: true
	! !

!GbtThing methodsFor: 'smart' stamp: 'hk 2/7/2017 17:58'!
smartGrowTo: aGetter
	"construct the branch from full thing and repeat the message"

	self smartAddBranch: aGetter.
	^self pathTo: aGetter
	! !

!GbtThing methodsFor: 'save - retrieve - remove' stamp: 'hk 3/24/2017 18:31'!
store   
	"single thing store: store the complete tree" 
	self setAllDirty . 
	GbtBizAppServer transact: {self serializedNodes} as: self user! !

!GbtThing methodsFor: 'save - retrieve - remove' stamp: 'hk 3/25/2017 12:42'!
stripped
	"for a single node"
	^self shallowCopy postCopyForStore ! !

!GbtThing methodsFor: 'analysing' stamp: 'hk 10/26/2016 10:42'!
structureNodes 
	"full things only"
	^self subnodes! !

!GbtThing methodsFor: 'accessing subnodes' stamp: 'hk 1/5/2016 11:32'!
subnodeAt: aSlotName 
	"answer the subnode content"
	^self subnodeAt: aSlotName ifAbsent: [  ] ! !

!GbtThing methodsFor: 'accessing subnodes' stamp: 'hk 2/17/2017 16:28'!
subnodeAt: aSlotName ifAbsent: aBlock
	"answer the subnode content"
	^(self nodeSlots detect: [:s| s key = aSlotName] ifNone: aBlock) value! !

!GbtThing methodsFor: 'accessing subnodes' stamp: 'hk 2/17/2017 16:28'!
subnodes
	^ self nodeSlots collect: [:s| s value ] ! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 8/3/2015 13:10'!
summary
	^summary ifNil: [ '' ]! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 11/23/2015 22:27'!
summary: aString
	self check: [ aString isString ] toBe: #aString.  
	summary := aString! !

!GbtThing methodsFor: 'tag substitution' stamp: 'hk 2/18/2016 14:39'!
summaryEnriched   
	"start same node above to resolve the tags in summary string"
	^self enrichFromTags: self summary! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 10/20/2016 21:17'!
svoName
	^ svoName ifNil: [super svoName]! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 10/11/2016 16:39'!
svoName: aString
	svoName := aString ! !

!GbtThing methodsFor: 'accessing slots' stamp: 'hk 6/12/2016 14:41'!
tagsAt: aSlotName 
	"answer the tags of slot aSlotName or nil"
	^self tagsAt: aSlotName ifAbsent: []
! !

!GbtThing methodsFor: 'accessing slots' stamp: 'hk 2/17/2017 16:03'!
tagsAt: aSlotName ifAbsent: aBlock
	"answer the tags of the slotAssociation"
	^(self slotAt: aSlotName ifAbsent: [^aBlock value]) tags! !

!GbtThing methodsFor: 'tag substitution' stamp: 'hk 2/7/2017 16:53'!
testAndEnrichFromTags: aString
	^aString substrings first = '#R'
		ifTrue: [self globalRoot enrichFromTags: (aString copyReplaceTokens: '#R' with: ' ' )]
		ifFalse: [self enrichFromTags: aString ]! !

!GbtThing methodsFor: 'constraints' stamp: 'hk 3/27/2017 13:56'!
testWith: aConstraintThing
	"test myself with aConstraintThing. answer true, false or nil (in case of errors).
	self and aConstraintThing need to be combined - to resolve references & lookups.
	the test applies to aConstraintThing alone"
	
	| testThing constraints|	
	aConstraintThing ifNil: [ ^true ].
	testThing :=  self class basicNew initialize fullVO: #self.
	testThing addSlot: (GbtSlotAssociation key: #self value: self copy).  
	constraints := aConstraintThing copy.
	testThing addSlot: (GbtSlotAssociation key: #constr value: constraints) . 
	^constraints checkConstraints ! !

!GbtThing methodsFor: 'ui helper' stamp: 'hk 7/1/2016 12:28'!
titleArrayFrom: titleColumns

	titleColumns ifNil: [^Array with: 'bizId' with: 'summary' ].
	^Array with: 'bizId' withAll: titleColumns
! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 2/7/2017 16:46'!
uiClass
	^widgetClass ifNil: [ self defaultUiClass  ] ifNotNil: [ Smalltalk at: widgetClass ]! !

!GbtThing methodsFor: 'accessing slots basic write' stamp: 'hk 3/25/2017 15:28'!
updateLeaf: aSlotName with: aValue
	"^nil if slot is missing, set the slot value otherwise
	pre: aSlotName denotes an existing leaf slot"
	| sl k vo prev newVO |
	vo := self slotSVOAt: aSlotName.
	prev := self evolve.
	newVO := vo copy 
					inputValue: aValue;
					container: self.
	k := self slotIndexOf: vo.
	self slots at: k put: ((self slots at: k) copy value: newVO).
	vo replaceContainer: prev.
	^newVO


! !

!GbtThing methodsFor: 'accessing slots basic write' stamp: 'hk 3/2/2017 12:28'!
updateNode: aSlotName with: aThing
	"^nil if slot is missing, set the slot value (SVO) otherwise
	pre: aSlotName denotes ann existing node slot"
	| sa k prev |
	prev := self evolve.
	sa := self slotSVOAt: aSlotName.
	k := self slotIndexOf: sa.
	self slots at: k put: ((self slots at: k) copy value: aThing).
	aThing container: self.
	sa replaceContainer: prev
! !

!GbtThing methodsFor: 'embedding' stamp: 'hk 2/23/2017 20:23'!
updateSlot: aGbtSlotAssociation
	"for Declarative only"
	aGbtSlotAssociation newValueContainer: self.
	1 to: slots size do: [:i| 
		((slots at: i) key = aGbtSlotAssociation key) ifTrue: 
			[slots at: i put: aGbtSlotAssociation. ^self]].
	slots add: aGbtSlotAssociation

! !

!GbtThing methodsFor: 'save - retrieve - remove' stamp: 'hk 3/17/2017 17:23'!
updateVersion
	dirty := false. 
	self nextVersion .
	self removePrevious.
	self saveValueTemplates.
	self bizApp addThing: self! !

!GbtThing methodsFor: 'accessing' stamp: 'hk 3/23/2017 10:52'!
user   
	"user of my context"
	^(self rootContextVO) 
		ifNil: [''] 
		ifNotNil: [:ctxt| ctxt user]! !

!GbtThing methodsFor: 'ui helper' stamp: 'hk 2/17/2017 16:03'!
valuesOf: aValueSlot  
	^(self fullThing slotAt: aValueSlot ifAbsent: [^#()]) templates asOrderedCollection! !

!GbtThing methodsFor: 'save - retrieve - remove' stamp: 'hk 2/7/2017 14:41'!
versionedNodes
	"version all dirty nodes and answer the newly versioned branch for store"
	| res |
	self isDirty ifFalse: [^#()]. 
	self updateVersion. 
	res := OrderedCollection with: self.
	self subnodes do: [:sn| res addAll: sn versionedNodes].
	^res 



	
! !

!GbtThing methodsFor: 'ui helper' stamp: 'hk 11/2/2016 13:15'!
voLabel
	^self longName, (self isDirty ifTrue: ['*']ifFalse: [''])! !

!GbtThing methodsFor: 'authoring' stamp: 'hk 1/14/2016 18:23'!
widgetClass: aClassName
	self check: [ (Smalltalk at: aClassName ) isClass ] toBe: #aUiClass.
	widgetClass := aClassName ! !

!GbtThing methodsFor: 'analysing' stamp: 'hk 2/26/2017 13:49'!
writeFullThingStructureHierarchy
	"rewrite all container links in the hierarchy - caution - only full things tolerate that"

	self structureNodes do: [:sn| sn container: self; writeFullThingStructureHierarchy] 
! !

GbtThing subclass: #GbtUlist
	instanceVariableNames: 'templates displayColumns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Things'!

!GbtUlist commentStamp: 'hk 3/22/2017 18:13' prior: 0!
I am a node thing that treats its subnodes as a list.
The slotNames are defined by my numberPolicy.
I am transparent for Views.

    Instance Variables
	templates		<Collection of ThingVO.longName>		templates for  exemplars
	displayColumns:	<Array of Symbol>					slotNames to display

newExemplar only works with an asvo

=====================================

| asvo sum |
asvo := (ThingVO newOfType: #top).
(sum := ThingVO new)
	define: #zahl no: 5;
	define: #nnz no: 3 tag: #zahl;
	define: #summe sum: #zahl .
asvo define:  #bla listOf: sum display: #(summe zahl nnz) . 
 (GcVOEditor on: asvo)  openWithSpec

| asvo sum |
asvo := (ThingVO newOfType: #top).
(sum := ThingVO new)
	define: #zahl no: 5;
	define: #nnz no: 3 tag: #zahl;
	define: #summe sum: #zahl ;
	summary: 'jaja: #summe = #zahl + #nnz' .
asvo define:  #bla listOf: sum display: nil. 
 (GcVOEditor on: asvo)  openWithSpec!

!GbtUlist class methodsFor: 'instance creation' stamp: 'hk 3/21/2017 14:09'!
new
	^self basicNew initialize; setID; yourself
! !

!GbtUlist class methodsFor: 'authoring' stamp: 'hk 3/14/2017 13:01'!
struct: aString define: definitionArray
	^self shouldNotImplement ! !

!GbtUlist class methodsFor: 'accessing' stamp: 'hk 5/11/2016 12:46'!
uiClass
	^ GbtListWidget ! !

!GbtUlist class methodsFor: 'authoring' stamp: 'hk 3/21/2017 14:09'!
withTemplates: aCollectionOfTemplateThings
	^self new templates: aCollectionOfTemplateThings.
! !

!GbtUlist methodsFor: 'authoring' stamp: 'hk 3/22/2017 18:13'!
addTemplate: aASVO
	"tell a template"
	self check: [ aASVO isThing ] toBe: #aThing.

	templates add: aASVO longName ! !

!GbtUlist methodsFor: 'accessing' stamp: 'hk 6/22/2016 16:22'!
classInitial
	^#U! !

!GbtUlist methodsFor: 'accessing' stamp: 'hk 11/2/2016 15:20'!
displayColumns
	^displayColumns! !

!GbtUlist methodsFor: 'accessing' stamp: 'hk 8/10/2015 17:34'!
displayColumns: anArray
	"tell the slots to be displayed in the list"
	
	displayColumns := anArray ! !

!GbtUlist methodsFor: 'printing' stamp: 'hk 8/11/2015 16:32'!
displayStringFor: item
	"answer the row content of an Ulist item for my UIclass"
	
	| stream |
	stream := WriteStream on: ''.
	(item displayArrayFrom: displayColumns) do: [ :str | stream nextPutAll: str; space; space ].
	^stream contents! !

!GbtUlist methodsFor: 'accessing' stamp: 'hk 4/30/2016 18:03'!
enrichFromTags: aString
	"ignore aString. Just take the summaries of my elements"
	
	| res |  
	(res := WriteStream on: '') nextPutAll: ' -- ' . 
	self list do: [ :e| res nextPutAll: (e enrichFromTags: e summary) . res nextPutAll: ' -- ' ].
	^res contents! !

!GbtUlist methodsFor: 'initialization' stamp: 'hk 2/6/2017 20:01'!
initialize
	super initialize.
	svoName := #Ulist.
	templates := OrderedCollection new! !

!GbtUlist methodsFor: 'testing' stamp: 'hk 1/24/2016 12:49'!
isThing
	^false! !

!GbtUlist methodsFor: 'testing' stamp: 'hk 10/25/2016 14:56'!
isUlist
	^true! !

!GbtUlist methodsFor: 'api' stamp: 'hk 10/24/2015 19:20'!
list
	"UlistVO new list"
	^self subnodes asOrderedCollection! !

!GbtUlist methodsFor: 'api' stamp: 'hk 6/25/2015 10:38'!
listSize
	^self list size! !

!GbtUlist methodsFor: 'api' stamp: 'hk 3/22/2017 18:22'!
newEntry
	"add a list element from the first or only template"
	
	^self newEntry: self templateThing copy 
	! !

!GbtUlist methodsFor: 'authoring' stamp: 'hk 2/20/2017 18:16'!
newEntry: aThing
	"add a subnode / list element in a UlistVO"

	self check: [ aThing isNode ] toBe: #GbtThing.
	self addSlot: ((GbtSlotAssociation 
							key: (self defaultPolicy nextID asSymbol) 
							value: aThing ) 
						purposes: aThing purposes).
	^ aThing! !

!GbtUlist methodsFor: 'api' stamp: 'hk 7/30/2016 14:46'!
newEntry: aThing with: aPurpose
	"add a subnode / list element in a UlistVO. 
	Set aPurpose to be the first purpose"

	aThing purpose: aPurpose.
	self newEntry: aThing! !

!GbtUlist methodsFor: 'copying' stamp: 'hk 2/15/2016 21:27'!
postCopy
	super postCopy.
	templates := templates copy.
	displayColumns := displayColumns copy .

	! !

!GbtUlist methodsFor: 'printing' stamp: 'hk 8/24/2016 19:15'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' (' .
	aStream nextPutAll: self list size printString.
	aStream nextPutAll: ' items)'! !

!GbtUlist methodsFor: 'save - retrieve - remove' stamp: 'hk 11/2/2016 15:18'!
saveTemplate: aThing   
	self addTemplate: aThing! !

!GbtUlist methodsFor: 'analysing' stamp: 'hk 10/26/2016 10:42'!
structureNodes 
	"full things only"
	^self templates collect: [:t| t fullThing ]! !

!GbtUlist methodsFor: 'accessing' stamp: 'hk 3/22/2017 18:22'!
templateThing
	^self bizApp thingDefinedAs: self templates first! !

!GbtUlist methodsFor: 'accessing' stamp: 'hk 3/22/2017 18:20'!
templateThingOf: aLongName
	^self bizApp thingDefinedAs: aLongName! !

!GbtUlist methodsFor: 'api' stamp: 'hk 3/27/2017 20:54'!
templateThings
	^templates collect: [:ln| self bizApp thingDefinedAs: ln ]! !

!GbtUlist methodsFor: 'api' stamp: 'hk 6/30/2015 12:23'!
templates
	^templates ! !

!GbtUlist methodsFor: 'authoring' stamp: 'hk 3/22/2017 18:23'!
templates: singleOrCollOfGbtThing
	"replace all templates by these ones"

	templates := (self checkThingMakeColl: singleOrCollOfGbtThing) collect: [:e| e longName]! !

Object subclass: #GbtService
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Utilities'!

!GbtService commentStamp: 'hk 5/17/2016 11:01' prior: 0!
I contain microServices for GBT apps!

!GbtService class methodsFor: 'list transformations' stamp: 'hk 3/27/2017 14:16'!
list: aThingList filteredBy: aConstraintThing 
	^aThingList select: [:e| (e testWith: aConstraintThing) = true ]! !

!GbtService class methodsFor: 'list transformations' stamp: 'hk 8/4/2016 19:02'!
list: aThingList filteredBy: aConstraintThing transformedWith: aDecl
	^self 
		list:  (self list: aThingList filteredBy: aConstraintThing)
		transformedWith: aDecl! !

!GbtService class methodsFor: 'list transformations' stamp: 'hk 9/26/2016 16:23'!
list: aThingList transformedWith: aDecl

	^aThingList 	collect: [:e| aDecl copyWithSource: e ]! !

!GbtService class methodsFor: 'pdf' stamp: 'hk 2/11/2017 16:26'!
pdfLabel: arg1 with: arg2
	| tmp1 tmp2 tmp3 tmp4 tmp5 tmp7 tmp11 |
	tmp5 := arg2 asOrderedCollection.
	tmp4 := self streamNamed: arg1.
	tmp1 := PDFDocument new.
	tmp3 := PDFTimesFont size: 14 pt.
	tmp2 := PDFPage new.
	tmp2
		add:
			((PDFRectElement from: 1 mm @ 1 mm dimension: 90 mm @ 45 mm)
				drawColor: (PDFColor new setGreyLevel: 200));
		add:
			(PDFJpegElement
				from: 3 mm @ 3 mm
				dimension: 86 mm @ 7.74 mm
				fromStream: 'icons/header.jpg' asFileReference readStream).
	tmp7 := 20 mm.
	tmp5 size - 1
		timesRepeat: [ | tmp9 |
			tmp9 := PDFTextElement new.
			tmp9
				font: tmp3;
				from: 10 mm @ tmp7.
			tmp2 add: (tmp9 text: tmp5 removeFirst).
			tmp7 := tmp7 + 5 mm ].
	tmp11 := PDFTextElement new.
	tmp11
		font: tmp3;
		from: 10 mm @ (tmp7 + 2 mm).
	tmp2 add: (tmp11 text: tmp5 removeFirst).
	tmp1
		add: tmp2;
		exportTo: tmp4.
	UIManager default inform: 'pdf created'! !

!GbtService class methodsFor: 'private' stamp: 'hk 5/19/2016 11:26'!
streamNamed: aName
	"get the FileStream of file aName"

	(FileSystem workingDirectory / 'pdf') ensureCreateDirectory.
	^ FileStream newFileNamed: 'pdf/' , aName, '.pdf'! !

Object subclass: #GbtSlotAssociation
	instanceVariableNames: 'assoc purposes private templates tagArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Things'!

!GbtSlotAssociation commentStamp: 'hk 8/17/2016 19:55' prior: 0!
I represent a vlaue in a slot dictionary.
Note our copy semantics: must copy the association values, too.

Instance Variables
	tagCollection:	<Collection of Symbol | nil>
	purposes:		<nil|Array of String>
	private: 			<Boolean|nil>					or public
	templates: 		<Collection of GbtThing>			node templates in full things
	
semantic specials:						
	the first purpose is the selected one!!
	#hasKeyOrTag determines how a slot is found in a Thing.  slotName overrides a tag.

Implementation hints
	There is a problem with OrdewredIdentityDictionary>>associationsSelect
	used in GbtThing>>constraintSlots, leafSlots etc.
	is  replaces the GbtSlotAssociations in slots by Associations during select!

!GbtSlotAssociation class methodsFor: 'instance creation' stamp: 'hk 2/16/2017 09:56'!
key: aKey value: aValue
	^self new key: aKey value: aValue! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 11/2/2016 14:59'!
addTemplate: aValOrThing
	self templates add: aValOrThing ! !

!GbtSlotAssociation methodsFor: 'copying' stamp: 'hk 2/3/2017 15:16'!
copyValue
	^self copy value: self value copy! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 2/16/2017 13:16'!
hasKeyOrTag: aSymbol
	"use the key=slotName as default-tag"
	^ (self key = aSymbol) or: [self hasTag: aSymbol]! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 8/17/2016 20:01'!
hasTag: aTagSymbol
	^ (tagArray ifNil: [ ^false ]) includes: aTagSymbol ! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 3/25/2017 15:31'!
isCalc
	self value ifNil: [^false].
	^self value isCalc! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 2/16/2017 13:16'!
isDeclarative
	self value ifNil: [ ^false ].
	^self value isDeclarative! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 2/16/2017 13:16'!
isFilled
	self value ifNil: [^false].
	self isLeaf ifTrue: [^self value isFilled].
	^true! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 2/16/2017 13:17'!
isGbtConstraint
	self value ifNil: [ ^false ].
	^self value isGbtConstraint! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 2/16/2017 13:17'!
isLeaf
	self value ifNil: [^false].
	^self value isLeaf! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 2/16/2017 13:17'!
isLink
	self value ifNil: [^false].
	^self value isKindOf: GbtThingLink! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 2/16/2017 13:17'!
isNode
	self value ifNil: [^false].
	^self value isNode! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 1/4/2016 14:34'!
isPrivate
	^private ifNil: [^false]! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 2/16/2017 13:17'!
isTag
	self value ifNil: [ ^false ].
	^self value isSymbol! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 2/15/2017 18:48'!
key
	^assoc key! !

!GbtSlotAssociation methodsFor: 'initialization' stamp: 'hk 2/16/2017 09:56'!
key: aKey value: aValue
	assoc := aKey -> aValue! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 2/22/2017 15:20'!
newValueContainer: aThing
	self value ifNotNil: [:v| v replaceContainer: aThing ]! !

!GbtSlotAssociation methodsFor: 'copying' stamp: 'hk 2/24/2017 13:14'!
postCopy
	super postCopy.
	tagArray := tagArray copy.
	purposes := purposes copy.
	assoc := assoc key -> assoc value.
	templates := nil.
! !

!GbtSlotAssociation methodsFor: 'printing' stamp: 'hk 2/19/2017 14:47'!
printOn: aStream
	"Store my assoc in the format (key->value)"
	aStream nextPutAll: self key.
	aStream nextPutAll: ' -> '.
	aStream nextPutAll: self value printString.
! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 1/4/2016 14:34'!
private: aBoolean
	private := aBoolean! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 10/31/2015 17:44'!
purposes 
	"the array of purposes"
	^(purposes ifNil: [ ^#() ]) ! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 1/4/2016 14:56'!
purposes: anArray
	"purposes describe the use of a slot"

	 purposes := anArray! !

!GbtSlotAssociation methodsFor: 'printing' stamp: 'hk 2/16/2017 09:53'!
storeOn: aStream
	"Store my assoc in the format (key->value)"
	aStream nextPutAll: 'Gbt'.
	assoc storeOn: aStream! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 8/17/2016 20:01'!
tags
	"answer the tagCollection or nil"
	^tagArray! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 11/2/2016 12:24'!
tags: aCollOrSymbolOrNil
	"tags used in authoring are protected here"
	|tagColl|  
	aCollOrSymbolOrNil ifNil: [^self].
	tagColl := #().
	aCollOrSymbolOrNil isString 
		ifTrue: [tagColl := {aCollOrSymbolOrNil asSymbol} ]
		ifFalse: [aCollOrSymbolOrNil isCollection 
			ifTrue: [tagColl := 	aCollOrSymbolOrNil ]
			ifFalse: [^self error: 'aSymbol or Collection expected']].
	tagArray := tagColl asArray! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 7/31/2016 16:03'!
templates 
	"the coll of thing templates (for nodes in full things)"
	^templates ifNil: [templates := Set new] ! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 7/31/2016 16:04'!
templates: aCollOfThings
	templates := aCollOfThings asSet! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 2/15/2017 18:50'!
value
	^assoc value! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 2/15/2017 18:50'!
value: aValue
	assoc value: aValue! !

Object subclass: #GbtThingLink
	instanceVariableNames: 'container sparsePath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Things'!

!GbtThingLink commentStamp: 'hk 10/11/2016 16:47' prior: 0!
I link to a node in a different branch of my node tree, possibly above.

I delegate all calls to my link target

    Instance Variables
	sparsePath	<String>		of colon separated slotnames , 
							identifying the branch from root to the linked node
	container	<Thing>		the node I am in!

!GbtThingLink class methodsFor: 'instance creation' stamp: 'hk 2/13/2017 14:28'!
for: aSmartPath in: aNode
	"aSlotNameSequence is a colon separated string"
	^ self new
		setLink: aSmartPath;
		container: aNode;
		yourself! !

!GbtThingLink class methodsFor: 'accessing' stamp: 'hk 5/11/2016 12:45'!
uiClass
	^ GbtLinkWidget ! !

!GbtThingLink methodsFor: 'accessing' stamp: 'hk 2/1/2016 14:56'!
container
	^container  ! !

!GbtThingLink methodsFor: 'accessing' stamp: 'hk 1/31/2016 16:31'!
container: aNode 
	container := aNode! !

!GbtThingLink methodsFor: 'accessing' stamp: 'hk 2/9/2016 17:38'!
defaultUiClass
	"default widget class"
	^(self linkTarget ifNil: [self class]) uiClass! !

!GbtThingLink methodsFor: 'reflective operations' stamp: 'hk 10/11/2016 16:48'!
doesNotUnderstand: aMessage
	"link to link node"
	| root |
	root := self linkTarget ifNil: [super doesNotUnderstand: aMessage].
	^root  perform: aMessage selector withArguments: aMessage arguments! !

!GbtThingLink methodsFor: 'accessing' stamp: 'hk 1/19/2017 14:26'!
globalRoot
	^(container ifNil: [^self]) globalRoot! !

!GbtThingLink methodsFor: 'testing' stamp: 'hk 3/25/2017 15:32'!
isCalc
	"not a true node - in contrast to my link target"
	
	^false! !

!GbtThingLink methodsFor: 'testing' stamp: 'hk 7/29/2016 12:47'!
isDeclarative
	^false! !

!GbtThingLink methodsFor: 'testing' stamp: 'hk 11/9/2016 13:00'!
isGbtConstraint	
	^false! !

!GbtThingLink methodsFor: 'testing' stamp: 'hk 12/14/2016 14:38'!
isLeaf	
	^false! !

!GbtThingLink methodsFor: 'testing' stamp: 'hk 4/30/2016 19:13'!
isNode
	"not a true node - in contrast to my link target"
	
	^false! !

!GbtThingLink methodsFor: 'testing' stamp: 'hk 4/30/2016 19:17'!
isThing
	"not a true thing - in contrast to my link target"
	
	^false! !

!GbtThingLink methodsFor: 'accessing' stamp: 'hk 2/7/2017 16:14'!
linkTarget
	"answer target or nil"
	| res |
	res := self globalRoot slotOnSmartPath: sparsePath.
	res = self ifTrue: [^GbtSVO error: 'link error: cant link to self' ].
	^res
 ! !

!GbtThingLink methodsFor: 'accessing' stamp: 'hk 1/20/2017 14:39'!
localRoot
	^(container ifNil: [^self]) localRoot! !

!GbtThingLink methodsFor: 'copying' stamp: 'hk 2/23/2017 13:06'!
removePrevious! !

!GbtThingLink methodsFor: 'accessing' stamp: 'hk 2/22/2017 15:28'!
replaceContainer: aNode 
	container := aNode! !

!GbtThingLink methodsFor: 'authoring' stamp: 'hk 2/13/2017 14:28'!
setLink: aSmartPath	
	GbtSVO check: [ aSmartPath isString ] toBe: #aString.
	sparsePath := aSmartPath
! !

!GbtThingLink methodsFor: 'accessing' stamp: 'hk 4/30/2016 19:15'!
sparsePath
	^sparsePath 
! !

Object subclass: #GbtTransaction
	uses: TGbtSerializer
	instanceVariableNames: 'user timeStamp id thingLongNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-BizAppServer'!

!GbtTransaction commentStamp: 'hk 12/12/2016 14:39' prior: 0!
I am a record in the transaction table (see datomic for concepts)

    Instance Variables
	thingLongNames: 	<Collection> 		of thing-node longNames:  svoNames, id's and versions
	timeStamp:			<DateAndTime>
	user:				<String>			user name
	id: 					<Integer> 		the transaction ID!

GbtTransaction class
	uses: TGbtSerializer classTrait
	instanceVariableNames: ''!

!GbtTransaction class methodsFor: 'instance creation' stamp: 'hk 1/24/2017 17:41'!
for: aUser 
	^self new user: aUser! !

!GbtTransaction class methodsFor: 'deserializing' stamp: ''!
fromString: aSerializedNode
	^STON fromString: aSerializedNode ! !

!GbtTransaction methodsFor: 'accessing' stamp: 'hk 1/24/2017 17:45'!
addThingLongName: aLongName
	thingLongNames add: aLongName ! !

!GbtTransaction methodsFor: 'accessing' stamp: 'hk 12/12/2016 13:36'!
id
	^id! !

!GbtTransaction methodsFor: 'initialization' stamp: 'hk 3/14/2017 10:36'!
initialize
	timeStamp := DateAndTime now.
	id := GbtBizAppServer default transactor nextTxId  .
	thingLongNames := OrderedCollection new.! !

!GbtTransaction methodsFor: 'serializing' stamp: ''!
serializedNodes
	^self versionedNodes collect: [:n| n stripped toString]
! !

!GbtTransaction methodsFor: 'accessing' stamp: 'hk 12/12/2016 14:38'!
thingLongNames
	^thingLongNames ! !

!GbtTransaction methodsFor: 'serializing' stamp: ''!
toString
	^STON toStringPretty: self! !

!GbtTransaction methodsFor: 'accessing' stamp: 'hk 12/11/2016 13:59'!
user: aName
	user := aName! !

Object subclass: #GbtTransactor
	uses: TGbtAccessSerialized
	instanceVariableNames: 'txID mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-BizAppServer'!

!GbtTransactor commentStamp: 'hk 2/6/2017 20:18' prior: 0!
I am the writer for Things - similar to Datomic transactor.
writing is additional, preserves all previous writings - with one exception: 
the rootMap file is changed on each write, this needs a transaction with a db lock .

I manage the notification of other users.
the file system db variant is organized in 
- 	current.things.svoName (directory)
	rootMap (file)
	v1 (directory)
	...
	vn (directory)
where n is the highest version


    Instance Variables
	mutex:		<Object>
	txID:		<Object>
!

GbtTransactor class
	uses: TGbtAccessSerialized classTrait
	instanceVariableNames: ''!

!GbtTransactor methodsFor: 'accessing serialized node' stamp: ''!
classInitialAndIdOf: aSerializedNode 
	"aSerializedNode classInitialAndId "
	| searchString |
	searchString := '#id\s\:\s\''(\w+)\''\,'.
	^ 'T',	((searchString asRegex search: aSerializedNode; yourself) subexpression: 2) ! !

!GbtTransactor methodsFor: 'private' stamp: 'hk 1/23/2017 14:05'!
critical: aBlock
	mutex critical: aBlock! !

!GbtTransactor methodsFor: 'initialization' stamp: 'hk 1/23/2017 14:05'!
initialize
	txID := 0.
	mutex := Mutex new.
	! !

!GbtTransactor methodsFor: 'accessing serialized node' stamp: ''!
longNameOf: aSerializedNode
	"aSerializedNode longName"
	^(self svoNameOf: aSerializedNode), ':', (self classInitialAndIdOf: aSerializedNode), (self versionStringOf: aSerializedNode)! !

!GbtTransactor methodsFor: 'private' stamp: 'hk 1/23/2017 14:05'!
nextTxId
	^(txID := txID+1) asString! !

!GbtTransactor methodsFor: 'api' stamp: 'hk 3/24/2017 17:06'!
notify: aTx from: aUser to: users
	| things|    
	things := (aTx thingLongNames collect: [:n| 
		(GbtBizAppServer default appAt: aUser) thingDefinedAs: n ifAbsent: []])
			select: [:th| 
				th isNotNil and: [th isContainerRoot]] .
	users do: [:u| self notify: u withAll: things storedBy: aUser]! !

!GbtTransactor methodsFor: 'notification' stamp: 'hk 3/25/2017 15:00'!
notify: aUser with: aThing storedBy: sUser
	"notify saveContext of all users, thing context of other users"
	| toNotify recApp sendApp|
	sendApp := GbtBizAppServer default appAt: sUser.
	recApp := GbtBizAppServer default appAt: aUser.
	toNotify := aThing saveContextNames collect: 
		[:scn| recApp contextNamed: scn].
	aThing saveContextName ifNotNil: 
		[:scn| toNotify add: (sendApp contextNamed: scn )].
	toNotify do: [:ct| (ct userRight allows: aThing) ifTrue:
		[ct updateBigThing: (self stonConvert: aThing)] ]

! !

!GbtTransactor methodsFor: 'notification' stamp: 'hk 3/24/2017 17:02'!
notify: aUser withAll: things storedBy: sUser
	things do: [:th| self notify: aUser with: th storedBy: sUser]! !

!GbtTransactor methodsFor: 'private' stamp: 'hk 3/25/2017 12:50'!
stonConvert: aThing
	"for Things: a copy preserving id & version"
	^(STON fromString:(STON toStringPretty: aThing copyForSton)) buildContainerHierarchy! !

!GbtTransactor methodsFor: 'private' stamp: 'hk 3/14/2017 10:36'!
storeNode: aSerializedThing 
	"do we need to store the tx id with the thing?"
	| dir subDir |
	dir := GbtBizAppServer thingsDir / (self svoNameOf: aSerializedThing) .
	dir ensureCreateDirectory .
	subDir := dir / (self classInitialAndIdOf: aSerializedThing) .
	subDir ensureCreateDirectory .
	subDir / (self versionStringOf: aSerializedThing) 
		writeStreamDo: [ :str| str nextPutAll: aSerializedThing]! !

!GbtTransactor methodsFor: 'private' stamp: 'hk 2/8/2017 17:05'!
storePath: serializedNodes tx: aTx
	serializedNodes ifNotEmpty: 
		[self updateRoot: serializedNodes].
	serializedNodes do: [:sn|
		aTx addThingLongName: (self longNameOf: sn).
		self storeNode: sn]! !

!GbtTransactor methodsFor: 'private' stamp: 'hk 3/14/2017 10:36'!
storeTx: aTx
	| dir |
	dir := GbtBizAppServer txDir.
	dir ensureCreateDirectory .
	(dir / aTx id) writeStreamDo: 
		[:str| str nextPutAll: (aTx toString) ]! !

!GbtTransactor methodsFor: 'accessing serialized node' stamp: ''!
svoNameOf: aSerializedNode
	"aSerializedNode svoName"
	^('#svoName\s\:\s[''|#](\w+)' asRegex search: aSerializedNode; yourself) subexpression: 2 ! !

!GbtTransactor methodsFor: 'api' stamp: 'hk 2/4/2017 13:57'!
transact: anArrayOfSerializedBranches as: aUser
	self transact: anArrayOfSerializedBranches as: aUser notify: #all! !

!GbtTransactor methodsFor: 'private' stamp: 'hk 3/21/2017 17:11'!
transact: anArrayOfSerializedBranches as: aUser notify: users
	"ensure reentrancy .  store root only for simplicity"

	| tx usrs |
	tx := GbtTransaction for: aUser.

	self critical: 
		[ anArrayOfSerializedBranches do: [:path| self storePath: path tx: tx].
		self storeTx: tx].

	users = #current ifTrue: [ ^ self ].
	usrs := users = #all
		ifTrue: [GbtBizAppServer default activeUsers  ]
		ifFalse: [ users ].
	self notify: tx from: aUser to: usrs! !

!GbtTransactor methodsFor: 'private' stamp: 'hk 3/14/2017 10:36'!
updateRoot: aPathOfSerializedThings 
	| dir rootMap svoName |
	svoName := self svoNameOf: aPathOfSerializedThings first .
	dir := (GbtBizAppServer thingsDir / svoName) ensureCreateDirectory .
	rootMap := GbtBizAppServer default rootMapAt: svoName.
	rootMap addRoot: aPathOfSerializedThings .
	(dir / 'rootMap') ensureDelete.
	dir / 'rootMap' writeStreamDo: [ :stream | stream nextPutAll: rootMap toString ].
	
	! !

!GbtTransactor methodsFor: 'accessing serialized node' stamp: ''!
versionStringOf: aSerializedNode 
	"aSerializedNode versionString"
	^ 'v',	(('#version\s\:\s([0-9]+)' asRegex search: aSerializedNode; yourself) subexpression: 2)! !

!Object methodsFor: '*GBT-DSL' stamp: 'hk 11/16/2016 13:29'!
ifString: aBlock
	"convenience - evaluate aBlock if I am a String"

	self isString ifTrue: [ ^aBlock value ] ! !

Object subclass: #SVO2
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'GBT-DSL'!

!SVO2 class methodsFor: 'development support' stamp: 'hk 9/30/2016 19:05'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!SVO2 class methodsFor: 'private' stamp: 'hk 9/30/2016 19:05'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!SVO2 class methodsFor: 'private' stamp: 'hk 9/30/2016 19:05'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!SVO2 class methodsFor: 'private' stamp: 'hk 9/30/2016 19:05'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!SVO2 class methodsFor: 'metacello tool support' stamp: 'hk 9/30/2016 19:05'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!SVO2 class methodsFor: 'loading' stamp: 'hk 9/30/2016 19:05'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!SVO2 class methodsFor: 'loading' stamp: 'hk 9/30/2016 19:05'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!SVO2 class methodsFor: 'loading' stamp: 'hk 9/30/2016 19:05'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!SVO2 class methodsFor: 'accessing' stamp: 'hk 9/30/2016 19:05'!
project

	^self new project! !

!SVO2 class methodsFor: 'development support' stamp: 'hk 9/30/2016 19:05'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!SVO2 methodsFor: 'accessing' stamp: 'hk 9/30/2016 19:05'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!SVO2 methodsFor: 'accessing' stamp: 'hk 9/30/2016 19:05'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ButtonModel methodsFor: '*GBT-DSL-initialize' stamp: 'hk 7/6/2016 16:18'!
initialize
	"helpHolder removed - already initialized in super"
	super initialize.

	actionHolder := [] asValueHolder.
	labelHolder := '' asValueHolder.
	iconHolder := nil asValueHolder.
	stateHolder := false asValueHolder.
	actionPerformedHolder := nil asValueHolder.
	askBeforeChangingHolder := false asValueHolder.
	shortcutHolder := nil asValueHolder.
	
	labelHolder whenChangedDo: [ self changed: #label ].
	iconHolder whenChangedDo: [ self changed: #label ].
	stateHolder whenChangedDo: [ self changed: #state ].
	enabledHolder whenChangedDo: [ self changed: #enabled ].
	askBeforeChangingHolder whenChangedDo: [:newValue | self changed: { #askBeforeChanging: . newValue} ].
	shortcutHolder whenChangedDo: [ :newShortcut :oldShortcut |
		self unregisterShortcut: oldShortcut.
		self registerShortcut: newShortcut.
		self changed: #label ].
	
	menuHolder := MenuModel new asValueHolder.	
	menuHolder whenChangedDo: [ :aMenuModel :oldMenu | 
		(oldMenu isNil or: [ oldMenu isBlock ]) ifFalse: [ oldMenu neglect: self ].
		(aMenuModel isNil or: [ aMenuModel isBlock ]) ifFalse: [ aMenuModel applyTo: self ] ].
		
	self bindKeyCombination: Character space toAction: [ self action ].! !

PackageManifest subclass: #ManifestSVO
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL'!

!ManifestSVO commentStamp: '<historical>' prior: 0!
I store metadata for this package. These meta data are used by other tools such as the SmalllintManifestChecker and the critics Browser!

!ManifestSVO class methodsFor: 'code-critics' stamp: 'hk 11/2/2016 16:26'!
ruleRBCodeCruftLeftInMethodsRuleV1FalsePositive
	^ #(#(#(#RGMethodDefinition #(#GbtActionHalt #doOn: #false)) #'2016-11-02T16:26:44.488425+01:00') )! !

GbtBizAppServer initialize!

GbtSVO initialize!

GbtIcons initialize!
